Ext.define('monitor.widget.abstract.MonitorWidget', {extend:'Ext.container.Container', alias:'widget.monitorBaseWidget', mixins:['BpcCommon.mixin.Widget'], config:{widgetConfiguration:{}}, statics:{MONITOR_ID_MISSING:'monitorIdMissing', COLUMN_CONFIG_MISSING:'columnConfigMissing'}, listeners:{add:function(me, item) {
  if (item.query('tabpanel')) {
    var tabs = item.query('tabpanel');
    for (var $jscomp$iter$1 = $jscomp.makeIterator(tabs), $jscomp$key$tab = $jscomp$iter$1.next(); !$jscomp$key$tab.done; $jscomp$key$tab = $jscomp$iter$1.next()) {
      var tab = $jscomp$key$tab.value;
      {
        tab.on('tabchange', function(subTabs, newSubTab) {
          var index = subTabs.items.items.findIndex(function(tab) {
            return tab === newSubTab;
          });
          tabs.forEach(function(tab) {
            tab.setActiveItem(index);
          });
        });
      }
    }
  }
}}, monitorNotFoundPanel:{xtype:'container', padding:'10 10 10 10', items:[{xtype:'bpcCenterMessageCmp', message:'MONITOR_WIDGET_NOT_FOUND', messageIconCls:'x-fal fa-exclamation-triangle'}]}, wrongConfigPanel:{xtype:'container', padding:'10 10 10 10', items:[{xtype:'box', localized:{html:'MONITOR_WIDGET_INCOMPLETE_CONFIG'}}, {xtype:'button', localized:{text:'MONITOR_WIDGET_SHOW_CONFIG'}, iconCls:'x-fal fa-cog', handler:function() {
  var widget = this.up('monitorBaseWidget');
  widget.configureWidget();
}}]}, getWrongConfigPanel:function(type) {
  var monitorWidgetStatics = monitor.widget['abstract'].MonitorWidget;
  var configPanel = {xtype:'container', padding:'10 10 10 10', layout:{type:'vbox', pack:'center', align:'middle'}, items:[]};
  var messageLanguageKey;
  if (type === monitorWidgetStatics.MONITOR_ID_MISSING) {
    messageLanguageKey = 'MONITOR_WIDGET_MONITOR_ID_MISSING';
  } else {
    if (type === monitorWidgetStatics.COLUMN_CONFIG_MISSING) {
      messageLanguageKey = 'MONITOR_WIDGET_INCORRECT_COLUMN_CONFIG';
    } else {
      messageLanguageKey = 'MONITOR_WIDGET_INCOMPLETE_CONFIG';
    }
  }
  var messageItem = {xtype:'box', html:'\x3ch3\x3e' + BpcCommon.Api.getTranslation(messageLanguageKey) + '\x3c/h3\x3e'};
  configPanel.items = [{xtype:'button', localized:{text:'MONITOR_WIDGET_SHOW_CONFIG'}, iconCls:'x-fal fa-cog', handler:function() {
    var widget = this.up('monitorBaseWidget');
    widget.configureWidget();
  }}, messageItem];
  return configPanel;
}, getSettingFromModuleInstance:function(key) {
  return BpcCommon.Api.getSetting(this.moduleId, key);
}, configureWidget:function() {
  var me = this;
  try {
    if (!me.settingPanel) {
      var accessAllowedItems = [{xtype:'bpcSettingPanel', settings:me.settingStore, buttons:[{iconCls:BpcCommon.Icons.RESET, itemId:'cancelBtn', ui:'secondary', localized:{text:'MONITOR_PROCESS_DEFAULT_VALUES'}, handler:me.prepareWidgetConfiguration.bind(this, true)}, {iconCls:BpcCommon.Icons.OK, itemId:'saveBtn', ui:'primary', localized:{text:'CORE_APPLY'}, handler:function(source) {
        source.up('bpcWindow').close();
      }}]}];
      var accessDeniedItems = [{xtype:'bpcCenterMessageCmp', message:'MONITOR_WIDGET_NO_RIGHTS_TO_EDIT', messageIconCls:'x-fal fa-exclamation-triangle'}];
      var isUserAllowed = BpcCommon.Api.hasUserRight(dashboard.assets.ModuleRights.editDashbaord);
      var renderItems = isUserAllowed ? accessAllowedItems : accessDeniedItems;
      me.settingPanel = Ext.create({xtype:'bpcWindow', layout:'fit', closeAction:'method-hide', items:renderItems});
    }
    me.settingPanel.show();
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR configureWidget', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.assets.ConfigKeys', {singleton:true, dataIndex:'data_index', dataType:'data_type', dataHistoryIndex:'data_historyIndex', dataHistoryType:'data_historyType', legacyPmGridId:'inubit_dbGridId', legacyPmTablePrefix:'inubit_dbTablePrefix', legacyPmMandant:'inubit_pmMandant', bpmBasePath:'inubit_baseUrl', bpmProxyId:'inubit_proxyId', changeStateEndpoint:'inubit_changeStateEndpoint', inubitLoadFilesAsZipEndpoint:'inubit_loadFilesAsZipEndpoint', detailViewEastEnabled:'detailView_east', 
detailViewSouthEnabled:'detailView_south', detailViewWestEnabled:'detailView_west', detailViewNorthEnabled:'detailView_north', detailViewInlineEnabled:'detailView_inline', detailViewPopupEnabled:'detailView_popup', detailViewEastConfig:'detailView_eastConfig', detailViewSouthConfig:'detailView_southConfig', detailViewWestConfig:'detailView_westConfig', detailViewNorthConfig:'detailView_northConfig', detailViewInlineConfig:'detailView_inlineConfig', detailViewPopupConfig:'detailView_popupConfig', 
columnConfig:'column_config', columnFile:'column_file', columnHistorySubId:'column_historySubId', columnHistoryId:'column_historyId', columnId:'column_id', columnStatus:'column_status', columnGroupField:'column_groupField', dateFormat:'date_format', columnCustomRenderer:'column_customRenderer', columnTaskView:'function_interactionColumn', columnTaskViewValue:'function_interactionFormId', columnTimeseries:'column_timeseries', guiShowFilterBar:'gui_showFilterBar', moduleHeaderEnabled:'moduleHeader_enabled', 
gridShowHeader:'grid_showHeader', moduleName:'module_name', moduleDescription:'module_description', processStart:'function_processStart', processStartConfig:'function_processStartConfig', columnList:'column_list', columnHistoryList:'column_historyList', viewStates:'view_states', actionSeperator:'function_processActionSeparator', columnActionPrefix:'function_processActionPrefix', parallelProcessActions:'function_processActionAllowParallel', processActions:'function_processActions', filterTextShowBoundList:' filter_textFilter_showBoundList', 
processRecordViewhideEmptyValues:'function_processRecord_hideEmptyValues', sortMulti:'sort_multi', sortMultiColumnCount:'sort_multiColumnCount', sortMultiReversedOrder:'sort_multiReversedOrder', exportJson:'function_exportConfigJson', exportCsv:'function_exportConfigCsv', exportXlsx:'function_exportConfigXlsx', exportDialogDefaults:'function_exportDialogDefaults', showFavorites:'function_moduleHeader_showFavorites', showSorter:'function_moduleHeader_showSorter', showToolbarRightInHeader:'function_moduleHeader_toolbarRight_show', 
gridSortingColumn:'grid_mainSortColumn', showGridLoadMask:'grid_showLoadMask', gridMultipleViews:'function_gridMultipleViews', gridMultipleViewsConfig:'function_gridMultipleViewsConfig', rowStyle:'row_style', rowStyleEnabled:'row_styleEnabled', countColumns:'gui_countFilteredColumns', changeState:'function_changeState', moduleIconCls:'module_iconCls', gridEditable:'grid_textSelectionEnabled', collabIntegration:'module_collab_descriptor', dataRefreshBufferInSeconds:'data_refreshBuffer', autoUpdate:'function_autoUpdate', 
functionMainGridAttachments:'function_mainGridAttachments', functionEnableMultiDownload:'function_enableMultiDownload', dataCountLimit:'monitor_data_count_limit', resourceSavingMode:'resource_saving_mode', hideZeroValues:'hideZeroValues', cellAlign:'cellAlign', aggregationLimit:'aggregationLimit', changeStateConfig:'function_changeStateConfig', dockSummary:'dockSummary', exportEnabled:'function_exportEnable', customViewsEnabled:'function_saveView', gridMainSortDirection:'grid_mainSortDirection', 
moduleHeaderContent:'function_moduleHeader_content', hideDefaultTableHeaderTooltip:'hideDefaultTableHeaderTooltip'});
Ext.define('monitor.widget.timeseriesAggregation.TimeseriesAggregation', {extend:'monitor.widget.abstract.MonitorWidget', alias:'widget.monitorWidgetTsAgg', statics:{WIDGET_NAME:BpcCommon.lang.Current.MONITOR_WIDGET_PROCESS_OVERVIEW_TIMEFRAME, WIDGET_DESCRIPTION:BpcCommon.lang.Current.MONITOR_WIDGET_PROCESS_OVERVIEW_TIMEFRAME_DESC, WIDGET_ICON_CLS:'x-fal fa-chart-bar'}, widgetConfigSettingMap:{dateFormat:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_DATE_FORMAT', '_tooltip':'MONITOR_SETTING_WIDGET_DATE_FORMAT_TOOLTIP'}, 
aggregationColumn:{moduleSettingName:monitor.assets.ConfigKeys.columnStatus, '_label':'MONITOR_SETTING_WIDGET_AGGREGATION_COLUMN', '_tooltip':'MONITOR_SETTING_WIDGET_AGGREGATION_COLUMN_TOOLTIP'}, timeseriesColumn:{moduleSettingName:monitor.assets.ConfigKeys.columnTimeseries, '_label':'MONITOR_SETTING_WIDGET_TIMESERIES_COLUMN', '_tooltip':'MONITOR_SETTING_WIDGET_TIMESERIES_COLUMN_TOOLTIP'}, hiddenGraphs:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_HIDDEN_GRAPHS', '_tooltip':'MONITOR_SETTING_WIDGET_HIDDEN_GRAPHS_TOOLTIP'}, 
hideEmptyRows:{settingType:'bool', '_label':'MONITOR_SETTING_WIDGET_HIDE_EMPTY_ROWS', '_tooltip':'MONITOR_SETTING_WIDGET_HIDE_EMPTY_ROWS_TOOLTIP'}, showPreviousData:{settingType:'bool', '_label':'MONITOR_SETTING_WIDGET_PREVIOUS_DATA', '_tooltip':'MONITOR_SETTING_WIDGET_PREVIOUS_DATA_TOOLTIP'}, showFollowingData:{settingType:'bool', '_label':'MONITOR_SETTING_WIDGET_FOLLOWING_DATA', '_tooltip':'MONITOR_SETTING_WIDGET_FOLLOWING_DATA_TOOLTIP'}, chartConfiguration:{settingType:'json', '_label':'MONITOR_SETTING_WIDGET_CHART_CONFIGURATION', 
'_tooltip':'MONITOR_SETTING_WIDGET_CHART_CONFIGURATION_TOOLTIP'}, initialView:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_INITIAL_VIEW', '_tooltip':'MONITOR_SETTING_WIDGET_INITIAL_VIEW_TOOLTIP'}, excludedValues:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_EXCLUDED_VALUES', '_tooltip':'MONITOR_SETTING_WIDGET_EXCLUDED_VALUES_TOOLTIP'}, views:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_VIEWS', '_tooltip':'MONITOR_SETTING_WIDGET_VIEWS_TOOLTIP'}, viewMode:{settingType:'list', 
'_valueList':['tabbed', 'stacked', 'chartOnly', 'tableOnly'], '_label':'MONITOR_SETTING_WIDGET_VIEWMODE', '_tooltip':'MONITOR_SETTING_WIDGET_VIEWMODE_TOOLTIP'}, hideZeroValues:{settingType:'bool', '_label':'MONITOR_SETTING_WIDGET_HIDE_ZERO_VALUES', '_tooltip':'MONITOR_SETTING_WIDGET_HIDE_ZERO_VALUES_TOOLTIP'}, cellAlign:{settingType:'list', '_valueList':['right', 'left', 'center'], '_label':'MONITOR_SETTING_WIDGET_CELL_ALIGN', '_tooltip':'MONITOR_SETTING_WIDGET_CELL_ALIGN_TOOLTIP'}, dataRefreshBuffer:{settingType:'int', 
'_label':'MONITOR_SETTING_WIDGET_LABEL_DATA_REFRESHBUFFER', '_tooltip':'MONITOR_SETTING_WIDGET_LABEL_DATA_REFRESHBUFFER_TOOLTIP'}, moduleId:{settingType:'moduleInstance', '_label':'MONITOR_SETTING_WIDGET_MODULE_ID', '_tooltip':'MONITOR_SETTING_WIDGET_MODULE_ID_TOOLTIP'}, startDate:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_START_DATE', '_tooltip':'MONITOR_SETTING_WIDGET_START_DATE_TOOLTIP'}, endDate:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_END_DATE', '_tooltip':'MONITOR_SETTING_WIDGET_END_DATE_TOOLTIP'}, 
interval:{settingType:'list', '_valueList':['year', 'quarter', 'month', 'week', 'day', 'hour', 'minute', 'second'], '_label':'MONITOR_SETTING_WIDGET_INTERVAL', '_tooltip':'MONITOR_SETTING_WIDGET_INTERVAL_TOOLTIP'}, dockSummary:{settingType:'list', '_valueList':[{label:'MONITOR_DOCK_SUMMARY_INLINE', value:''}, {label:'MONITOR_DOCK_SUMMARY_TOP', value:'top'}, {label:'MONITOR_DOCK_SUMMARY_BOTTOM', value:'bottom'}], '_label':'MONITOR_SETTING_WIDGET_SUMMARY_DOCK', '_tooltip':'MONITOR_SETTING_WIDGET_SUMMARY_DOCK_TOOLTIP'}, 
graphType:{settingType:'list', '_valueList':[{label:'MONITOR_LINE_GRAPH', value:'line'}, {label:'MONITOR_COLUMN_GRAPH', value:'column'}], '_label':'MONITOR_SETTING_WIDGET_GRAPH_TYPE', '_tooltip':'MONITOR_SETTING_WIDGET_GRAPH_TYPE_TOOLTIP'}}, defaultWidgetConfiguration:{startDate:'now-7d/d', dateFormat:'d.m.', dataRefreshBuffer:10, endDate:'now', interval:'day', title:BpcCommon.lang.Current.MONITOR_WIDGET_PROCESS_OVERVIEW_TIMEFRAME, viewMode:'tabbed', hideEmptyRows:false, hideZeroValues:true, showPreviousData:false, 
showFollowingData:false, cellAlign:'center', chartConfiguration:{categoryAxis:{dateFormats:[{period:'fff', format:'JJ:NN:SS'}, {period:'ss', format:'JJ:NN:SS'}, {period:'mm', format:'JJ:NN'}, {period:'hh', format:'DD.MM.'}, {period:'DD', format:'DD.MM.'}, {period:'WW', format:'MMM DD'}, {period:'MM', format:'MMM YYYY'}, {period:'YYYY', format:'YYYY'}], parseDates:true, minPeriod:'ss', markPeriodChange:false, labelRotation:90, equalSpacing:true}, fixedColumnWidth:20, categoryField:'date', valueAxes:[{integersOnly:true, 
axisAlpha:0.3, gridAlpha:0, stackType:'regular'}], legend:{position:'bottom', useGraphSettings:true, align:'center', markerType:'circle'}, language:'de', theme:'none', 'export':{language:'de', enabled:true}}, dockSummary:'', graphType:'column'}, layout:'card', activeItem:0, items:[{html:'\x3ci class\x3d"fa fa-spinner fa-spin fa-3x fa-fw margin-bottom"\x3e\x3c/i\x3e Chart wird geladen'}], title:false, plugins:{monitorCustomRenderer:true}, initComponent:function() {
  this.initWidgetSettings();
  this.callParent(arguments);
  this.initWidget();
  this.getLayout().setActiveItem(this.contentPanel);
  var vm = this.lookupViewModel();
  vm.bind({bindTo:'{global.dateRange}', deep:true}, Ext.Function.createBuffered(this.handleGlobalDateRange, 100, this));
  this.handleGlobalDateRange(true);
}, initWidget:function() {
  var me = this;
  try {
    var moduleId = this.moduleId;
    var widgetId = this.getWidgetId();
    var components = null;
    if (this.contentPanel) {
      this.remove(this.contentPanel);
      delete this.contentPanel;
    }
    if (!moduleId) {
      this.contentPanel = this.add(this.getWrongConfigPanel(monitor.widget['abstract'].MonitorWidget.MONITOR_ID_MISSING));
      this.getLayout().setActiveItem(this.contentPanel);
      return;
    } else {
      if (!BpcCommon.Api.getModuleModel(moduleId) || BpcCommon.Api.getModuleModel(moduleId).getModuleConfiguration().get('moduleId') !== 'monitor') {
        this.contentPanel = this.add(this.monitorNotFoundPanel);
        this.getLayout().setActiveItem(this.contentPanel);
        return;
      }
    }
    var columnName = String(this.getSetting('aggregationColumn')).trim();
    var monitorColumnConfig = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnConfig);
    me.columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
      return colConfig.id === columnName;
    });
    if (!me.columnConfig) {
      me.columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
        return colConfig.dataIndex === columnName;
      });
    }
    if (!me.columnConfig) {
      this.contentPanel = this.add(this.getWrongConfigPanel(monitor.widget['abstract'].MonitorWidget.COLUMN_CONFIG_MISSING));
      this.getLayout().setActiveItem(this.contentPanel);
      return;
    }
    me.monitorCustomRenderer = me.findPlugin('monitorCustomRenderer');
    me.customRendererId = me.monitorCustomRenderer.getRendererIdByColumnConfig(me.columnConfig);
    me.customColumnRenderer = me.monitorCustomRenderer.getColumnRenderer(me.customRendererId);
    if (this.getSettingFromModuleInstance(monitor.assets.ConfigKeys.gridMultipleViews) === true) {
      var multiConf = this.getSettingFromModuleInstance(monitor.assets.ConfigKeys.gridMultipleViewsConfig);
      var enabledViewStr = this.getSetting('views') || '';
      var showAllViews = enabledViewStr.length === 0;
      var enabledViewArr = enabledViewStr.split(',').map(Ext.String.trim);
      var widgetViews = [];
      var tabPanel = {xtype:'tabpanel', tabPosition:Ext.isDefined(multiConf.tabPosition) ? multiConf.tabPosition : 'top', activeTab:0, items:[]};
      Ext.Array.each(multiConf.views, function(view) {
        if (BpcCommon.Api.isUserAllowedToSee(view)) {
          if (showAllViews || Ext.Array.contains(enabledViewArr, view.id)) {
            widgetViews.push({xtype:'monitorTimeseriesAggregationMonitorView', moduleId:moduleId, viewObj:view, title:view.title ? view.title : view.id, widgetId:widgetId});
          }
        }
      });
      if (widgetViews.length > 1) {
        tabPanel.items = widgetViews;
        var activeTab = 0;
        var initialView = this.getSetting('initialView');
        if (initialView) {
          var viewId = initialView.split(':')[0];
          if (viewId) {
            Ext.Array.each(widgetViews, function(viewConf, index) {
              if (viewConf.viewObj.id === viewId) {
                activeTab = index;
                return false;
              }
            });
          }
        }
        tabPanel.activeTab = activeTab;
      } else {
        if (widgetViews.length === 1) {
          delete widgetViews[0].title;
          tabPanel = widgetViews[0];
        } else {
          tabPanel.items = [{xtype:'box', padding:'10 10 10 10', title:BpcCommon.Api.getTranslation('MONITOR_PROCESS_CHECK_CONFIG'), html:BpcCommon.Api.getTranslation({tpl:'\x3cbr\x3e\x3cbr\x3e{MONITOR_PROCESS_NO_VIEWS}\x3cbr\x3e\x3cbr\x3e' + '{MONITOR_PROCESS_CHECK_FLEX_MON_VIEW}', keys:['MONITOR_PROCESS_NO_VIEWS', 'MONITOR_PROCESS_CHECK_FLEX_MON_VIEW']})}];
        }
      }
      components = tabPanel;
    } else {
      components = {xtype:'monitorTimeseriesAggregationMonitorView', moduleId:moduleId, widgetId:widgetId};
    }
    this.contentPanel = this.add(components);
    this.getLayout().setActiveItem(this.contentPanel);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initWidget', dump:e, stack:true, level:'error'});
  }
}, refreshWidget:function(options) {
  var tabs = this.query('monitorTimeseriesAggregationMonitorView');
  if (tabs.length > 0) {
    Ext.Array.each(tabs, function(tab) {
      tab.refreshWidget(options);
    });
  }
}, handleGlobalDateRange:function(init) {
  var dateRangeState = BpcCommon.Api.getGlobalViewModel().get('global.dateRange');
  if (init === true) {
    this.oldDataRangeState = dateRangeState.active;
  }
  if (dateRangeState.active === true) {
    if (dateRangeState.value && (dateRangeState.value.start || dateRangeState.value.end)) {
      var options = {};
      if (dateRangeState.value.start) {
        options.startDate = dateRangeState.value.start;
      }
      if (dateRangeState.value.end) {
        options.endDate = dateRangeState.value.end;
      }
      this.oldDataRangeState = true;
      this.refreshWidget(options);
    }
  } else {
    if (this.oldDataRangeState === true) {
      this.oldDataRangeState = false;
      this.refreshWidget();
    }
  }
}});
Ext.define('monitor.widget.processPreview.Table', {alternateClassName:['monitor.widget.monitorWidget.Table'], extend:'monitor.widget.abstract.MonitorWidget', alias:'widget.monitorDashboardWidget', statics:{WIDGET_NAME:BpcCommon.lang.Current.MONITOR_PROCESS_PREVIEW, WIDGET_DESCRIPTION:BpcCommon.lang.Current.MONITOR_PROCESS_PREVIEW_TABLE_DESCRIPTION, WIDGET_ICON_CLS:'x-fal fa-table'}, widgetConfigSettingMap:{columnList:{moduleSettingName:monitor.assets.ConfigKeys.columnId, '_label':'MONITOR_SETTING_WIDGET_COLUMN_LIST', 
'_tooltip':'MONITOR_SETTING_WIDGET_COLUMN_LIST_TOOLTIP'}, timeseriesColumn:{moduleSettingName:monitor.assets.ConfigKeys.columnTimeseries, '_label':'MONITOR_SETTING_WIDGET_TIMESERIES_COLUMN', '_tooltip':'MONITOR_SETTING_WIDGET_TIMESERIES_COLUMN_TOOLTIP'}, views:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_VIEWS', '_tooltip':'MONITOR_SETTING_WIDGET_VIEWS_TOOLTIP'}, goTo:{settingType:'boolean', '_label':'MONITOR_SETTING_WIDGET_JUMP_COLUMN', '_tooltip':'MONITOR_SETTING_WIDGET_JUMP_COLUMN_TOOLTIP'}, 
moduleId:{settingType:'moduleInstance', '_label':'MONITOR_SETTING_WIDGET_MODULE_ID', '_tooltip':'MONITOR_SETTING_WIDGET_MODULE_ID_TOOLTIP'}, startDate:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_START_DATE', '_tooltip':'MONITOR_SETTING_WIDGET_START_DATE_TOOLTIP'}, endDate:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_END_DATE', '_tooltip':'MONITOR_SETTING_WIDGET_END_DATE_TOOLTIP'}, pageSize:{settingType:'number', '_label':'MONITOR_SETTING_WIDGET_PAGE_SIZE', '_tooltip':'MONITOR_SETTING_WIDGET_PAGE_SIZE_TOOLTIP'}}, 
defaultWidgetConfiguration:{startDate:'now-1h', endDate:'now', goTo:true, pageSize:25}, minHeight:100, layout:'card', activeItem:0, items:[{html:'\x3ci class\x3d"fa fa-spinner fa-spin fa-3x fa-fw margin-bottom"\x3e\x3c/i\x3e Daten werden geladen'}], rendererColumn:undefined, title:false, plugins:{monitorCustomRenderer:true}, initComponent:function() {
  this.initWidgetSettings();
  this.callParent();
  this.initWidget();
  this.getLayout().setActiveItem(this.contentPanel);
}, initWidget:function() {
  try {
    var me = this;
    var moduleId = this.moduleId;
    if (this.contentPanel) {
      this.remove(this.contentPanel);
      delete this.contentPanel;
    }
    if (!moduleId) {
      this.contentPanel = this.add(this.getWrongConfigPanel(monitor.widget['abstract'].MonitorWidget.MONITOR_ID_MISSING));
      this.getLayout().setActiveItem(this.contentPanel);
      return;
    } else {
      if (!BpcCommon.Api.getModuleModel(moduleId) || BpcCommon.Api.getModuleModel(moduleId).getModuleConfiguration().get('moduleId') !== 'monitor') {
        this.contentPanel = this.add(this.monitorNotFoundPanel);
        this.getLayout().setActiveItem(this.contentPanel);
        return;
      }
    }
    var viewMenu = {xtype:'monitorStateSelectionMenu', stateSelectFn:me.setMonitorState.bind(me), stateResetFn:me.setMonitorState.bind(me), moduleId:moduleId};
    if (BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.gridMultipleViews) === true) {
      var multiConf = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.gridMultipleViewsConfig);
      var tabPanel = {xtype:'tabpanel', tabPosition:multiConf.tabPosition || 'top', activeTab:0, minHeight:100, items:[], tabBar:{items:[{xtype:'tbfill'}, viewMenu]}};
      var widgetViewsStr = this.getSetting('views') || '';
      var widgetViewsArray = widgetViewsStr.split(',').map(Ext.String.trim);
      var showAllViews = widgetViewsStr.length === 0 ? true : false;
      var tabs = [];
      Ext.Array.each(multiConf.views, function(view) {
        if (BpcCommon.Api.isUserAllowedToSee(view)) {
          if (showAllViews || Ext.Array.contains(widgetViewsArray, view.id)) {
            tabs.push(me.createGrid(moduleId, view, true));
          }
        }
      });
      if (tabs.length > 1) {
        tabPanel.items = tabPanel.items.concat(tabs);
        this.contentPanel = this.add(tabPanel);
      } else {
        if (tabs.length === 1) {
          this.contentPanel = this.add(tabs[0]);
        }
      }
    } else {
      var gridObj = this.createGrid(moduleId, 'mainGrid');
      gridObj.header = {items:[{xtype:'tbfill'}, viewMenu]};
      this.contentPanel = this.add(gridObj);
    }
    this.getLayout().setActiveItem(this.contentPanel);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initWidget', dump:e, stack:true, level:'error'});
  }
}, createGrid:function(moduleId, viewObj, multi) {
  try {
    var widgetId = this.getWidgetId();
    return {xtype:'monitorWidgetGridCmp', moduleId:moduleId, viewObj:viewObj, multi:multi, widgetId:widgetId};
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createGrid', dump:e, stack:true, level:'error'});
  }
}, refreshWidget:function() {
  Ext.log(this.self.getName() + ': refreshWidget');
  var grids = this.query('monitorWidgetGridCmp');
  if (grids.length > 0) {
    Ext.Array.each(grids, function(grid) {
      if (grid.refreshGrid && typeof grid.refreshGrid === 'function') {
        grid.refreshGrid();
      }
    });
  }
}, setMonitorState:function(source, moduleId, state) {
  var me = this;
  me.query('monitorWidgetGridCmp').forEach(function(gridCmp) {
    var stateObj = {};
    if (state && state.state) {
      stateObj = state.state;
    } else {
      if (state && state.views) {
        stateObj = state.views[moduleId + '_' + gridCmp.bpcGridViewName];
      }
    }
    stateObj.storeState = stateObj.storeState || {};
    Ext.applyIf(stateObj.storeState, {filters:[], sorters:[]});
    gridCmp.applyState(stateObj);
  });
}});
Ext.define('monitor.widget.columnAggregation.CircleController', {extend:'Ext.app.ViewController', alias:'controller.circleController', updateOverViewData:function(source) {
  try {
    this.moduleId = this.getView().getSetting('moduleId');
    var target = this.getView().down('monitorWidgetColAggOverview');
    if (target && source && source.moduleId && source.moduleId === this.moduleId) {
      var sourceCmps = this.getView().query('monitorWidgetCircleTab');
      var dataArray = [];
      Ext.Array.each(sourceCmps, function(sourceCmp) {
        var view = '';
        if (sourceCmp.viewObj && sourceCmp.viewObj.title) {
          view = sourceCmp.viewObj.title;
        }
        var record = {view:view};
        sourceCmp.store.each(function(i) {
          record[i.get('value')] = i.get('count');
        });
        dataArray.push(record);
      }, this);
      target.store.loadData(dataArray);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateOverViewData', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.widget.columnAggregation.Circle', {extend:'monitor.widget.abstract.MonitorWidget', alias:'widget.monitorWidgetColAgg', requires:['monitor.widget.columnAggregation.CircleController'], controller:'circleController', statics:{WIDGET_NAME:BpcCommon.lang.Current.MONITOR_PROCESS_CIRCLE_TOTAL, WIDGET_DESCRIPTION:BpcCommon.lang.Current.MONITOR_PROCESS_CIRCLE_AGGREGATION_ALL_DATA, WIDGET_ICON_CLS:'x-fal fa-chart-pie'}, widgetConfigSettingMap:{column:{moduleSettingName:monitor.assets.ConfigKeys.columnStatus, 
'_label':'MONITOR_SETTING_WIDGET_AGGREGATION_COLUMN', '_tooltip':'MONITOR_SETTING_WIDGET_AGGREGATION_COLUMN_TOOLTIP'}, '3d':{settingType:'boolean', '_label':'MONITOR_SETTING_WIDGET_3D', '_tooltip':'MONITOR_SETTING_WIDGET_3D_TOOLTIP'}, initialView:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_INITIAL_VIEW', '_tooltip':'MONITOR_SETTING_WIDGET_INITIAL_VIEW_TOOLTIP'}, chartConfiguration:{settingType:'json', '_label':'MONITOR_SETTING_WIDGET_CHART_CONFIGURATION', '_tooltip':'MONITOR_SETTING_WIDGET_CHART_CONFIGURATION_TOOLTIP'}, 
hideZeroValues:{settingType:'bool', '_label':'MONITOR_SETTING_WIDGET_HIDE_ZERO_VALUES', '_tooltip':'MONITOR_SETTING_WIDGET_HIDE_ZERO_VALUES_TOOLTIP'}, cellAlign:{settingType:'list', '_valueList':['right', 'left', 'center'], '_label':'MONITOR_SETTING_WIDGET_CELL_ALIGN', '_tooltip':'MONITOR_SETTING_WIDGET_CELL_ALIGN_TOOLTIP'}, aggregationLimit:{settingType:'int', '_label':'MONITOR_SETTING_WIDGET_AGGREGATION_LIMIT', '_tooltip':'MONITOR_SETTING_WIDGET_AGGREGATION_LIMIT_TOOLTIP'}, excludedValues:{settingType:'text', 
'_label':'MONITOR_SETTING_WIDGET_EXCLUDED_VALUES', '_tooltip':'MONITOR_SETTING_WIDGET_EXCLUDED_VALUES_TOOLTIP'}, hiddenGraphs:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_HIDDEN_GRAPHS', '_tooltip':'MONITOR_SETTING_WIDGET_HIDDEN_GRAPHS_TOOLTIP'}, views:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_VIEWS', '_tooltip':'MONITOR_SETTING_WIDGET_VIEWS_TOOLTIP'}, viewMode:{settingType:'list', '_valueList':['tabbed', 'stacked', 'chartOnly', 'tableOnly'], '_label':'MONITOR_SETTING_WIDGET_VIEWMODE', 
'_tooltip':'MONITOR_SETTING_WIDGET_VIEWMODE_TOOLTIP'}, dataRefreshBuffer:{settingType:'int', '_label':'MONITOR_SETTING_WIDGET_LABEL_DATA_REFRESHBUFFER', '_tooltip':'MONITOR_SETTING_WIDGET_LABEL_DATA_REFRESHBUFFER_TOOLTIP'}, moduleId:{settingType:'moduleInstance', '_label':'MONITOR_SETTING_WIDGET_MODULE_ID', '_tooltip':'MONITOR_SETTING_WIDGET_MODULE_ID_TOOLTIP'}, timeseriesColumn:{moduleSettingName:monitor.assets.ConfigKeys.columnTimeseries, '_label':'MONITOR_SETTING_WIDGET_TIMESERIES_COLUMN', '_tooltip':'MONITOR_SETTING_WIDGET_TIMESERIES_COLUMN_TOOLTIP'}, 
startDate:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_START_DATE', '_tooltip':'MONITOR_SETTING_WIDGET_START_DATE_TOOLTIP'}, endDate:{settingType:'text', '_label':'MONITOR_SETTING_WIDGET_END_DATE', '_tooltip':'MONITOR_SETTING_WIDGET_END_DATE_TOOLTIP'}, dockSummary:{settingType:'list', '_valueList':['', 'top', 'bottom'], '_label':'MONITOR_SETTING_WIDGET_SUMMARY_DOCK', '_tooltip':'MONITOR_SETTING_WIDGET_SUMMARY_DOCK_TOOLTIP'}}, defaultWidgetConfiguration:{hideZeroValues:true, cellAlign:'center', 
aggregationLimit:10, '3d':true, dataRefreshBuffer:10, chartConfiguration:{'labelRadius':2, 'language':'de', 'export':{'language':'de', 'enabled':true}, 'marginTop':5}, dockSummary:''}, layout:'card', activeItem:0, title:false, minHeight:100, plugins:{monitorCustomRenderer:true}, initComponent:function() {
  this.initWidgetSettings();
  this.callParent();
  this.widgetId = this.getWidgetId();
  this.initWidget();
  this.getLayout().setActiveItem(this.contentPanel);
  var vm = this.lookupViewModel();
  vm.bind({bindTo:'{global.dateRange}', deep:true}, Ext.Function.createBuffered(this.handleGlobalDateRange, 100, this));
  this.handleGlobalDateRange(true);
}, initWidget:function() {
  try {
    var moduleId = this.moduleId;
    var me = this;
    if (this.contentPanel) {
      this.remove(this.contentPanel);
      delete this.contentPanel;
    }
    if (!moduleId) {
      this.contentPanel = this.add(this.getWrongConfigPanel(monitor.widget['abstract'].MonitorWidget.MONITOR_ID_MISSING));
      this.getLayout().setActiveItem(this.contentPanel);
      return;
    } else {
      if (!BpcCommon.Api.getModuleModel(moduleId) || BpcCommon.Api.getModuleModel(moduleId).getModuleConfiguration().get('moduleId') !== 'monitor') {
        this.contentPanel = this.add(this.monitorNotFoundPanel);
        this.getLayout().setActiveItem(this.contentPanel);
        return;
      }
    }
    var columnName = String(this.getSetting('column')).trim();
    var monitorColumnConfig = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnConfig);
    me.columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
      return colConfig.id === columnName;
    });
    if (!me.columnConfig) {
      me.columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
        return colConfig.dataIndex === columnName;
      });
    }
    if (!me.columnConfig) {
      this.contentPanel = this.add(this.getWrongConfigPanel(monitor.widget['abstract'].MonitorWidget.COLUMN_CONFIG_MISSING));
      this.getLayout().setActiveItem(this.contentPanel);
      return;
    }
    me.columnRenderer = me.findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(me.columnConfig);
    me.columnRendererId = me.findPlugin('monitorCustomRenderer').getRendererIdByColumnConfig(me.columnConfig);
    if (BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.gridMultipleViews) === true) {
      var multiConf = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.gridMultipleViewsConfig);
      var tabPanel = {xtype:'tabpanel', tabPosition:Ext.isDefined(multiConf.tabPosition) ? multiConf.tabPosition : 'top', activeTab:0, items:[]};
      var enabledViewStr = this.getSetting('views') || '';
      var showAllViews = enabledViewStr.length === 0 ? true : false;
      var enabledViewArr = enabledViewStr.split(',').map(Ext.String.trim);
      var widgetViews = [];
      Ext.Array.each(multiConf.views, function(view) {
        if (BpcCommon.Api.isUserAllowedToSee(view)) {
          if (showAllViews || Ext.Array.contains(enabledViewArr, view.id)) {
            widgetViews.push({xtype:'monitorWidgetCircleTab', widgetId:me.widgetId, moduleId:moduleId, viewObj:view, viewId:view.id, title:view.title ? view.title : view.id, tabConfig:{tooltip:view.id}});
          }
        }
      });
      if (widgetViews.length > 1) {
        tabPanel.items.push({xtype:'monitorWidgetColAggOverview', storeId:'overView' + moduleId, moduleId:moduleId});
        tabPanel.items = tabPanel.items.concat(widgetViews);
        var initViewStr = this.getSetting('initialView') || '';
        var initViewArr = initViewStr.split(':');
        if (initViewStr.length > 0) {
          var viewId = initViewArr[0];
          var activeTab = 0;
          Ext.Array.each(tabPanel.items, function(item, index) {
            if (item.viewId === viewId) {
              activeTab = index;
              return false;
            }
          });
          tabPanel.activeTab = activeTab;
        }
        this.contentPanel = this.add(tabPanel);
      } else {
        if (widgetViews.length === 1) {
          delete widgetViews[0].title;
          this.contentPanel = this.add(widgetViews[0]);
        } else {
          this.contentPanel = this.add({xtype:'box', padding:'10 10 10 10', title:BpcCommon.Api.getTranslation('MONITOR_PROCESS_CHECK_CONFIG'), html:BpcCommon.Api.getTranslation({tpl:'\x3cbr\x3e\x3cbr\x3e{MONITOR_PROCESS_CHECK_CONFIG_HTML1} \x3cbr\x3e\x3cbr\x3e' + '{MONITOR_PROCESS_CHECK_CONFIG_HTML2}', keys:['MONITOR_PROCESS_CHECK_CONFIG_HTML1', 'MONITOR_PROCESS_CHECK_CONFIG_HTML2']})});
        }
      }
    } else {
      this.contentPanel = this.add({xtype:'monitorWidgetCircleTab', moduleId:moduleId, widgetId:me.widgetId, activeTab:0});
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initWidget', dump:e, stack:true, level:'error'});
  }
}, refreshWidget:function(options) {
  var me = this;
  try {
    this.cascade(function(child) {
      if (child !== me && Ext.isFunction(child.refreshWidget)) {
        child.refreshWidget(options);
      }
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshWidget', dump:e, stack:true, level:'error'});
  }
}, handleGlobalDateRange:function(init) {
  var dateRangeState = BpcCommon.Api.getGlobalViewModel().get('global.dateRange');
  if (init === true) {
    this.oldDataRangeState = dateRangeState.active;
  }
  if (dateRangeState.active === true) {
    if (dateRangeState.value && (dateRangeState.value.start || dateRangeState.value.end)) {
      var options = {};
      if (dateRangeState.value.start) {
        options.startDate = dateRangeState.value.start;
      }
      if (dateRangeState.value.end) {
        options.endDate = dateRangeState.value.end;
      }
      this.oldDataRangeState = true;
      this.refreshWidget(options);
    }
  } else {
    if (this.oldDataRangeState === true) {
      this.oldDataRangeState = false;
      this.refreshWidget();
    }
  }
}});
Ext.define('monitor.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['monitor.widget.timeseriesAggregation.TimeseriesAggregation', 'monitor.widget.processPreview.Table', 'monitor.widget.columnAggregation.Circle'], config:{moduleConfigurationComponents:['monitorGlobalStateConfigurationPanel', 'monitorTableViewConfigurationContainer'], requiredModules:[], widgets:['monitor.widget.timeseriesAggregation.TimeseriesAggregation', 'monitor.widget.processPreview.Table', 'monitor.widget.columnAggregation.Circle']}});
Ext.define('monitor.controller.RowStyleController', {extend:'Ext.app.Controller', init:function() {
  this.createStylesheets();
}, createStylesheets:function() {
  try {
    var monitorInstances = BpcCommon.Api.getModuleInstances('monitor');
    monitorInstances.each(this.createStylesheetForMonitor, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createStylesheets', dump:e, stack:true, level:'error'});
  }
}, createStylesheetForMonitor:function(monitorInstance) {
  var $jscomp$this = this;
  var monitorId = monitorInstance.id;
  try {
    if (!BpcCommon.Api.getSetting(monitorId, monitor.assets.ConfigKeys.rowStyleEnabled)) {
      return;
    }
    var rowStyleSettings = BpcCommon.Api.getSetting(monitorId, monitor.assets.ConfigKeys.rowStyle);
    if (rowStyleSettings && Ext.isArray(rowStyleSettings) && rowStyleSettings.length !== 0) {
      Ext.Array.each(rowStyleSettings, function(setting) {
        var rowClasses = setting.rowClasses;
        var applyToViews = setting.views;
        if (applyToViews && applyToViews.length > 0) {
          Ext.Array.each(applyToViews, function(viewId) {
            $jscomp$this.createStyleSheet(monitorId + viewId, rowClasses);
          });
        } else {
          $jscomp$this.createStyleSheet(monitorId, setting.rowClasses);
        }
      });
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createStylesheetForMonitor', dump:e, stack:true, level:'error'});
  }
}, createStyleSheet:function(styleId, styles) {
  try {
    styles = styles || '';
    var styleSheetId = styleId + 'rowStyle';
    Ext.util.CSS.removeStyleSheet(styleSheetId);
    styles = styles.replace(/\.-/g, '._' + styleId + '-');
    Ext.util.CSS.createStyleSheet(styles, styleId);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createStyleSheet', dump:e, stack:true, level:'error'});
  }
}, getRowClass:function(monitorId, viewId, record, rowIndex, rowParams, store) {
  var baseRowClass = 'monitorGrid-row ';
  var classes = baseRowClass;
  try {
    var grid = this;
    if (!BpcCommon.Api.getSetting(monitorId, monitor.assets.ConfigKeys.rowStyleEnabled)) {
      return baseRowClass;
    }
    var addClassFn = function(column, shouldApplyAllView) {
      column = column || '';
      var value = record.get(column) || '';
      value = value.toUpperCase();
      var splitArray = column.split('-');
      splitArray.push(store.bpcGridViewId);
      if (BpcCommon.Util.isStringEqual(splitArray[0], 'tpl') && splitArray[1]) {
        var columnId = splitArray.slice(1).join('-');
        var columnObject = grid.getColumnManager().getHeaderById(columnId);
        if (columnObject && Ext.isFunction(columnObject.renderer)) {
          value = String(columnObject.renderer(record.get(columnObject.dataIndex), {}, record)).toUpperCase();
        }
      }
      if (shouldApplyAllView) {
        classes = classes + ' _' + [id, column, value].join('-');
      } else {
        classes = classes + ' _' + [id + viewId, column, value].join('-');
      }
    };
    var rowStyleSettings = BpcCommon.Api.getSetting(monitorId, monitor.assets.ConfigKeys.rowStyle);
    var id = monitorId;
    if (rowStyleSettings && Ext.isArray(rowStyleSettings) && rowStyleSettings.length !== 0) {
      Ext.Array.each(rowStyleSettings, function(setting) {
        if (setting.columnList) {
          Ext.Array.each(setting.columnList, function(column) {
            var shouldApplyAllView = !setting.views || setting.views.length === 0;
            addClassFn(column, shouldApplyAllView);
          });
        }
      });
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getRowClass', dump:e, stack:true, level:'error'});
  }
  return classes;
}});
Ext.define('monitor.controller.StateController', {extend:'Ext.app.Controller', settingMap:{}, addState:function(moduleId, state) {
  var me = this;
  var stateCollection = me.getStateCollection(moduleId);
  state = state || me.getCurrentState(moduleId);
  var addedState = stateCollection.add(state);
  me.setState(moduleId, stateCollection.getRange());
  return addedState;
}, updateState:function(moduleId, state) {
  var me = this;
  var stateCollection = me.getStateCollection(moduleId);
  state = state || me.getCurrentState(moduleId);
  stateCollection.replace(state);
  me.setState(moduleId, stateCollection.getRange());
}, setState:function(moduleId, state) {
  var me = this;
  var stateCollection = me.getStateCollection(moduleId);
  var stateSettingModel = me.getStateSettingModel(moduleId);
  state = state || me.getCurrentState(moduleId);
  stateCollection.removeAll();
  stateCollection.add(state);
  stateSettingModel.set('value', stateCollection.getRange());
  stateSettingModel.save({success:BpcCommon.Api.showNotification.bind(BpcCommon.Api, {type:'INFO', text:'MONITOR_VIEW_SAVED'}), failure:BpcCommon.Api.showNotification.bind(BpcCommon.Api, {type:'ERROR', text:'MONITOR_ERROR_SAVING_VIEW'})});
}, getCurrentState:function(moduleId) {
  var me = this;
  var moduleInstanceCmp = Ext.first('bpcMonitor[moduleId\x3d' + moduleId + ']');
  if (moduleInstanceCmp) {
    return me.cleanStateObject(moduleInstanceCmp.getState());
  }
}, resetState:function(moduleId) {
  try {
    var monitor$3 = Ext.first('bpcMonitor[moduleId\x3d' + moduleId + ']');
    if (monitor$3) {
      monitor$3.resetState();
    } else {
      Ext.state.Manager.set('monitorMainView_' + moduleId, {stateReset:true});
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR resetState', dump:e, stack:true, level:'error'});
  }
}, applyState:function(moduleId, state) {
  try {
    var targetMonitor = Ext.first('bpcMonitor[moduleId\x3d' + moduleId + ']');
    targetMonitor.applyState(this.cleanStateObject(state));
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR applyState', dump:e, stack:true, level:'error'});
  }
}, cleanStateObject:function(state) {
  state = state || {};
  if (state instanceof Ext.data.Model) {
    state = state.getData();
  }
  state.id = state.id || (new Date).getTime();
  delete state.activeStateDirty;
  return state;
}, getStateSettingModel:function(moduleId) {
  var me = this;
  if (!me.settingMap[moduleId]) {
    me.settingMap[moduleId] = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.viewStates, true);
  }
  return me.settingMap[moduleId];
}, getStateCollection:function(moduleId) {
  var me = this;
  var stateCollection = new Ext.util.Collection({decoder:me.cleanStateObject.bind(me)});
  var stateArray = me.getStateSettingModel(moduleId).get('value') || [];
  stateCollection.add(stateArray);
  return stateCollection;
}, getState:function(moduleId, stateId) {
  var me = this;
  var stateCollection = me.getStateCollection(moduleId);
  return stateCollection.get(stateId);
}, compareState:function(state1, state2) {
  if (state1 === state2) {
    return true;
  } else {
    if (!state1 && state2 || state1 && !state2) {
      return false;
    }
  }
  var compareState1 = {views:state1 ? state1.views : []};
  var compareState2 = {views:state2 ? state2.views : []};
  return state1.searchQuery === state2.searchQuery && BpcCommon.Util.compareObject(compareState1, compareState2);
}});
Ext.define('monitor.store.NumericOperatorStore', {extend:'Ext.data.Store', storeId:'numericOperatorStore', fields:['id', 'text'], data:[{id:'lt', text:'\x3c'}, {id:'lte', text:'\x3c\x3d'}, {id:'\x3d', text:'\x3d'}, {id:'gt', text:'\x3e'}, {id:'gte', text:'\x3e\x3d'}]});
Ext.define('monitor.Module', {singleton:true, requires:['monitor.widget.timeseriesAggregation.TimeseriesAggregation', 'monitor.widget.columnAggregation.Circle', 'monitor.assets.ConfigKeys', 'monitor.controller.RowStyleController', 'monitor.controller.StateController', 'monitor.store.NumericOperatorStore'], constructor:function() {
  try {
    this.rowStyleController = Ext.getApplication().getController('monitor.controller.RowStyleController');
    this.stateController = Ext.getApplication().getController('monitor.controller.StateController');
    Ext.create('monitor.store.NumericOperatorStore');
    var showMonitorSearchFieldButton = false;
    if (Ext.state.Manager.get('monitorSearchFieldButton') && Ext.isBoolean(Ext.state.Manager.get('monitorSearchFieldButton').pressed)) {
      showMonitorSearchFieldButton = Ext.state.Manager.get('monitorSearchFieldButton').pressed;
    }
    BpcCommon.Api.getGlobalViewModel().set('global.monitor.showSearchField', showMonitorSearchFieldButton);
  } catch (e) {
    Ext.log({msg:'monitor.Module: ERROR constructor', dump:e, stack:true, level:'error'});
  }
}, testRenderer:function() {
  return function(value) {
    return 'Tested_' + value;
  };
}});
Ext.define('monitor.Util', {singleton:true, createFilterObj:function(property, value, anyMatch, type, source, operator) {
  var filter;
  try {
    if (!type) {
      type = 'text';
    }
    if (!source) {
      source = 'analyzed';
    }
    if (!anyMatch) {
      anyMatch = false;
    }
    if (!operator) {
      operator = 'analyzed';
    }
    if (Array.isArray(value)) {
      filter = {property:property, operator:operator, value:value, source:source};
    } else {
      filter = {property:property, value:value, type:type, source:source};
    }
  } catch (e) {
    Ext.log('Fehler beim Erstellen des Filters' + e);
    filter = {};
  }
  return filter;
}, ajaxGetCall:function(url, callback) {
  Ext.Ajax.request({url:url, method:'GET', callback:function(options, success, response) {
    var responseData = '';
    if (success) {
      try {
        responseData = Ext.JSON.decode(response.responseText);
      } catch (e) {
        Ext.log({msg:'Monitor: Invalid json configured: ' + e, level:'warn'});
      }
    }
    if (callback) {
      callback(success, responseData);
    }
  }});
}, toXML:function(value) {
  return Ext.util.Format.htmlEncode(value);
}, toAtomXML:function(name, value) {
  return '\x3c' + name + '\x3e' + this.toXML(value) + '\x3c/' + name + '\x3e';
}, toBeginXML:function(name, type) {
  if (type === 'atom' || Ext.isEmpty(type)) {
    type = '';
  } else {
    type = ' type\x3d"' + this.toXML(type) + '"';
  }
  return '\x3c' + name + type + '\x3e';
}, toEndXML:function(name) {
  return '\x3c/' + name + '\x3e';
}, parseXML:function(dataInString) {
  if (window.DOMParser) {
    return (new window.DOMParser).parseFromString(dataInString, 'text/xml');
  } else {
    if (typeof window.ActiveXObject !== 'undefined' && new window.ActiveXObject('Microsoft.XMLDOM')) {
      var xmlDoc = new window.ActiveXObject('Microsoft.XMLDOM');
      xmlDoc.async = 'false';
      xmlDoc.loadXML(dataInString);
      return xmlDoc;
    }
  }
  return null;
}, isEmpty:function(element) {
  if (typeof element === 'undefined') {
    return true;
  }
  if (typeof element === 'boolean' && (element === true || element === false)) {
    return false;
  }
  if (element === null) {
    return true;
  }
  if (element.length > 0) {
    return false;
  }
  if (element.length === 0) {
    return true;
  }
  for (var key in element) {
    if (hasOwnProperty.call(element, key)) {
      return false;
    }
  }
  if (typeof element === 'number') {
    return isNaN(element);
  }
  return !element;
}, createRendererFn:function(key, values, globalIconOnly, labelOnly, basic) {
  return function(value, meta, record, testLabelOnly) {
    var styleStr = 'font-size: 18px; margin-right: 3px;';
    var htmlString, icon, color, label;
    var tooltip = '';
    var iconOnly = globalIconOnly ? globalIconOnly : false;
    var rawValue = value;
    testLabelOnly = testLabelOnly ? testLabelOnly : false;
    htmlString = Ext.util.Format.htmlEncode2(value);
    if (Ext.isDefined(value) && value !== null) {
      value = String(value);
      value = value.toLowerCase().trim();
      if (values[value]) {
        if (Ext.isDefined(values[value].iconOnly) && values[value].iconOnly) {
          iconOnly = true;
        }
        icon = values[value].iconCls;
        color = values[value].color;
        label = values[value].label;
      } else {
        if (values['*']) {
          if (Ext.isDefined(values['*'].iconOnly) && values[value].iconOnly) {
            iconOnly = true;
          }
          icon = values['*'].iconCls;
          color = values['*'].color;
          label = values['*'].label;
        }
      }
    } else {
      if (values['!']) {
        if (Ext.isDefined(values['!'].iconOnly) && values[value].iconOnly) {
          iconOnly = true;
        }
        icon = values['!'].iconCls;
        color = values['!'].color;
        label = values['!'].label;
      }
    }
    label = BpcCommon.Api.getTranslation(label);
    if (testLabelOnly === true) {
      return Ext.isDefined(label) ? label : rawValue;
    }
    if (basic) {
      iconOnly = false;
    }
    if (iconOnly) {
      htmlString = "\x3ci class\x3d'" + icon + "' style\x3d'color:" + color + '; ' + styleStr + "'\x3e\x3c/i\x3e";
      label = Ext.isDefined(label) ? label : rawValue;
    } else {
      if (labelOnly) {
        htmlString = Ext.isDefined(label) ? label : rawValue;
      } else {
        if (value === null) {
          value = '';
        }
        label = Ext.isDefined(label) ? label : rawValue;
        htmlString = "\x3ci class\x3d'" + icon + "' style\x3d'color:" + color + '; ' + styleStr + "'\x3e\x3c/i\x3e" + label;
      }
    }
    if (meta) {
      tooltip = Ext.isDefined(label) ? label : rawValue;
      meta.tdAttr = 'data-qtip\x3d"' + tooltip + '"';
    }
    return htmlString;
  };
}, nodeToJsonTree:function(node) {
  var jsonTree = {text:node.nodeName, draggable:false};
  var textValue = '';
  Ext.each(node.childNodes, function(item) {
    if (item.nodeType === 3 && item.textContent.trim() !== '') {
      textValue = textValue + item.textContent.trim() + ' ';
      textValue = textValue.replace(/</g, '\x26lt;');
      textValue = textValue.replace(/>/g, '\x26gt;');
    }
  }, this);
  var attributes = '';
  if (node.attributes) {
    for (var i = 0; i < node.attributes.length; i++) {
      attributes = attributes + node.attributes.item(i).name + '\x3d' + node.attributes.item(i).value + ' ';
    }
  }
  if (attributes.length > 0) {
    jsonTree.text = jsonTree.text + ' (' + attributes + ')';
  }
  if (textValue.length > 0) {
    jsonTree.text = jsonTree.text + ' : \x3cb\x3e' + textValue + '\x3c/b\x3e';
  }
  if (!node.childElementCount || node.childElementCount < 1) {
    jsonTree.leaf = true;
    jsonTree.iconCls = '';
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
  } else {
    jsonTree.leaf = false;
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
    jsonTree.children = [];
    Ext.each(node.childNodes, function(node) {
      if (node.nodeType !== 3) {
        jsonTree.children.push(this.nodeToJsonTree(node));
      }
    }, this);
  }
  return jsonTree;
}, mergeAmChartGraphConfiguration:function(configuration1, configuration2) {
  var valueMap = Ext.Array.toValueMap(configuration1, 'valueField');
  var newValueMap = Ext.Array.toValueMap(configuration2, 'valueField');
  Ext.Array.each(configuration2, function(config) {
    if (config.valueField && !valueMap[config.valueField]) {
      configuration1.push(config);
    }
  });
  Ext.Array.each(configuration1, function(config, index) {
    if (config.valueField && !newValueMap[config.valueField]) {
      configuration1[index].hidden = true;
      configuration1[index].visibleInLegend = false;
    } else {
      configuration1[index].visibleInLegend = true;
    }
  });
  return configuration1;
}, getViewModel:function(startCmpOrViewModel, alias) {
  alias = alias || 'monitorMainViewModel';
  var vm;
  if (startCmpOrViewModel instanceof Ext.Component) {
    vm = startCmpOrViewModel.lookupViewModel();
  } else {
    if (startCmpOrViewModel instanceof Ext.app.ViewModel) {
      vm = startCmpOrViewModel;
    }
  }
  if (vm) {
    if (vm.type === alias) {
      return vm;
    }
    return monitor.Util.getViewModel(vm.getParent(), alias);
  }
}});
Ext.define('monitor.assets.Icons', {singleton:true, PLAY:'x-fal fa-play', TASKS:'x-fal fa-tasks', PROCESS_ACTION:'x-fal fa-indent', REFRESH:'x-fal fa-sync', VIEW:'x-fal fa-browser', DOWNLOAD:'x-fal fa-download', MONITOR:'x-fal fa-table', COLUMN_CONFIGURATOR:'fal fa-game-board-alt'});
Ext.define('monitor.assets.LicenseKeys', {singleton:true, processStarter:'MODULE_MONITOR_PROCESSSTARTER', detailViewSplit:'MODULE_MONITOR_DETAILVIEW_SPLIT', detailViewPopup:'MODULE_MONITOR_DETAILVIEW_POPUP', fullTextQuery:'MODULE_MONITOR_FULLTEXTQUERY'});
Ext.define('monitor.assets.ModuleRights', {singleton:true, editMonitorViews:'bpcmonitor_editmonitorviews', changeProcessState:'bpcmonitor_changeprocessstate', startProcess:'bpcmonitor_startprocess', processAction:'bpcmonitor_processaction'});
Ext.define('BPC.component.grid.DistinctDataMixin', {extend:'Ext.Mixin', getStoreConfig:function() {
  var me = this;
  var newModel = Ext.define(null, {extend:'BPC.component.grid.DistinctDataModel', column:me.column});
  return {proxy:{type:'ajax', url:BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + this.moduleId + '/distinctFieldValues/' + this.column.dataIndex, extraParams:{source:this.source, size:100}, reader:{type:'json', rootProperty:'values'}}, model:newModel, sorters:[{property:'value', transform:Ext.util.Format.uppercase}], moduleId:this.moduleId, listeners:{beforeload:function(store) {
    if (BpcCommon.Api.getSetting(store.moduleId, 'function_filterRespectOtherColumns') === true) {
      store.getProxy().setExtraParam('filter', me.getEncodedFilters());
      store.getProxy().setExtraParam('view', me.grid.bpcGridViewName);
    }
  }}};
}, getEncodedFilters:function() {
  var me = this;
  var grid = me.grid;
  var filters = Ext.clone(grid.store.getFilters().items);
  var columnId = me.column.columnId;
  Ext.each(filters, function(filter, index) {
    var filterId = filter.columnId || filter.getProperty();
    if (filterId === columnId) {
      filters.splice(index, 1);
    }
  });
  var encodedFilters = grid.store.proxy.encodeFilters(filters);
  if (encodedFilters && !Ext.isArray(encodedFilters)) {
    JSON.stringify(encodedFilters);
  }
  return encodedFilters;
}, getBoundListConfig:function() {
  var me = this;
  return {localized:{loadingText:'MONITOR_LOADING_VALUES', emptyText:'MONITOR_NO_DATA_FOUND'}, scrollable:'y', itemId:'distinctDataTagfieldPicker', cls:'distinctDataTagfieldPicker', maxWidth:500, itemTpl:new Ext.XTemplate('\x3ctpl\x3e', '\x3cdiv style\x3d" display: flex; justify-content: space-between; align-items: center;" ' + 'data-qtip\x3d"{[this.returnLabel(values.value)]}"\x3e' + '\x3cdiv class\x3d"tagfieldPicker-checkbox"\x3e\x3c/div\x3e' + '{[this.returnRenderer(values)]}\x3c/div\x3e', '\x3c/tpl\x3e', 
  {returnRenderer:function(values) {
    var returnVal = values.value;
    if (!(me.column instanceof Ext.grid.column.Template) && me.column.renderer) {
      var renderer = me.column.renderer;
      returnVal = renderer(returnVal, false, false, false) || returnVal;
      if (returnVal && values.value !== returnVal && Ext.util.Format.htmlEncode2(values.value) !== returnVal && BpcCommon.util.JsonPointer.get(me, '/column/filter/hideRawValue') !== true) {
        returnVal = returnVal + ' (' + values.value + ')';
      }
    }
    if (values['count']) {
      returnVal = '\x3cspan class\x3d"tagfieldPicker-text" style\x3d"width: 100%; margin-right:15px"\x3e' + returnVal + '\x3c/span\x3e';
      var counter = '\x3cspan class\x3d"tagfieldPicker-count" style\x3d"min-width:16px text-align: right"\x3e' + values['count'] + '\x3c/span\x3e';
      returnVal = returnVal + counter;
    }
    return returnVal;
  }, returnLabel:function(value) {
    if (!(me.column instanceof Ext.grid.column.Template) && me.column.renderer) {
      var renderer = me.column.renderer;
      value = renderer(value, false, false, true) || value;
    }
    return Ext.util.Format.htmlEncode(value);
  }}), tooltipItemTpl:new Ext.XTemplate('\x3ctpl\x3e', '\x3cdiv style\x3d" display: flex; justify-content: space-between; align-items: center;" ' + 'data-qtip\x3d"{[this.returnLabel(values.value)]}"\x3e' + '{[this.returnRenderer(values)]}\x3c/div\x3e', '\x3c/tpl\x3e', {returnRenderer:function(values) {
    var returnVal = values.value;
    if (me.column.renderer) {
      var renderer = me.column.renderer;
      returnVal = renderer(returnVal, false, false, false) || returnVal;
      if (returnVal && values.value !== returnVal && Ext.util.Format.htmlEncode2(values.value) !== returnVal && BpcCommon.util.JsonPointer.get(me, '/column/filter/hideRawValue') !== true) {
        returnVal = returnVal + ' (' + values.value + ')';
      }
    }
    if (values['count']) {
      returnVal = '\x3cspan style\x3d"margin-right:15px"\x3e' + returnVal + '\x3c/span\x3e';
      var counter = '\x3cspan style\x3d"text-align: right"\x3e' + values['count'] + '\x3c/span\x3e';
      returnVal = returnVal + counter;
    }
    return returnVal;
  }, returnLabel:function(value) {
    if (me.column.renderer) {
      var renderer = me.column.renderer;
      value = renderer(value, false, false, true) || value;
    }
    return Ext.util.Format.htmlEncode(value);
  }})};
}, getTooltipListener:function() {
  return {afterrender:function() {
    this.tooltip = Ext.create('Ext.tip.ToolTip', {target:this.id, html:BpcCommon.Api.getTranslation('MONITOR_NO_FILTER_SET'), emptyValue:BpcCommon.Api.getTranslation('MONITOR_NO_FILTER_SET'), listeners:{beforeshow:function(tooltip) {
      var field = tooltip.target.component;
      var store = field.store;
      var valueArray = field.getValue();
      if (valueArray && !Ext.isArray(valueArray)) {
        valueArray = [valueArray];
      } else {
        if (!valueArray) {
          valueArray = [];
        }
      }
      var getDataFn = function(id) {
        var record = store.getAt(store.find('value', id));
        var data;
        if (record) {
          data = record.getData();
        } else {
          data = {value:id, count:''};
        }
        return data;
      };
      if (valueArray.length === 0) {
        tooltip.setHtml(tooltip.emptyValue);
      } else {
        if (valueArray.length === 1) {
          tooltip.setHtml(field.listConfig.itemTpl.apply(getDataFn(valueArray[0])));
        } else {
          var newToolTip = '';
          Ext.Array.each(valueArray, function(id) {
            newToolTip = newToolTip + '\x3cli style\x3d"list-style: none; margin: 10px 4px;"\x3e' + field.listConfig.tooltipItemTpl.apply(getDataFn(id)) + '\x3c/li\x3e';
          });
          tooltip.setHtml('\x3cspan\x3e' + BpcCommon.Api.getTranslation('MONITOR_SET_COLUMN_FILTER_ACTIVE') + ':\x3c/span\x3e\x3cbr\x3e\x3cul style\x3d"padding: 0"\x3e' + newToolTip + '\x3c/ul\x3e');
        }
      }
    }}});
  }};
}, onExpand:function() {
  var me = this;
  me.callParent(arguments);
  if (me.store.loadCount === 0) {
    me.store.load();
    me.setFilterChanged(false);
    return;
  }
  if (me.getFilterChanged()) {
    if (!me.store.isLoading() || me.store.loadCount > 0) {
      me.store.reload();
    }
    me.setFilterChanged(false);
  }
}});
Ext.define('BPC.component.grid.DistinctDataCombobox', {extend:'Ext.form.field.ComboBox', alias:'widget.bpcMonitoDistinctDataCombobox', mixins:{distinctDataMixin:'BPC.component.grid.DistinctDataMixin'}, column:undefined, grid:undefined, moduleId:undefined, enableKeyEvents:true, valueField:'value', displayField:'value', triggerAction:'all', forceSelection:false, minChars:0, matchFieldWidth:false, minWidth:64, autoSelect:false, config:{filterChanged:false, source:'noSource'}, initComponent:function() {
  var me = this;
  this.store = this.getStoreConfig();
  this.listConfig = this.getBoundListConfig();
  Ext.override(this, {onExpand:me.mixins.distinctDataMixin.onExpand});
  this.listeners = Ext.apply(this.listeners || {}, this.getTooltipListener());
  this.callParent();
  if (BpcCommon.Api.getSetting(me.moduleId, 'function_filterRespectOtherColumns') === true) {
    me.grid.getStore().on({filterchange:function() {
      me.setFilterChanged(true);
    }});
  }
}});
Ext.define('BPC.component.grid.DistinctDataModel', {extend:'Ext.data.Model', fields:['value', 'count', {name:'renderedValue', calculate:function(data) {
  if (this.owner.prototype.column && !(this.owner.prototype.column instanceof Ext.grid.column.Template) && this.owner.prototype.column.renderer) {
    return this.owner.prototype.column.renderer(data.value, false, false, true);
  }
  return data.value;
}}], idProperty:'value', rendererFn:undefined});
Ext.define('BPC.component.grid.DistinctDataTagPicker', {extend:'Ext.panel.Panel', alias:'widget.bpcDistinctDataTagPicker', requires:['Ext.util.KeyNav'], plugins:['bpcFocusKeeper'], defaultFocus:'bpcGridFilterField', pickerColumnRenderer:Ext.identityFn, labelValueRenderer:Ext.identityFn, layout:'fit', resizable:true, initComponent:function() {
  var me = this;
  me.column = me.pickerField.column;
  me.moduleId = me.pickerField.moduleId;
  me.value = me.pickerField.value;
  me.queryMode = me.pickerField.queryMode;
  me.gridStore = me.getStoreConfig();
  if (me.column.customRenderer) {
    me.pickerColumnRenderer = me.pickerField.grid.up('bpcMonitor').findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(me.column.config, true, true);
    me.labelValueRenderer = me.pickerField.grid.up('bpcMonitor').findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(me.column.config, false, true);
  }
  me.items = [{xtype:'grid', cls:'distinctDataPickerGrid', itemId:'distinctDataPickerGrid', selModel:{selType:'checkboxmodelselectable', checkOnly:false, mode:'MULTI'}, store:me.gridStore, columns:[{localized:{text:'MONITOR_VALUE'}, dataIndex:'value', flex:1, minWidth:100, cellWrap:true, renderer:me.pickerColumnRenderer}, {localized:{text:'MONITOR_VALUE_RAW'}, dataIndex:'value', cellWrap:true, flex:1, minWidth:100, hidden:true}, {localized:{text:'MONITOR_VALUE_LABEL'}, dataIndex:'renderedValue', 
  cellWrap:true, flex:1, minWidth:100, hidden:true}, {localized:{text:'MONITOR_COUNT'}, dataIndex:'count', minWidth:32, width:60}]}];
  me.dockedItems = [{dock:'top', xtype:me.queryMode === 'remote' ? 'bpcRemoteGridFilterField' : 'bpcLocalGridFilterField', itemId:'distinctDataPickerGridFilterField', emptyText:'Filter Tags', flex:1, source:me.pickerField.source, grid:'^ panel grid'}];
  me.resizable = {listeners:{resize:{fn:me.pickerField.expand.bind(me.pickerField), buffer:50}}};
  me.callParent();
  var monitorGrid = me.pickerField.up('processGrid');
  if (monitorGrid) {
    monitorGrid.on('load', me.reloadStoreWhenVisible, me);
  }
}, reloadStoreWhenVisible:function() {
  var me = this;
  if (me.isVisible(true)) {
    delete me.flagReloadOnShow;
    me.down('#distinctDataPickerGrid').getStore().reload();
  } else {
    if (!me.flagReloadOnShow) {
      me.flagReloadOnShow = true;
      me.on('show', me.reloadStoreWhenVisible, me, {single:true});
    }
  }
}, afterRender:function() {
  var me = this;
  me.setInitialPickerSelection();
  me.callParent();
}, setInitialPickerSelection:function() {
  var me = this;
  var currentValue = me.pickerField.value ? me.pickerField.value : '';
  if (currentValue.length) {
    var grid = me.down('#distinctDataPickerGrid');
    var gridSelectionModel = grid.getSelectionModel();
    var selection = [];
    if (grid.store.isLoaded()) {
      currentValue.forEach(function(val) {
        grid.store.data.items.forEach(function(item) {
          if (val === item.data.value) {
            selection.push(item);
          }
        });
      });
      gridSelectionModel.select(selection);
    } else {
      grid.store.on('load', me.setInitialPickerSelection, me, {single:true});
    }
  }
}, deselectPickerGridAll:function() {
  var me = this;
  var currentValue = me.pickerField.value ? me.pickerField.value : '';
  if (currentValue.length === 0) {
    var grid = me.down('#distinctDataPickerGrid');
    var gridSelectionModel = grid.getSelectionModel();
    gridSelectionModel.deselectAll();
  }
}, getValue:function() {
  var me = this;
  var currentGridSelection = me.down('#distinctDataPickerGrid').getSelection();
  var selectionValues = [];
  currentGridSelection.forEach(function(item) {
    selectionValues.push(item.data.value);
  });
  me.value = selectionValues;
  return selectionValues;
}, getStoreConfig:function() {
  var me = this;
  var newModel = Ext.define(null, {extend:'BPC.component.grid.DistinctDataModel', column:me.column, fields:[{name:'renderedValue', calculate:function(data) {
    if (me.labelValueRenderer) {
      return me.labelValueRenderer(data.value);
    }
    return data.value;
  }}]});
  return {proxy:{type:'ajax', url:BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + me.moduleId + '/distinctFieldValues/' + this.column.dataIndex, extraParams:{source:me.pickerField.source, size:100}, reader:{type:'json', rootProperty:'values'}}, model:newModel, sorters:[{transform:Ext.util.Format.uppercase, sorterFn:function(item1, item2) {
    var me = this;
    var transform = me._transform;
    var root = me._root;
    var property = 'value';
    var lhs, rhs;
    if (root) {
      item1 = item1[root];
      item2 = item2[root];
    }
    lhs = item1[property];
    rhs = item2[property];
    if (lhs === '!') {
      return -1;
    } else {
      if (rhs === '!') {
        return 1;
      }
    }
    if (transform) {
      lhs = transform(lhs);
      rhs = transform(rhs);
    }
    return lhs > rhs ? 1 : lhs < rhs ? -1 : 0;
  }}], moduleId:me.moduleId, listeners:{beforeload:function(store) {
    if (BpcCommon.Api.getSetting(store.moduleId, 'function_filterRespectOtherColumns') === true) {
      store.getProxy().setExtraParam('filter', me.getEncodedFilters());
      store.getProxy().setExtraParam('view', me.pickerField.grid.bpcGridViewName);
    }
  }}, autoLoad:true};
}, getEncodedFilters:function() {
  var me = this;
  var grid = me.pickerField.grid;
  var filters = Ext.clone(grid.store.getFilters().items);
  var columnId = me.column.columnId;
  Ext.each(filters, function(filter, index) {
    var filterId = filter.columnId || filter.getProperty();
    if (filterId === columnId) {
      filters.splice(index, 1);
    }
  });
  var encodedFilters = grid.store.proxy.encodeFilters(filters);
  if (encodedFilters && !Ext.isArray(encodedFilters)) {
    JSON.stringify(encodedFilters);
  }
  return encodedFilters;
}});
Ext.define('BPC.component.grid.DistinctDataPickerField', {extend:'Ext.form.field.Picker', alias:'widget.bpcMonitorDistinctDataPickerField', column:undefined, grid:undefined, moduleId:undefined, enableKeyEvents:true, matchFieldWidth:false, oldDisplayValue:undefined, editable:false, queryMode:'local', viewModel:{data:{mouseOver:false}}, config:{filterChanged:false}, initComponent:function() {
  var me = this;
  me.listeners = Ext.apply({afterrender:function() {
    this.tooltip = Ext.create('Ext.tip.ToolTip', {target:this.id, html:BpcCommon.Api.getTranslation('MONITOR_NO_FILTER_SET'), emptyValue:BpcCommon.Api.getTranslation('MONITOR_NO_FILTER_SET'), listeners:{beforeshow:function(tooltip) {
      var valueArray = me.getDisplayValues(me.value, false);
      if (me.value.length === 0) {
        tooltip.setHtml(tooltip.emptyValue);
      } else {
        if (valueArray.length === 1) {
          tooltip.setHtml(valueArray[0]);
        } else {
          var newToolTip = '';
          Ext.Array.each(valueArray, function(item) {
            newToolTip = newToolTip + ' ' + item;
          });
          tooltip.setHtml('\x3cspan\x3e' + BpcCommon.Api.getTranslation('MONITOR_SET_COLUMN_FILTER_ACTIVE') + ':\x3c/span\x3e\x3cbr\x3e\n                                        \x3cul style\x3d"padding: 0"\x3e' + newToolTip + '\x3c/ul\x3e');
        }
      }
    }}});
  }}, me.listeners);
  me.callParent();
  if (BpcCommon.Api.getSetting(me.moduleId, 'function_filterRespectOtherColumns') === true) {
    me.grid.getStore().on({filterchange:function() {
      me.setFilterChanged(true);
    }});
  }
  me.on('select', me.updateLayout.bind(me));
}, initEvents:function() {
  var me = this;
  this.callParent();
  me.listWrapper.on({scope:me, click:me.onItemListClick});
}, fieldSubTpl:['\x3cdiv id\x3d"{cmpId}-listWrapper" data-ref\x3d"listWrapper" ' + (Ext.isGecko ? ' tabindex\x3d"-1"' : '') + ' class\x3d"' + Ext.baseCSSPrefix + 'tagfield {fieldCls} {typeCls} {typeCls}-{ui}"\x3e', '\x3cul id\x3d"{cmpId}-itemList" data-ref\x3d"itemList" role\x3d"presentation" class\x3d"' + Ext.baseCSSPrefix + 'tagfield-list{itemListCls}" style\x3d"overflow: hidden"\x3e', '\x3cli id\x3d"{cmpId}-inputElCt" data-ref\x3d"inputElCt" role\x3d"presentation" class\x3d"' + Ext.baseCSSPrefix + 
'tagfield-input"\x3e', '\x3cspan id\x3d"{cmpId}-inputElSelection" data-ref\x3d"inputElSelection" class\x3d"' + Ext.baseCSSPrefix + 'tagfield-selection" style\x3d"white-space: nowrap; position: absolute"\x3e\x3c/span\x3e', '\x3cinput id\x3d"{cmpId}-inputEl" data-ref\x3d"inputEl" type\x3d"{type}" class\x3d"' + Ext.baseCSSPrefix + 'tagfield-input-field {inputElCls} {emptyCls} {fixCls}"\x3e', '\x3c/li\x3e', '\x3c/ul\x3e', '\x3c/div\x3e', {disableFormats:true}], postSubTpl:['\x3clabel id\x3d"{cmpId}-placeholderLabel" data-ref\x3d"placeholderLabel" for\x3d"{cmpId}-inputEl" class\x3d"{placeholderCoverCls} {placeholderCoverCls}-{ui} {emptyCls}"\x3e{emptyText}\x3c/label\x3e', 
'\x3c/div\x3e', '\x3ctpl for\x3d"triggers"\x3e{[values.renderTrigger(parent)]}\x3c/tpl\x3e', '\x3c/div\x3e'], childEls:['listWrapper', 'itemList', 'inputEl', 'inputElCt', 'inputElSelection'], createPicker:function() {
  var me = this;
  me.filterPickList = false;
  var pickerCfg = Ext.create({xtype:'bpcDistinctDataTagPicker', floating:true, width:300, height:300, bodyPadding:8, hidden:true, displayField:me.displayField, preserveScrollOnRefresh:true, pickerField:me, keyMap:{ENTER:me.setValueFromPicker.bind(me)}, keyMapEnabled:true, buttons:[{text:BpcCommon.Api.getTranslation('MONITOR_CANCEL'), iconCls:BpcCommon.Icons.CANCEL, itemId:'cancelBtn', ui:'secondary', handler:me.closePicker.bind(me)}, {text:BpcCommon.Api.getTranslation('MONITOR_APPLY'), iconCls:BpcCommon.Icons.OK, 
  itemId:'applyBtn', ui:'primary', handler:me.setValueFromPicker.bind(me)}]});
  var picker = me.picker = Ext.widget(pickerCfg);
  return picker;
}, afterRender:function() {
  var me = this;
  me.callParent();
  if (me.value && me.value.length) {
    var displayValues = me.displayValues = me.getDisplayValues(me.value, true);
    me.setDisplayValue(displayValues);
  }
}, getDisplayValues:function(values, isInputValues) {
  var me = this;
  var returnVal;
  try {
    var valueArray = Ext.isArray(values) ? values : [values];
    if (me.column.renderer) {
      var renderer = me.column.renderer;
      if (!me.tooltipRenderer) {
        var customRenderer = me.grid.up('bpcMonitor').findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(me.column.config, true, true);
        me.tooltipRenderer = customRenderer || Ext.identityFn;
      }
      returnVal = Ext.Array.map(valueArray, function(item) {
        var itemData = {value:renderer(item, false, false, false) || item, tooltip:me.tooltipRenderer(item) || item};
        if (isInputValues) {
          return '\x3cspan\x3e' + itemData.value + '\x3c/span\x3e';
        }
        return '\x3cli style\x3d"list-style: none; margin: 10px 4px;"\x3e\x3cspan\x3e' + itemData.tooltip + '\x3c/span\x3e\x3c/li\x3e';
      });
    } else {
      if (isInputValues) {
        returnVal = Ext.Array.map(valueArray, function(item) {
          return '\x3cspan\x3e' + item + '\x3c/span\x3e';
        });
      } else {
        returnVal = Ext.Array.map(valueArray, function(item) {
          return '\x3cli style\x3d"list-style: none; margin: 10px 4px;"\x3e\x3cspan\x3e' + item + '\x3c/span\x3e';
        });
      }
    }
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR getDisplayValues', dump:e, stack:true, level:'error'});
  }
  return returnVal;
}, setDisplayValue:function(values) {
  var me = this;
  var displayValues = values;
  if (!me.rendered) {
    me.on('afterrender', me.setDisplayValue.bind(me, values), me, {single:true});
    return;
  }
  if (Ext.isArray(displayValues)) {
    displayValues = Ext.Array.map(values, function(item) {
      if (item instanceof Ext.data.Model) {
        return Ext.String.htmlEncode(item);
      }
      return item;
    });
  }
  var newDisplayValue = displayValues.toString();
  if (me.oldDisplayValue !== newDisplayValue) {
    me.inputElSelection.setHtml(newDisplayValue);
    me.inputEl.dom.value = '';
  }
  me.oldDisplayValue = newDisplayValue;
}, getValue:function() {
  var me = this;
  var value = me.value;
  if (Ext.isArray(value)) {
    var newValueArray = Ext.Array.map(value, function(item) {
      if (item instanceof Ext.data.Model) {
        return item.get(me.valueField);
      }
      return item;
    });
    return newValueArray;
  }
  return value;
}, setValueFromPicker:function() {
  var me = this;
  me.setValue(me.picker.getValue());
  me.closePicker();
  me.fireEvent('select', me);
}, setValue:function(value) {
  var me = this;
  value = this.callParent([value]);
  me.refreshEmptyText();
  if (!me.value || me.value.length === 0) {
    if (me.picker) {
      me.picker.deselectPickerGridAll();
    }
    me.setDisplayValue('');
  } else {
    me.displayValues = me.getDisplayValues(me.value, true);
    me.setDisplayValue(me.displayValues);
  }
  return value;
}, onFocusEnter:function() {
  var me = this;
  me.callParent(arguments);
  if (!me.readOnly && !me.disabled) {
    me.delayedExpandTask = new Ext.util.DelayedTask(function() {
      me.expand();
    });
    me.delayedExpandTask.delay(100);
  }
}, collapse:function() {
  var me = this;
  if (me.delayedExpandTask) {
    me.delayedExpandTask.cancel();
    delete me.delayedExpandTask;
  }
  me.callParent();
}, closePicker:function() {
  var me = this;
  me.collapse();
}, onFocus:function(e) {
  var me = this;
  var focusCls = me.focusCls;
  var itemList = me.itemList;
  if (focusCls && itemList && !itemList.hasCls('form-focus')) {
    itemList.addCls(focusCls);
  }
  me.callParent([e]);
}, onBlur:function() {
  var me = this;
  var focusCls = me.focusCls;
  var itemList = me.itemList;
  if (focusCls && itemList) {
    itemList.removeCls(focusCls);
  }
  me.callParent(arguments);
}, onItemListClick:function(e) {
  var me = this;
  if (me.readOnly || me.disabled) {
    return;
  }
  e.stopPropagation();
  me.inputEl.focus();
}, onItemMouseDown:function(e) {
  if (e.target !== this.inputEl.dom) {
    e.preventDefault();
  }
}});
Ext.define('BPC.component.grid.LocalGridFilterField', {extend:'BpcCommon.component.grid.GridFilterField', alias:'widget.bpcLocalGridFilterField', filterBuffer:250, selectedGridRecords:[], onFilterChange:function(textField, newVal, oldVal) {
  var me = this;
  var store = me.grid.getStore();
  var filters = store.getFilters();
  me.rememberSelection();
  filters.removeAll();
  if (newVal && newVal.length > 0) {
    store.filterBy(function(item) {
      item.isSelected = false;
      var match = false;
      var matcher = Ext.String.createRegex(newVal, false, false, true);
      if (me.selectedGridRecords.length) {
        me.selectedGridRecords.forEach(function(selectionItem) {
          if (selectionItem.data.value === item.data.value) {
            item.isSelected = true;
          }
        });
      }
      if (me.filterFields.length === 0) {
        me.filterFields = Ext.Object.getKeys(store.getModel().getFieldsMap());
      }
      Ext.Array.each(me.filterFields, function(key) {
        var value = item.get(key);
        if (Ext.isObject(value) || Ext.isArray(value)) {
          value = JSON.stringify(value);
        }
        match = matcher.test(value);
        if (match === true) {
          return false;
        }
      });
      return match || item.isSelected;
    });
  }
}, rememberSelection:function(selModel, selectedRecords) {
  var me = this;
  me.selectedGridRecords = me.grid.getSelectionModel().getSelection();
}});
Ext.define('BPC.component.grid.RemoteGridFilterField', {extend:'BpcCommon.component.grid.GridFilterField', alias:'widget.bpcRemoteGridFilterField', filterBuffer:500, selectedGridRecords:[], onFilterChange:function(textField, newVal) {
  var me = this;
  var store = me.grid.getStore();
  store.load({params:{query:newVal, size:100, source:me.source}});
  store.on('beforeload', this.rememberSelection, this);
  me.grid.getView().on('refresh', this.setCurrentSelection, me);
}, rememberSelection:function(selModel, selectedRecords) {
  var me = this;
  me.selectedGridRecords = me.grid.getSelectionModel().getSelection();
}, setCurrentSelection:function(view, loadedGridItems) {
  var me = this;
  if (me.selectedGridRecords.length) {
    var gridSelectionModel = view.grid.getSelectionModel();
    var grid = view.grid;
    var itemsToSelect = [];
    var itemsToAdd = [];
    var selection = me.selectedGridRecords;
    selection.forEach(function(selectionItem) {
      if (!grid.store.getById(selectionItem.id)) {
        itemsToAdd.push(selectionItem);
        itemsToSelect.push(selectionItem);
      }
      grid.store.data.items.forEach(function(item) {
        if (selectionItem.data.value === item.data.value) {
          itemsToSelect.push(item);
        }
      });
    });
    if (itemsToAdd.length) {
      grid.store.insert(0, itemsToAdd);
    }
    gridSelectionModel.select(itemsToSelect);
  }
}});
Ext.define('monitor.component.grid.filter.Base', {extend:'Ext.grid.filters.filter.Base', mixin:['Ext.mixin.Bindable'], viewModel:{data:{dirty:false, source:undefined, mouseOver:false, operator:undefined, invert:false}}, emptyValue:'', viewModelDefaults:{}, columnId:undefined, dirty:false, menuDefaults:{plain:true}, menuOptionFieldDefaults:[], columHeaderFieldDefault:{xtype:'bpcMonitoDistinctDataCombobox', setTriggerPickerHidden:function(hidden) {
  this.getTrigger('picker').setVisible(!hidden);
}, getTriggerPickerHidden:function() {
  return !this.getTrigger('picker').isVisible();
}, setTriggerResetHidden:function(hidden) {
  this.getTrigger('reset').setVisible(!hidden);
}, getTriggerResetHidden:function() {
  return !this.getTrigger('reset').isVisible();
}, bind:{triggerPickerHidden:'{!dirty}', triggerResetHidden:'{!mouseOver}'}, triggers:{reset:{cls:BpcCommon.Icons.FILTER_RESET, extraCls:'resetTrigger', weight:-2, scope:'this', handler:'deactivate', width:'24px'}, picker:{cls:BpcCommon.Icons.OK, weight:-1, scope:'this', itemId:'submitColumHeader', handler:'submitColumHeaderField', width:'24px'}}, margin:0}, constructor:function(config) {
  var me = this;
  me.viewModel.data = Ext.apply(me.viewModel.data, me.viewModelDefaults);
  me.viewModel = Ext.Factory.viewModel(me.viewModel);
  me.source = config.source || me.source;
  me.viewModel.set('source', me.source);
  me.dataIndex = config.column.dataIndex;
  me.callParent(arguments);
  me.moduleId = me.grid.config.moduleId;
  me.column.addListener({mouseenter:{fn:function() {
    me.viewModel.set('mouseOver', true);
    me.column.onTitleMouseOver();
  }, element:'el'}, mouseleave:{fn:me.viewModel.set.bind(me.viewModel, 'mouseOver', false), element:'el'}});
  me.columHeaderFieldConfig = Ext.apply({viewModel:me.viewModel, submitColumHeaderField:me.submitColumHeaderField.bind(me), deactivate:me.deactivate.bind(me), column:me.column, moduleId:me.moduleId, grid:me.grid, source:me.source, ui:'columnHeaderField', listeners:{keyup:me.onValueChange.bind(me), change:me.checkDirty.bind(me), select:me.submitColumHeaderField.bind(me)}}, me.columHeaderFieldDefault, me.column.filter.fieldConfig);
  if (me.active) {
    me.columHeaderFieldConfig.value = me.getValue();
  }
  me.column.isContainer = true;
  me.focusable = true;
  me.column.setLayout({type:'vbox', align:'stretch'});
  me.columHeaderField = me.column.add(me.columHeaderFieldConfig);
  me.getGridStore().on({filterchange:me.onFilterChange, scope:me});
}, getFilterConfig:function(config, key) {
  config = this.callParent(arguments);
  if (!config.columnId) {
    config.columnId = this.column.columnId;
  }
  if (!config.key) {
    config.key = key;
  }
  return config;
}, getValue:function(field) {
  return field ? field.getValue() : undefined;
}, setValue:function(value, silent) {
  silent = silent === true ? silent : false;
  this.value = value;
  if (this.columHeaderField.getValue() !== value) {
    this.columHeaderField.setValue(value);
  }
  if (this.inputItem && this.inputItem.getValue() !== value) {
    this.inputItem.setValue(value);
  }
  if (silent === false) {
    if (this.columHeaderField && this.columHeaderField.collapse) {
      this.columHeaderField.collapse();
    }
  }
}, clearValue:function() {
  this.setValue(this.emptyValue);
}, getStoreFilter:function(key) {
  var filters = this.getGridStore().getFilters();
  var filter;
  if (!key) {
    var filterIndex = filters.findIndex('columnId', this.column.columnId);
    if (filterIndex >= 0) {
      return filters.getAt(filterIndex);
    }
  } else {
    filter = filters.findBy(function(item) {
      if (item.config) {
        return item.config.columnId === this.column.columnId && item.config.key === key;
      }
    }, this);
    if (filter) {
      return filter;
    }
  }
  var id = this.getBaseIdPrefix();
  if (key) {
    id += '-' + key;
  }
  filter = filters.get(id);
  if (filter && filter.columnId) {
    filter = undefined;
  }
  if (!filter) {
    filter = filters.get(this.dataIndex);
  }
  return filter;
}, onFilterChange:function() {
  var me = this;
  if (me.destroyed) {
    return;
  }
  var storeFilter = me.getStoreFilter();
  if (!storeFilter) {
    me.setColumnActive(false);
    me.setValue(me.emptyValue, true);
    me.active = false;
  } else {
    me.filter = storeFilter;
    me.setColumnActive(true);
    me.setValue(storeFilter.getValue(), true);
    me.active = true;
  }
  this.checkDirty();
}, getMenuConfig:function() {
  return Ext.apply({viewModel:this.viewModel}, this.getMenuDefaults());
}, createMenu:function() {
  var me = this;
  me.callParent();
  me.menu.add(me.menuOptionFieldDefaults);
  me.itemDefaults = me.columHeaderFieldConfig;
  var config = Ext.apply({}, me.getItemDefaults());
  if (config.iconCls && !('labelClsExtra' in config)) {
    config.labelClsExtra = Ext.baseCSSPrefix + 'grid-filters-icon ' + config.iconCls;
  }
  delete config.iconCls;
  config.emptyText = config.emptyText || me.emptyText;
  me.inputItem = me.menu.add(config);
  me.inputItem.on({scope:me, keyup:me.onValueChange, el:{click:function(e) {
    e.stopPropagation();
  }}});
}, setColumnActive:function(active) {
  this.column[active ? 'addCls' : 'removeCls'](this.owner.filterCls);
}, onValueChange:function(field, e) {
  var me = this;
  var keyCode = e.getKey();
  var value;
  if (keyCode === e.TAB) {
    return;
  }
  if (field.isValid()) {
    if (keyCode === e.RETURN) {
      value = me.getValue(field);
      if (value === me.value) {
        return;
      }
      me.setValue(value);
    } else {
    }
  }
}, submitColumHeaderField:function(source) {
  var me = this;
  var sourceField = me.columHeaderField;
  if (source && source.getValue) {
    sourceField = source;
  }
  me.setValue(sourceField.getValue());
  sourceField.blur();
}, checkDirty:function() {
  var oldDirtyState = this.viewModel.get('dirty');
  var newDirtyState = oldDirtyState;
  if (this.isDirty() === true) {
    newDirtyState = true;
    this.viewModel.set('dirty', newDirtyState);
  } else {
    newDirtyState = false;
    this.viewModel.set('dirty', newDirtyState);
  }
  return newDirtyState;
}, isDirty:Ext.emptyFn, activateMenu:function() {
  this.inputItem.setValue(this.filter.getValue());
}, isValueFilterable:function(value) {
  return !!value;
}});
Ext.define('monitor.component.grid.filter.MultiFilter', {extend:'monitor.component.grid.filter.Base', activeFilterArray:undefined, defaultFilterMap:undefined, inactiveFilterArray:undefined, filterMap:undefined, constructor:function(config) {
  var me = this;
  if (!me.defaultFilterMap) {
    me.defaultFilterMap = {};
  } else {
    me.defaultFilterMap = Ext.clone(me.defaultFilterMap);
  }
  me.filterMap = {};
  me.callParent([config]);
  var filters = me.getStoreFilters();
  if (filters.length > 0) {
    me.active = true;
    Ext.Array.each(filters, me.addStoreFilter.bind(me));
  }
  if (me.active) {
    me.setColumnActive(true);
  }
  me.activeFilterArray = filters;
}, getStoreFilters:function() {
  var filters = [];
  var me = this;
  me.inactiveFilterArray = [];
  Ext.Object.each(me.defaultFilterMap, function(key, value) {
    var filter = me.getStoreFilter(key);
    if (filter) {
      filters.push(filter);
    } else {
      filter = me.createFilter(value, key);
      me.inactiveFilterArray.push(filter);
    }
    me.filterMap[key] = filter;
  });
  return filters;
}, activate:function(showingMenu) {
  var me = this;
  if (showingMenu) {
    this.activateMenu();
  } else {
    Ext.Array.each(me.activeFilterArray, me.addStoreFilter.bind(me));
  }
}, deactivate:function() {
  var me = this;
  me.clearValue();
  Ext.Array.each(me.activeFilterArray, me.removeStoreFilter.bind(me));
}, onFilterRemove:function() {
  if (!this.menu || this.active) {
    this.active = false;
  }
}, activateMenu:function() {
  this.inputItem.setValue(this.getFilterValueMap());
}, getFilterValueMap:function() {
  var valueMap = {};
  Ext.Object.each(this.filterMap, function(key, filter) {
    valueMap[key] = filter.getValue();
  });
  return valueMap;
}});
Ext.define('monitor.component.grid.filter.Date', {extend:'monitor.component.grid.filter.MultiFilter', alias:['grid.filter.daterange'], columHeaderFieldDefault:{xtype:'bpcDateRangeField', matchFieldWidth:false, setTriggerPickerHidden:function(hidden) {
  this.getTrigger('picker').setVisible(!hidden);
}, getTriggerPickerHidden:function() {
  return !this.getTrigger('picker').isVisible();
}, setTriggerResetHidden:function(hidden) {
  this.getTrigger('reset').setVisible(!hidden);
}, getTriggerResetHidden:function() {
  return !this.getTrigger('reset').isVisible();
}, bind:{triggerPickerHidden:'{!dirty}', triggerResetHidden:'{!mouseOver}'}, triggers:{reset:{cls:BpcCommon.Icons.FILTER_RESET, extraCls:'resetTrigger', scope:'this', handler:function() {
  this.setValue({});
  this.submitColumHeaderField();
}}, picker:{cls:BpcCommon.Icons.OK, scope:'this', handler:'submitColumHeaderField'}}, listeners:{scope:'this', change:'submitColumHeaderField'}, margin:0}, defaultFilterMap:{start:{operator:'gte', invert:false}, end:{operator:'lt', invert:false}}, menuOptionFieldDefaults:[], constructor:function() {
  var me = this;
  me.callParent(arguments);
  me.startFilter = me.filterMap.start;
  me.endFilter = me.filterMap.end;
}, activate:function(showingMenu) {
  if (showingMenu) {
    this.activateMenu();
  } else {
    if (this.startFilter.getValue()) {
      this.addStoreFilter(this.startFilter);
    }
    if (this.endFilter.getValue()) {
      this.addStoreFilter(this.endFilter);
    }
  }
}, setValue:function(value, silent) {
  silent = silent === true ? silent : false;
  var me = this;
  if (me.preventFilterRemoval) {
    return;
  }
  me.preventFilterRemoval = true;
  this.value = value;
  if (this.columHeaderField.getValue() !== value) {
    this.columHeaderField.setValue(value);
  }
  if (this.inputItem && this.inputItem.getValue() !== value) {
    this.inputItem.setValue(value);
  }
  if (this.startFilter && this.startFilter.getValue() !== value.start) {
    this.startFilter.setValue(value.start);
  }
  if (this.endFilter && this.endFilter.getValue() !== value.end) {
    this.endFilter.setValue(value.end);
  }
  if (silent === false) {
    if (this.columHeaderField) {
      this.columHeaderField.collapse();
    }
    if ((value.start || value.end) && me.active) {
      var filterCollection = me.getGridStore().getFilters();
      filterCollection.beginUpdate();
      if (this.startFilter.getValue()) {
        this.addStoreFilter(this.startFilter);
      } else {
        this.removeStoreFilter(this.startFilter);
      }
      if (this.endFilter.getValue()) {
        this.addStoreFilter(this.endFilter);
      } else {
        this.removeStoreFilter(this.endFilter);
      }
      me.setActive(true);
      filterCollection.endUpdate();
    } else {
      this.removeStoreFilter(this.startFilter);
      this.removeStoreFilter(this.endFilter);
      me.setActive(!!(value.start || value.end));
    }
  }
  me.preventFilterRemoval = false;
}, onFilterChange:function() {
  var me = this;
  var startFilter = me.getStoreFilter('start');
  var endFilter = me.getStoreFilter('end');
  if (!startFilter && !endFilter) {
    me.setColumnActive(false);
    me.setValue({start:null, end:null}, true);
    me.active = false;
  } else {
    me.setColumnActive(true);
    me.startFilter = startFilter || me.startFilter;
    me.endFilter = endFilter || me.endFilter;
    me.setValue({start:startFilter ? startFilter.getValue() : null, end:endFilter ? endFilter.getValue() : null}, true);
    me.active = true;
  }
  this.checkDirty();
}});
Ext.define('monitor.component.grid.filter.Dummy', {extend:'Ext.grid.filters.filter.Base', alias:['grid.filter.dummy'], type:'dummy', activate:function() {
}, deactivate:function() {
}, getValue:function() {
  return 'dummy';
}, onFilterRemove:function() {
}});
Ext.define('monitor.component.grid.filter.SingleFilter', {extend:'monitor.component.grid.filter.Base', filter:undefined, constructor:function(config) {
  var me = this;
  var filter;
  me.callParent([config]);
  var value = me.value;
  filter = me.getStoreFilter();
  if (filter) {
    me.active = true;
  } else {
    me.active = me.getActiveState(config, value);
    filter = me.createFilter({value:value});
    if (me.active) {
      me.addStoreFilter(filter);
    }
  }
  if (me.active) {
    me.setColumnActive(true);
  }
  me.filter = filter;
  me.viewModel.bind('{operator}', me.filter.setOperator.bind(me.filter));
  me.viewModel.bind('{invert}', me.setInvert.bind(me));
}, setInvert:function(invertState) {
  var me = this;
  me.filter.setConfig('invert', invertState);
  me.onFilterChange();
}, isDirty:function() {
  var dirty = false;
  var fieldValue = this.columHeaderField.getValue() || '';
  var filterValue = this.filter.getValue() || '';
  if (Ext.isArray(filterValue)) {
    filterValue = filterValue.join(',');
  }
  if (this.viewModel.get('invert') !== this.filter.getConfig('invert')) {
    dirty = true;
  }
  if (fieldValue !== filterValue) {
    dirty = true;
  }
  return dirty;
}, activate:function(showingMenu) {
  if (showingMenu) {
    this.activateMenu();
  } else {
    this.addStoreFilter(this.filter);
  }
}, deactivate:function() {
  var me = this;
  me.clearValue();
  this.removeStoreFilter(this.filter);
}, onFilterRemove:function() {
  this.setInvert(false);
  if (!this.menu || this.active) {
    this.active = false;
  }
}});
Ext.define('monitor.component.grid.filter.Text', {extend:'monitor.component.grid.filter.SingleFilter', alias:['grid.filter.text'], operator:'\x3d*', invert:false, menuOptionFieldDefaults:[{xtype:'checkbox', localized:{fieldLabel:'MONITOR_FILTER_INVERT'}, itemId:'invertFilter', bind:'{invert}'}, {xtype:'combobox', fieldLabel:'Operator', itemId:'operator', bind:'{operator}', valueField:'id', store:{fields:['id', 'text'], data:[{id:'\x3d*', text:'enthält'}, {id:'\x3d', text:'gleich'}]}}], constructor:function() {
  var me = this;
  me.callParent(arguments);
  me.viewModel.set('operator', me.operator);
  me.viewModel.set('invert', me.invert);
  me.oldOperator = me.operator;
  me.oldInvert = me.invert;
  me.viewModel.set('source', me.source);
  me.viewModel.bind('{operator}', Ext.Function.createThrottled(me.updateFilterConfig, 100, me));
  me.viewModel.bind('{source}', Ext.Function.createThrottled(me.updateFilterConfig, 100, me));
  me.viewModel.bind('{invert}', Ext.Function.createThrottled(me.updateFilterConfig, 100, me));
}, updateFilterConfig:function() {
  var me = this;
  me.filter.config.source = me.viewModel.get('source') || me.source;
  me.filter.config.operator = me.viewModel.get('operator') || me.operator;
  me.filter.config.invert = me.viewModel.get('invert') || me.invert;
  me.filter.setConfig('source', me.filter.config.source);
  me.filter.setConfig('operator', me.filter.config.operator);
  me.filter.setConfig('invert', me.filter.config.invert);
  me.setValue(me.value);
}, getFilterConfig:function(config) {
  config = this.callParent(arguments);
  config.source = this.viewModel.get('source') || this.source;
  config.operator = this.viewModel.get('operator') || this.operator;
  config.invert = this.viewModel.get('invert') || this.invert;
  return config;
}, getValue:function(field) {
  return field ? field.getValue() : this.filter.getValue();
}, setValue:function(value, silent) {
  var me = this;
  silent = silent === true ? silent : false;
  me.value = value;
  me.callParent(arguments);
  if (me.filter && me.filter.getValue() !== value) {
    me.filter.setValue(value);
  } else {
    if (me.filter && me.filter.getValue() === value && me.active === true && me.oldOperator === me.viewModel.get('operator') && me.oldInvert === me.viewModel.get('invert')) {
      silent = true;
    }
  }
  if (silent === false) {
    if (Ext.isArray(value) && value.length === 0) {
      value = '';
    }
    if (me.isValueFilterable(value) && me.active) {
      me.oldOperator = me.viewModel.get('operator');
      me.oldInvert = me.viewModel.get('invert');
      me.updateStoreFilter();
    } else {
      me.setActive(me.isValueFilterable(value));
    }
  }
}, onFilterChange:function() {
  var me = this;
  var storeFilter = me.getStoreFilter();
  if (storeFilter) {
    me.viewModel.set('operator', storeFilter.getOperator());
    me.viewModel.set('invert', storeFilter.getConfig('invert'));
  }
  me.callParent();
}});
Ext.define('monitor.component.grid.filter.MultiText', {extend:'monitor.component.grid.filter.Text', alias:['grid.filter.dynamiclist'], operator:'\x3d', emptyValue:[], columHeaderFieldDefault:{xtype:'bpcMonitorDistinctDataPickerField', itemId:'bpcMonitorDistinctDataPickerField', setTriggerPickerHidden:function() {
  this.getTrigger('picker').hide();
}, setTriggerResetHidden:function(hidden) {
  this.getTrigger('reset').setVisible(!hidden);
}, getTriggerResetHidden:function() {
  return !this.getTrigger('reset').isVisible();
}, bind:{triggerResetHidden:'{!mouseOver}'}, triggers:{reset:{cls:BpcCommon.Icons.FILTER_RESET, weight:-2, scope:'this', extraCls:'resetTrigger', handler:'deactivate', width:'24px'}, picker:{hidden:true, width:'0px'}}, margin:0}, isDirty:function() {
  var newDirtyState = false;
  var fieldValue = this.columHeaderField.getValue();
  if (Ext.isArray(fieldValue) && fieldValue.length === 0) {
    fieldValue = '';
  }
  var filterValue = this.filter.getValue();
  if (Ext.isArray(filterValue) && filterValue.length === 0) {
    filterValue = '';
  }
  newDirtyState = fieldValue !== filterValue;
  return newDirtyState;
}, getFilterConfig:function(config) {
  config = this.callParent(arguments);
  if (!config.value) {
    config.value = [];
  }
  return config;
}});
Ext.define('monitor.component.grid.filter.check.Checkbox', {extend:'Ext.form.field.Text', alias:'widget.monitorFilterCheckbox', setTriggerResetHidden:function(hidden) {
  this.getTrigger('reset').setVisible(!hidden);
}, getTriggerResetHidden:function() {
  return !this.getTrigger('reset').isVisible();
}, bind:{triggerResetHidden:'{!mouseOver}'}, triggers:{reset:{cls:BpcCommon.Icons.FILTER_RESET, extraCls:'resetTrigger', weight:-2, scope:'this', handler:'deactivate'}}, preSubTpl:['\x3cdiv id\x3d"{cmpId}-triggerWrap" data-ref\x3d"triggerWrap"', '\x3ctpl if\x3d"ariaEl \x3d\x3d \'triggerWrap\'"\x3e', '\x3ctpl foreach\x3d"ariaElAttributes"\x3e {$}\x3d"{.}"\x3c/tpl\x3e', '\x3ctpl else\x3e', ' role\x3d"presentation"', '\x3c/tpl\x3e', ' class\x3d"{triggerWrapCls} {triggerWrapCls}-{ui}"\x3e', '\x3cdiv style\x3d"text-align: center;" id\x3d{cmpId}-inputWrap data-ref\x3d"inputWrap"', 
' role\x3d"presentation" class\x3d"{inputWrapCls} {inputWrapCls}-{ui}"\x3e'], fieldSubTpl:['\x3cspan style\x3d"display: inline-block; position: relative;" id\x3d"{cmpId}-displayEl" data-ref\x3d"displayEl" role\x3d"presentation" class\x3d" x-form-cb-checked x-form-field x-form-checkbox x-form-checkbox-default x-form-cb x-form-cb-default', '"\x3e', '\x3cinput id\x3d"{id}" data-ref\x3d"inputEl" type\x3d"checkbox" value\x3d"{value}" {inputAttrTpl}', ' size\x3d"1"', '\x3ctpl if\x3d"name"\x3e name\x3d"{name}"\x3c/tpl\x3e', 
'\x3ctpl if\x3d"placeholder"\x3e placeholder\x3d"{placeholder}"\x3c/tpl\x3e', '{%if (values.maxLength !\x3d\x3d undefined){%} maxlength\x3d"{maxLength}"{%}%}', '\x3ctpl if\x3d"readOnly"\x3e readonly\x3d"readonly"\x3c/tpl\x3e', '\x3ctpl if\x3d"disabled"\x3e disabled\x3d"disabled"\x3c/tpl\x3e', '\x3ctpl if\x3d"tabIdx !\x3d null"\x3e tabindex\x3d"{tabIdx}"\x3c/tpl\x3e', '\x3ctpl if\x3d"fieldStyle"\x3e style\x3d"{fieldStyle}"\x3c/tpl\x3e', '\x3ctpl if\x3d"ariaEl \x3d\x3d \'inputEl\'"\x3e', '\x3ctpl foreach\x3d"ariaElAttributes"\x3e {$}\x3d"{.}"\x3c/tpl\x3e', 
'\x3c/tpl\x3e', '\x3ctpl foreach\x3d"inputElAriaAttributes"\x3e {$}\x3d"{.}"\x3c/tpl\x3e', ' class\x3d"x-form-cb-input" autocomplete\x3d"off"/\x3e', '\x3c/span\x3e', {disableFormats:true}], initEvents:function() {
  this.callParent();
  this.inputEl.on('mousedown', this.toggleValue, this);
}, toggleValue:function() {
  this.setValue(!this.getValue());
}, getValue:function() {
  var value = this.callParent();
  if (value === 'true' || value === 'on') {
    value = true;
  }
  return value === true;
}, setValue:function(value) {
  var newValue = false;
  if (value === 'true' || value === 'on' || value === true) {
    newValue = true;
  }
  if (newValue) {
    this.addCls('x-form-cb-checked');
  } else {
    this.removeCls('x-form-cb-checked');
  }
  this.callParent([newValue]);
}, initComponent:function() {
  this.callParent();
  if (this.getValue()) {
    this.addCls('x-form-cb-checked');
  }
}});
Ext.define('monitor.component.grid.filter.check.Check', {extend:'monitor.component.grid.filter.SingleFilter', alias:['grid.filter.check'], operator:'\x3d', emptyValue:false, trueValues:[true, 'true', 1, '1', 'ja', 'yes', 'on'], falseValues:['!', false, 'false', '*0', '*nein', 'no', 'off'], menuOptionFieldDefaults:[], columHeaderFieldDefault:{xtype:'monitorFilterCheckbox', listeners:{scope:'this', change:'submitColumHeaderField'}, margin:0}, getFilterConfig:function(config) {
  config = this.callParent(arguments);
  config.source = this.viewModel.get('source') || this.source;
  config.operator = this.viewModel.get('operator') || this.operator;
  return config;
}, getValue:function(field) {
  return field ? field.getValue() : this.filter.getValue();
}, setValue:function(value, silent) {
  silent = silent === true ? silent : false;
  if (Ext.isArray(value)) {
    value = Ext.Array.contains(value, true);
  }
  if (this.columHeaderField.getValue() !== value) {
    this.columHeaderField.setValue(value);
  }
  if (this.inputItem && this.inputItem.getValue() !== value) {
    this.inputItem.setValue(value);
  }
  if (value === true) {
    value = this.trueValues;
  } else {
    value = this.falseValues;
  }
  if (this.filter && this.filter.getValue() !== value) {
    this.filter.setValue(value);
  }
  if (silent === false) {
    if (Ext.isArray(value) && value.length === 0) {
      value = '';
    }
    if (value && this.active) {
      this.updateStoreFilter();
    } else {
      this.setActive(!!value);
    }
  }
}});
Ext.define('monitor.component.grid.filter.number.NumberField', {extend:'Ext.form.field.Number', alias:'widget.monitorFilterNumberField', operatorStore:undefined, config:{operator:'?'}, publishes:['value', 'rawValue', 'dirty', 'operator'], setTriggerPickerHidden:function(hidden) {
  this.getTrigger('picker').setVisible(!hidden);
}, getTriggerPickerHidden:function() {
  return !this.getTrigger('picker').isVisible();
}, setTriggerResetHidden:function(hidden) {
  this.getTrigger('reset').setVisible(!hidden);
}, getTriggerResetHidden:function() {
  return !this.getTrigger('reset').isVisible();
}, bind:{triggerPickerHidden:'{!dirty}', triggerResetHidden:'{!mouseOver}'}, enableKeyEvents:true, triggers:{reset:{cls:BpcCommon.Icons.FILTER_RESET, extraCls:'resetTrigger', weight:-2, scope:'this', handler:'deactivate'}, picker:{cls:BpcCommon.Icons.OK, weight:-1, scope:'this', handler:'submitColumHeaderField'}, spinner:{hidden:true}}, childEls:['operatorEl', 'triggerWrap', 'inputWrap', 'placeholderLabel'], preSubTpl:['\x3cdiv id\x3d"{cmpId}-triggerWrap" data-ref\x3d"triggerWrap"', '\x3ctpl if\x3d"ariaEl \x3d\x3d \'triggerWrap\'"\x3e', 
'\x3ctpl foreach\x3d"ariaElAttributes"\x3e {$}\x3d"{.}"\x3c/tpl\x3e', '\x3ctpl else\x3e', ' role\x3d"presentation"', '\x3c/tpl\x3e', ' class\x3d"{triggerWrapCls} {triggerWrapCls}-{ui}"\x3e', '\x3cdiv id\x3d"{cmpId}-operatorEl" data-ref\x3d"operatorEl" class\x3d"x-unselectable" role\x3d"presentation" style\x3d"width: 25px;', 'display: table-cell; font-style: normal; text-align: center;"\x3e{operator}\x3c/div\x3e', '\x3cdiv id\x3d"{cmpId}-inputWrap" data-ref\x3d"inputWrap"', ' role\x3d"presentation" class\x3d"{inputWrapCls} {inputWrapCls}-{ui}"\x3e'], 
initComponent:function() {
  this.callParent();
  this.operatorStore = Ext.StoreManager.lookup('numericOperatorStore');
}, getSubTplData:function() {
  var data = this.callParent(arguments);
  data.operator = this.getOperator();
  return data;
}, setOperator:function(operator) {
  this.callParent(arguments);
  if (this.rendered && this.operatorEl) {
    var operatorRecord = this.operatorStore.getById(operator);
    var operatorText = operator;
    if (operatorRecord) {
      operatorText = operatorRecord.get('text') || operatorText;
    }
    this.operatorEl.update(operatorText);
  }
}, afterRender:function() {
  var me = this;
  var currentOperator = me.getOperator();
  me.callParent();
  var items = [];
  me.operatorStore.each(function(operatorRecord) {
    items.push({xtype:'menucheckitem', group:'operator', text:operatorRecord.get('text'), operator:operatorRecord.get('id'), checked:operatorRecord.get('id') === currentOperator, checkHandler:function(menuItem) {
      me.setOperator(menuItem.operator);
    }});
  });
  me.operatorMenu = Ext.create('Ext.menu.Menu', {items:items});
  me.operatorEl.on('click', me.operatorMenu.showBy.bind(me.operatorMenu, me, undefined, undefined));
}});
Ext.define('monitor.component.grid.filter.number.Number', {extend:'monitor.component.grid.filter.Text', alias:['grid.filter.bpcMonitorNumber', 'grid.filter.bpcmonitornumber'], operator:'\x3d', menuOptionFieldDefaults:[{xtype:'combobox', fieldLabel:'Operator', itemId:'operator', bind:'{operator}', valueField:'id', store:'numericOperatorStore'}], columHeaderFieldDefault:{xtype:'monitorFilterNumberField', bind:{operator:'{operator}'}, margin:0}, constructor:function() {
  var me = this;
  me.callParent(arguments);
  this.columHeaderField.on('keyup', this.onKeyUp.bind(this));
  this.viewModel.bind('{operator}', this.submitColumHeaderField.bind(this));
}, onKeyUp:function(src, e) {
  if (e.getKey() === Ext.event.Event.ENTER) {
    this.submitColumHeaderField();
  }
}, isValueFilterable:function(value) {
  return Ext.isNumber(value);
}});
Ext.define('monitor.component.grid.plugin.BpcRowExpander', {extend:'Ext.grid.plugin.RowExpander', alias:'plugin.bpcrowexpander', init:function(grid) {
  this.callParent(arguments);
  this.grid = grid;
  grid.on('headerclick', this.onHeaderClick, this);
  grid.on('filterchange', this.onFilterChange, this);
}, onHeaderClick:function(ct, column) {
  if (column.bpcRowExpander === true) {
    this.grid.getController().filterCurrentViewOrSelect();
  }
}, onFilterChange:function(store, filters) {
  try {
    var filterBtn = this.grid.down('[bpcType\x3dclearFilterBtn]');
    if (!filterBtn) {
      return;
    }
    if (filters.length > 0) {
      filterBtn.addCls('bpc-monitor-filterActive');
    } else {
      filterBtn.removeCls('bpc-monitor-filterActive');
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onFilterChange', dump:e, stack:true, level:'error'});
  }
}, getHeaderConfig:function() {
  var me = this;
  var lockable = me.grid.ownerLockable;
  var grid = me.grid;
  var moduleId = grid.config.moduleId;
  var showFilterFields = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.guiShowFilterBar);
  var returnExpander = {width:me.headerWidth, bpcRowExpander:true, ignoreExport:true, lockable:false, autoLock:true, sortable:false, resizable:false, draggable:false, hideable:false, menuDisabled:true, tdCls:Ext.baseCSSPrefix + 'grid-cell-special', innerCls:Ext.baseCSSPrefix + 'grid-cell-inner-row-expander', style:'cursor: pointer;', tooltip:BpcCommon.Api.getTranslation('MONITOR_FILTER_CURRENT_VIEW_OR_SELECTION'), isLocked:function() {
    return lockable && (lockable.lockedGrid.isVisible() || this.locked);
  }, editRenderer:function() {
    return '\x26#160;';
  }, getColumnState:function() {
    return undefined;
  }, text:'\x3ci style\x3d"cursor: pointer;" class\x3d"fa fa-crosshairs"\x3e\x3c/i\x3e', iconCls:'x-fal fa-filter', layout:{type:'vbox', align:'stretch', pack:'start'}, items:[{xtype:'box', cls:'x-fas fa-times-circle fa-fw', itemId:'clearFilterBox', bpcType:'clearFilterBtn', style:'cursor: pointer; padding-top: 10px;', width:me.headerWidth, hidden:!showFilterFields, listeners:{click:{element:'el', fn:'removeAllFilter'}, render:function(c) {
    Ext.create('Ext.tip.ToolTip', {target:c.getEl(), html:BpcCommon.Api.getTranslation('MONITOR_REMOVE_FILTER')});
  }}}], triggerFilterFields:true};
  var showExpander = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.detailViewInlineEnabled);
  if (showExpander) {
    returnExpander = Ext.apply(returnExpander, {renderer:function() {
      return '\x3cdiv class\x3d"' + Ext.baseCSSPrefix + 'grid-row-expander" role\x3d"presentation" tabIndex\x3d"0"\x3e\x3c/div\x3e';
    }, processEvent:function(type, view, cell, rowIndex, cellIndex, e, record) {
      if (type === 'click' && e.getTarget('.' + Ext.baseCSSPrefix + 'grid-row-expander') || type === 'keydown' && e.getKey() === e.SPACE) {
        me.toggleRow(rowIndex, record);
        return me.selectRowOnExpand;
      }
    }});
  }
  return returnExpander;
}});
Ext.define('monitor.component.grid.plugin.CustomRenderer', {alias:'plugin.monitorCustomRenderer', config:{rendererConfigMap:{}, defaultColumnRendererConfigMap:{}, hostCmp:undefined}, DEFAULT_RENDERER_NAME:'defaultRenderer', NO_RENDERER_NAME:'disabledCustomRenderer_', constructor:function(config) {
  var me = this;
  config = config || {};
  me.initConfig(config);
}, init:function(hostCmp) {
  var me = this;
  if (!hostCmp) {
    return;
  }
  me.setHostCmp(hostCmp);
  me.setRendererConfigMap(BpcCommon.Api.getSetting(hostCmp.moduleId, monitor.assets.ConfigKeys.columnCustomRenderer));
  me.setDefaultColumnRendererConfigMap(BpcCommon.Api.getSetting(hostCmp.moduleId, monitor.assets.ConfigKeys.columnConfig));
  hostCmp.on('afterrender', me.updateRendererInDefaultColumnRendererConfigMap, me);
}, applyRendererConfigMap:function(rendererConfigMap) {
  var preparedConfigMap = {};
  if (Ext.isObject(rendererConfigMap)) {
    Ext.Object.each(rendererConfigMap, function(rendererId, rendererConfig) {
      rendererConfig = rendererConfig || {};
      var valueMap = {};
      Ext.Object.each(rendererConfig.valueMap, function(key, value) {
        value = value || {};
        valueMap[String(key).toLowerCase()] = {color:value.color || 'black', iconCls:value.iconCls || ''};
        if (Ext.isDefined(value.label)) {
          valueMap[String(key).toLowerCase()].label = BpcCommon.Api.getTranslation(value.label);
        }
      });
      if (!valueMap['!']) {
        valueMap['!'] = {color:'black', label:'', iconCls:''};
      }
      if (!valueMap['*']) {
        valueMap['*'] = {color:'black', iconCls:''};
      }
      preparedConfigMap[String(rendererId).toLowerCase()] = {iconOnly:rendererConfig.iconOnly === true, valueMap:valueMap};
    });
  }
  return preparedConfigMap;
}, applyDefaultColumnRendererConfigMap:function(columnConfig) {
  var me = this;
  var preparedConfigMap = {};
  if (Ext.isArray(columnConfig)) {
    Ext.Array.each(columnConfig, function(column) {
      column = column || {};
      if (!column.customRenderer) {
        var id = column.id || column.dataIndex;
        var config = Ext.clone(column);
        config.xtype = config.xtype || 'gridcolumn';
        try {
          var columnCmp = Ext.create(config);
          if (columnCmp.renderer) {
            preparedConfigMap[String(id).toLowerCase()] = {renderer:columnCmp.renderer.bind(columnCmp), columnConfig:column};
          }
          if (columnCmp instanceof Ext.grid.column.Widget) {
            columnCmp.ownerGrid = {destroyManagedWidgets:Ext.emptyFn};
          }
          columnCmp.destroy();
        } catch (e) {
          Ext.log({msg:me.self.getName() + ': ERROR ', dump:e, stack:true, level:'error'});
        }
      }
    });
  }
  return preparedConfigMap;
}, updateRendererInDefaultColumnRendererConfigMap:function() {
  var me = this;
  Ext.Object.each(me.getDefaultColumnRendererConfigMap(), function(key, defaultColumnRendererConfig) {
    var colId = defaultColumnRendererConfig.columnConfig.stateId || defaultColumnRendererConfig.columnConfig.id || defaultColumnRendererConfig.columnConfig.columnId || defaultColumnRendererConfig.columnConfig.dataIndex;
    var column = me.getHostCmp().down('gridcolumn[columnId\x3d' + colId + ']');
    if (column && column.renderer) {
      defaultColumnRendererConfig.renderer = column.renderer.bind(column);
    }
  });
}, render:function(rendererId, value, icon, label, suppressDefaultRenderer) {
  var me = this;
  var result = '';
  if (!rendererId || rendererId === me.NO_RENDERER_NAME) {
    return value;
  }
  var rendererConfig = me.getRendererConfigMap()[String(rendererId).toLowerCase()];
  if (!rendererConfig) {
    if (rendererId.startsWith(me.NO_RENDERER_NAME) || suppressDefaultRenderer === true) {
      var columnRendererConfig = me.getDefaultColumnRendererConfigMap()[String(rendererId).replace(me.NO_RENDERER_NAME, '').toLowerCase()];
      if (columnRendererConfig && columnRendererConfig.renderer) {
        return columnRendererConfig.renderer(value);
      }
      return value;
    }
    rendererConfig = me.getRendererConfigMap()[String(me.DEFAULT_RENDERER_NAME).toLowerCase()];
    rendererId = me.DEFAULT_RENDERER_NAME;
    if (!rendererConfig) {
      return value;
    }
  }
  var valueConfig = me.getValueConfig(rendererId, value);
  if (!Ext.isBoolean(icon)) {
    icon = true;
  }
  if (!Ext.isBoolean(label)) {
    label = rendererConfig.iconOnly !== true;
  }
  if (icon && valueConfig.iconCls) {
    result = result + "\x3ci class\x3d' fa-lg " + valueConfig.iconCls + "' style\x3d'color:" + valueConfig.color + "'\x3e\x26nbsp;\x3c/i\x3e ";
  }
  if (label) {
    var labelString = value || '';
    if (Ext.isDefined(valueConfig.label)) {
      labelString = valueConfig.label;
    }
    result = '' + result + Ext.util.Format.htmlEncode2(labelString);
  }
  return result;
}, getColumnRenderer:function(rendererId, icon, label, cfg) {
  cfg = cfg === undefined ? {} : cfg;
  var me = this;
  var renderHelpArr = String(rendererId).split('!_!');
  if (renderHelpArr.length === 2) {
    try {
      var rendererClass = Ext.ClassManager.get(renderHelpArr[0] + '.Module');
      if (rendererClass) {
        return rendererClass[renderHelpArr[1]](cfg);
      }
      return null;
    } catch (e) {
      Ext.log({msg:this.self.getName() + ': ERROR getColumnRenderer', dump:e, stack:true, level:'error'});
    }
  }
  return function(value, meta) {
    if (rendererId.startsWith(me.NO_RENDERER_NAME)) {
      var columnId = rendererId.replace(me.NO_RENDERER_NAME, '');
      var defaultColumnRenderer = me.getDefaultColumnRendererConfigMap()[columnId.toLowerCase()];
      if (defaultColumnRenderer) {
        return defaultColumnRenderer.renderer.apply(defaultColumnRenderer.renderer, arguments);
      }
    }
    if (meta) {
      var tooltip = me.render(rendererId, value, false, true) || value;
      meta.tdAttr = 'data-qtip\x3d"' + tooltip + '"';
    }
    return me.render(rendererId, value, icon, label);
  };
}, getValueConfig:function(rendererId, value) {
  var me = this;
  var rendererConfig = me.getRendererConfigMap()[String(rendererId).toLowerCase()];
  if (!rendererConfig && !rendererId.startsWith(me.NO_RENDERER_NAME)) {
    rendererConfig = me.getRendererConfigMap()[String(me.DEFAULT_RENDERER_NAME).toLowerCase()];
  }
  if (!rendererConfig) {
    return {iconCls:'', color:'', label:value};
  }
  var mapValue = value;
  if (value === undefined || value === null) {
    mapValue = '!';
  }
  return rendererConfig.valueMap[String(mapValue).toLowerCase().trim()] || rendererConfig.valueMap['*'];
}, getColumnRendererByColumnConfig:function(columnConfig, icon, label) {
  var me = this;
  if (!Ext.isObject(columnConfig)) {
    return;
  }
  return me.getColumnRenderer(me.getRendererIdByColumnConfig(columnConfig), icon, label, columnConfig);
}, getRendererIdByColumnConfig:function(columnConfig) {
  var me = this;
  if (!Ext.isObject(columnConfig)) {
    return;
  }
  var rendererId = columnConfig.id || columnConfig.dataIndex;
  if (Ext.isString(columnConfig.customRenderer) && columnConfig.customRenderer !== '') {
    rendererId = columnConfig.customRenderer;
  } else {
    if (columnConfig.customRenderer === true) {
    } else {
      rendererId = '' + me.NO_RENDERER_NAME + rendererId;
    }
  }
  return rendererId;
}});
Ext.define('monitor.model.Action', {extend:'Ext.data.Model', fields:[{name:'name'}, {name:'label'}, {name:'id'}, {name:'iconCls'}, {name:'tooltip'}, {name:'sortValue', defaultValue:1}, {name:'params'}, {name:'column'}, {name:'selection'}, {name:'target'}]});
Ext.define('monitor.model.Filter', {extend:'Ext.data.Model', alias:'model.monitorFilterModel', fields:[{name:'property', type:'string'}, {name:'value'}, {name:'operator', type:'string'}, {name:'id'}]});
Ext.define('monitor.model.Grid', {extend:'Ext.data.Model', alias:'model.monitorGridModel', idProperty:'PROCESSID'});
Ext.define('monitor.model.Sorter', {extend:'Ext.data.Model', alias:'model.monitorSorterModel', fields:[{name:'property', type:'string'}, {name:'direction', type:'string'}, {name:'id'}]});
Ext.define('monitor.model.Starter', {extend:'Ext.data.Model', idProperty:'key', fields:['label', 'key', 'parameters', 'parametersEndpoint', 'description']});
Ext.define('monitor.model.State', {extend:'Ext.data.Model', alias:'model.monitorStateModel', fields:[{name:'name', type:'string'}, {name:'id', type:'int'}, {name:'favorite', type:'boolean'}, {name:'state', type:'auto', defaultValue:{}, convert:null}]});
Ext.define('monitor.plugin.ColumnHook', {extend:'Ext.grid.column.Column', alias:'widget.monitorColumnHook', context:{instanceId:undefined}, hidden:true, hideable:false, dataIndex:'monitorColumnHook', pluginPromiseArray:[], columnDefaults:{items:[{xtype:'textfield', editable:false, fieldStyle:'cursor: not-allowed;', margin:0, ui:'columnHeaderField'}], stateId:'plugin_column', columnId:'plugin_column', minWidth:32}, initComponent:function() {
  var me = this;
  me.context.moduleId = 'monitor';
  var activeInstance = me.context.instanceId;
  me.stateId = me.columnId;
  me.callParent();
  if (!activeInstance) {
    return;
  }
  me.pluginPromiseArray = BpcCommon.Api.getPluginComponentsAsync('monitor_column', me.context);
  me.pluginPromiseArray.forEach(function(pluginPromise) {
    pluginPromise.then(me.onPluginResolve.bind(me, pluginPromise), me.onPluginReject.bind(me, pluginPromise));
  });
}, onPluginResolve:function(pluginPromise, pluginCmp) {
  if (!BpcCommon.Api.isUserAllowedToSee(pluginCmp.pluginConfiguration)) {
    return;
  }
  var me = this;
  var columnConfig = pluginCmp;
  if (pluginCmp.pluginConfiguration && pluginCmp.pluginConfiguration.configuration && pluginCmp.pluginConfiguration.configuration.wrap === true) {
    columnConfig = me.wrapCmpWithColumn(pluginCmp);
  }
  if (pluginCmp.pluginConfiguration && pluginCmp.pluginConfiguration.configuration && pluginCmp.pluginConfiguration.configuration.columnConfig) {
    columnConfig = Ext.apply(columnConfig, pluginCmp.pluginConfiguration.configuration.columnConfig);
  }
  columnConfig = Ext.apply({xtype:'gridcolumn', stateId:pluginCmp.pluginConfiguration.id, columnId:pluginCmp.pluginConfiguration.id, moduleId:me.context.instanceId}, columnConfig, me.columnDefaults);
  var pluginCmpInstance = columnConfig.isComponent ? columnConfig : Ext.create(columnConfig);
  if (!(pluginCmpInstance instanceof Ext.grid.column.Column)) {
    Ext.log({msg:this.self.getName() + ': onPluginResolve - failed to add plugin ' + pluginCmpInstance.id + ' as column, please use configuration wrap:true', level:'warn'});
    pluginCmp = me.wrapCmpWithColumn(pluginCmp);
    pluginCmpInstance = me.ownerCt.add(pluginCmp);
  } else {
    me.ownerCt.add(pluginCmpInstance);
  }
  me.ownerCt.moveBefore(pluginCmpInstance, me);
  if (!pluginCmpInstance.text || pluginCmpInstance.text === ' ') {
    pluginCmpInstance.setText(BpcCommon.Api.getTranslation('MONITOR_PLUGIN_COLUMN'));
  }
  me.removePluginPromise(pluginPromise);
}, onPluginReject:function(pluginPromise, errorMsg) {
  var me = this;
  Ext.log({msg:me.self.getName() + ': onPluginReject: Plugin loading failed:\n' + errorMsg, level:'error'});
  me.removePluginPromise(pluginPromise);
}, removePluginPromise:function(pluginPromise) {
  var me = this;
  Ext.Array.remove(me.pluginPromiseArray, pluginPromise);
  if (me.pluginPromiseArray.length === 0 && me.items.getCount() === 0) {
    me.hide();
  }
}, wrapCmpWithColumn:function(cmp) {
  return Ext.apply({xtype:'widgetcolumn', widget:cmp, text:this.text}, this.columnDefaults);
}});
Ext.define('monitor.plugin.ColumnHookInterface', {extend:'BpcCommon.plugin.HookContainer', inheritableStatics:{NAME:'Column', HOOK_ID:'monitor_column', MODULE:'monitor'}});
Ext.define('monitor.plugin.DetailHook', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.monitorDetailHook', title:'Plugins', iconCls:'x-fal fa-puzzle-piece', inheritableStatics:{NAME:'Detail View', HOOK_ID:'monitor_detail_view', MODULE:'monitor', HOOK_LEVEL:'module'}, context:{moduleId:'monitor'}, autoInjectPlugins:true, pluginTarget:'self', hidden:false});
Ext.define('monitor.plugin.Instance', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.monitorInstanceHook', inheritableStatics:{NAME:'Monitor Instance', HOOK_ID:'monitor_root', MODULE:'monitor', HOOK_LEVEL:'instance'}});
Ext.define('monitor.plugin.wrapper.PluginInterface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Monitor Wrapper', COMPONENT_XTYPE:'monitorWrapperPlugin', PLUGIN_ID:'monitor_wrapper'}});
Ext.define('monitor.plugin.wrapper.Wrapper', {extend:'Ext.Container', alias:'widget.monitorWrapperPlugin', layout:'card', viewModel:{parent:BpcCommon.Api.getGlobalViewModel()}, initComponent:function() {
  var me = this;
  me.items = [];
  if (!(me.pluginConfiguration && me.pluginConfiguration.configuration && me.pluginConfiguration.configuration.monitorId)) {
    me.items.push({xtype:'bpcCenterMessageCmp', message:'Missing monitorId config'});
    me.callParent();
    return;
  } else {
    if (!BpcCommon.Util.isStringEqual(BpcCommon.Api.getBaseModuleIdById(me.pluginConfiguration.configuration.monitorId), 'monitor')) {
      me.items.push({xtype:'bpcCenterMessageCmp', message:"can't get monitor instance for configured monitorId"});
      me.callParent();
      return;
    }
  }
  Ext.applyIf(me, me.pluginConfiguration.configuration.wrapperConfiguration);
  if (me.pluginConfiguration.configuration.monitorConfiguration && me.pluginConfiguration.context.record) {
    var stringConfig = JSON.stringify(me.pluginConfiguration.configuration.monitorConfiguration);
    Ext.Object.each(me.pluginConfiguration.context.record.getData(), function(key, value) {
      stringConfig = stringConfig.replaceAll('record.' + key, value);
    });
    me.pluginConfiguration.configuration.monitorConfiguration = JSON.parse(stringConfig);
  }
  me.items.push({xtype:'bpcCenterMessageCmp', message:'CORE_LOADING', messageIconCls:'x-fal fa-spinner fa-spin'});
  me.callParent();
  me.on('show', function() {
    var me = this;
    Ext.defer(function() {
      me.monitorCmp = me.add(Ext.applyIf({xtype:'bpcMonitor', moduleId:me.pluginConfiguration.configuration.monitorId}, me.pluginConfiguration.configuration.monitorConfiguration));
      me.getLayout().setActiveItem(me.monitorCmp);
    }, 100);
    var btn = me.add({xtype:'button', floating:true, iconCls:BpcCommon.Icons.LINK, handler:BpcCommon.Api.showModule.bind(BpcCommon.Api, me.pluginConfiguration.configuration.monitorId, false, {}, [], false)});
    btn.showBy(me, 'tr-tr');
  }, me, {single:true});
  me.on('show', function() {
    me.query('monitorGrid').forEach(function(monitorGrid) {
      monitorGrid.getController().onViewChange();
    });
  });
}});
Ext.define('monitor.store.State', {extend:'Ext.data.Store', alias:'store.monitorState', requires:['monitor.model.State'], model:'monitor.model.State', stateModel:undefined, setStateModel:function(stateModel) {
  this.stateModel = stateModel;
  this.setData(stateModel.get('value'));
}, getStateModel:function() {
  return this.stateModel;
}});
Ext.define('monitor.store.Store', {extend:'Ext.data.BufferedStore', alias:'store.process', leadingBufferZone:50, trailingBufferZone:50, pageSize:300, autoLoad:false, proxy:{type:'ajax', url:undefined, reader:{type:'json', rootProperty:'data', totalProperty:'totalCount', keepRawData:true}, extraParams:{query:''}, actionMethods:{create:'POST', read:'POST', update:'POST', destroy:'POST'}}, constructor:function(config) {
  var me = this;
  me.callParent([config]);
  me.on('beforeprefetch', me.updateStoreParams, me);
  me.on('beforeload', me.fixReloadParams, me);
}, updateStoreParams:function(store, operation) {
  var me = this;
  var params = operation.getParams() || {};
  params.queryId = me.queryId + '_page:' + operation.getPage();
  operation.setParams(params);
}, fixReloadParams:function(store, options) {
  var me = this;
  if (!me.lastRequestStart || !me.preserveScrollOnReload) {
    options.count = options.count || me.viewSize;
  }
}, sort:function(field, direction, mode) {
  var me = this;
  var bpcSortMode = this.multiSortMode;
  var sorters = me.getSorters();
  if (sorters.getByKey(field)) {
    var oldDirection = sorters.getByKey(field).getDirection();
    if (oldDirection === 'ASC') {
      direction = 'DESC';
    } else {
      direction = 'ASC';
    }
  }
  if (arguments.length === 0) {
    if (me.getRemoteSort()) {
      me.load();
    } else {
      me.forceLocalSort();
    }
  } else {
    mode = bpcSortMode ? 'append' : mode;
    if (mode === 'append') {
      var multiSortLimit = sorters.getMultiSortLimit();
      var nrOfCurrentSorters = sorters.length;
      if (nrOfCurrentSorters >= multiSortLimit && !sorters.containsKey(field)) {
        sorters.removeAt(0);
      }
    }
    sorters.addSort(field, direction, mode);
  }
}, getState:function() {
  try {
    var result = this.callParent();
    if (result && result.grouper) {
      delete result.grouper;
    }
    return result;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getState', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.store.StoreChained', {extend:'Ext.data.ChainedStore'});
Ext.define('monitor.view.MainModel', {extend:'Ext.app.ViewModel', alias:'viewmodel.monitorMainViewModel', data:{moduleId:undefined, totalCount:0, activeFilter:0, activeSorter:0, activeSortOrder:'', activeGrid:undefined, activeGridSelection:[], instanceStoreUrl:undefined, detailViewInline:undefined, detailViewPopup:undefined, detailViewEast:undefined, processAction:true, globalFilterValue:'', stackedCount:0, groupField:undefined, actions:undefined, monitorTitle:'Virtimo BPC - Monitor', autoRefreshDisabled:false, 
showAutoFilter:false, hideStartProcess:true, hideAlternativeMessage:true, hideExportPartnerManagement:true, stateModel:undefined, processActionsEnabled:undefined, processActionsColumns:undefined, processActionsSeparator:undefined, monitorData:'MONITOR_DATASETS', monitorFilter:'MONITOR_FILTER_ACTIVE', monitorSorter:'MONITOR_SORTER_ACTIVE', activeState:undefined, activeStateDirty:false, setting:{}, right:{}, moduleState:{}}, formulas:{totalItems:{get:function(get) {
  var total = get('totalCount');
  if (BpcCommon.Api.getSetting(get('moduleId'), monitor.assets.ConfigKeys.gridMultipleViews)) {
    var multiGridConf = BpcCommon.Api.getSetting(get('moduleId'), monitor.assets.ConfigKeys.gridMultipleViewsConfig);
    if (multiGridConf.multiViewMode === 'stacked') {
      total = get('stackedCount');
    }
  }
  var totalString = Ext.util.Format.number(total, '0,000');
  var countLimit = BpcCommon.Api.getSetting('monitor', monitor.assets.ConfigKeys.dataCountLimit);
  if (total >= countLimit) {
    totalString = '\x3e' + String(totalString);
  }
  return totalString;
}}, globalFilterActive:{get:function(get) {
  var query = get('globalFilterValue');
  return query && query.length > 0;
}}}});
Ext.define('monitor.view.contextmenu.ContextMenuController', {extend:'Ext.app.ViewController', alias:'controller.contextMenuController', requires:[], grid:undefined, gridController:undefined, init:function() {
  this.grid = this.getView().grid;
  this.gridController = this.grid.getController();
  this.monitorController = this.grid.up('bpcMonitor').getController();
}, openSplitView:function() {
  var mainVm = this.grid.lookupViewModel();
  var gridRefs = this.monitorController.getReferences();
  var detailPanelEast = gridRefs.detailPanelEast;
  var moduleId = this.getView().moduleId;
  var selectionModel = this.grid.getSelectionModel();
  var selection = selectionModel.getSelection();
  var record = selection[0];
  var conf = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.detailViewEastConfig);
  if (detailPanelEast.hidden) {
    try {
      var detailedContainer = this.gridController.createDetailContainer(conf, record, mainVm, this.grid, 'detailViewEast');
      detailPanelEast.removeAll();
      detailPanelEast.add(detailedContainer);
      detailPanelEast.show().expand(true);
    } catch (e) {
      Ext.log({msg:'Error in split view. ' + e, level:'error'});
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ERROR_IN_SPLIT_VIEW') + ': ' + e);
    }
  }
}, openCopyPasteBox:function(item) {
  var copyPasteValue = this.getView().feature_copyCell_value;
  var dataIndex = item.dataIndex;
  var fname = this.grid.down('[dataIndex\x3d' + dataIndex + ']');
  if (fname.format) {
    var dateFormat = fname.format;
    var dt = new Date(copyPasteValue);
    copyPasteValue = Ext.Date.format(dt, dateFormat);
  }
  Ext.createByAlias('widget.bpcCopyPasteWindow', {copyPasteValue:copyPasteValue}).show();
}, filterCurrentViewOrSelect:function() {
  this.gridController.filterCurrentViewOrSelect();
}, setMonitorFilter:function() {
  this.monitorController.setMonitorFilter(false, this.getView().feature_copyCell_value);
}, setMonitorFilterOnColumn:function() {
  this.monitorController.setMonitorFilter(false, this.getView().column.dataIndex + ':' + this.getView().feature_copyCell_value);
}, removeSingleSorter:function(item) {
  this.gridController.removeSorter(item.dataIndex);
}, removeColumnFilter:function() {
  var filter = this.getView().column.filter;
  filter.setValue(filter.emptyValue);
}, setColumnFilter:function() {
  var column = this.getView().column;
  var colType = column.xtype;
  if (colType !== 'datecolumn') {
    var filterObj = column.filter || {};
    this.gridController.addFilterToStore({property:column.dataIndex, value:[this.getView().feature_copyCell_value], source:filterObj.source});
  } else {
    var field = column.down('field');
    if (field && field.getXType() !== 'simpleDate') {
      var start = new Date(this.getView().feature_copyCell_value);
      var end = Ext.Date.add(start, Ext.Date.DAY, 1);
      start = start.setHours(0, 0, 0);
      end = end.setHours(0, 0, 0);
      var startFilter = this.createFilterObj(this.getView().column, '_start', 'gte', start);
      var endFilter = this.createFilterObj(this.getView().column, '_end', 'lt', end);
      this.gridController.addFilterToStore([startFilter, endFilter]);
    } else {
      field.activateFilter(this.getView().feature_copyCell_value);
    }
  }
}, setExclusiveColumnFilter:function() {
  this.gridController.removeAllFilter();
  this.setColumnFilter();
}, createFilterObj:function(col, idSuffix, operator, date) {
  var filter = new Ext.util.Filter({id:col + idSuffix, property:col, operator:operator, value:date});
  return filter;
}});
Ext.define('monitor.view.contextmenu.ContextMenu', {extend:'Ext.menu.Menu', alias:['widget.monitorContextMenu'], requires:['monitor.view.contextmenu.ContextMenuController'], controller:'contextMenuController', hidden:true, copyCell:undefined, column:undefined, grid:undefined, moduleId:undefined, feature_copyCell_value:undefined, viewModel:{data:{moduleId:undefined, collabEnabled:false}}, collabEnabled:false, initComponent:function() {
  var me = this;
  me.getViewModel().set('moduleId', me.moduleId);
  if (me.collaborationConfig) {
    me.getViewModel().set('collabEnabled', me.collaborationConfig.collabEnabled);
    me.collabEnabled = me.collaborationConfig.collabEnabled;
  }
  var splitViewEnabled = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.detailViewEastEnabled) && BpcCommon.Api.getLicenseInformationForKey(monitor.assets.LicenseKeys.detailViewSplit) !== false;
  var selectedRecords = me.grid.getSelection();
  var noSelection = selectedRecords.length === 0;
  var selection = !noSelection;
  var multiRowSelection = selectedRecords.length > 1;
  var filterEnabled = true, filterMenuTooltip;
  if (me.column.filter === false || !me.column.filter || me.column.filter.type === false) {
    filterEnabled = false;
    filterMenuTooltip = BpcCommon.Api.getTranslation('MONITOR_COLUMN_FILTER_DISABLED');
  } else {
    if (multiRowSelection) {
      filterEnabled = false;
      filterMenuTooltip = BpcCommon.Api.getTranslation('MONITOR_SINGLE_ROW_FUNCTION');
    }
  }
  me.items = [{localized:{text:{tpl:'\x3cb\x3e\x3cu\x3e{MONITOR_NO_SELECTION_WARNING}\x3c/u\x3e\x3c/b\x3e', keys:['MONITOR_NO_SELECTION_WARNING']}}, hidden:!noSelection, iconCls:BpcCommon.Icons.WARNING + ' warningColor', handler:function() {
    me.grid.setSelection(me.grid.getStore().getAt(0));
  }}, {iconCls:'x-fal fa-outdent', text:BpcCommon.Api.getTranslation('MONITOR_MENU_SPLIT_VIEW'), handler:'openSplitView', hidden:!splitViewEnabled || multiRowSelection, itemId:'menu-item-splitview'}, {xtype:'menuseparator', hidden:!splitViewEnabled}, {iconCls:'x-fal fa-users', text:BpcCommon.Api.getTranslation('MONITOR_COLLABORATION'), itemId:'collabMenuHolder', hidden:!me.collaborationConfig.collabEnabled}, {xtype:'menuseparator', hidden:!me.collaborationConfig.collabEnabled}, {xtype:'monitorProcessActionMenu', 
  moduleId:me.moduleId, reference:'monitorProcessActionMenu', selection:selectedRecords, publishes:['hidden']}, {xtype:'menuseparator', hidden:true, bind:{hidden:'{monitorProcessActionMenu.hidden}'}}, {xtype:'monitorModuleJumpMenu', moduleId:me.moduleId, reference:'monitorModuleJumpMenu', selection:selectedRecords, publishes:['hidden']}, {xtype:'menuseparator', hidden:true, bind:{hidden:'{monitorModuleJumpMenu.hidden}'}}, {xtype:'monitorStartProcessMenu', moduleId:me.moduleId, reference:'monitorStartProcessMenu', 
  publishes:['hidden']}, {xtype:'menuseparator', hidden:true, bind:{hidden:'{monitorStartProcessMenu.hidden}'}}, {xtype:'monitorChangeStateMenu', moduleId:me.moduleId, reference:'monitorChangeStateMenu', publishes:['hidden']}, {xtype:'menuseparator', hidden:true, bind:{hidden:'{monitorChangeStateMenu.hidden}'}}, {iconCls:'x-fa fa-crosshairs', localized:{text:selection ? 'MONITOR_FILTER_CURRENT_SELECTION' : 'MONITOR_FILTER_CURRENT_VIEW'}, handler:'filterCurrentViewOrSelect'}, {iconCls:'x-fal fa-filter', 
  text:BpcCommon.Api.getTranslation('MONITOR_FILTER'), hidden:!filterEnabled, tooltip:filterMenuTooltip, itemId:'menu-item-filter', menu:[{iconCls:'x-fa fa-filter', text:BpcCommon.Api.getTranslation('MONITOR_SET_COLUMN_FILTER'), handler:'setColumnFilter', hidden:noSelection}, {iconCls:'x-fal fa-filter', text:BpcCommon.Api.getTranslation('MONITOR_SET_THIS_FILTER_ONLY'), handler:'setExclusiveColumnFilter', hidden:noSelection}, {iconCls:BpcCommon.Icons.DELETE, text:BpcCommon.Api.getTranslation('MONITOR_REMOVE_COLUMN_FILTER'), 
  handler:'removeColumnFilter'}, {iconCls:'x-fal fa-filter', text:BpcCommon.Api.getTranslation('MONITOR_SET_VOLLTEXTSUCHE'), handler:'setMonitorFilter', itemId:'menu-item-filter-full-text-search', hidden:noSelection}, {iconCls:'x-fal fa-filter', text:BpcCommon.Api.getTranslation('MONITOR_SET_VOLLTEXTSUCHE_COLUMN'), handler:'setMonitorFilterOnColumn', itemId:'menu-item-filter-full-text-search-column', hidden:noSelection}]}, {iconCls:BpcCommon.Icons.SORT, text:BpcCommon.Api.getTranslation('MONITOR_SORTING'), 
  menu:[{iconCls:BpcCommon.Icons.DELETE, text:BpcCommon.Api.getTranslation('MONITOR_REMOVE_SORTER'), dataIndex:me.column.dataIndex, handler:'removeSingleSorter'}]}, {iconCls:'x-fal fa-copy', text:BpcCommon.Api.getTranslation('MONITOR_COPY_CELL_CONTENT'), dataIndex:me.column.dataIndex, hidden:!me.feature_copyCell, handler:'openCopyPasteBox'}, {xtype:'menuseparator'}, {iconCls:BpcCommon.Icons.ResetIcon, text:BpcCommon.Api.getTranslation('MONITOR_RESET_VIEW'), handler:monitor.Module.stateController.resetState.bind(monitor.Module.stateController, 
  me.moduleId)}, {xtype:'bpcMonitorContextMenuViewHook', context:{instanceId:BpcCommon.Api.getActiveModuleId(), moduleId:'monitor', selection:selectedRecords}}];
  me.callParent(arguments);
  me.cmpCreated();
  me.on('hide', me.destroy, me, {delay:100});
}, cmpCreated:function() {
  Ext.GlobalEvents.fireEvent('monitor_contextMenu_created', this);
}});
Ext.define('monitor.view.MainController', {extend:'Ext.app.ViewController', alias:'controller.monitorController', requires:['monitor.view.contextmenu.ContextMenu'], control:{'#':{beforedestroy:'onBeforeDestroy', afterrender:'updateCurrentStateInformation'}, monitorTabPanel:{tabchange:'updateCurrentStateInformation'}, monitorGrid:{show:'checkActiveGrid', activate:'checkActiveGrid', selectionchange:'onSelectionChange', statesave:'updateCurrentStateInformation', load:'onMonitorLoad'}}, currentRoute:[], 
onBeforeDestroy:function() {
  try {
    var gridArray = this.getView().query('processGrid');
    Ext.Array.each(gridArray, function(grid) {
      Ext.TaskManager.stop(grid.getController().autoRefreshTaskHolder);
    });
    this.getView().applicationToolbarRight.destroy();
    this.getView().applicationToolbarLeft.destroy();
    this.getView().bpcModuleHeader.destroy();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onBeforeDestroy', dump:e, stack:true, level:'error'});
  }
}, grid:undefined, refs:undefined, vm:undefined, lastCellIndex:undefined, lastRowIndex:undefined, lastValue:undefined, lastClickedColumn:undefined, lastRecord:undefined, actionColumns:undefined, actualSelection:undefined, bpcActions:undefined, moduleId:undefined, moduleModel:undefined, ready:false, init:function() {
  var me = this;
  var vm = me.getViewModel();
  me.moduleId = me.getView().moduleId;
  me.moduleModel = BpcCommon.Api.getModuleModel(me.moduleId);
  BpcCommon.Api.getSettings(me.moduleId).each(function(setting) {
    vm.set('setting.' + setting.get('name'), Ext.clone(setting.get('value')));
  });
  me.ready = true;
}, initViewModel:function(vm) {
  for (var $jscomp$iter$2 = $jscomp.makeIterator(Object.entries(Object.getPrototypeOf(monitor.assets.ModuleRights))), $jscomp$key$$jscomp$destructuring$var0 = $jscomp$iter$2.next(); !$jscomp$key$$jscomp$destructuring$var0.done; $jscomp$key$$jscomp$destructuring$var0 = $jscomp$iter$2.next()) {
    var $jscomp$destructuring$var0 = $jscomp$key$$jscomp$destructuring$var0.value;
    {
      var $jscomp$destructuring$var1 = $jscomp.makeIterator($jscomp$destructuring$var0);
      var key = $jscomp$destructuring$var1.next().value;
      var value = $jscomp$destructuring$var1.next().value;
      if (Ext.isString(value) && value.startsWith('bpcmonitor_')) {
        vm.set('right.' + value, BpcCommon.Api.hasUserRight(value));
      }
    }
  }
}, isSplitViewActive:function() {
  var isOpen = false;
  try {
    var mainCtrlRefs = this.getReferences();
    var detailPanelEast = mainCtrlRefs.detailPanelEast;
    isOpen = detailPanelEast.isVisible(true);
  } catch (e) {
    Ext.log('error' + this.self.getName());
    isOpen = false;
  }
  return isOpen;
}, updateSplitViewWithCmp:function(cmp) {
  try {
    var mainCtrlRefs = this.getReferences();
    var detailPanelEast = mainCtrlRefs.detailPanelEast;
    detailPanelEast.removeAll();
    if (detailPanelEast.isVisible(true)) {
      try {
        detailPanelEast.add(cmp);
      } catch (e) {
        Ext.log({msg:'Error in split view. ' + e, level:'error'});
        BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ERROR_EAST_UPDATE') + ': ' + e);
      }
    }
  } catch (e$4) {
    Ext.log('error' + this.self.getName());
  }
}, setMonitorFilter:function(kill, value) {
  try {
    this.getViewModel().set('global.monitor.showSearchField', true);
    var oldValue = this.getViewModel().get('globalFilterValue');
    if (kill) {
      this.getViewModel().set('globalFilterValue', '');
    } else {
      if (oldValue !== value) {
        this.getViewModel().set('globalFilterValue', this.getViewModel().get('globalFilterValue') + ' ' + value);
      }
    }
  } catch (e) {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ERROR_SETTING_FILTER') + e);
  }
  this.getView().getActiveGrid().getController().updateActiveFilter();
}, onRouteChange:function(routeArray) {
  try {
    if (Ext.Array.equals(this.currentRoute, routeArray)) {
      return;
    }
    if (routeArray[0] === 'detailPopup') {
      this.showDetailViewForId(routeArray[1]);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onRouteChange', dump:e, stack:true, level:'error'});
  }
}, showDetailViewForId:function(id) {
  try {
    var idKey = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnId);
    var dataObj = {};
    dataObj[idKey] = id;
    var record = Ext.data.Model.create(dataObj);
    var detailedWindow = Ext.createByAlias('widget.detailWindow', {moduleId:this.getView().moduleId, selectedRecord:record, hackMode:true, grid:this.getView().getActiveGrid(), width:document.body.clientWidth * 0.8, height:document.body.clientHeight * 0.8, minWidth:document.body.clientWidth * 0.4, minHeight:document.body.clientHeight * 0.5, maxWidth:document.body.clientWidth, maxHeight:document.body.clientHeight});
    detailedWindow.show();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR showDetailViewForId', dump:e, stack:true, level:'error'});
  }
}, updateCurrentStateInformation:function() {
  var me = this;
  var vm = me.getViewModel();
  if (!me.ready) {
    return;
  }
  try {
    if (vm.get('activeState')) {
      me.getViewModel().set('activeStateDirty', !monitor.Module.stateController.compareState(monitor.Module.stateController.getCurrentState(me.moduleId), monitor.Module.stateController.getState(me.moduleId, vm.get('activeState'))));
    }
    var monitorViewTitle = '';
    var tabPanel = this.getView().down('monitorTabPanel');
    if (tabPanel && tabPanel.getActiveTab()) {
      monitorViewTitle = tabPanel.getActiveTab().getTitle();
    }
    BpcCommon.Api.setModuleInformation(this.moduleId, {moduleBrowserTitle:monitorViewTitle});
    var state = this.getView().getState();
    this.getViewModel().set('moduleState', state);
    this.getView().saveState(state);
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR updateCurrentStateInformation', dump:e, stack:true, level:'error'});
  }
}, checkActiveGrid:function(eventSource) {
  var me = this;
  me.getView().setActiveGrid(eventSource);
}, onSelectionChange:function(selModel, selection) {
  var me = this;
  if (selModel && selModel.view && selModel.view.ownerGrid === me.getView().getActiveGrid()) {
    me.getViewModel().set('activeGridSelection', selection);
  }
}, onMonitorLoad:function(bpcMonitor) {
  var me = this;
  if (bpcMonitor === me.getView().getActiveGrid()) {
    me.getViewModel().set('activeGridSelection', bpcMonitor.getSelection());
  }
}});
Ext.define('monitor.view.state.StateViewController', {extend:'Ext.app.ViewController', alias:'controller.monitorStateViewController', requires:[], toggleGrouping:function(cmp) {
  var me = this;
  this.getViewModel().set('isGrouped', cmp.getValue());
  if (cmp.getValue() !== true) {
    me.getView().down('monitorStateViewDetails:visible').down('#groupingCombo').setValue('');
  }
}, getStateObject:function() {
  var me = this;
  var stateObject = this.getViewModel().get('stateObject');
  try {
    var state = stateObject.get('state');
    var detailView = me.getView().down('monitorStateViewDetails:visible');
    var columns = Ext.Array.map(detailView.down('#columnGrid').store.getRange(), function(rec) {
      return rec.getData();
    });
    state.columns = columns;
    var sorter = Ext.Array.map(detailView.down('#sorterGrid').store.getRange(), function(rec) {
      return rec.getData();
    });
    state.storeState.sorters = sorter;
    var filter = Ext.Array.map(detailView.down('#filterGrid').store.getRange(), function(rec) {
      return rec.getData();
    });
    state.storeState.filters = filter;
    var groupingEnabled = detailView.down('#groupingCheck').getValue();
    state.groupingEnabled = groupingEnabled;
    state.groupField = detailView.down('#groupingCombo').getValue();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getStateObject', dump:e, stack:true, level:'error'});
  }
  return stateObject;
}});
Ext.define('monitor.view.state.StateToolbarItem', {extend:'Ext.button.Button', alias:'widget.monitorStateToolbarItem', requires:['monitor.view.state.StateViewController'], controller:'monitorStateToolbarItemController', hidden:true, bind:{hidden:'{!setting.' + monitor.assets.ConfigKeys.customViewsEnabled + '}'}, viewModel:{data:{currentStateId:undefined, currentStateName:'', currentStateFavorite:undefined, stateModel:undefined, updateCurrentView:'MONITOR_SAVE_VIEW_AS'}, formulas:{canUpdateCurrentState:function(get) {
  return BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.editMonitorViews) && String(get('currentStateName')).length > 0;
}}}, iconCls:monitor.assets.Icons.VIEW, localized:{tooltip:'MONITOR_VIEWS'}, menu:{plain:true, items:[{localized:{text:'MONITOR_REMOVE_FILTER'}, iconCls:'x-fal fa-times-circle', handler:'removeAllFilter'}, {localized:{text:'MONITOR_REMOVE_SORTERS'}, iconCls:'x-fal fa-ban', handler:'removeSorter'}, {xtype:'menuseparator'}, {localized:{text:'MONITOR_SAVE_CURRENT_VIEW'}, iconCls:'x-fal fa-plus-square', disabled:false, handler:'saveCurrentStatePopup', bind:{hidden:'{!' + monitor.assets.ModuleRights.editMonitorViews + 
'}'}}, {localized:{text:'MONITOR_RESET_VIEW'}, iconCls:BpcCommon.Icons.RESET, handler:'resetState'}, {localized:{text:'MONITOR_MANAGE_VIEWS'}, iconCls:BpcCommon.Icons.EDIT, handler:'openStateWindow'}, {bind:{text:'{updateCurrentView:translate}: {currentStateName:translate}', hidden:'{!canUpdateCurrentState}'}, iconCls:BpcCommon.Icons.SAVE, handler:'updateCurrentState'}, {xtype:'menuseparator'}, {localized:{text:'MONITOR_NO_FILTER_SAVED'}, itemId:'filterListPlaceholder', disabled:true, cls:'bpc-menu-item-text-default'}]}, 
initComponent:function() {
  this.getViewModel().set(monitor.assets.ModuleRights.editMonitorViews, BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.editMonitorViews));
  this.callParent();
  this.moduleInstance = this.up('toolbar').moduleInstance;
}});
Ext.define('monitor.view.toolbar.RightToolbar', {extend:'Ext.toolbar.Toolbar', requires:['monitor.view.state.StateToolbarItem'], alias:'widget.monitorRightToolbar', layout:{align:'center', pack:'start'}, initComponent:function() {
  var me = this;
  me.items = [{xtype:'tbfill'}, {xtype:'toolbar', hidden:true, bind:{hidden:'{setting.' + monitor.assets.ConfigKeys.showToolbarRightInHeader + '}'}, items:[{xtype:'monitorMultiAttachmentDownloadBtn', moduleId:me.moduleId}, {xtype:'monitorStartProcessBtn', moduleId:me.moduleId}, {xtype:'monitorChangeStateBtn', moduleId:me.moduleId}, {xtype:'monitorProcessActionBtn', moduleId:me.moduleId}, {xtype:'monitorExportBtn', moduleId:me.moduleId}, {xtype:'monitorStateToolbarItem', moduleId:me.moduleId}, {xtype:'monitorRefreshBtn', 
  moduleId:me.moduleId}]}, {xtype:'bpcMonitorRightToolbarHook', context:{moduleId:'monitor', instanceId:me.moduleInstance.moduleId}}];
  me.callParent(arguments);
}});
Ext.define('monitor.view.moduleheader.MonitorModuleHeader', {extend:'Ext.container.Container', alias:'widget.monitorModuleHeader', layout:'fit', controller:'monitorModuleHeaderController', overflowHandler:'scroller', initComponent:function() {
  var me = this;
  var content = {metadata:{items:[{xtype:'bpcMonitorMeta', cls:'bpcMonitorMetaContainer', moduleId:me.moduleId, moduleInstance:me.moduleInstance}]}, favorites:{flex:1, items:[{xtype:'monitorFavoriteToolbar', hidden:true, bind:{hidden:'{!setting.' + monitor.assets.ConfigKeys.showFavorites + '}'}, moduleId:me.moduleId, moduleInstance:me.moduleInstance}, {xtype:'tbfill'}], overflowHandler:'scroller'}, toolbar:{flex:0.9, hidden:true, bind:{hidden:'{!setting.' + monitor.assets.ConfigKeys.showToolbarRightInHeader + 
  '}'}, items:[{xtype:'tbfill'}, {xtype:'monitorModuleHeaderToolbar', moduleId:me.moduleId}], overflowHandler:'menu'}};
  var contentConfig = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.moduleHeaderContent);
  if (!Ext.isArray(contentConfig)) {
    contentConfig = ['metadata', 'favorites', 'toolbar'];
  }
  try {
    me.defaults = {moduleId:me.moduleId};
    me.items = [{xtxpe:'container', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'toolbar'}, items:contentConfig.map(function(key) {
      return content[String(key).toLowerCase()];
    })}];
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  me.callParent();
  me.getViewModel().set('moduleId', me.moduleId);
}});
Ext.define('monitor.view.Main', {extend:'Ext.panel.Panel', alias:'widget.bpcMonitor', requires:['monitor.store.Store', 'monitor.store.State', 'monitor.view.MainModel', 'monitor.view.MainController', 'monitor.Util', 'monitor.view.toolbar.RightToolbar', 'monitor.view.moduleheader.MonitorModuleHeader', 'monitor.assets.ConfigKeys', 'monitor.assets.Icons'], bpcSkipStateInjection:true, layout:'border', config:{moduleCfg:undefined, iconCls:monitor.assets.Icons.MONITOR, activeGrid:undefined}, controller:'monitorController', 
viewModel:{type:'monitorMainViewModel'}, bind:{title:'{monitorTitle:translate} - {totalItems} {monitorData:translate} - {activeFilter} {monitorFilter:translate}' + ' - {activeSorter} {monitorSorter:translate} {activeSortOrder}'}, stateful:true, stateId:undefined, moduleCfg:undefined, moduleRoute:undefined, moduleId:undefined, tools:[{iconCls:'x-fal fa-cog', bind:{hidden:'{!global.role.bpcadmin}'}, handler:function() {
  var activeModuleId = BpcCommon.Api.getActiveModuleId();
  BpcCommon.Api.showModule('_core', false, undefined, [BpcCommon.Api.getBaseModuleIdById(activeModuleId), activeModuleId]);
}}], plugins:{monitorCustomRenderer:true}, initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  var errorState = me.verifyMonitorConfig();
  me.itemId = me.xtype + '_' + me.moduleId;
  BpcCommon.Performance.mark('monitor_main_init_start');
  try {
    vm.set('moduleId', me.moduleId);
    vm.set('moduleInstance', me.moduleInstance);
    me.stateId = 'monitorMainView_' + me.moduleId;
    me.header = !me.getSetting(monitor.assets.ConfigKeys.moduleHeaderEnabled);
    me.bpcModuleHeader = Ext.create({xtype:'monitorModuleHeader', moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}});
    me.instanceStoreUrl = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + me.moduleId;
    vm.set('monitorTitle', me.getSetting('module_name'));
    vm.set(monitor.assets.ModuleRights.editMonitorViews, BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.editMonitorViews));
    if (errorState.configError === false) {
      me.items = me.createGrids();
    } else {
      me.items = [{xtype:'bpcCenterMessageCmp', message:errorState.msg, messageIconCls:errorState.iconCls}];
    }
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  me.callParent();
  if (!me.getActiveGrid()) {
    me.setActiveGrid(me.down('monitorGrid'));
  }
  me.applicationToolbarRight = Ext.create('monitor.view.toolbar.RightToolbar', {moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}});
  me.applicationToolbarLeft = Ext.create('monitor.view.toolbar.LeftToolbar', {moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}});
  vm.set('autoRefreshDisabled', !BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.autoUpdate));
  me.updateInstance(me.moduleCfg, me.moduleRoute);
  BpcCommon.Performance.markAndMeasure('monitor_main_init', 'monitor_main_init_start', 'monitor_main_init_end');
}, verifyMonitorConfig:function() {
  var me = this;
  var configDataIndex = me.getSetting(monitor.assets.ConfigKeys.dataIndex);
  var errorState = {configError:true, msg:BpcCommon.Api.getTranslation('MONITOR_MISSING_CONFIG'), iconCls:''};
  if (configDataIndex === undefined || configDataIndex === '') {
    errorState.msg += BpcCommon.Api.getTranslation('MONITOR_NO_INDEX_SET');
    errorState.iconCls = 'fas fa-exclamation-triangle';
  } else {
    errorState.configError = false;
  }
  return errorState;
}, createGrids:function() {
  try {
    var items = [];
    var me = this;
    var mainView;
    var showHeader = this.getSetting(monitor.assets.ConfigKeys.gridShowHeader);
    var mainGridObj = {id:'mainGrid', header:showHeader};
    var multipleViews = this.getSetting(monitor.assets.ConfigKeys.gridMultipleViews);
    if (multipleViews) {
      this.isMultiGrid = true;
      var gridMultipleViewsConfig = this.getSetting(monitor.assets.ConfigKeys.gridMultipleViewsConfig);
      var mode = gridMultipleViewsConfig.multiViewMode;
      var grids = [];
      var activeView = 0;
      Ext.Array.each(gridMultipleViewsConfig.views, function(view) {
        if (BpcCommon.Api.isUserAllowedToSee(view)) {
          var grid = me.gridFactory(view, mode);
          grids.push(grid);
        }
      });
      if (mode === 'stacked') {
        mainView = {xtype:'monitorStackedPanel', items:grids};
      } else {
        if (mode === 'tabbed') {
          if (activeView === 0 && Ext.isObject(gridMultipleViewsConfig.defaultView)) {
            var initialActiveGrid = gridMultipleViewsConfig.defaultView;
            var viewId = undefined;
            var checkFunction = function(object, checkFn) {
              var result = null;
              if (object && Ext.isObject(object)) {
                var keyArray = Ext.Object.getKeys(object);
                Ext.Array.each(keyArray, function(key) {
                  if (checkFn(key)) {
                    result = object[key];
                    return false;
                  }
                });
              }
              return result;
            };
            viewId = checkFunction(initialActiveGrid.organisation, BpcCommon.Api.hasUserOrganisation.bind(BpcCommon.Api));
            if (!viewId) {
              viewId = checkFunction(initialActiveGrid.role, BpcCommon.Api.hasUserRole.bind(BpcCommon.Api));
            }
            if (!viewId) {
              viewId = checkFunction(initialActiveGrid.right, BpcCommon.Api.hasUserRight.bind(BpcCommon.Api));
            }
            activeView = viewId || 0;
          }
          mainView = {xtype:'monitorTabPanel', tabPosition:gridMultipleViewsConfig.tabPosition, tabRotation:gridMultipleViewsConfig.tabRotation, items:grids, activeTab:activeView};
        }
      }
    } else {
      mainView = this.gridFactory(mainGridObj);
      mainView.region = 'center';
      mainView.title = 'mainViewGrid';
    }
    var panelEast = {region:'east', reference:'detailPanelEast', itemId:'detailPanelEast', stateful:true, stateId:'detailPanelEast' + this.moduleId, xtype:'panel', margin:'5 0 0 5', width:document.body.clientWidth * 0.3, split:true, hidden:true, collapsed:true, collapsible:true, layout:'fit', tools:[{type:'close', localized:{tooltip:'MONITOR_MAIN_CLOSE_EAST_PANEL'}, callback:function(panel) {
      panel.hide();
    }}]};
    items.push(mainView);
    items.push(panelEast);
    return items;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createGrids', dump:e, stack:true, level:'error'});
  }
}, gridFactory:function(viewObject, mode) {
  var me = this;
  try {
    var header = viewObject.header === false ? viewObject.header : true;
    var iconCls = viewObject.iconCls ? viewObject.iconCls : null;
    var margin = viewObject.margin ? viewObject.margin : '0 0 0 0';
    var textAlign = viewObject.textAlign ? viewObject.textAlign : 'left';
    var hideColumnHeaders = viewObject.hideColumnHeaders ? viewObject.hideColumnHeaders : false;
    var grid = {xtype:'processGrid', flex:1, moduleId:me.moduleId, localized:{title:viewObject.title}, bpcGridViewName:viewObject.id, tabConfig:{iconCls:iconCls, localized:{tooltip:viewObject.title}, margin:margin, textAlign:textAlign}, config:{storeUrl:me.instanceStoreUrl, moduleId:me.moduleId, moduleCfg:me.moduleCfg, bpcGridViewId:viewObject.id, gridStyles:viewObject}, header:header, hideHeaders:hideColumnHeaders};
    if (mode && mode === 'stacked') {
      if (viewObject && viewObject.ratio) {
        grid.flex = viewObject.ratio;
      }
    }
    return grid;
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR gridFactory', dump:e, stack:true, level:'error'});
  }
}, updateInstance:function(moduleCfg, routeArray) {
  var me = this;
  try {
    if (moduleCfg && Ext.Object.getAllKeys(moduleCfg).length > 0) {
      me.on('beforestaterestore', function() {
        return false;
      }, me, {single:true});
      if (moduleCfg.stateId) {
        me.applyState(monitor.Module.stateController.getState(me.moduleId, moduleCfg.stateId));
        return;
      }
      if (moduleCfg.state) {
        me.applyState(moduleCfg.state);
        return;
      }
      var grid = this.getActiveGrid();
      var store = grid.store;
      if (moduleCfg.viewId) {
        grid = this.down('#' + this.moduleId + '_' + moduleCfg.viewId);
        var monitorTabPanel = this.down('monitorTabPanel');
        if (monitorTabPanel && grid) {
          store = grid.store;
          monitorTabPanel.setActiveTab(grid);
        }
      }
      var loadStore = false;
      if (moduleCfg.storeState && moduleCfg.storeState.filters) {
        var filterArr = moduleCfg.storeState.filters;
        store.clearFilter();
        if (filterArr.length !== 0) {
          if (grid) {
            grid.clearFilterFields();
            Ext.each(filterArr, function(filter) {
              store.addFilter(filter);
              loadStore = true;
            });
          }
        }
      }
      var groupField = this.getViewModel().get('groupField');
      if (groupField) {
        store.setGroupField(groupField);
      }
      var searchQuery = moduleCfg.searchQuery || '';
      this.getViewModel().set('globalFilterValue', searchQuery);
      store.proxy.extraParams.query = searchQuery;
      if (moduleCfg.storeState && moduleCfg.storeState.sorters) {
        var sorterArr = moduleCfg.storeState.sorters;
        store.sorters.removeAll();
        if (sorterArr.length !== 0) {
          if (grid) {
            store.sorters.add(sorterArr);
            loadStore = true;
          }
        }
      }
      if (loadStore && store) {
        store.load();
      }
    }
    if (routeArray && Ext.isArray(routeArray)) {
      this.getController().onRouteChange(routeArray);
    }
    BpcCommon.Api.updateRouteWithChangeCheck('/module', ['monitor', me.moduleId], undefined, true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateInstance', dump:e, stack:true, level:'error'});
  }
}, getState:function() {
  var me = this;
  var state = me.callParent() || {};
  state.views = {};
  state.searchQuery = me.lookupViewModel().get('globalFilterValue');
  me.query('processGrid').forEach(function(monitorGrid) {
    state.views[monitorGrid.stateId] = monitorGrid.getState();
  });
  var activeGrid = me.getActiveGrid();
  if (activeGrid) {
    state.activeView = activeGrid.stateId;
  }
  state.id = me.getViewModel().get('activeState');
  state.activeStateDirty = me.getViewModel().get('activeStateDirty');
  return state;
}, applyState:function(state) {
  var me = this;
  if (state.stateReset === true) {
    me.resetState();
    return;
  }
  if (state.state) {
    state = Ext.apply(state, state.state);
    delete state.state;
  }
  me.lookupViewModel().set('activeState', state.id);
  me.lookupViewModel().set('activeStateDirty', state.activeStateDirty === true);
  var legacySearchQuery = '';
  if (state && Ext.isObject(state.views)) {
    Ext.Object.each(state.views, function(stateId, stateObj) {
      var target = me.down('monitorGrid[stateId\x3d' + stateId + ']');
      if (target && stateObj) {
        target.applyState(stateObj);
      }
      legacySearchQuery = legacySearchQuery || stateObj.searchQuery || '';
    });
  } else {
    if (state) {
      me.getActiveGrid().applyState(state);
    }
  }
  me.lookupViewModel().set('globalFilterValue', state.searchQuery || legacySearchQuery || '');
  if (state.activeView) {
    this.setActiveGrid('[stateId\x3d' + state.activeView + ']');
  }
}, resetState:function() {
  var clearState = {columns:undefined, storeState:{sorters:[], filters:[]}, groupingEnabled:false};
  var state = {id:undefined, views:{}};
  this.query('monitorGrid').forEach(function(grid) {
    var gridState = Ext.clone(clearState);
    gridState.storeState.sorters = grid.createInitialSorter();
    state.views[grid.stateId] = gridState;
  });
  this.applyState(state);
}, getLeftToolbar:function() {
  return this.applicationToolbarLeft;
}, getRightToolbar:function() {
  return this.applicationToolbarRight;
}, getGrid:function() {
  return this.down('processGrid');
}, getGridList:function() {
  return this.query('processGrid');
}, getStore:function() {
  var grid = this.getGrid();
  grid.getStore();
  return grid.getStore();
}, getModuleHeader:function() {
  return BpcCommon.Api.getModuleHeader();
}, updateModuleHeaderSorter:function(sorters) {
  try {
    var me = this;
    if (!me.bpcModuleHeader.down('bpcMonitorMeta')) {
      return;
    }
    this.updateSorterViewModel(sorters);
    if (sorters.length > 0) {
      var sortersStr = '';
      sorters.each(function(sorter) {
        var textA = '';
        if (me.columnLocalizedStrings) {
          textA = me.setSorterStringIfFilterisSet(sorter) || me.getLocalizedStringModuleHeader(sorter);
        } else {
          textA = me.getLocalizedStringModuleHeader(sorter);
        }
        var sortDirection = sorter._direction === 'ASC' ? '\x3ci class\x3d"fas fa-long-arrow-alt-up monitorInfoIcons"\x3e\x3c/i\x3e' : sorter._direction === 'DESC' ? '\x3ci class\x3d"fas fa-long-arrow-alt-down monitorInfoIcons"\x3e\x3c/i\x3e' : '';
        sortersStr += sortDirection + textA + '\x3cbr\x3e';
      });
      sortersStr = sortersStr.substring(0, sortersStr.length - 4);
      me.bpcModuleHeader.down('bpcMonitorMeta').getViewModel().set('sorters', sortersStr);
    } else {
      me.bpcModuleHeader.down('bpcMonitorMeta').getViewModel().set('sorters', '');
    }
  } catch (e) {
    Ext.log('Fehler beim updaten des Sort ranks...');
  }
}, updateModuleHeaderFilter:function(filters) {
  var me = this;
  if (!me.bpcModuleHeader.down('bpcMonitorMeta')) {
    return;
  }
  var globalFilterValue = me.getViewModel().get('globalFilterValue');
  try {
    var me$5 = this;
    if (filters.length > 0) {
      var filterStr = '';
      filters.each(function(filter) {
        var textA = me$5.getLocalizedStringModuleHeader(filter);
        var filterIcon = '\x3ci class\x3d"fal fa-filter monitorInfoIcons"\x3e\x3c/i\x3e';
        var filterValue = ': \x3ci\x3e' + filter._value + '\x3c/i\x3e';
        filterStr += filterIcon + textA + filterValue + '\x3cbr\x3e';
      });
      if (globalFilterValue && globalFilterValue.length) {
        var textA = BpcCommon.Api.getTranslation('MONITOR_SET_VOLLTEXTSUCHE');
        var filterIcon = '\x3ci class\x3d"fal fa-search monitorInfoIcons"\x3e\x3c/i\x3e';
        var filterValue = ': \x3ci\x3e' + globalFilterValue + '\x3c/i\x3e';
        filterStr += filterIcon + textA + filterValue + '\x3cbr\x3e';
      }
      filterStr = filterStr.substring(0, filterStr.length - 4);
      me$5.bpcModuleHeader.down('bpcMonitorMeta').getViewModel().set('filters', filterStr);
    } else {
      if (filters.length === 0 && globalFilterValue && globalFilterValue.length) {
        var filterStr$6 = '';
        var textA$7 = BpcCommon.Api.getTranslation('MONITOR_SET_VOLLTEXTSUCHE');
        var filterIcon$8 = '\x3ci class\x3d"fal fa-search monitorInfoIcons"\x3e\x3c/i\x3e';
        var filterValue$9 = ': \x3ci\x3e' + globalFilterValue + '\x3c/i\x3e';
        filterStr$6 += filterIcon$8 + textA$7 + filterValue$9;
        me$5.bpcModuleHeader.down('bpcMonitorMeta').getViewModel().set('filters', filterStr$6);
      } else {
        me$5.bpcModuleHeader.down('bpcMonitorMeta').getViewModel().set('filters', '');
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateModuleHeaderFilter', dump:e, stack:true, level:'error'});
  }
}, updateSorterViewModel:function(sorters) {
  var me = this;
  var sortOrderArray = [];
  var viewModel = me.getViewModel();
  viewModel.set('activeSorter', sorters.length);
  this.updateSorterItems(sorters);
  sorters.each(function(sorter) {
    var textA = me.getColumnAttributeMatch('dataIndex', sorter.getProperty(), 'text');
    sortOrderArray.push(textA);
  });
  if (sortOrderArray.length > 0) {
    viewModel.set('activeSortOrder', '(' + sortOrderArray.toString() + ')');
  } else {
    viewModel.set('activeSortOrder', '');
  }
}, getLocalizedStringModuleHeader:function(sorterOrFilter) {
  var me = this;
  var text = '';
  var property = sorterOrFilter.getProperty();
  if (me.getColumnAttributeMatch('dataIndex', property, 'text').length) {
    text = me.getColumnAttributeMatch('dataIndex', property, 'text');
  } else {
    if (me.getColumnAttributeMatch('dataIndex', property, 'localized')) {
      var localizedObj = me.getColumnAttributeMatch('dataIndex', property, 'localized');
      text = BpcCommon.Api.getTranslation(localizedObj.text);
      if (!me.columnLocalizedStrings) {
        me.columnLocalizedStrings = [];
        me.columnLocalizedStrings.push({property:property, text:text});
      } else {
        if (me.columnLocalizedStrings.length) {
          var contains = false;
          me.columnLocalizedStrings.forEach(function(obj) {
            if (obj.property === property) {
              contains = true;
            }
          });
          if (!contains) {
            me.columnLocalizedStrings.push({property:property, text:text});
          }
        }
      }
    } else {
      text = property || '';
    }
  }
  return text;
}, setSorterStringIfFilterisSet:function(sorter) {
  var me = this;
  var text = '';
  var sortProperty = sorter.getProperty();
  me.columnLocalizedStrings.forEach(function(obj) {
    if (obj.property === sortProperty) {
      text = obj.text;
    }
  });
  return text.length ? text : false;
}, getColumnAttributeMatch:function(attribute, value, returnAttribute) {
  var val = '';
  var colConfig = this.getSetting(monitor.assets.ConfigKeys.columnConfig);
  Ext.Array.each(colConfig, function(col) {
    if (col[attribute] === value) {
      if (col.localized && col.localized[returnAttribute]) {
        val = BpcCommon.Api.getTranslation(col.localized[returnAttribute]);
      } else {
        if (col[returnAttribute]) {
          val = col[returnAttribute];
        } else {
          val = col[attribute];
        }
      }
      return false;
    }
  });
  return val;
}, getSetting:function(settingName) {
  return BpcCommon.Api.getSetting(this.moduleId, settingName);
}, applyActiveGrid:function(cmpQueryStringOrCmp) {
  var me = this;
  if (!cmpQueryStringOrCmp) {
    return null;
  }
  var activeGrid = cmpQueryStringOrCmp;
  if (Ext.isString(cmpQueryStringOrCmp)) {
    activeGrid = me.down(cmpQueryStringOrCmp);
  }
  if (activeGrid instanceof Ext.grid.Panel) {
    var tabpanel = this.down('monitorTabPanel');
    if (tabpanel) {
      tabpanel.setActiveTab(activeGrid);
    }
    me.getViewModel().set('activeGridSelection', activeGrid.getSelection());
  }
  return activeGrid;
}, getMonitorMode:function() {
  var mode = 'singleMon';
  try {
    var multipleGrid = this.getSetting(monitor.assets.ConfigKeys.gridMultipleViews);
    var multipleGridCfg = this.getSetting(monitor.assets.ConfigKeys.gridMultipleViewsConfig);
    if (multipleGrid && multipleGridCfg.multiViewMode) {
      mode = multipleGridCfg.multiViewMode;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getMonitorMode', dump:e, stack:true, level:'error'});
    mode = 'error';
  }
  return mode;
}, updateDataItems:function(dataLength) {
  var metaDataCmp = this.bpcModuleHeader.down('bpcMonitorMeta');
  if (metaDataCmp) {
    metaDataCmp.getViewModel().set('itemInt', dataLength);
  }
}, updateStackedDataItems:function(dataLength) {
  var metaDataCmp = this.bpcModuleHeader.down('bpcMonitorMeta');
  if (metaDataCmp) {
    metaDataCmp.getViewModel().set('stackedInt', dataLength);
  }
}, updateFilterItems:function(filters) {
  var me = this;
  var count = filters.length;
  if (me.getViewModel().get('globalFilterValue')) {
    count++;
  }
  var metaDataCmp = this.bpcModuleHeader.down('bpcMonitorMeta');
  if (metaDataCmp) {
    metaDataCmp.getViewModel().set('filterInt', count);
  }
}, updateSorterItems:function(sorters) {
  var metaDataCmp = this.bpcModuleHeader.down('bpcMonitorMeta');
  if (metaDataCmp) {
    metaDataCmp.getViewModel().set('sortInt', sorters.length);
  }
}, updatelastReplication:function(lastReplicationDate) {
  var metaDataCmp = this.bpcModuleHeader.down('bpcMonitorMeta');
  if (metaDataCmp) {
    metaDataCmp.getViewModel().set('lastReplication', lastReplicationDate);
  }
}, downloadFile:function(record) {
  var proxyId = BpcCommon.Api.getSetting(this.moduleId, 'inubit_proxyId');
  if (!proxyId || proxyId === '') {
    BpcCommon.Api.showNotification({text:'Fehler beim Datei herunterladen. Konfiguration ' + " 'inubit_proxyId' fehlerhaft.", popUp:true, type:'ERROR'});
    return;
  }
  var url = this.createFileDownloadUrl(record);
  if (!Ext.isEmpty(url)) {
    window.open(url, '_blank');
  } else {
    BpcCommon.Api.showNotification({text:'Fehler beim Datei herunterladen. Konfiguration ' + monitor.assets.ConfigKeys.columnFile + ' fehlerhaft.', popUp:true, type:'ERROR'});
  }
}, createFileDownloadUrl:function(record) {
  var url = null;
  var moduleId = this.moduleId;
  var processIDkey = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnHistoryId);
  var childIDKey = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnHistorySubId);
  if (BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.functionMainGridAttachments)) {
    processIDkey = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnId);
  }
  var childId = encodeURIComponent(record.get(childIDKey));
  if (processIDkey.includes('.raw')) {
    processIDkey = processIDkey.substring(0, processIDkey.lastIndexOf('.'));
  }
  if (processIDkey.includes('.lowercase')) {
    processIDkey = processIDkey.substring(0, processIDkey.lastIndexOf('.'));
  }
  var processId = encodeURIComponent(record.get(processIDkey));
  var prefix = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/';
  var blob_field = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnFile);
  if (!Ext.isEmpty(blob_field)) {
    url = prefix + moduleId + '/data/' + processId + '/' + childId + '/' + blob_field;
  }
  return url;
}});
Ext.define('monitor.view.contextmenu.PluginHook', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcMonitorContextMenuViewHook', inheritableStatics:{NAME:'Monitor Kontextmenu', HOOK_ID:'monitor_context_menu', HOOK_LEVEL:'instance'}, autoInjectPlugins:true, pluginTarget:'^', hidden:true});
Ext.define('monitor.view.detail.ActionPanelController', {extend:'Ext.app.ViewController', alias:'controller.actionPanelController', listen:{global:{monitorProcessAction:'onMonitorProcessAction', monitorStartProcess:'onMonitorProcessAction'}}, onMonitorProcessAction:function() {
  var me = this;
  var view = me.getView();
  if (view.closeOnAction === true && view.up('window')) {
    view.up('window').close();
  }
}});
Ext.define('monitor.view.detail.ActionPanel', {extend:'Ext.panel.Panel', alias:'widget.actionPanel', requires:['monitor.view.detail.ActionPanelController'], localized:{title:'MONITOR_ACTIONS'}, controller:'actionPanelController', record:undefined, layout:{type:'vbox', align:'stretch'}, stateful:true, stateId:undefined, closeOnAction:false, initComponent:function() {
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowActionPanel' + this.moduleId;
  this.items = this.createItems(this.record);
  this.callParent(arguments);
}, createItems:function(record) {
  var baseConfig = {vertical:undefined, layout:{type:'vbox', align:'stretch'}, moduleId:this.moduleId, padding:'5 0 0 0', defaults:{ui:'default', margin:'2 0 2 0'}};
  return [Ext.apply({}, baseConfig, {xtype:'monitorProcessActionToolbar', selectedProcesses:[record]}), {xtype:'box', height:3}, Ext.apply({}, baseConfig, {xtype:'monitorStartProcessToolbar'}), {xtype:'box', height:3}];
}});
Ext.define('monitor.view.detail.ChildLogGridController', {extend:'Ext.app.ViewController', alias:'controller.childLogGridController', requires:['BpcCommon.Api', 'Ext.grid.column.Action', 'monitor.Util', 'monitor.assets.ConfigKeys', 'Ext.data.Store', 'Ext.data.proxy.Ajax', 'Ext.data.reader.Json', 'Ext.grid.column.Column', 'Ext.util.Format', 'Ext.util.Sorter'], init:function() {
  this.callParent(arguments);
}, onRowDbClick:function(grid, record, tr, rowIndex) {
  this.callShowMessageInNewTab(grid, rowIndex, this.getView().fileDataIndex);
}, createItems:function(columns, monitorGrid, setActionColumn, fileDataIndex) {
  try {
    if (!monitor.Util.isEmpty(columns)) {
      var preparedColumns = this.addRenderer(columns, monitorGrid);
      if (setActionColumn) {
        preparedColumns.unshift(this.setActionForFileColumns(fileDataIndex));
      }
      return preparedColumns;
    }
    var defaultColumns = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnHistoryList) || [];
    var generatedColumns = this.generateGridColumns(defaultColumns);
    if (setActionColumn) {
      generatedColumns.unshift(this.setActionForFileColumns(fileDataIndex));
    }
    return generatedColumns;
  } catch (e) {
    Ext.log({msg:'Error in create items in child log grid.' + e, level:'error'});
  }
}, addRenderer:function(columns, monitorGrid) {
  var preparedColumns = columns;
  Ext.each(preparedColumns, function(column) {
    if (Ext.isString(column.renderer)) {
      try {
        column.renderer = eval(column.renderer);
      } catch (e) {
        Ext.log({msg:'Problem in child grid: Monitor: Invalid renderer configuration: ' + e, level:'warn'});
      }
    } else {
      if (column.dataIndex && typeof column.renderer === 'undefined' && typeof column.xtype === 'undefined') {
        var monitorColumn = this.getColumnByDataName(monitorGrid, column.dataIndex);
        if (monitorColumn && monitorColumn.renderer) {
          column.renderer = monitorColumn.renderer;
        } else {
          if (monitorColumn) {
            monitorColumn.formatter = 'htmlEncode';
          }
        }
      } else {
        if (column.xtype === 'datecolumn' && !column.format) {
          column.format = this.getView().dateFormat;
        }
      }
    }
  }, this);
  return preparedColumns;
}, getColumnByDataName:function(grid, name) {
  var columns = grid.getColumns();
  var searchedColumn = null;
  Ext.each(columns, function(column) {
    if (column.dataIndex === name) {
      searchedColumn = column;
      return;
    }
  });
  return searchedColumn;
}, callShowMessageInNewTab:function(grid, rowIndex, fileDataIndex) {
  var record = grid.getStore().getAt(rowIndex);
  var childGridView = this.getView();
  var detailWindowController = grid.up('detailContainer').getController();
  if (detailWindowController) {
    detailWindowController.showMessageInNewTab(record, fileDataIndex, childGridView);
  }
}, setActionForFileColumns:function(fileDataIndex) {
  var items = [];
  var me = this;
  var moduleId = this.getView().moduleId;
  var mimetypeDataIndex = BpcCommon.Api.getSetting(moduleId, 'column_mimetype');
  var defaultMimetype = BpcCommon.Api.getSetting(moduleId, 'column_default_mimetype');
  var iconMapping = {'application/pdf':'fa-file-pdf', 'text/plain':'fa-file-alt', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':'fa-file-word', 'application/xml':'fa-file-code', 'text/xml':'fa-file-code', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':'fa-file-excel', 'other':'fa-file'};
  if (this.existsFileViewer()) {
    items.push({tooltip:'Nachricht anzeigen', scope:this, handler:function(grid, rowIndex) {
      me.callShowMessageInNewTab(grid, rowIndex, fileDataIndex);
    }, isDisabled:function(view, rowIndex, colIndex, item, record) {
      return !(record.get(fileDataIndex) || record.get(fileDataIndex.toUpperCase()));
    }, getClass:function(value, metadata, record) {
      var mimeType = record.get(mimetypeDataIndex);
      if (!Ext.isDefined(mimeType) || Ext.isEmpty(mimeType)) {
        mimeType = defaultMimetype;
      }
      var testCls = 'file-preview-actioncolumn';
      var iconCls = iconMapping[mimeType] ? 'x-fal ' + iconMapping[mimeType] : 'x-fal ' + iconMapping['other'];
      return testCls + ' ' + iconCls;
    }});
  }
  items.push({iconCls:'x-fal fa-download', tooltip:BpcCommon.Api.getTranslation('MONITOR_DOWNLOAD_MESSAGE'), scope:this, handler:function(grid, rowIndex) {
    var record = grid.getStore().getAt(rowIndex);
    var detailWindowController = grid.up('detailContainer');
    if (detailWindowController) {
      this.downloadFile(record, fileDataIndex);
    }
  }, isDisabled:function(view, rowIndex, colIndex, item, record) {
    return !(record.get(fileDataIndex) || record.get(fileDataIndex.toUpperCase()));
  }});
  return {xtype:'actioncolumn', width:items.length === 1 ? 30 : 60, items:items};
}, downloadFile:function(record, fileDataIndex) {
  var moduleId = this.getView().moduleId;
  var monitorInstance = BpcCommon.Api.getModuleInstanceComponent(moduleId);
  return monitorInstance.downloadFile(record, fileDataIndex);
}, existsFileViewer:function() {
  try {
    if (this.existsFileViewerState) {
      return this.existsFileViewerState;
    }
    var configuration = this.getView().configuration;
    var tabPanel = null;
    for (var key in configuration) {
      if (configuration[key].type && configuration[key].type === 'tabPanel') {
        tabPanel = configuration[key].config;
      }
    }
    var configAsString = JSON.stringify(tabPanel);
    this.existsFileViewerState = configAsString.indexOf('fileViewer') > -1;
    return this.existsFileViewerState;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR existsFileViewer', dump:e, stack:true, level:'error'});
  }
}, getParentQueryId:function() {
  var idString = null;
  var detailContainer = this.getView().up('detailContainer');
  if (detailContainer && detailContainer.isComponent) {
    if (detailContainer.queryId) {
      idString = detailContainer.queryId;
    }
  } else {
    var view = this.getView();
    if (view && view.isComponent && view.queryId && Ext.isDefined(view.queryId)) {
      idString = view.queryId;
    }
  }
  return idString;
}, createStore:function(columns) {
  try {
    var queryId = this.getParentQueryId();
    var childId = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnHistorySubId);
    var newModel = Ext.define(null, {extend:'Ext.data.Model', idProperty:childId, fields:columns});
    var store = Ext.create('Ext.data.Store', {sorters:[], model:newModel, pageSize:5000, proxy:{type:'ajax', url:this.getView().storeUrl, reader:{type:'json', rootProperty:'data', totalProperty:'totalCount'}, extraParams:{query:'', queryId:queryId}}});
    store.load();
    this.createFilterForStore(store);
    this.createSortersForStore(store);
    return store;
  } catch (e) {
    Ext.log({msg:'Error in create store in child log grid.' + e, level:'error'});
  }
}, generateGridColumns:function(columns) {
  var $jscomp$this = this;
  try {
    var generatedColumns = [];
    if (!columns) {
      return [];
    }
    Object.keys(columns).forEach(function(key) {
      var column = {text:key, dataIndex:key, columnId:key};
      var parentColumn = $jscomp$this.getColumnByDataName($jscomp$this.getView().grid, key) || {};
      column.renderer = parentColumn.renderer;
      if (!column.renderer) {
        column.formatter = 'htmlEncode';
      }
      generatedColumns.push(column);
    });
    return generatedColumns;
  } catch (e) {
    Ext.log({msg:'Error in generate grid columns in child log grid.' + e, level:'error'});
  }
}, getStatusRendererFunction:function() {
  var monitorGrid = this.getView().grid;
  var statusColumn = this.getColumnByDataName(monitorGrid, 'status') || {};
  return statusColumn.renderer;
}, createFilterForStore:function(store) {
  var filter = this.getView().filter;
  if (filter) {
    store.filterBy(function(record) {
      var result;
      try {
        result = eval(filter);
      } catch (e) {
        result = true;
      }
      return result;
    }, this);
  }
}, createSortersForStore:function(store) {
  if (!monitor.Util.isEmpty(this.getView().sorters)) {
    this.createSorters(this.getView().sorters, store);
  } else {
    var childId = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnHistorySubId);
    if (monitor.Util.isEmpty(childId)) {
      childId = 'childId';
    }
    var sorters = [{'dataIndex':childId, 'direction':'ASC'}];
    this.createSorters(sorters, store);
  }
}, createSorters:function(sorters, store) {
  store.sorters.clear();
  for (var i = 0; i < sorters.length; i++) {
    var item = sorters[i];
    var directory = item.direction ? item.direction : 'ASC';
    store.sorters.add(new Ext.util.Sorter({property:item.dataIndex, direction:directory}));
  }
  store.sort();
}, loadProcessData:function(data) {
  var store = this.getView().getStore();
  var columns = this.getView().columns;
  if (columns[0] && columns[0].xtype === 'actioncolumn' && columns.length - 1 === 0 || columns.length === 0) {
    this.addNotConfiguredColumns(data);
    this.getView().forceFit = true;
  }
  if (typeof data === 'undefined') {
    data = [];
  }
  store.loadData(data);
  var filter = this.getView().filter;
  if (filter) {
    store.filterBy(function(record) {
      var result;
      try {
        result = eval(filter);
      } catch (e) {
        result = true;
      }
      return result;
    }, this);
  }
  if (!monitor.Util.isEmpty(this.getView().sorters)) {
    this.createSorters(this.getView().sorters, store);
  } else {
    var childId = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnHistorySubId);
    if (monitor.Util.isEmpty(childId)) {
      childId = 'childId';
    }
    var sorters = [{'dataIndex':childId, 'direction':'ASC'}];
    this.createSorters(sorters, store);
  }
}, addNotConfiguredColumns:function(data) {
  var columns = this.getView().columns;
  var missingColumns = [];
  if (data) {
    for (var i = 0; i < data.length; i++) {
      var dataItem = data[i];
      for (var key in dataItem) {
        if (!this.existsColumn(columns, key) && missingColumns.indexOf(key) === -1) {
          missingColumns.push(key);
        }
      }
    }
    Ext.each(missingColumns, function(missingColumnKey) {
      var column = Ext.create('Ext.grid.column.Column', {text:missingColumnKey, dataIndex:missingColumnKey});
      if (missingColumnKey === 'timestamp') {
        column.renderer = Ext.util.Format.dateRenderer(this.getView().dateFormat);
      } else {
        if (missingColumnKey === 'status') {
          column.renderer = this.getStatusRendererFunction();
        }
      }
      this.getView().headerCt.insert(columns.length, column);
    }, this);
  }
}, existsColumn:function(columns, searchColumnName) {
  var columnExists = false;
  Ext.each(columns, function(column) {
    if (column.dataIndex === searchColumnName) {
      columnExists = true;
      return;
    }
  });
  return columnExists;
}});
Ext.define('monitor.view.detail.ChildLogGrid', {extend:'Ext.grid.Panel', requires:['monitor.Util', 'monitor.assets.ConfigKeys', 'monitor.view.detail.ChildLogGridController', 'BpcCommon.Api'], localized:{title:'MONITOR_PROCESSING_HISTORY'}, alias:'widget.childLogGrid', controller:'childLogGridController', loadMask:true, viewConfig:{localized:{emptyText:'MONITOR_NO_DATA_FOUND', loadingText:'MONITOR_LOADING_DATA'}}, configuration:undefined, record:undefined, grid:undefined, columns:undefined, setActionColumn:undefined, 
fileDataIndex:undefined, sorters:undefined, textSelectable:undefined, listeners:{rowdblclick:'onRowDbClick'}, stateful:true, stateId:'', stateEvents:['selectionchange'], queryId:undefined, initComponent:function() {
  if (this.record) {
    this.stateId = this.record.getId() + this.stateId;
  }
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowChildLogGrid' + this.moduleId + this.bpcViewId + (this.record ? this.record.getId() : '');
  this.setActionColumn = typeof this.setActionColumn !== 'undefined' ? this.setActionColumn : true;
  this.fileDataIndex = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnFile);
  this.dateFormat = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.dateFormat);
  this.viewConfig.enableTextSelection = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.gridEditable);
  this.columns = this.getController().createItems(Ext.clone(this.columns), this.grid, this.setActionColumn, this.fileDataIndex);
  this.store = this.getController().createStore(this.columns);
  this.callParent(arguments);
  this.getView().on('scrollend', this.saveState.bind(this));
}, getState:function() {
  var state = this.callParent();
  try {
    var selection = this.getSelection();
    if (selection && selection[0] && selection[0].getId) {
      state.selectedRecord = this.getSelection()[0].getId();
    }
    state.scrollX = this.getView().getScrollX();
    state.scrollY = this.getView().getScrollY();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getState', dump:e, stack:true, level:'error'});
  }
  return state;
}, applyState:function(state) {
  var me = this;
  if (!me.destroyed) {
    me.callParent(arguments);
    me.applyStateLazy(state);
  }
}, applyStateLazy:function(state) {
  var me = this;
  if (!me.destroyed && !me.store.isLoaded()) {
    me.store.on('load', me.applyStateLazy.bind(me, state));
    return;
  }
  if (!me.rendered === true) {
    me.on('afterrender', me.applyStateLazy.bind(me, state));
    return;
  }
  var record = me.store.getById(state.selectedRecord);
  me.setSelection(record);
  me.getView().setScrollX(state.scrollX);
  me.getView().setScrollY(state.scrollY);
}});
Ext.define('monitor.view.detail.DetailContainerController', {extend:'Ext.app.ViewController', alias:'controller.detailContainerController', requires:['monitor.Util', 'monitor.assets.ConfigKeys'], init:function() {
  this.callParent(arguments);
}, showMessageInNewTab:function(record, fileDataIndex, childLogGridView) {
  try {
    if (this.fileViewContainer) {
      this.fileViewContainer.getController().onShowMessage(record, fileDataIndex, this.fileViewContainerConfig, childLogGridView);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR showMessageInNewTab', dump:e, stack:true, level:'error'});
  }
}, setConfigurationParams:function() {
  try {
    var baseUrl = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_baseUrl');
    var processId = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnId);
    var childId = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnHistorySubId);
    var tablePrefix = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.legacyPmTablePrefix);
    var referenceEndPoint = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_referenceEndpoint');
    var actionEndPoint = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_actionEndpoint');
    var actionColumn = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnActionPrefix);
    if (monitor.Util.isEmpty(processId)) {
      processId = 'processId';
    }
    if (monitor.Util.isEmpty(childId)) {
      childId = 'childId';
    }
    if (monitor.Util.isEmpty(tablePrefix)) {
      tablePrefix = '';
    }
    if (monitor.Util.isEmpty(baseUrl) || typeof tablePrefix === 'undefined' || monitor.Util.isEmpty(referenceEndPoint) || monitor.Util.isEmpty(actionEndPoint)) {
      Ext.log({msg:"Problem in detail container: Couldn't find the configuration 'inubit_baseUrl', '" + monitor.assets.ConfigKeys.legacyPmTablePrefix + "', 'inubit_actionEndpoint' or " + "'inubit_referenceEndpoint'. Please check the configuration of monitor.", level:'warn'});
    }
    return {baseUrl:baseUrl, processId:processId, childId:childId, tablePrefix:tablePrefix, referenceEndpoint:referenceEndPoint, actionEndpoint:actionEndPoint, actionColumn:actionColumn};
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR setConfigurationParams', dump:e, stack:true, level:'error'});
  }
}, createComponents:function(configuration) {
  try {
    if (this.isValidConfiguration(configuration)) {
      var defaultHeight = configuration.height ? configuration.height / 3 : 150;
      var defaultWidth = configuration.width ? configuration.width / 3 : 150;
      var collapsible = configuration.collapsible || true;
      var autoScroll = configuration.autoScroll || true;
      var split = configuration.split || true;
      var nonCenterRegionDefault = {autoScroll:autoScroll, split:split, collapsible:collapsible};
      if (configuration.paddingOfElements) {
        nonCenterRegionDefault.padding = configuration.paddingOfElements;
      }
      var items = [];
      var item, defaultConfig = null;
      if (typeof configuration.left !== 'undefined') {
        defaultConfig = Ext.apply({}, nonCenterRegionDefault, {region:'west', width:defaultWidth});
        configuration.left.config = Ext.apply({}, configuration.left.config, defaultConfig);
        item = this.parseLayoutObject(configuration.left, Ext.apply({}, configuration.left.config, defaultConfig));
        if (item) {
          items.push(item);
        }
      }
      if (typeof configuration.right !== 'undefined') {
        defaultConfig = Ext.apply({}, nonCenterRegionDefault, {region:'east', width:defaultWidth});
        configuration.right.config = Ext.apply({}, configuration.right.config, defaultConfig);
        item = this.parseLayoutObject(configuration.right, Ext.apply({}, configuration.right.config, defaultConfig));
        if (item) {
          items.push(item);
        }
      }
      if (typeof configuration.top !== 'undefined') {
        defaultConfig = Ext.apply({}, nonCenterRegionDefault, {region:'north', height:defaultHeight});
        configuration.top.config = Ext.apply({}, configuration.top.config, defaultConfig);
        item = this.parseLayoutObject(configuration.top, Ext.apply({}, configuration.top.config, defaultConfig));
        if (item) {
          items.push(item);
        }
      }
      if (typeof configuration.bottom !== 'undefined') {
        defaultConfig = Ext.apply({}, nonCenterRegionDefault, {region:'south', height:defaultHeight});
        configuration.bottom.config = Ext.apply({}, configuration.bottom.config, defaultConfig);
        item = this.parseLayoutObject(configuration.bottom, Ext.apply({}, configuration.bottom.config, defaultConfig));
        if (item) {
          items.push(item);
        }
      }
      var centerConfig = {region:'center', minWidth:defaultWidth};
      if (configuration.paddingOfElements) {
        centerConfig.padding = configuration.paddingOfElements;
      }
      configuration.center.config = Ext.apply({}, configuration.center.config, centerConfig);
      items.push(this.parseLayoutObject(configuration.center, Ext.apply({}, centerConfig, configuration.center.config)));
      return items;
    }
    return this.createErrorComponents();
  } catch (e) {
    Ext.log({msg:'Error in create components of DetailController: ' + e, level:'error'});
  }
}, isValidConfiguration:function(configuration) {
  if (monitor.Util.isEmpty(configuration) || monitor.Util.isEmpty(configuration.center)) {
    return false;
  }
  if (!monitor.Util.isEmpty(configuration.center)) {
    var center = configuration.center;
    if (center.type) {
      return true;
    }
  }
}, createErrorComponents:function() {
  return Ext.create('Ext.container.Container', {layout:{type:'hbox', align:'stretch'}, padding:10, items:[{xtype:'box', html:'\x3cp\x3e\x3c/p\x3e\x3ci class\x3d"fa fa-exclamation-triangle" style\x3d"color: #D49A6A; ' + 'font-size: 18px; margin-right: 3px;"\x3e\x3c/i\x3e\x3c/p\x3e'}, {xtype:'box', html:BpcCommon.Api.getTranslation({tpl:'\x3cp\x3e{MONITOR_DETAIL_CONTAINER_ERROR1}' + '{MONITOR_DETAIL_CONTAINER_ERROR2}\x3c/p\x3e', keys:['MONITOR_DETAIL_CONTAINER_ERROR1', 'MONITOR_DETAIL_CONTAINER_ERROR2']}), 
  style:{marginLeft:'10px'}}]});
}, parseLayoutObject:function(layoutObject, params) {
  try {
    params = params || {};
    layoutObject.config = Ext.applyIf(layoutObject.config, params.extContainerSettings);
    params = Ext.apply({}, params, {configuration:this.getView().configuration, record:this.getView().selectedRecord, grid:this.getView().grid, moduleId:this.getView().moduleId, settings:this.getView().settings, bpcViewId:this.getView().bpcViewId});
    if (params.title) {
      params.localized = Ext.apply({}, {title:params.title}, params.localized);
    }
    if (layoutObject.type === 'processPanel') {
      return this.createProcessPanel(params);
    } else {
      if (layoutObject.type === 'childGrid') {
        return this.createChildLogGrid(params);
      } else {
        if (layoutObject.type === 'jumpPanel') {
          return this.createJumpPanel(params);
        } else {
          if (layoutObject.type === 'tabPanel') {
            return this.createTabPanel(params);
          } else {
            if (layoutObject.type === 'fileViewer') {
              this.fileViewContainerConfig = params;
              return 'fileViewContainer';
            } else {
              if (layoutObject.type === 'actionPanel') {
                return this.createActionPanel(params);
              } else {
                if (layoutObject.type === 'aperakViewer') {
                  return this.createAperakPanel(layoutObject.config, params);
                } else {
                  if (layoutObject.type === 'taskPanel') {
                    return this.createTaskPanel(layoutObject.config, params);
                  } else {
                    if (layoutObject.type === 'widgetPanel') {
                      return this.createWidgetPanel(layoutObject.config, params);
                    } else {
                      if (layoutObject.type === 'okbPanel') {
                        return this.createOkbPanel(layoutObject.config, params);
                      } else {
                        if (layoutObject.type === 'interactionPanel') {
                          return this.createInteractionPanel(layoutObject.config, params);
                        } else {
                          if (BpcCommon.Util.isStringEqual(layoutObject.type, 'plugin')) {
                            return Ext.applyIf({xtype:'monitorDetailHook', context:Ext.applyIf({instanceId:this.getView().moduleId, record:this.getView().selectedRecord}, layoutObject.config.context), hidden:layoutObject.config.pluginTarget && layoutObject.config.pluginTarget !== 'self', pluginTarget:layoutObject.config.pluginTarget || 'self'}, layoutObject.config);
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    return null;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR parseLayoutObject', dump:e, stack:true, level:'error'});
  }
}, createJumpPanel:function(config) {
  return Ext.create(Ext.apply({xtype:'monitorJumpPanel'}, config));
}, createProcessPanel:function(config) {
  return Ext.createByAlias('widget.processRecordView', Ext.apply({}, config, {}));
}, createChildLogGrid:function(config) {
  var processIDKey = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnId);
  var url = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + this.getView().moduleId + '/details/' + encodeURIComponent(this.getView().selectedRecord.get(processIDKey));
  var childLogGrid = Ext.createByAlias('widget.childLogGrid', Ext.apply({}, config, {storeUrl:url, queryId:this.getView().queryId}));
  return childLogGrid;
}, createTabPanel:function(config) {
  var tabs = [];
  var setFileViewContainer = false;
  var setTabPanel = false;
  Ext.each(config.subItems, function(item) {
    if (item.type === 'taskPanel') {
      var field = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnTaskView);
      var fieldValue = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.columnTaskViewValue);
      if (monitor.Util.isEmpty(field) || monitor.Util.isEmpty(fieldValue)) {
        Ext.log({msg:"Problem in detail container: Couldn't find the configuration '" + monitor.assets.ConfigKeys.columnTaskView + "' or '" + monitor.assets.ConfigKeys.columnTaskViewValue + "'. Please check the configuration of monitor.", level:'warn'});
      } else {
        var fieldValueArray = fieldValue.split(',');
        var currentValue = config.record.get(field.toUpperCase());
        Ext.Array.each(fieldValueArray, function(value) {
          if (currentValue && currentValue.toUpperCase() === Ext.String.trim(value).toUpperCase()) {
            var taskTab = this.parseLayoutObject(item, item.config);
            tabs.push(taskTab);
            return false;
          }
        }, this);
      }
    } else {
      var parsedItem = this.parseLayoutObject(item, item.config);
      if (parsedItem) {
        if (parsedItem === 'fileViewContainer') {
          setFileViewContainer = true;
        } else {
          tabs.push(parsedItem);
        }
      }
    }
  }, this);
  var tabPanel = Ext.createByAlias('widget.tabPanel', Ext.apply({}, config, {tabs:tabs}));
  if (setFileViewContainer) {
    this.fileViewContainer = tabPanel;
  }
  if (setTabPanel) {
    this.tabPanel = tabPanel;
  }
  return tabPanel;
}, createActionPanel:function(params) {
  return Ext.createByAlias('widget.actionPanel', params);
}, createAperakPanel:function(objectConfig, params) {
  return Ext.applyIf({xtype:'monitorAperakView', aperakConfig:objectConfig}, params);
}, createTaskPanel:function(objectConfig, params) {
  return Ext.createByAlias('widget.taskPanel', Ext.apply({}, objectConfig, {configuration:objectConfig, moduleId:params.moduleId, record:params.record, title:'Aufgabe'}));
}, createInteractionPanel:function(objectConfig, params) {
  return Ext.createByAlias(objectConfig.formId, Ext.apply({}, objectConfig, {configuration:objectConfig, moduleId:params.moduleId, record:params.record}));
}, createWidgetPanel:function(objectConfig) {
  return Ext.createByAlias('widget.widgetPanel', Ext.apply({}, objectConfig, {widgetId:objectConfig.widgetId, title:'Widget'}));
}, createOkbPanel:function(objectConfig, params) {
  return Ext.createByAlias('widget.okbPanel', Ext.apply({}, objectConfig, {title:'OKB', moduleId:params.moduleId, configuration:objectConfig, record:params.record}));
}});
Ext.define('monitor.view.detail.DetailContainer', {extend:'Ext.container.Container', alias:['widget.detailContainer', 'widget.monitorDetailContainer'], requires:['monitor.view.detail.DetailContainerController'], controller:'detailContainerController', layout:'border', selectedRecord:undefined, grid:undefined, instanceConfiguration:undefined, configuration:undefined, loadedChildren:undefined, settings:undefined, componentName:undefined, items:[], stateful:true, stateId:undefined, padding:'5px 10px 10px 5px', 
queryId:undefined, initComponent:function() {
  this.width = Ext.isDefined(this.configuration.width) ? this.configuration.width : '100%';
  this.height = this.configuration.height ? this.configuration.height : 300;
  this.settings = this.getController().setConfigurationParams(this.moduleId);
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowDetailContainer' + this.moduleId;
  if (Ext.isDefined(this.queryId)) {
    this.defaults = {queryId:this.queryId};
  }
  Ext.apply(this, {items:this.getController().createComponents(this.configuration)});
  this.callParent(arguments);
  var pluginHook = this.down('monitorDetailHook');
  if (!pluginHook) {
    var target = this.down('tabpanel') || this.down('container');
    if (target) {
      target.add({xtype:'monitorDetailHook', context:{instanceId:this.moduleId, record:this.selectedRecord}, hidden:true, pluginTarget:'^'});
    }
  }
}});
Ext.define('monitor.view.detail.DetailWindowController', {extend:'Ext.app.ViewController', alias:'controller.detailWindowController', init:function() {
  this.callParent(arguments);
}});
Ext.define('monitor.view.detail.DetailWindow', {extend:'BpcCommon.component.window.Window', alias:'widget.detailWindow', requires:['BpcCommon.Api', 'monitor.assets.ConfigKeys', 'monitor.view.detail.DetailContainer', 'monitor.view.detail.DetailWindowController', 'Ext.layout.container.Fit'], controller:'detailWindowController', layout:'fit', scrollable:false, localized:{title:'MONITOR_PROCESS_DETAIL_WINDOW'}, iconCls:'x-fal fa-cubes', constrain:true, stateful:true, resizable:true, grid:undefined, selectedRecord:undefined, 
vm:undefined, hackMode:false, initComponent:function() {
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindow' + this.moduleId;
  var conf = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.detailViewPopupConfig);
  if (conf.width) {
    this.width = conf.width;
  }
  if (conf.height) {
    this.height = conf.height;
  }
  if (this.hackMode === true) {
    this.items = this.createDetailContainer(conf, this.selectedRecord, this.vm, this.grid, true);
  } else {
    this.items = this.createDetailContainer(conf, this.selectedRecord, this.vm, this.grid);
  }
  if (conf.title) {
    this.localized = Ext.clone(this.localized);
    this.localized.title = this.createTitle(conf.title, this.selectedRecord);
  }
  this.listeners = {close:function() {
    try {
      this.query('fileViewer').forEach(function(element) {
        return element.editor.destroy();
      });
    } catch (err) {
    }
  }};
  this.callParent(arguments);
}, createDetailContainer:function(conf, record, instanceConfig, grid, hackMode) {
  try {
    var instanceConfiguration;
    if (Ext.isDefined(hackMode) && hackMode === true) {
      instanceConfiguration = {instanceStoreUrl:BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + this.moduleId};
    } else {
      instanceConfiguration = instanceConfig.getData();
    }
    return Ext.create('monitor.view.detail.DetailContainer', Ext.apply({}, conf, {configuration:conf, selectedRecord:record, instanceConfiguration:instanceConfiguration, grid:grid, moduleId:this.moduleId, resizable:true, resizeHandles:'s', componentName:'detailViewPopup', bpcViewId:this.bpcViewId}));
  } catch (e) {
    Ext.log({msg:'Error while creating the detail container: ' + e, level:'error'});
  }
}, createTitle:function(title, record) {
  try {
    var tpl = new Ext.XTemplate(title);
    return tpl.apply(record.data);
  } catch (e) {
    Ext.log({msg:'Error while setting the title in DetailContainer: ' + e, level:'error'});
  }
}});
Ext.define('monitor.view.detail.FileViewerController', {extend:'Ext.app.ViewController', alias:'controller.fileViewerController', requires:['monitor.Util', 'monitor.assets.ConfigKeys', 'BpcCommon.Api', 'Ext.data.TreeStore', 'Ext.dom.Query', 'Ext.tree.Panel', 'Ext.util.Format'], control:{'#xmlToggleBnt':{click:'toggleSourceView'}, '#downloadFileBnt':{click:'downloadFile'}, '#selectFileBnt':{click:'selectFile'}}, init:function() {
  this.callParent(arguments);
}, isXML:function(record, data) {
  var me = this;
  var moduleId = me.getView().moduleId;
  var mimetypeDataIndex = BpcCommon.Api.getSetting(moduleId, 'column_mimetype');
  var defaultMimetype = BpcCommon.Api.getSetting(moduleId, 'column_default_mimetype');
  var mimeType = record.get(mimetypeDataIndex);
  if (!Ext.isDefined(mimeType) || Ext.isEmpty(mimeType)) {
    mimeType = defaultMimetype;
  }
  if (mimeType === 'text/xml' && (data.indexOf('\x3c') === -1 || data.indexOf('\x3e') === -1)) {
    return false;
  }
  if (mimeType === 'text/xml' || data.substr(0, 5) === '\x3c?xml') {
    return true;
  }
  if (data.substr(0, 1) !== '\x3c' || data.substr(data.length - 1, 1) !== '\x3e' || data.lastIndexOf('\x3c/') === -1) {
    return false;
  }
  var firstTagEndPosition = data.indexOf('\x3e');
  if (data.indexOf(' ') < firstTagEndPosition) {
    firstTagEndPosition = data.indexOf(' ');
  }
  var firstTag = data.substring(1, firstTagEndPosition);
  var lastTag = data.substr(data.lastIndexOf('\x3c/') + 2, firstTag.length);
  return firstTag === lastTag;
}, isImageOrPdf:function(record) {
  var me = this;
  var moduleId = me.getView().moduleId;
  var mimetypeDataIndex = BpcCommon.Api.getSetting(moduleId, 'column_mimetype');
  var defaultMimetype = BpcCommon.Api.getSetting(moduleId, 'column_default_mimetype');
  var mimeType = record.get(mimetypeDataIndex);
  if (!Ext.isDefined(mimeType) || Ext.isEmpty(mimeType)) {
    mimeType = defaultMimetype;
  }
  var allowedImageTyped = ['image/png', 'image/jpeg', 'image/bmp', 'image/gif', 'image/jpg'];
  return allowedImageTyped.indexOf(mimeType) > -1 || mimeType === 'application/pdf';
}, toggleSourceView:function(button) {
  var me = this;
  var moduleId = me.getView().moduleId;
  var mimetypeDataIndex = BpcCommon.Api.getSetting(moduleId, 'column_mimetype');
  var defaultMimetype = BpcCommon.Api.getSetting(moduleId, 'column_default_mimetype');
  this.getView().removeAll();
  if (button.pressed) {
    this.getView().add(this.getFileView());
  } else {
    var record = this.getView().record;
    var mimeType = record.get(mimetypeDataIndex);
    if (!Ext.isDefined(mimeType) || Ext.isEmpty(mimeType)) {
      mimeType = defaultMimetype;
    }
    if (mimeType === 'application/edifact') {
      Ext.util.CSS.swapStyleSheet('prettifyCss', 'resources/code-prettify/prettifyEdi.css');
      this.getView().add(this.getPrettifiedEDICmp());
    } else {
      Ext.util.CSS.swapStyleSheet('prettifyCss', 'resources/code-prettify/prettify.css');
      this.getView().add(this.getPrettifiedXMLCmp());
    }
  }
}, showFormattedView:function(btn) {
  var me = this;
  var xmlDataView = this.lookupReference('xmlData');
  var ediDataView = this.lookupReference('ediData');
  if (btn.pressed) {
    me.getViewModel().set('hideSelectAll', false);
    if (ediDataView && ediDataView.isVisible()) {
      ediDataView.getLayout().setActiveItem(0);
    } else {
      if (xmlDataView && xmlDataView.isVisible()) {
        xmlDataView.getLayout().setActiveItem(0);
      }
    }
  }
}, showXmlTreeView:function(btn) {
  var me = this;
  var xmlDataView = this.lookupReference('xmlData');
  if (btn.pressed) {
    me.getViewModel().set('hideSelectAll', true);
    if (xmlDataView && xmlDataView.isVisible()) {
      if (!xmlDataView.treeViewCreated) {
        xmlDataView.setLoading(true);
        xmlDataView.down('#xmlTreeView').add(me.getXMLTreePanel());
        xmlDataView.treeViewCreated = true;
        xmlDataView.setLoading(false);
      }
      xmlDataView.getLayout().setActiveItem(1);
    }
  }
}, showRawDataView:function(btn) {
  var me = this;
  var xmlDataView = this.lookupReference('xmlData');
  var ediDataView = this.lookupReference('ediData');
  if (btn.pressed) {
    me.getViewModel().set('hideSelectAll', false);
    if (ediDataView && ediDataView.isVisible()) {
      ediDataView.getLayout().setActiveItem(1);
    } else {
      if (xmlDataView && xmlDataView.isVisible()) {
        xmlDataView.getLayout().setActiveItem(2);
      }
    }
  }
}, getEDIMultilinePanel:function() {
  return this.createMultiLinePanel(this.getView().receivedData);
}, getXMLTreePanel:function() {
  var xmlData = monitor.Util.parseXML(this.getView().receivedData.replace(/<([a-zA-Z0-9]+)(?:xml)ns=".*"(.*)>/g, '\x3c$1$2\x3e').replace(/^\s/, ''));
  var childNode = CSS.escape(xmlData.childNodes[0].nodeName);
  var treeData = Ext.DomQuery.selectNode(childNode, xmlData);
  return this.createXmlTree(treeData);
}, getFileView:function() {
  return {xtype:'box', reference:'fileViewerTextFile', scrollable:'true', autoEl:{tag:'pre', style:'overflow: auto; margin-left: 5px;', children:[{tag:'code', style:'display: inline;', html:Ext.util.Format.htmlEncode(this.getView().receivedData)}]}};
}, selectFile:function() {
  var xmlDataView = this.lookupReference('xmlData');
  var ediDataView = this.lookupReference('ediData');
  if (xmlDataView && xmlDataView.isVisible() || ediDataView && ediDataView.isVisible()) {
    var editor = this.getView().editor;
    editor.selection.selectAll();
  }
}, createXmlTree:function(data) {
  var children = monitor.Util.nodeToJsonTree(data);
  var store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:children}});
  var me = this;
  return Ext.create('Ext.tree.Panel', {store:store, reference:'fileViewerTreePanel', rootVisible:false, scrollable:true, listeners:{itemexpand:{fn:function() {
    var me = this;
    var columns = me.getColumns()[0];
    columns.autoSize();
  }}, afterrender:function(tree) {
    var root = tree.getRootNode();
    root.getChildAt(0).expand();
  }, itemcontextmenu:function(view, record, item, index, event) {
    event.stopEvent();
    if (record.hasChildNodes()) {
      Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', items:[{localized:{text:'MONITOR_EXPAND'}, iconCls:'fal fa-plus', menu:{items:[{localized:{text:'MONITOR_EXPAND_NODE'}, iconCls:'fal fa-chevron-down', listeners:{click:function() {
        record.expand();
      }}}, {localized:{text:'MONITOR_EXPAND_CHILDREN'}, iconCls:'fal fa-chevron-double-down', listeners:{click:function() {
        me.expandChildNodes(record);
      }}}]}}, {localized:{text:'MONITOR_COLLAPSE'}, iconCls:'fal fa-minus', menu:{items:[{localized:{text:'MONITOR_COLLAPSE_NODE'}, iconCls:'fal fa-chevron-up', listeners:{click:function() {
        record.collapse();
      }}}, {localized:{text:'MONITOR_COLLAPSE_CHILDREN'}, iconCls:'fal fa-chevron-double-up', listeners:{click:function() {
        me.collapseChildNodes(record);
      }}}]}}]}).showAt(event.getXY());
    }
  }}});
}, expandChildNodes:function(node) {
  var me = this;
  node.expand();
  if (node.hasChildNodes()) {
    node.eachChild(function(child) {
      me.expandChildNodes(child);
    });
  }
}, collapseChildNodes:function(node) {
  var me = this;
  node.collapse();
  if (node.hasChildNodes()) {
    node.eachChild(function(child) {
      me.collapseChildNodes(child);
    });
  }
}, downloadFile:function() {
  var moduleId = this.getView().moduleId;
  var monitorInstance = BpcCommon.Api.getModuleInstanceComponent(moduleId);
  return monitorInstance.downloadFile(this.getView().record);
}, createMultiLinePanel:function(data) {
  var value = data.toString();
  var newLineRegExp = new RegExp('["\']', 'g');
  return Ext.create('Ext.Component', {reference:'ediMultiLineView', autoEl:{tag:'pre', style:'overflow: auto; margin-left: 5px;', children:[{tag:'code', style:'display: inline;', html:value.replace(newLineRegExp, "'\x3cbr/\x3e")}]}});
}, getPrettifiedEDIData:function() {
  var ediData = this.getView().receivedData;
  var newLineRegExp = new RegExp('["\']', 'g');
  return ediData.toString().replace(newLineRegExp, '\n');
}, getPrettifiedXMLData:function() {
  var xmlData = this.getView().receivedData;
  return vkbeautify.xml(xmlData, 3);
}, getCodeEditor:function(beautifiedData) {
  var mimeType = this.getView().mimeType;
  return {xtype:'bpcEditorField', value:beautifiedData, editorLanguage:mimeType, editorConfigs:{readOnly:true}};
}});
Ext.define('monitor.view.detail.FileViewer', {extend:'Ext.panel.Panel', requires:['monitor.view.detail.FileViewerController'], alias:'widget.fileViewer', controller:'fileViewerController', receivedData:undefined, record:undefined, viewModel:{data:{hideSelectAll:false, hideXmlViewBtn:true}}, stateful:true, stateId:undefined, editorTheme:'chrome', layout:'fit', initComponent:function() {
  var me = this;
  var items = [];
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowFileViewer' + this.moduleId;
  var mimetypeDataIndex = BpcCommon.Api.getSetting(this.moduleId, 'column_mimetype');
  var defaultMimetype = BpcCommon.Api.getSetting(this.moduleId, 'column_default_mimetype');
  var mimeType = this.record.get(mimetypeDataIndex);
  if (!Ext.isDefined(mimeType) || Ext.isEmpty(mimeType)) {
    mimeType = defaultMimetype;
  }
  if (mimeType === 'application/edifact' || this.getController().isXML(this.record, this.receivedData) || this.getController().isImageOrPdf(this.record, this.receivedData)) {
    if (mimeType === 'application/edifact') {
      this.mimeType = 'edifact';
      var beautifiedData = this.getController().getPrettifiedEDIData();
      items.push({xtype:'panel', layout:'card', reference:'ediData', defaults:{scrollable:true}, items:[me.getController().getCodeEditor(beautifiedData), {items:[me.getController().getFileView()]}], listeners:{afterrender:function(panel) {
        panel.getLayout().setActiveItem(0);
      }}});
    } else {
      if (this.getController().isXML(this.record, this.receivedData)) {
        me.getViewModel().set('hideXmlViewBtn', false);
        this.mimeType = 'xml';
        var beautifiedData$10 = this.getController().getPrettifiedXMLData();
        items.push({xtype:'panel', layout:'card', reference:'xmlData', defaults:{scrollable:true}, items:[me.getController().getCodeEditor(beautifiedData$10), {layout:'fit', itemId:'xmlTreeView'}, {items:[me.getController().getFileView()]}], listeners:{afterrender:function(panel) {
          panel.getLayout().setActiveItem(0);
        }}});
      } else {
        if (this.getController().isImageOrPdf(this.record, this.receivedData)) {
          var monitorInstance = BpcCommon.Api.getModuleInstanceComponent(this.moduleId);
          var url = monitorInstance.createFileDownloadUrl(this.record);
          url += '\x26noContentDisposition\x3dtrue';
          items.push({xtype:'box', reference:'fileViewerImageOrPdf', autoEl:{tag:'iframe', loadMask:'Opening File...please wait!', width:'100%', height:'100%', src:url}});
        }
      }
    }
  } else {
    items.push({xtype:'box', reference:'fileViewerTextFile', autoEl:{tag:'pre', style:'overflow: auto; margin-left: 5px;', children:[{tag:'code', style:'display: inline;', html:Ext.util.Format.htmlEncode(this.receivedData)}]}});
  }
  this.tbar = [{localized:{text:'MONITOR_DOWNLOAD'}, itemId:'downloadFileBnt', iconCls:'x-fal fa-download'}, {localized:{text:'MONITOR_SELECT_ALL'}, itemId:'selectFileBnt', iconCls:'x-fal fa-i-cursor', bind:{disabled:'{hideSelectAll}'}}, {xtype:'tbspacer', width:20}, {localized:{text:'MONITOR_FORMATTED_DATA'}, toggleGroup:'changeFileView', iconCls:'x-fal fa-file-alt', handler:'showFormattedView', pressed:true, toggleHandler:function() {
    var me = this;
    if (!(me.pressed || Ext.ButtonToggleManager.getPressed(me.toggleGroup))) {
      me.toggle(true, true);
    }
  }}, {localized:{text:'MONITOR_TREE_VIEW'}, bind:{hidden:'{hideXmlViewBtn}'}, toggleGroup:'changeFileView', iconCls:'x-fal fa-sitemap', handler:'showXmlTreeView', toggleHandler:function() {
    var me = this;
    if (!(me.pressed || Ext.ButtonToggleManager.getPressed(me.toggleGroup))) {
      me.toggle(true, true);
    }
  }}, {localized:{text:'MONITOR_RAW_DATA'}, toggleGroup:'changeFileView', iconCls:'x-fal fa-file', handler:'showRawDataView', toggleHandler:function() {
    var me = this;
    if (!(me.pressed || Ext.ButtonToggleManager.getPressed(me.toggleGroup))) {
      me.toggle(true, true);
    }
  }}];
  this.listeners = {close:function() {
    try {
      console.log(this);
      this.editor.destroy();
    } catch (err) {
    }
  }, resize:function() {
    try {
      this.editor.resize();
    } catch (err) {
    }
  }};
  Ext.apply(this, {items:items});
  this.callParent(arguments);
}});
Ext.define('monitor.view.detail.InteractionPanel', {extend:'Ext.container.Container', alias:'widget.interactionPanel', scrollable:true, configuration:undefined, record:undefined, moduleId:undefined, widgetType:undefined, stateful:true, stateId:undefined, layout:'fit', initComponent:function() {
  this.stateId = (this.stateId ? this.stateId : '') + 'interactionPanel' + this.moduleId;
  this.items = [{xtype:this.configuration.formId.replace('widget.', ''), record:this.record, configuration:this.configuration}];
  this.callParent(arguments);
}});
Ext.define('monitor.view.detail.JumpPanel', {extend:'Ext.panel.Panel', alias:'widget.monitorJumpPanel', configuration:undefined, record:undefined, moduleId:undefined, stateful:true, stateId:undefined, layout:{'align':'stretch', 'type':'vbox'}, initComponent:function() {
  this.checkForTitle();
  this.stateId = (this.stateId ? this.stateId : '') + 'jumpPanel' + this.moduleId;
  this.createButtons();
  this.callParent(arguments);
}, checkForTitle:function() {
  if (this.tabTitle !== undefined && this.tabTitle !== null && this.tabTitle !== '') {
    this.setTitle(this.tabTitle);
  } else {
    this.setTitle(BpcCommon.Api.getTranslation('MONITOR_JUMP_TO'));
  }
}, createButtons:function() {
  var moduleJumpController = Ext.getApplication().getController('monitor.view.interaction.moduleJump.Controller');
  var jumpColumns = moduleJumpController.getJumpColumnsForMonitor(this.config.moduleId);
  var selectedRecord = this.config.record;
  if (jumpColumns.length === 0 || !selectedRecord) {
    this.hidden = true;
    return;
  }
  this.items = jumpColumns.map(function(column, index) {
    var value = selectedRecord.get(column.dataIndex);
    return {xtype:'button', margin:10, iconCls:'x-fal fa-external-link', text:value, hidden:value === undefined || value === '', itemId:'jumpToMenuItem-' + index, handler:moduleJumpController.doModuleJump.bind(moduleJumpController, column, selectedRecord, value, column.jumpParamFn)};
  });
}});
Ext.define('monitor.view.detail.OkbPanelController', {extend:'Ext.app.ViewController', alias:'controller.okbPanelController', requires:['monitor.Util'], init:function() {
  this.callParent(arguments);
}, onAfterRender:function() {
  if (this.getView().items.items.length === 0) {
    this.getView().getEl().mask(BpcCommon.Api.getTranslation('MONITOR_LOADING_DATA'));
  }
}, loadConfig:function(receivedConfig) {
  var defaultConfig = this.getDefaultConfiguration();
  if (!monitor.Util.isEmpty(receivedConfig)) {
    if (monitor.Util.isEmpty(receivedConfig.subItems)) {
      Ext.log({msg:'Problem to read the configuration of OKB container: properties are missing. Set the default configuration.', level:'warn'});
      if (receivedConfig.endPoint) {
        defaultConfig.endPoint = receivedConfig.endPoint;
      }
      return defaultConfig;
    }
    return receivedConfig;
  }
  return defaultConfig;
}, setConfigurationParams:function(monitorId) {
  var baseUrl = BpcCommon.Api.getSetting(monitorId, 'inubit_baseUrl');
  var processId = BpcCommon.Api.getSetting(this.getView().moduleId, 'monitor.assets.ConfigKeys.columnId');
  if (monitor.Util.isEmpty(processId)) {
    processId = 'processId';
  }
  if (monitor.Util.isEmpty(baseUrl)) {
    Ext.log({msg:"Problem in OKB panel: Couldn't find the configuration 'inubit_baseUrl'. Please check the configuration of monitor.", level:'warn'});
  }
  return {baseUrl:baseUrl, processId:processId};
}, requestOkbData:function(record, configuration) {
  var me = this;
  try {
    var inubitProxyId = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_proxyId');
    var settings = this.getView().settings;
    var columnId = '';
    if (configuration.columnId) {
      columnId = configuration.processColumnId;
    } else {
      columnId = settings.processId;
    }
    var processId = record.get(columnId.toUpperCase());
    if (monitor.Util.isEmpty(processId)) {
      this.createErrorMessage(BpcCommon.Api.getTranslation('MONITOR_OKB_NO_VALUE_FOR_PROCESS1') + columnId + BpcCommon.Api.getTranslation('MONITOR_OKB_NO_VALUE_FOR_PROCESS2'));
      var el = me.getView().getEl();
      if (typeof el !== 'undefined') {
        el.unmask();
      }
    } else {
      var url = BpcCommon.Api.getBackendUrl(inubitProxyId) + settings.baseUrl + configuration.endPoint + '?method\x3dgetProcessData\x26id\x3d' + processId + '\x26forceJson\x3dtrue';
      if (!monitor.Util.isEmpty(configuration.matchingParameter)) {
        url += '\x26matchingParameter\x3d' + configuration.matchingParameter;
      }
      monitor.Util.ajaxGetCall(url, function(success, response) {
        try {
          if (success) {
            if (response.error) {
              me.createErrorMessage(BpcCommon.Api.getTranslation('MONITOR_OKB_COLUMN_NO_DATA') + configuration.matchingParameter + BpcCommon.Api.getTranslation('MONITOR_OKB_NO_VALUE_FOR_PROCESS2'));
            } else {
              if (response.root) {
                var resultSet = response.root.okb.row;
                if (!monitor.Util.isEmpty(resultSet)) {
                  me.createStores(response);
                  me.createItems(configuration);
                } else {
                  me.createEmptyMessage(BpcCommon.Api.getTranslation('MONITOR_NO_ENTRIES_AVAILABLE'));
                }
              }
            }
          } else {
            me.createErrorMessage(BpcCommon.Api.getTranslation('MONITOR_SERVER_NOT_RESPONDING'));
          }
          var el$11 = me.getView().getEl();
          if (typeof el$11 !== 'undefined') {
            el$11.unmask();
          }
        } catch (e) {
          Ext.log({msg:'Error in OKB panel while create elements.' + e, level:'error'});
        }
      });
    }
  } catch (e) {
    Ext.log({msg:'Error in OKB panel while request the data.' + e, level:'error'});
  }
}, createStores:function(data) {
  var jiraData = data.root.jira.issues;
  var jiraArray = [];
  if (Object.prototype.toString.call(jiraData) === '[object Object]') {
    jiraArray.push(jiraData);
  } else {
    jiraArray = jiraData;
  }
  this.jiraStore = Ext.create('Ext.data.Store', {reader:{type:'json'}});
  if (jiraArray) {
    this.jiraStore.loadData(jiraArray);
  }
  var okbData = data.root.okb.row;
  var okbArray = [];
  if (Object.prototype.toString.call(okbData) === '[object Object]') {
    okbArray.push(okbData);
  } else {
    okbArray = okbData;
  }
  this.okbStore = Ext.create('Ext.data.Store', {reader:{type:'json'}});
  if (okbArray) {
    this.okbStore.loadData(okbArray);
  }
}, convertDataToJson:function(data) {
  var list = [];
  if (data) {
    for (var i = 0; i < data.length; i++) {
      list.push(this.convertObjectToJson(data[i].children));
    }
  }
  return list;
}, convertObjectToJson:function(data) {
  var item = {};
  for (var i = 0; i < data.length; i++) {
    var child = data[i];
    var nodeName = child.nodeName.toLowerCase();
    if (child.children.length > 0) {
      item[nodeName] = this.convertObjectToJson(child.children);
    } else {
      item[nodeName] = child.textContent;
    }
  }
  return item;
}, createItems:function(configuration) {
  var subItems = configuration.subItems;
  var storeData = this.okbStore.getData();
  var tabs = [];
  Ext.each(storeData.items, function(record) {
    var items = [];
    Ext.each(subItems, function(item) {
      var parsedItem = this.parseObject(item, record);
      if (parsedItem) {
        items.push(parsedItem);
      }
    }, this);
    tabs.push({title:'Cluster ' + record.get('id'), iconCls:this.getStatusCls(record.get('status')), autoScroll:true, items:items});
  }, this);
  if (tabs.length > 0) {
    this.getView().add(tabs);
    this.getView().setActiveTab(0);
  }
}, getStatusCls:function(statusCode) {
  var cls = '';
  if (statusCode === 0) {
    cls = 'statusRed';
  } else {
    if (statusCode === 1) {
      cls = 'statusYellow';
    } else {
      if (statusCode === 2) {
        cls = 'statusGreen';
      } else {
        if (statusCode === 3) {
          cls = 'statusBlue';
        } else {
          if (statusCode === 4) {
            cls = 'statusGray';
          }
        }
      }
    }
  }
  return cls;
}, parseObject:function(layoutObject, record) {
  if (layoutObject.type === 'fieldSet') {
    return this.createTemplateContainer(layoutObject.config, record);
  } else {
    if (layoutObject.type === 'fieldSetJira') {
      return this.createFieldSetJira(layoutObject.config, record);
    } else {
      if (layoutObject.type === 'textContainer') {
        return this.createTextContainer(layoutObject.config, record);
      } else {
        if (layoutObject.type === 'container') {
          return this.createContainer(layoutObject.config, record);
        }
      }
    }
  }
  return null;
}, createContainer:function(objectConfig, record) {
  var items = [];
  Ext.each(objectConfig.subItems, function(item) {
    var parsedItem = this.parseObject(item, record);
    if (parsedItem) {
      items.push(parsedItem);
    }
  }, this);
  if (monitor.Util.isEmpty(objectConfig.layout)) {
    objectConfig.layout = {type:'hbox', align:'stretch'};
  }
  return Ext.create('Ext.container.Container', Ext.apply({}, objectConfig, {items:items}));
}, createTemplateContainer:function(objectConfig, record) {
  if (!monitor.Util.isEmpty(record)) {
    var container = Ext.create('Ext.container.Container', {tpl:['\x3ctpl if\x3d"data.length \x26gt; 0"\x3e', '\x3ctable style\x3d"width: 100%; padding: 10px"\x3e', '\x3ctpl for\x3d"data"\x3e', '  \x3ctr\x3e', '    \x3ctd valign\x3d"top" style\x3d" padding-top: .5em;padding-bottom: .5em;"\x3e\x3cb\x3e{title}:\x3c/b\x3e\x3c/td\x3e', '    \x3ctd valign\x3d"top" style\x3d" padding-top: .5em;padding-bottom: .5em;"\x3e{value}\x3c/td\x3e', '  \x3c/tr\x3e', '\x3c/tpl\x3e', '\x3c/table\x3e', '\x3c/tpl\x3e']});
    var data = [];
    var items = objectConfig.subItems;
    Ext.each(items, function(item) {
      var name = item.dataIndex.toLowerCase();
      var value = null;
      if (name.indexOf('.') > -1) {
        var splitName = name.split('.');
        var recordValue = record.data;
        for (var i = 0; i < splitName.length; i++) {
          recordValue = recordValue[splitName[i]];
        }
        value = recordValue;
      } else {
        value = record.get(name);
      }
      var newValue = Ext.clone(value);
      if (item.values) {
        var valueText = this.getValueText(item.values, value);
        if (valueText.length > 0) {
          newValue = valueText;
        }
      }
      if (item.shownAsLink === true) {
        var valueLink = '';
        if (newValue !== value) {
          valueLink = this.getValueLink(item.linkConfig, value);
        } else {
          valueLink = this.getValueLink(item.linkConfig, value, newValue);
        }
        if (valueLink.length > 0) {
          newValue = valueLink;
        }
      }
      if (item.icons) {
        var iconValue = '';
        if (newValue !== value) {
          iconValue = this.getIconValue(item.icons, value, newValue);
        } else {
          iconValue = this.getIconValue(item.icons, value);
        }
        if (iconValue.length > 0) {
          newValue = iconValue;
        }
      }
      var elem = {title:item.title, value:newValue};
      data.push(elem);
    }, this);
    container.update({data:data});
    return Ext.create('Ext.form.FieldSet', {title:objectConfig.title, items:container, flex:1, autoScroll:true, defaults:{anchor:'100%', layout:'hbox', padding:'0 20 0 0'}, style:{marginRight:'10px'}});
  }
  return null;
}, createFieldSetJira:function(objectConfig, record) {
  try {
    var globalConfig = this.getView().configuration;
    var jiraId = record.get(globalConfig.jiraIssueDataIndex.toLowerCase());
    if (!monitor.Util.isEmpty(jiraId)) {
      var jiraRecord = this.jiraStore.findRecord('key', jiraId, 0, false, false, true);
      return this.createTemplateContainer(objectConfig, jiraRecord);
    }
    return null;
  } catch (e) {
    Ext.log({msg:'Error in OKB panel while create fieldJiraSets' + e, level:'error'});
  }
}, getValueText:function(values, oldValue) {
  var value = '';
  if (!monitor.Util.isEmpty(oldValue)) {
    oldValue = oldValue.toString();
    for (var j = 0; j < values.length; j++) {
      var comparativeValue = values[j].value.toString();
      if (oldValue.toLowerCase() === comparativeValue.toLowerCase()) {
        value = values[j].text;
        break;
      }
    }
  }
  return value;
}, getValueLink:function(linkConfig, oldValue, textValue) {
  var value = '';
  if (!monitor.Util.isEmpty(oldValue) && !monitor.Util.isEmpty(linkConfig)) {
    if (linkConfig.showBpcModule) {
      value = '\x3ca data-showBpcModule\x3d"true" data-bpcModule\x3d"' + linkConfig.moduleId + '" href\x3d"#"\x3e';
    } else {
      if (!monitor.Util.isEmpty(linkConfig.externalUrl)) {
        value = '\x3ca href\x3d"' + linkConfig.externalUrl + '"\x3e';
      } else {
        var url = BpcCommon.Api.getSetting(linkConfig.moduleName, linkConfig.configuredId) + oldValue;
        value = '\x3ca target\x3d"_blank" href\x3d"' + url + '"\x3e';
      }
    }
    if (textValue) {
      value += textValue + '\x3c/a\x3e';
    } else {
      value += oldValue + '\x3c/a\x3e';
    }
  }
  return value;
}, getIconValue:function(icons, value, textValue) {
  var newValue = '';
  var icon = '';
  var iconStyle = {};
  value = value.toString();
  for (var j = 0; j < icons.length; j++) {
    if (value.toLowerCase() === icons[j].value.toLowerCase()) {
      icon = icons[j].icon;
      iconStyle = icons[j].style;
      break;
    }
  }
  if (icon.length > 0) {
    var styleInString = '';
    if (!monitor.Util.isEmpty(iconStyle)) {
      for (var key in iconStyle) {
        if (iconStyle[key]) {
          styleInString += key + ':' + iconStyle[key] + ';';
        }
      }
    } else {
      styleInString = 'font-size: 18px; margin-right: 10px';
    }
    if (textValue) {
      newValue = '\x3cdiv\x3e\x3ci class\x3d"' + icon + '" style\x3d"' + styleInString + '"\x3e\x3c/i\x3e' + textValue + '\x3c/div\x3e';
    } else {
      newValue = '\x3cdiv\x3e\x3ci class\x3d"' + icon + '" style\x3d"' + styleInString + '"\x3e\x3c/i\x3e' + value + '\x3c/div\x3e';
    }
  }
  return newValue;
}, createTextContainer:function(objectConfig, record) {
  var value = record.get(objectConfig.dataIndex.toLowerCase());
  if (!monitor.Util.isEmpty(value)) {
    value = value.replace(/(?:\r\n|\r|\n)/g, '\x3cbr /\x3e');
    return Ext.create('Ext.form.FieldSet', {title:objectConfig.title, items:[{xtype:'component', html:value}]});
  }
  return null;
}, createErrorMessage:function(message) {
  var container = Ext.create('Ext.container.Container', {title:BpcCommon.Api.getTranslation('MONITOR_ERROR'), layout:{type:'hbox', align:'stretch'}, padding:10, items:[{xtype:'box', html:'\x3cp\x3e\x3ci class\x3d"fa fa-exclamation-triangle" style\x3d"color: #D49A6A; font-size: 18px; margin-right: 3px;"\x3e\x3c/i\x3e\x3c/p\x3e'}, {xtype:'box', html:'\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_OKB_DATA_ERROR_DESCRIPTION') + message + '\x3c/p\x3e', style:{marginLeft:'10px'}}]});
  this.getView().add(container);
  this.getView().setActiveTab(0);
}, createEmptyMessage:function(message) {
  var container = Ext.create('Ext.container.Container', {title:BpcCommon.Api.getTranslation('MONITOR_INFORMATION'), layout:{type:'hbox', align:'stretch'}, padding:10, items:[{xtype:'box', html:'\x3cp\x3e' + message + '\x3c/p\x3e', style:{marginLeft:'10px'}}]});
  this.getView().add(container);
  this.getView().setActiveTab(0);
}, getDefaultConfiguration:function() {
  return {'endPoint':'VKB_API', 'jiraIssueDataIndex':'INCIDENT_NR', 'subItems':[{'type':'container', 'config':{'layout':{'type':'hbox', 'align':'stretch'}, 'subItems':[{'type':'fieldSet', 'config':{'title':BpcCommon.Api.getTranslation('MONITOR_CLUSTER_DETAILS'), 'subItems':[{'title':BpcCommon.Api.getTranslation('MONITOR_CLUSTER'), 'dataIndex':'id', 'shownAsLink':true, 'linkConfig':{'showBpcModule':true, 'moduleId':'okb'}}, {'title':BpcCommon.Api.getTranslation('MONITOR_STATUS'), 'dataIndex':'STATUS', 
  'values':[{'value':'0', 'text':'\x3cspan class\x3d"statusRed" style\x3d"padding-left: 20px;"\x3e\x3c/span\x3e\x3cspan\x3e' + BpcCommon.Api.getTranslation('MONITOR_UNADDRESSED') + '\x3c/span\x3e'}, {'value':'1', 'text':'\x3cspan class\x3d"statusYellow" style\x3d"padding-left: 20px;"\x3e' + BpcCommon.Api.getTranslation('MONITOR_NEW') + '\x3c/span\x3e'}, {'value':'2', 'text':'\x3cspan class\x3d"statusGreen" style\x3d"padding-left: 20px;"\x3e' + BpcCommon.Api.getTranslation('MONITOR_ADDRESSED') + '\x3c/span\x3e'}, 
  {'value':'3', 'text':'\x3cspan class\x3d"statusBlue" style\x3d"padding-left: 20px;"\x3e' + BpcCommon.Api.getTranslation('MONITOR_IN_PROGRESS') + '\x3c/span\x3e'}, {'value':'4', 'text':'\x3cspan class\x3d"statusGray" style\x3d"padding-left: 20px;"\x3e' + BpcCommon.Api.getTranslation('MONITOR_IGNORED') + '\x3c/span\x3e'}]}, {'title':BpcCommon.Api.getTranslation('MONITOR_SYSTEM'), 'dataIndex':'SYSTEM'}, {'title':BpcCommon.Api.getTranslation('MONITOR_USER_GROUP'), 'dataIndex':'USERGROUP'}, {'title':BpcCommon.Api.getTranslation('MONITOR_ASSIGNEE'), 
  'dataIndex':'ASSIGNEENAME'}, {'title':BpcCommon.Api.getTranslation('MONITOR_BUSINESS_IMPACT'), 'dataIndex':'CLASSIFICATION'}, {'title':BpcCommon.Api.getTranslation('MONITOR_ERROR'), 'dataIndex':'ERRORMESSAGE'}]}}, {'type':'fieldSetJira', 'config':{'title':BpcCommon.Api.getTranslation('MONITOR_JIRA_TICKETS'), 'subItems':[{'title':BpcCommon.Api.getTranslation('MONITOR_TICKET_NUMBER'), 'dataIndex':'key', 'shownAsLink':true, 'linkConfig':{'showBpcModule':false, 'moduleName':'_core', 'configuredId':'jiraLink'}}, 
  {'title':BpcCommon.Api.getTranslation('MONITOR_STATUS'), 'dataIndex':'fields.status.name'}, {'title':BpcCommon.Api.getTranslation('MONITOR_SUMMARY'), 'dataIndex':'fields.summary'}]}}]}}, {'type':'textContainer', 'config':{'title':BpcCommon.Api.getTranslation('MONITOR_ANALYSIS'), 'dataIndex':'SOLUTION_STRATEGY'}}]};
}});
Ext.define('monitor.view.detail.OkbPanel', {extend:'Ext.tab.Panel', requires:['monitor.view.detail.OkbPanelController'], autoScroll:true, title:'OKB', tabPosition:'left', tabRotation:0, defaults:{textAlign:'left', bodyPadding:15}, alias:'widget.okbPanel', controller:'okbPanelController', configuration:undefined, moduleId:undefined, settings:undefined, stateful:true, stateId:undefined, listeners:{afterrender:'onAfterRender', click:{element:'el', delegate:'a[data-showBpcModule\x3dtrue]', fn:function() {
  var panel = Ext.getCmp(this.id);
  var window = panel.up('detailWindow');
  window.close();
  BpcCommon.Api.showModule('okb');
}}}, initComponent:function() {
  this.configuration = this.getController().loadConfig(this.configuration);
  this.configuration.matchingParameter = this.matchingParameter;
  this.configuration.processColumnId = this.processColumnId;
  this.settings = this.getController().setConfigurationParams(this.moduleId);
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowOkbPanel' + this.moduleId;
  Ext.apply(this, {items:[]});
  this.callParent(arguments);
  this.getController().requestOkbData(this.record, this.configuration);
}});
Ext.define('monitor.view.detail.ProcessRecordView', {extend:'Ext.panel.Panel', alias:'widget.processRecordView', localized:{title:'MONITOR_PROCESS_DATA'}, layout:{type:'hbox', align:'stretch'}, configuration:undefined, record:undefined, grid:undefined, stateful:true, stateId:undefined, autoScroll:true, initComponent:function() {
  try {
    this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowProcessRecordView' + this.moduleId;
    this.items = this.createItems(this.group, this.item, this.record);
    this.callParent(arguments);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, createItems:function(group, item, record) {
  try {
    var items = [];
    if (!group && item) {
      items = [this.addItemsToContainer(item, record, this.config)];
    } else {
      if (group) {
        items = [];
        Ext.each(group, function(groupElem, index) {
          var config = {fieldWidth:groupElem.fieldWidth ? groupElem.fieldWidth : 70, labelWidth:groupElem.labelWidth ? groupElem.labelWidth : 70};
          var minWidth = config.fieldWidth + config.labelWidth + 20;
          var fieldSet = {xtype:'fieldset', style:{marginRight:'10px'}, width:groupElem.width ? groupElem.width : '100%', minWidth:groupElem.minWidth ? groupElem.minWidth : minWidth, autoScroll:!monitor.Util.isEmpty(groupElem.autoScroll) ? groupElem.autoScroll : false, scrollable:true, localized:{title:groupElem.title}, collapsible:groupElem.collapsible ? groupElem.collapsible : false, items:[this.addGroupsToContainer(groupElem.item, record, config)]};
          if (index === 0 || this.config.layout.type === 'vbox') {
            fieldSet.style.marginLeft = '10px';
          }
          items.push(Ext.apply(fieldSet, groupElem));
        }, this);
      }
    }
    return items;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createItems', dump:e, stack:true, level:'error'});
  }
}, addItemsToContainer:function(items, record, config) {
  try {
    var container = {xtype:'box', autoEl:{tag:'ul', style:'padding-left: 10px;margin: 0; list-style: none; -ms-box-orient: horizontal;' + ' -webkit-flex-wrap: wrap;flex-wrap: wrap;', children:[]}, autoScroll:config.autoScroll ? config.autoScroll : false};
    Ext.each(items, function(item) {
      var labelWidth = config.labelWidth || 150;
      container.autoEl.children.push({tag:'li', style:'position: relative; padding: 5px 0 0 ' + labelWidth + 'px; height: 20px; margin-top: 10px', html:this.renderItem(item, record, config)});
    }, this);
    return container;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR addItemsToContainer', dump:e, stack:true, level:'error'});
  }
}, renderItem:function(item, record, config) {
  var me = this;
  try {
    var name = item.name;
    var labelWidth = config.labelWidth || 150;
    var fieldWidth = config.fieldWidth || 300;
    var html = '\x3cspan valign\x3d"top" style\x3d"position: absolute; left: 0px; width: ' + labelWidth + 'px;"\x3e\x3cb\x3e' + (item.title || item.name) + ':\x3c/b\x3e \x3c/span\x3e';
    var renderedValue = me.renderWithCustomRenderer(name, record.get(name)) || record.get(name);
    renderedValue = '\x3cdiv style\x3d"width: ' + fieldWidth + 'px;"\x3e' + renderedValue + '\x3c/div\x3e';
    html = html + renderedValue;
    return html;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR renderItem', dump:e, stack:true, level:'error'});
  }
}, renderWithCustomRenderer:function(name, value) {
  var me = this;
  var monitorMain = BpcCommon.Api.getModuleInstanceComponent(me.moduleId);
  var monitorColumnConfig = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.columnConfig);
  var columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
    return colConfig.id === name;
  });
  if (!columnConfig) {
    columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
      return colConfig.dataIndex === name;
    });
  }
  var rendererId = monitorMain.findPlugin('monitorCustomRenderer').getRendererIdByColumnConfig(columnConfig) || name;
  return monitorMain.findPlugin('monitorCustomRenderer').render(rendererId, value, undefined, undefined, true);
}, addGroupsToContainer:function(items, record, config) {
  var me = this;
  try {
    var container = Ext.create('Ext.container.Container', {tpl:['\x3ctpl if\x3d"data.length \x26gt; 0"\x3e', '\x3ctable style\x3d"width: 100%; height: 100%"\x3e', '\x3ctpl for\x3d"data"\x3e', "  \x3ctr data-qtip\x3d'{renderedHtml:htmlEncode2}'\x3e", '    \x3ctd valign\x3d"top" style\x3d"width:' + config.labelWidth + 'px; max-width:' + config.labelWidth + '"\x3e\x3cb\x3e{title}:\x3c/b\x3e\x3c/td\x3e', '    \x3ctd valign\x3d"top" \n                        style\x3d"width:' + config.fieldWidth + 'px; \n                        max-width:' + 
    config.fieldWidth + 'px;\n                        padding-right: 10px;\n                        word-break: break-word;"\x3e\n                        {renderedHtml}\n                     \x3c/td\x3e', '  \x3c/tr\x3e', '\x3c/tpl\x3e', '\x3c/table\x3e', '\x3c/tpl\x3e']});
    var data = [];
    var hideEmptyValues;
    var detailPopupConfig = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.detailViewPopupConfig);
    if (Ext.isObject(detailPopupConfig) && detailPopupConfig.hideEmptyValues) {
      hideEmptyValues = detailPopupConfig.hideEmptyValues;
    } else {
      hideEmptyValues = false;
    }
    Ext.each(items, function(item) {
      var name = item.name;
      var value = record.get(name);
      var title = item.title ? item.title : item.name;
      var elem = null;
      var html = me.renderWithCustomRenderer(name, value) || value;
      elem = {title:BpcCommon.Api.getTranslation(title), renderedHtml:html};
      if (hideEmptyValues) {
        if (elem.renderedHtml && elem.renderedHtml !== '' && elem.renderedHtml !== null) {
          data.push(elem);
        }
      } else {
        data.push(elem);
      }
    }, this);
    container.update({data:data});
    return container;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR addGroupsToContainer', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.view.detail.TabPanelController', {extend:'Ext.app.ViewController', alias:'controller.tabPanelController', requires:['monitor.Util', 'monitor.assets.ConfigKeys'], init:function() {
  this.callParent(arguments);
}, onAfterRender:function() {
  if (this.getView().items.items.length === 0) {
    this.getView().getEl().mask(BpcCommon.Api.getTranslation('MONITOR_LOADING_DATA'));
  }
}, unMask:function() {
  var el = this.getView().getEl();
  if (typeof el !== 'undefined') {
    el.unmask();
    this.getView().setActiveTab(0);
  }
}, onShowMessage:function(record, fileDataIndex, config, childLogGridView) {
  var directory = record.get(fileDataIndex);
  if (directory) {
    var settings = this.getView().settings;
    var baseUrl = settings.baseUrl;
    var referenceEndpoint = settings.referenceEndpoint;
    var moduleId = this.getView().moduleId;
    if (!monitor.Util.isEmpty(baseUrl) && !monitor.Util.isEmpty(referenceEndpoint)) {
      var monitorInstance = BpcCommon.Api.getModuleInstanceComponent(moduleId);
      var url = monitorInstance.createFileDownloadUrl(record);
      var me = this;
      me.getView().setLoading(true);
      Ext.Ajax.request({url:url, method:'GET', callback:function(options, success, response) {
        if (success) {
          var responseData = response.responseText;
          var previewMaxAllowedSize = BpcCommon.Api.getSetting(moduleId, 'function_filePreviewSizeLimit') || 300000;
          if (responseData.length > previewMaxAllowedSize) {
            Ext.MessageBox.show({title:BpcCommon.Api.getTranslation('MONITOR_INFORMATION'), msg:BpcCommon.Api.getTranslation('MONITOR_PREVIEW_UNABLE_MSG'), fn:function(btn) {
              if (btn === 'yes') {
                me.triggerDownloadFile(record, fileDataIndex, childLogGridView);
              }
            }, icon:Ext.MessageBox['INFO'], buttons:Ext.MessageBox.YESNO, buttonText:{yes:"\x3ci class\x3d'fal fa-download' style\x3d'font-size:18px'\x3e\x3c/i\x3e\x26nbsp" + BpcCommon.Api.getTranslation('MONITOR_DOWNLOAD'), no:"\x3ci class\x3d'fal fa-times' style\x3d'font-size:18px'\x3e\x3c/i\x3e\x26nbsp" + BpcCommon.Api.getTranslation('MONITOR_CANCEL')}});
          } else {
            me.showFileInTab(responseData, record, fileDataIndex, config);
          }
        } else {
          Ext.Msg.alert(BpcCommon.Api.getTranslation('MONITOR_ERROR'), BpcCommon.Api.getTranslation('MONITOR_TAB_PANEL_ERROR_MSG'));
        }
        me.getView().setLoading(false);
      }});
    } else {
      Ext.Msg.alert(BpcCommon.Api.getTranslation('MONITOR_ERROR_DOWNLOADING_DATA'), BpcCommon.Api.getTranslation('MONITOR_ERROR_DOWNLOADING_DATA_MSG'));
      Ext.log({msg:"Problem in tab panel: Couldn't find the configuration 'inubit_baseUrl', '" + monitor.assets.ConfigKeys.legacyPmTablePrefix + "', or 'inubit_referenceEndpoint'. Please check the configuration of monitor.", level:'warn'});
    }
  }
}, showFileInTab:function(processDetailData, record, fileDataIndex, config) {
  var view = this.getView();
  var childIDKey = view.settings.childId;
  var childId = record.get(childIDKey);
  var itemId = ('tab-' + childId).replace(/[^a-zA-Z0-9]/g, '');
  var title = '';
  if (config.tabTitle) {
    var tpl = new Ext.XTemplate(config.tabTitle);
    title = tpl.apply(record.data);
  } else {
    title = childId !== '' ? BpcCommon.Api.getTranslation('MONITOR_FILE_CONTENT') + childId : BpcCommon.Api.getTranslation('MONITOR_FILE_CONTENT');
  }
  var newTab = Ext.createByAlias('widget.fileViewer', Ext.apply({}, {title:title, itemId:itemId, closable:true, receivedData:processDetailData, record:record, sizeLimits:config.sizeLimits || {}, fileDataIndex:fileDataIndex, settings:this.getView().settings, moduleId:this.getView().moduleId}));
  if (record.fileViewerTab) {
    var fileViewerTab = record.fileViewerTab;
    var index = view.items.indexOf(record.fileViewerTab);
    view.remove(fileViewerTab);
    view.insert(index, newTab);
  } else {
    this.getView().add(newTab);
  }
  record.fileViewerTab = newTab;
  this.getView().setActiveTab(newTab);
}, getTabIndex:function(itemId) {
  var index = -1;
  this.getView().items.each(function(tab, idx) {
    if (tab.itemId && tab.itemId === itemId) {
      index = idx;
      return;
    }
  });
  return index;
}, triggerDownloadFile:function(record, fileDataIndex, childLogGridView) {
  childLogGridView.getController().downloadFile(record, fileDataIndex);
}});
Ext.define('monitor.view.detail.TabPanel', {extend:'Ext.tab.Panel', requires:['monitor.view.detail.TabPanelController'], alias:'widget.tabPanel', controller:'tabPanelController', activeTab:0, width:700, tabs:undefined, configuration:undefined, record:undefined, grid:undefined, stateful:true, stateId:undefined, listeners:{tabchange:function(tabPanel) {
  tabPanel.scrollTo('Top', 0, true);
}, afterrender:'onAfterRender'}, initComponent:function() {
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowTabPanel' + this.moduleId;
  Ext.apply(this, {items:this.tabs});
  this.callParent(arguments);
}});
Ext.define('monitor.view.detail.TaskPanelController', {extend:'Ext.app.ViewController', alias:'controller.taskPanelController', init:function() {
  this.callParent(arguments);
}});
Ext.define('monitor.view.detail.TaskPanel', {extend:'Ext.panel.Panel', requires:['monitor.view.detail.TaskPanelController'], alias:'widget.taskPanel', controller:'taskPanelController', autoScroll:true, configuration:undefined, record:undefined, moduleId:undefined, widgetType:undefined, stateful:true, stateId:undefined, initComponent:function() {
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowTaskPanel' + this.moduleId;
  var items = [];
  items.push(this.addComponent(this.configuration));
  this.items = items;
  this.callParent(arguments);
}, addComponent:function(configuration) {
  var type = configuration.widgetType;
  try {
    if (Ext.ClassManager.getByAlias('widget.' + type)) {
      return Ext.createByAlias('widget.' + type, {configuration:configuration, record:this.record, moduleId:this.moduleId});
    }
    Ext.log({msg:'Unknown type: ' + type, level:'warn'});
    return this.showErrorMessage(BpcCommon.Api.getTranslation('MONITOR_TYPE_IS_UNKNOWN') + ': ' + type + '.');
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR', dump:e, stack:true, level:'error'});
    return this.showErrorMessage('');
  }
}, showErrorMessage:function(message) {
  return Ext.create('Ext.container.Container', {layout:{type:'hbox', align:'stretch'}, padding:10, items:[{xtype:'box', html:'\x3cp\x3e\x3c/p\x3e\x3ci class\x3d"fa fa-exclamation-triangle" style\x3d"color: #D49A6A; font-size: 18px; margin-right: 3px;"\x3e\x3c/i\x3e\x3c/p\x3e'}, {xtype:'box', html:'\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_ERROR_LOADING_COMPONENT') + message + '\x3c/p\x3e', style:{marginLeft:'10px'}}]});
}});
Ext.define('monitor.view.detail.WidgetPanelController', {extend:'Ext.app.ViewController', alias:'controller.widgetPanelController', init:function() {
  this.callParent(arguments);
}, addComponent:function(widgetId) {
  var widget = BpcCommon.Api.getWidgetComponent(widgetId);
  if (!monitor.Util.isEmpty(widget)) {
    var title = widget.config.configuration.title;
    this.getView().title = title;
    return widget;
  }
  return this.showErrorMessage(BpcCommon.Api.getTranslation('MONITOR_WIDGET_PANEL_ERROR1') + widgetId + BpcCommon.Api.getTranslation('MONITOR_WIDGET_PANEL_ERROR2'));
}, showErrorMessage:function(message) {
  return Ext.create('Ext.container.Container', {layout:{type:'hbox', align:'stretch'}, padding:10, items:[{xtype:'box', html:'\x3cp\x3e\x3c/p\x3e\x3ci class\x3d"fa fa-exclamation-triangle" style\x3d"color: #D49A6A; font-size: 18px; margin-right: 3px;"\x3e\x3c/i\x3e\x3c/p\x3e'}, {xtype:'box', html:'\x3cp\x3eFehler beim Laden der Komponente. ' + BpcCommon.Api.getTranslation('MONITOR_ERROR_LOADING_COMPONENT') + message + '\x3c/p\x3e', style:{marginLeft:'10px'}}]});
}});
Ext.define('monitor.view.detail.WidgetPanel', {extend:'Ext.panel.Panel', alias:'widget.widgetPanel', requires:['monitor.view.detail.WidgetPanelController'], controller:'widgetPanelController', autoScroll:true, layout:'fit', configuration:undefined, widgetId:undefined, stateful:true, stateId:undefined, initComponent:function() {
  this.stateId = (this.stateId ? this.stateId : '') + 'detailWindowWidgetPanel' + this.moduleId;
  var items = [];
  items.push(this.getController().addComponent(this.widgetId));
  Ext.apply(this, {items:items});
  this.callParent(arguments);
}});
Ext.define('monitor.view.grid.GridController', {extend:'Ext.app.ViewController', alias:'controller.gridController', control:{'processGrid \x3e gridview':{expandbody:'onExpandBody', collapsebody:'onCollapseBody', refresh:'onRefresh', itemremove:'onViewItemRemove', itemadd:'onViewItemAdd', scroll:{element:'body', buffer:200, fn:'removeFocus'}}, 'processGrid':{selectionchange:'onSelectionChange', cellcontextmenu:'onShowContextMenu', rowdblclick:'onDetailWindow', sortchange:{fn:'onSortChange', buffer:100}, 
filterchange:'onFilterChange', show:'onViewChange'}}, listen:{global:{dataLoaded:'onDataLoaded', moduleShow:'onViewChange'}}, lastCellIndex:undefined, lastRowIndex:undefined, lastValue:undefined, lastClickedColumn:undefined, lastRecord:undefined, actualSelection:undefined, expandMap:undefined, storeItems:0, init:function() {
  this.moduleId = this.getView().config.moduleId;
  this.handleGlobalDateRange = BpcCommon.Util.getGlobalDateRangeHandler(this.getView().getStore(), BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnTimeseries));
  var vm = this.getViewModel();
  vm.bind({bindTo:'{global.dateRange}', deep:true}, Ext.Function.createBuffered(this.handleGlobalDateRange, 100, this));
  this.handleGlobalDateRange(true);
  vm.bind('{globalFilterValue}', Ext.Function.createBuffered(this.onGlobalSearch, 500, this));
  if (!this.grid) {
    this.grid = this.getView();
    this.grid.store.on('load', this.onStoreLoad.bind(this));
    this.grid.store.on('beforeload', this.onBeforeLoad.bind(this));
    var proxy = this.grid.store.getProxy();
    proxy.on('exception', this.onException.bind(this));
    this.proxy = proxy;
    this.grid.up('bpcMonitor').on('show', this.onViewChange.bind(this));
  }
  this.expandMap = [];
  var bufferSetting = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.dataRefreshBufferInSeconds, true);
  bufferSetting.on('changed', this.updateRefreshDataBufferedFn, this);
  this.updateRefreshDataBufferedFn(bufferSetting);
  this.autoRefreshTaskHolder = Ext.TaskManager.start({run:this.autoRefreshTask.bind(this), interval:1000 * 30});
  this.bufferdNewDataNotification = Ext.Function.createThrottled(BpcCommon.Api.showNotification.bind(BpcCommon.Api, 'MONITOR_NEW_DATA_AVAILABLE'), 15000);
}, updateRefreshDataBufferedFn:function(bufferSettingModel) {
  if (bufferSettingModel instanceof Ext.data.Model) {
    var bufferInSeconds = bufferSettingModel.get('value');
    this.refreshDataBuffered = Ext.Function.createThrottled(this.refreshData, bufferInSeconds * 1000);
  }
}, refreshDataBuffered:function() {
  this.refreshData();
}, autoRefreshTask:function() {
  try {
    var autoRefresh = !this.getMainViewModel().get('autoRefreshDisabled');
    if (autoRefresh && !BpcCommon.Api.hasWebsocketConnection()) {
      this.onRefresh();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR autoRefreshTask', dump:e, stack:true, level:'error'});
  }
}, onDataLoaded:function(dataObj) {
  try {
    var queryId = this.getView().getQueryId();
    var store = this.getView().getStore();
    if (dataObj.properties.componentId && (dataObj.properties.componentId === 'monitor' || dataObj.properties.componentId === 'monitor_details') && dataObj.properties.customId && dataObj.properties.customId.startsWith(queryId)) {
      if (dataObj.properties.dataCount === 0) {
        var needRefresh = false;
        if (Ext.isArray(dataObj.properties.obsoleteIDs)) {
          Ext.Array.each(dataObj.properties.obsoleteIDs, function(oId) {
            if (store.getById(oId) || store.getById(parseFloat(oId))) {
              needRefresh = true;
              return false;
            }
          });
        }
        if (!needRefresh && Ext.isArray(dataObj.properties.deletedIDs)) {
          Ext.Array.each(dataObj.properties.deletedIDs, function(dId) {
            if (store.getById(dId) || store.getById(parseFloat(dId))) {
              needRefresh = true;
              return false;
            }
          });
        }
        if (!needRefresh) {
          return;
        }
      }
      if (this.getViewModel().get('setting.' + monitor.assets.ConfigKeys.autoUpdate)) {
        this.refreshDataBuffered();
      } else {
        this.bufferdNewDataNotification();
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onDataLoaded', dump:e, stack:true, level:'error'});
  }
}, onViewItemRemove:function(records) {
  try {
    Ext.Array.each(records, function(record) {
      if (record && record.detailViewInlineCmp) {
        record.detailViewInlineCmp.destroy();
        delete record.detailViewInlineCmp;
      }
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onViewItemRemove', dump:e, stack:true, level:'error'});
  }
}, onViewItemAdd:function(records) {
  try {
    var expandMap = this.getView().getPlugin('bpcrowexpander').recordsExpanded;
    Ext.Array.each(records, function(record) {
      if (record && expandMap[record.internalId] === true) {
        this.showInlineDetailView(record);
      }
    }, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onViewItemAdd', dump:e, stack:true, level:'error'});
  }
}, onException:function(proxy, response) {
  try {
    if (response.aborted === true) {
      return;
    }
    var msg = '';
    if (response.status === 401) {
      BpcCommon.Api.handleSessionLost();
    } else {
      var errorObj = BpcCommon.Util.getErrorFromFailureResponse(response);
      msg = BpcCommon.Api.getTranslation('MONITOR_DATA_LOADING_ERROR') + ' - ' + errorObj.message;
    }
    if (msg.length > 0) {
      BpcCommon.Api.showNotification({type:'ERROR', text:msg, toast:true, toastTarget:this.getView()});
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onException', dump:e, stack:true, level:'error'});
  }
}, onRefresh:function() {
  try {
    var grid = this.getView();
    var expander = grid.getPlugin('bpcrowexpander');
    var moduleId = this.getView().config.moduleId;
    var viewId = this.getView().bpcGridViewName;
    var orphanCmps = Ext.ComponentQuery.query('detailContainer[moduleId\x3d' + moduleId + '][bpcViewId\x3d' + viewId + '][componentName\x3ddetailViewInline]');
    Ext.Array.each(orphanCmps, function(cmp) {
      cmp.destroy();
    });
    this.updateColumnText();
    var store = grid.getStore();
    if (this.expandMap) {
      Ext.Array.each(this.expandMap, function(id) {
        try {
          var extModel = store.getById(id);
          var row = store.indexOf(extModel);
          if (row >= 0) {
            expander.toggleRow(row, extModel);
          }
        } catch (e) {
          Ext.log('Fehler beim Herstellen der detailInlineView' + e);
        }
      });
    }
    var gridView = this.getView();
    if (BpcCommon.Api.getSetting(gridView.config.moduleId, monitor.assets.ConfigKeys.gridMultipleViews)) {
      var multiGridConf = BpcCommon.Api.getSetting(gridView.config.moduleId, monitor.assets.ConfigKeys.gridMultipleViewsConfig);
      if (multiGridConf.multiViewMode === 'stacked') {
        var total = 0;
        var countLimit = BpcCommon.Api.getSetting('monitor', monitor.assets.ConfigKeys.dataCountLimit);
        var limitReached = false;
        Ext.Array.each(multiGridConf.views, function(view) {
          var store = Ext.StoreManager.lookup(view.id);
          if (store) {
            var storeTotal = store.getTotalCount();
            if (storeTotal >= countLimit) {
              limitReached = true;
            }
            total += storeTotal;
          }
        });
        this.getMainView().updateStackedDataItems(total);
        if (limitReached) {
          total = '\x3e' + String(total);
        }
        this.getMainView().getViewModel().set('stackedCount', total);
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onRefresh', dump:e, stack:true, level:'error'});
  }
}, onSortChange:function() {
  this.updateColumnText();
  this.getMainView().updateModuleHeaderSorter(this.getView().getStore().sorters);
  this.expandMap = [];
}, updateColumnText:function() {
  try {
    var columnManager = this.getView().getColumnManager();
    var columnArray = columnManager.getColumns();
    var sorters = this.grid.getStore().getSorters();
    Ext.Array.each(columnArray, function(column) {
      if (column.textEl && column.textEl.setHtml) {
        var headerIconEl = column.headerIconCls ? '\x3cspan role\x3d"presentation" data-ref\x3d"iconEl" class\x3d"' + column.headerIconCls + ' ' + Ext.baseCSSPrefix + 'column-header-iconEl"\x3e\x26nbsp\x3c/span\x3e' : '';
        var filterIcon = '\x3cspan role\x3d"presentation" class\x3d"' + Ext.baseCSSPrefix + 'bpc-filter-icon"\x3e\x3c/span\x3e';
        var filterInverted = false;
        if (column.filter && column.filter.filter && column.filter.active) {
          filterInverted = column.filter.filter.getConfig('invert');
        }
        if (filterInverted === true) {
          filterIcon = '\x3cspan class\x3d"fa-stack fa-1x ' + Ext.baseCSSPrefix + 'bpc-filter-invert-icon  ""\x3e\n                                    \x3ci class\x3d"fas fa-circle fa-stack-2x"\x3e\x3c/i\x3e\n                                    \x3ci class\x3d"fas fa-filter fa-stack-1x fa-inverse"\x3e\x3c/i\x3e\n                                \x3c/span\x3e';
        }
        var headerTextEl = '\x3cspan role\x3d"presentation" data-ref\x3d"textInnerEl" class\x3d"' + Ext.baseCSSPrefix + 'column-header-text-inner"\x3e' + column.text + '\x3c/span\x3e';
        var sortRank = '';
        var sortCls = '';
        if (sorters.get(column.dataIndex)) {
          sortRank = sorters.indexOfKey(column.dataIndex) + 1;
          sortCls = 'bpc-monitor-filterActive';
        }
        var headerRankEl = '\x3cspan role\x3d"presentation" class\x3d"' + Ext.baseCSSPrefix + 'bpc-rank ' + sortCls + '"\x3e' + sortRank + '\x3c/span\x3e';
        column.textEl.setHtml(headerIconEl + headerTextEl + filterIcon + headerRankEl);
      }
    });
  } catch (e) {
    Ext.log('Fehler beim Resetten des Spaltentextes' + e);
  }
}, updateModuleHeaderInfos:function() {
  try {
    var mainView = this.getMainView();
    var gridView = this.getView();
    var store = gridView.getStore();
    var filters = store.getFilters();
    var sorters = store.getSorters();
    mainView.updateFilterItems(filters);
    mainView.updateModuleHeaderFilter(this.getView().getStore().filters);
    mainView.updateSorterItems(sorters);
    mainView.updateDataItems(this.storeItems);
    mainView.getViewModel().set('totalCount', this.storeItems);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateModuleHeaderInfos', dump:e, stack:true, level:'error'});
  }
}, onFilterChange:function(store, filters) {
  try {
    var vm = this.getMainViewModel();
    vm.set('activeFilter', filters.length);
    var mainView = this.getMainView();
    mainView.updateFilterItems(filters);
    this.updateActiveFilter(filters);
    this.getMainView().updateModuleHeaderFilter(this.getView().getStore().filters);
    this.expandMap = [];
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR', dump:e, stack:true, level:'error'});
  }
}, updateActiveFilter:function(filters) {
  try {
    var vm = this.getMainViewModel();
    if (!filters) {
      var store = this.getView().getStore();
      filters = store.getFilters().items;
    }
    var filtersLength = filters.length;
    var countColumns = BpcCommon.Api.getSetting(this.getView().config.moduleId, monitor.assets.ConfigKeys.countColumns);
    if (countColumns) {
      var filterProperties = [];
      if (countColumns) {
        if (filters.length > 0) {
          Ext.Array.each(filters, function(filter) {
            if (filter) {
              filterProperties.push(filter.getConfig('property'));
            }
          });
        }
        filterProperties = Ext.Array.unique(filterProperties);
        filtersLength = filterProperties.length;
      }
    }
    if (vm.get('globalFilterValue')) {
      filtersLength++;
    }
    vm.set('activeFilter', filtersLength);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateActiveFilter', dump:e, stack:true, level:'error'});
  }
}, onViewChange:function() {
  try {
    var view = this.getView();
    if (view.isVisible(true)) {
      if (this.refreshDataOnView) {
        this.refreshDataOnView = false;
        this.refreshData(true);
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onViewChange', dump:e, stack:true, level:'error'});
  }
}, onDetailWindow:function(view, record) {
  var vm = this.getMainViewModel();
  var showWindow = BpcCommon.Api.getSetting(vm.get('moduleId'), monitor.assets.ConfigKeys.detailViewPopupEnabled) && BpcCommon.Api.getLicenseInformationForKey('MODULE_MONITOR_DETAILVIEW_POPUP') !== false;
  if (showWindow) {
    try {
      var detailedWindow = Ext.createByAlias('widget.detailWindow', {moduleId:vm.get('moduleId'), selectedRecord:record, vm:vm, grid:this.getView(), width:document.body.clientWidth * 0.8, height:document.body.clientHeight * 0.8, minWidth:document.body.clientWidth * 0.4, minHeight:document.body.clientHeight * 0.5, maxWidth:document.body.clientWidth, maxHeight:document.body.clientHeight, bpcViewId:this.getView().bpcGridViewName, viewModel:{parent:vm}});
      detailedWindow.show();
    } catch (e) {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_DETAIL_WINDOW_ERROR') + e);
    }
  }
}, refreshData:function(force) {
  var $jscomp$this = this;
  var forceRefresh = force || false;
  var view = this.getView();
  if (!forceRefresh && !view.isVisible(true)) {
    this.refreshDataOnView = true;
    return;
  }
  var selectionModel = this.getView().getSelectionModel();
  this.actualSelection = selectionModel.getSelection();
  this.reloadStore(function() {
    $jscomp$this.updateActiveFilter();
    $jscomp$this.updateModuleHeaderInfos();
    $jscomp$this.updateChildLogGrids();
    $jscomp$this.updateDetailViews();
  });
}, reloadStore:function(callback) {
  this.getView().store.reload({callback:callback});
}, onSelectionChange:function(selModel, selection) {
  var me = this;
  try {
    selection = [].concat(selection);
    me.getView().setSelectedRecords(selection);
    this.actualSelection = selection;
    if (selection.length > 0) {
      this.updateSplitView(selection[0]);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onSelectionChange', dump:e, stack:true, level:'error'});
  }
}, getMainView:function() {
  try {
    return this.getView().up('bpcMonitor');
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getMainView', dump:e, stack:true, level:'error'});
  }
}, getMainViewModel:function() {
  try {
    return this.getView().up('bpcMonitor').getViewModel();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getMainViewModel', dump:e, stack:true, level:'error'});
  }
}, getMainViewController:function() {
  try {
    return this.getView().up('bpcMonitor').getController();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getMainViewController', dump:e, stack:true, level:'error'});
  }
}, fireStoreLoadEventOnSuccess:function(moduleId) {
  Ext.GlobalEvents.fireEvent('monitor_store_load', {baseModuleId:'monitor', moduleId:moduleId});
}, onStoreLoad:function(store, records, success) {
  var me = this;
  var gridView = this.getView();
  if (me.destroyed) {
    return;
  }
  if (success === true) {
    this.fireStoreLoadEventOnSuccess(gridView.moduleId);
    var total = store.getTotalCount();
    var vm = this.getView().up('bpcMonitor').getViewModel();
    vm.set('totalCount', total);
    if (this.getView() === this.getMainView().getActiveGrid()) {
      me.getMainView().updateDataItems(total);
      var rawData = store.getProxy().getReader().rawData;
      if (rawData.lastReplication) {
        me.getMainView().updatelastReplication(rawData.lastReplication);
      }
    }
    me.storeItems = total;
    if (gridView.multiColumnSort && !isNaN(gridView.multiSortLimit) && gridView.multiSortLimit > 0) {
      store.sorters.getOptions().setMultiSortLimit(gridView.multiSortLimit);
    } else {
      store.sorters.getOptions().setMultiSortLimit(1);
    }
    var sorterColl = store.getSorters();
    me.getMainView().updateModuleHeaderSorter(sorterColl);
    me.getView().fireEvent('load', me.getView());
  } else {
    if (success === false) {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ERROR_LOADING_DATA'));
    } else {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_UNEXPECTED_ERROR_DATA'));
    }
  }
  if (!gridView.up('monitorStackedPanel')) {
    gridView.saveState();
  }
}, getElementIdForRecord:function(record) {
  return this.getView().rowExpandDivPrefix + record.get('bpcCleanedId');
}, createDetailContainer:function(config, record, instanceConfig, grid, resizable, componentName) {
  var targetId = this.getElementIdForRecord(record);
  if (componentName === 'detailViewInline') {
    config = BpcCommon.Api.getSetting(this.getView().config.moduleId, monitor.assets.ConfigKeys.detailViewInlineConfig);
    if (!config.width) {
      var visibleWidth = this.getView().getView().getWidth() - 64;
      var parentWidth = Ext.get(targetId).getWidth();
      config.width = parentWidth < visibleWidth ? parentWidth : visibleWidth;
    }
    config = Ext.applyIf(config, {resizable:{handles:'s'}, padding:0});
  }
  return Ext.create('monitor.view.detail.DetailContainer', Ext.apply({}, config, {configuration:config, selectedRecord:record, bpcViewId:this.getView().bpcGridViewName, instanceConfiguration:instanceConfig.getData(), grid:grid, renderTo:targetId, moduleId:this.getView().config.moduleId, componentName:componentName, queryId:this.getView().getQueryId()}));
}, onExpandBody:function(rowNode, record) {
  this.showInlineDetailView(record);
}, showInlineDetailView:function(record) {
  try {
    var conf = false;
    var detailedContainer = this.createDetailContainer(conf, record, this.getMainViewModel(), this.getView(), true, 'detailViewInline');
    record.detailViewInlineCmp = detailedContainer;
    detailedContainer.show();
    var enthalten = Ext.Array.contains(this.expandMap, record.id);
    if (!enthalten) {
      this.expandMap.push(record.id);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR showInlineDetailView', dump:e, stack:true, level:'error'});
  }
}, onCollapseBody:function(rowNode, record) {
  Ext.Array.remove(this.expandMap, record.id);
  if (record.detailViewInlineCmp) {
    record.detailViewInlineCmp.destroy();
    delete record.detailViewInlineCmp;
  }
  var elem = Ext.get(this.getElementIdForRecord(record));
  elem.update('');
}, removeAllFilter:function() {
  this.getView().getStore().clearFilter();
  this.getMainViewController().setMonitorFilter(true);
}, removeSorter:function(dataIndex) {
  var sorters = this.grid.getStore().sorters;
  if (dataIndex) {
    sorters.removeAtKey(dataIndex);
  } else {
    sorters.clear();
    this.updateColumnText();
  }
  this.refreshData();
}, onShowContextMenu:function(view, td, cellIndex, record, tr, rowIndex, e) {
  e.preventDefault();
  var grid = this.getView();
  var moduleId = grid.config.moduleId;
  var copyCell = true;
  var column = view.panel.headerCt.getHeaderAtIndex(cellIndex);
  var clickedDataIndex = column.dataIndex;
  var cellValue = record.get(clickedDataIndex);
  this.lastValue = cellValue;
  if (cellValue) {
    if (cellValue === '') {
      copyCell = false;
    }
  } else {
    copyCell = false;
  }
  var contextMenu = Ext.create({xtype:'monitorContextMenu', column:column, feature_copyCell:copyCell, feature_copyCell_value:cellValue, grid:grid, record:record, moduleId:moduleId, viewModel:{parent:this.getViewModel()}, collaborationConfig:{moduleId:moduleId, collabEnabled:grid.collabEnabled, processKey:BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnId)}});
  this.lastCellIndex = cellIndex;
  this.lastRowIndex = rowIndex;
  this.lastClickedColumn = clickedDataIndex;
  this.lastRecord = record;
  contextMenu.showAt(e.getXY());
}, updateSplitView:function(record) {
  if (this.getMainViewController().isSplitViewActive()) {
    var conf = this.getMainView().getSetting(monitor.assets.ConfigKeys.detailViewEastConfig);
    var detailedContainer = this.createDetailContainer(conf, record, this.getMainViewModel(), this.getView(), 'detailViewEast');
    this.getMainViewController().updateSplitViewWithCmp(detailedContainer);
  }
}, addFilterToStore:function(filterObj) {
  this.getView().store.addFilter(filterObj);
}, setMonitorFilter:function(kill) {
  try {
    if (kill) {
      this.getViewModel().set('globalFilterValue', '');
    } else {
      this.getViewModel().set('globalFilterValue', this.getViewModel().get('globalFilterValue') + ' ' + this.lastValue);
    }
  } catch (e) {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ERROR_SETTING_FILTER') + e);
  }
  this.updateActiveFilter();
  this.updateModuleHeaderInfos();
}, selectionChange:function(selectionModel) {
  var me = this;
  var appTbarRightViewModel = me.getMainView().getRightToolbar().getViewModel();
  if (selectionModel.getSelection().length > 1) {
    appTbarRightViewModel.set('function_multiDownload', true);
  } else {
    appTbarRightViewModel.set('function_multiDownload', false);
  }
}, removeFocus:function() {
  try {
    Ext.get(document.activeElement).blur();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR removeFocus', dump:e, stack:true, level:'error'});
  }
}, filterCurrentViewOrSelect:function() {
  var recordsToFilter = this.getView().getSelection();
  var store = this.getView().getStore();
  if (!recordsToFilter || recordsToFilter.length === 0) {
    recordsToFilter = this.getVisibleRecords();
  }
  recordsToFilter = Ext.Array.map(recordsToFilter, function(record) {
    return record.getId();
  });
  var filter = new Ext.util.Filter({operator:'\x3d', value:recordsToFilter, source:'raw', property:BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnId)});
  store.setFilters([filter]);
}, getVisibleRecords:function() {
  var gridView = this.getView().getView();
  var firstIndex = gridView.getFirstVisibleRowIndex();
  var lastIndex = gridView.getLastVisibleRowIndex() + 1;
  var store = this.getView().getStore();
  var records = [];
  for (var i = firstIndex; i <= lastIndex; i++) {
    records.push(store.getAt(i));
  }
  return records;
}, onBeforeLoad:function() {
  var me = this;
  var view = this.getView();
  if (me.destroyed || !view.isVisible(true)) {
    this.refreshDataOnView = true;
    return false;
  }
}, onGlobalSearch:function(searchQuery) {
  var me = this;
  var value = String(searchQuery).replace(/UND/g, 'AND').replace(/ODER/g, 'OR');
  var storeProxy = me.getView().getStore().getProxy();
  if (storeProxy.getExtraParams().query === value) {
    return;
  }
  storeProxy.setExtraParam('query', value);
  me.refreshData();
}, updateChildLogGrids:function() {
  var childLogGrids = Ext.ComponentQuery.query('childLogGrid:visible(true)');
  childLogGrids.forEach(function(grid) {
    if (grid.componentName !== 'detailViewInline') {
      grid.store.reload();
    }
  });
}, updateDetailViews:function() {
  var detailComponents = Ext.ComponentQuery.query('detailContainer');
  var updateDetailComponents = function(detailComponent, reloadedRecord) {
    var processRecordViews = detailComponent.query('processRecordView');
    if (processRecordViews && processRecordViews.length !== 0) {
      processRecordViews.forEach(function(processRecordView) {
        processRecordView.removeAll();
        processRecordView.add(processRecordView.createItems(processRecordView.group, processRecordView.item, reloadedRecord));
      });
    }
    var actionPanels = detailComponent.query('actionPanel');
    if (actionPanels && actionPanels.length !== 0) {
      actionPanels.forEach(function(actionPanel) {
        actionPanel.removeAll();
        actionPanel.add(actionPanel.createItems(reloadedRecord));
      });
    }
  };
  if (detailComponents && detailComponents.length !== 0) {
    var firstDetailView = detailComponents[0];
    var currentRecord = firstDetailView.selectedRecord;
    var currentRecordId = currentRecord.id;
    var store = this.getView().store;
    var reloadedRecord = store.getById(currentRecordId);
    detailComponents.forEach(function(detailComponent) {
      return updateDetailComponents(detailComponent, reloadedRecord);
    });
  }
}});
Ext.define('monitor.view.grid.Grid', {extend:'Ext.grid.Panel', alias:['widget.processGrid', 'widget.monitorGrid'], cls:'monitorGrid', requires:['monitor.component.grid.plugin.BpcRowExpander', 'monitor.view.grid.GridController'], config:{moduleId:undefined, storeUrl:undefined, selectedRecords:[]}, publishes:['selectedRecords'], store:undefined, stateId:undefined, stateful:true, viewModel:{data:{gridTitle:'', monitorData:'MONITOR_DATASETS', monitorFilter:'MONITOR_FILTER_ACTIVE', monitorSorter:'MONITOR_SORTER_ACTIVE', 
initialState:undefined}}, listeners:{afterrender:function(me) {
  me.down('tableview').rowSelector = 'tr.x-grid-row.monitorGrid-row';
  me.lookupViewModel().set('activeGrid', me);
}, focus:function(me) {
  me.lookupViewModel().set('activeGrid', me);
}, show:function(me) {
  me.lookupViewModel().set('activeGrid', me);
}}, features:[{ftype:'grouping'}], bind:{title:'{monitorTitle} {gridTitle} - {totalItems} {monitorData:translate} - ' + '{activeFilter} {monitorFilter:translate} - {activeSorter} {monitorSorter:translate} {activeSortOrder}'}, controller:'gridController', selModel:{mode:'MULTI', pruneRemoved:false}, autoScroll:true, multiColumnSort:undefined, multiSortLimit:undefined, reserveScrollbar:true, rowExpandDivPrefix:undefined, minHeight:100, collabEnabled:false, initComponent:function() {
  var me = this;
  me.stateId = me.moduleId + '_' + me.bpcGridViewName;
  me.itemId = me.stateId;
  BpcCommon.Performance.mark('monitor_grid_init_start_' + me.stateId);
  me.viewConfig = {loadMask:BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.showGridLoadMask), enableTextSelection:BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.gridEditable), preserveScrollOnRefresh:true, preserveScrollOnReload:true, deferEmptyText:false, localized:{emptyText:'MONITOR_NO_DATA_AVAILABLE'}, getRowClass:monitor.Module.rowStyleController.getRowClass.bind(this, me.config.moduleId, me.bpcGridViewName), onItemMouseLeave:function(record) {
    if (!record.detailViewInlineCmp) {
      if (me.trackOver) {
        me.clearHighlight();
      }
    }
  }};
  me.header = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.gridShowHeader);
  me.creationTimeStamp = (new Date).getTime();
  this.collabEnabled = me.isCollabEnabled();
  me.store = me.createStore();
  me.store.load();
  var rowExpandDivPrefix = BpcCommon.Util.cleanUpId(me.bpcGridViewName + '-' + me.config.moduleId + '-');
  me.rowExpandDivPrefix = rowExpandDivPrefix;
  me.columnId = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.columnId);
  me.multiColumnSort = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.sortMulti);
  me.multiSortLimit = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.sortMultiColumnCount);
  me.multiSortMode = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.sortMultiReversedOrder);
  me.plugins = [{ptype:'bpcrowexpander', pluginId:'bpcrowexpander', selectRowOnExpand:false, expandOnDblClick:false, rowBodyTpl:new Ext.XTemplate('\x3cdiv id\x3d"' + rowExpandDivPrefix + '{bpcCleanedId}"\x3e\x3c/div\x3e')}, {ptype:'gridfilters'}];
  var fileDataIndex = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.columnFile);
  if (BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.functionEnableMultiDownload)) {
    me.selModel = {selType:'checkboxmodel', mode:'MULTI', selectable:function(record) {
      return !record.get(fileDataIndex);
    }, showHeaderCheckbox:true, listeners:{selectionchange:'selectionChange'}};
  }
  me.columns = {items:me.createGridColumnConfig(), initFocusableContainerKeyNav:function(el) {
    var me = this;
    if (!me.focusableKeyNav) {
      me.focusableKeyNav = new Ext.util.KeyNav({target:el, scope:me, down:me.showHeaderMenu, home:me.onHomeKey, end:me.onEndKey, space:me.onHeaderActivate, enter:me.onHeaderActivate});
    }
  }};
  me.callParent(arguments);
  BpcCommon.Performance.markAndMeasure('monitor_grid_init_' + me.config.moduleId + '_' + me.bpcGridViewName, 'monitor_grid_init_start_' + me.config.moduleId + '_' + me.bpcGridViewName, 'monitor_grid_init_end_' + me.config.moduleId + '_' + me.bpcGridViewName);
}, isCollabEnabled:function() {
  var $jscomp$this = this;
  try {
    if (!window.collaboration) {
      return false;
    }
    var pluginConfigurations = BpcCommon.Api.getSetting('monitor', 'plugin_configuration') || [];
    var collabColumnPluginsForModuleId = pluginConfigurations.filter(function(conf) {
      return Ext.isDefined(conf.targetInstance) && Ext.isArray(conf.targetInstance) && conf.targetInstance.indexOf($jscomp$this.config.moduleId) !== -1;
    }).filter(function(conf) {
      return conf.hook === 'monitor_root' && conf.plugin === 'collabArtefactGridColumn';
    });
    return collabColumnPluginsForModuleId.length > 0;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR isCollabEnabled', dump:e, stack:true, level:'error'});
    return false;
  }
}, getQueryId:function() {
  return this.bpcGridViewName + ':::' + this.creationTimeStamp;
}, createStore:function() {
  var me = this;
  var newModel = Ext.define(null, {extend:'Ext.data.Model', idProperty:BpcCommon.Api.getSetting(this.config.moduleId, monitor.assets.ConfigKeys.columnId), fields:[{name:'bpcCleanedId', convert:function(value, record) {
    var cleanId = value;
    try {
      var idColumn = BpcCommon.Api.getSetting(me.config.moduleId, monitor.assets.ConfigKeys.columnId);
      if (Ext.isDefined(idColumn)) {
        cleanId = BpcCommon.Util.cleanUpId(record.get(idColumn));
      }
    } catch (e) {
      Ext.log({msg:this.self.getName() + ': ERROR convert', dump:e, stack:true, level:'error'});
    }
    return cleanId;
  }}]});
  var params = {view:this.bpcGridViewName, timezoneOffset:'+0' + (new Date).getTimezoneOffset() / 60 * -1 + ':00', timezoneName:BpcCommon.Util.getTimezoneName()};
  if (this.collabEnabled === true) {
    params.collaboration = 'true';
  }
  var id = this.config.moduleId + '_' + this.config.bpcGridViewId;
  return Ext.create('monitor.store.Store', {model:newModel, moduleId:this.config.moduleId, bpcGridViewId:this.config.bpcGridViewId, storeId:this.bpcGridViewName, sorters:this.createInitialSorter(), groupField:BpcCommon.Api.getSetting(this.config.moduleId, monitor.assets.ConfigKeys.columnGroupField), queryId:this.getQueryId(), proxy:{url:this.config.storeUrl, extraParams:params}, statefulFilters:true, multiSortMode:BpcCommon.Api.getSetting(this.config.moduleId, monitor.assets.ConfigKeys.sortMultiReversedOrder), 
  listeners:{beforeload:BpcCommon.Performance.mark.bind(BpcCommon.Performance, 'monitor_store_load_start_' + id), load:BpcCommon.Performance.markAndMeasure.bind(BpcCommon.Performance, 'monitor_store_load_' + id, 'monitor_store_load_start_' + id, 'monitor_store_load_end_' + id)}});
}, createInitialSorter:function() {
  var sorterList = BpcCommon.Api.getSetting(this.config.moduleId, monitor.assets.ConfigKeys.gridSortingColumn) || '';
  var sorterArrHelper = BpcCommon.Util.trimArray(sorterList.split(','));
  var sorterArr = [];
  var sortDirection = BpcCommon.Api.getSetting(this.config.moduleId, monitor.assets.ConfigKeys.gridMainSortDirection) || 'DESC';
  Ext.Array.each(sorterArrHelper, function(sorterCol) {
    sorterArr.push({property:sorterCol, direction:sortDirection});
  });
  return sorterArr;
}, clearFilterFields:function() {
  var columns = this.getColumns();
  Ext.each(columns, function(column) {
    var trigger;
    column.removeCls('bpc-monitor-filterActive');
    var field = column.down('field');
    if (field && field instanceof Ext.form.field.Base) {
      field.suspendEvents();
      field.setValue('');
      if (field.getTrigger) {
        trigger = field.getTrigger('resetField');
        if (trigger) {
          trigger.hide();
        }
      }
      field.resumeEvents(true);
      field.saveState();
    }
  });
}, getState:function() {
  var me = this;
  var state = me.callParent();
  if (this.getStore().isGrouped()) {
    state.groupingEnabled = true;
    state.groupField = me.getStore().getGroupField();
  } else {
    state.groupingEnabled = false;
  }
  return state;
}, applyState:function(state) {
  var me = this;
  if (!state) {
    return;
  }
  state = Ext.clone(state);
  state.storeState = state.storeState || {};
  Ext.applyIf(state.storeState, {filters:[], sorters:[]});
  if (!state.columns || Ext.isArray(state.columns) && state.columns.length === 0) {
    state.columns = me.createGridColumnConfig();
  }
  delete state.id;
  if (me.rendered) {
    me.stateful = false;
    var newColumns = [];
    var oldColumnsMap = {};
    var configuredColumns = me.createGridColumnConfig();
    configuredColumns.forEach(function(column) {
      oldColumnsMap[column.columnId] = column;
    });
    state.columns.forEach(function(columnState) {
      var column = oldColumnsMap[columnState.id] || oldColumnsMap[columnState.columnId];
      if (column) {
        delete columnState.id;
        newColumns.push(Ext.apply(column, columnState));
        configuredColumns.splice(configuredColumns.indexOf(column), 1);
      }
    });
    me.reconfigure(newColumns.concat(configuredColumns));
    me.stateful = true;
    delete state.columns;
  }
  me.callParent([state]);
  var monitorCmp = me.up('bpcMonitor');
  if (state.groupField && state.groupingEnabled === true) {
    monitorCmp.getViewModel().set('groupField', state.groupField);
  }
}, createGridColumnConfig:function() {
  var me = this;
  var columns = [];
  try {
    var columnObj = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.columnConfig);
    var colConfig = Ext.clone(columnObj);
    var pluginHookColumns = colConfig.filter(function(col) {
      return col.xtype === 'monitorColumnHook';
    });
    if (pluginHookColumns.length > 0) {
      pluginHookColumns.forEach(function(colConfig, index) {
        colConfig.columnId = colConfig.columnId || 'monitorColumnHook-' + index + '-' + me.bpcGridViewName;
        colConfig.context = {instanceId:me.moduleId};
      });
    } else {
      colConfig.push({xtype:'monitorColumnHook', columnId:'monitorColumnHook-0-' + me.bpcGridViewName, context:{instanceId:me.moduleId}});
    }
    if (this.isCollabEnabled()) {
      colConfig = Ext.Array.insert(colConfig, 0, [collaboration.Module.getCollabColumn(me.moduleId)]);
    }
    var columnStateIdMap = {};
    Ext.each(colConfig, function(col) {
      if (!BpcCommon.Api.isUserAllowedToSee(col)) {
        return;
      }
      if (!col.dataIndex) {
        Ext.log({msg:this.self.getName() + ': dataIndex missing or empty', level:'warn'});
        col.dataIndex = 'dummy';
      } else {
        if (!col.tooltip && BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.hideDefaultTableHeaderTooltip) !== true) {
          col.tooltip = col.dataIndex;
        }
      }
      if (col.id) {
        col.id = col.id + '-' + me.bpcGridViewName;
      }
      var stateId = col.id || col.dataIndex;
      if (columnStateIdMap[stateId]) {
        var counter = columnStateIdMap[stateId];
        var baseStateId = stateId;
        stateId = baseStateId + '_' + counter;
        columnStateIdMap[baseStateId] = counter + 1;
      } else {
        columnStateIdMap[stateId] = 1;
      }
      var defaultColumnConfig = {xtype:'gridcolumn', stateId:stateId, columnId:stateId, layout:{type:'vbox', align:'stretch', pack:'start'}, minWidth:64, items:[], moduleId:me.moduleId, getColumnState:function() {
        var me = this;
        var items = me.items.items;
        var state = {id:me.getStateId(), hidden:me.hidden, flex:me.flex};
        if (me.width) {
          state.width = me.width;
        }
        me.savePropsToState(['sortable', 'locked'], state);
        if (me.isGroupHeader && items && items.length) {
          state.columns = me.getColumnsState();
        }
        if ('width' in state) {
          delete state.flex;
        }
        return state;
      }};
      if (col.filter && col.filter.type) {
        if (BpcCommon.Util.isStringEqual(col.filter.type, 'date') || BpcCommon.Util.isStringEqual(col.filter.type, 'simpledate')) {
          col.filter.type = 'daterange';
        }
        if (BpcCommon.Util.isStringEqual(col.filter.type, 'number')) {
          col.filter.type = 'bpcMonitorNumber';
        }
      }
      if (col.filter && col.filter.type && Ext.isString(col.filter.type)) {
        col.filter.type = col.filter.type.toLowerCase();
        if (!Ext.ClassManager.getByAlias('grid.filter.' + col.filter.type)) {
          Ext.log({msg:this.self.getName() + ': unknown filter type ' + col.filter.type, level:'warn'});
          col.filter.type = false;
        }
      } else {
        defaultColumnConfig.items.push({xtype:'textfield', editable:false, fieldStyle:'cursor: not-allowed;', margin:0, ui:'columnHeaderField'});
      }
      if (col.customRenderer) {
        col.renderer = me.up('bpcMonitor').findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(col);
      }
      if (col.xtype === 'datecolumn') {
        if (!col.format) {
          col.format = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.dateFormat);
        }
      }
      if (col.text) {
        col.text = Ext.String.htmlEncode(col.text);
      }
      columns.push(Ext.applyIf(col, defaultColumnConfig));
    }, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createColumns', dump:e, stack:true, level:'error'});
  }
  return columns;
}});
Ext.define('monitor.view.grid.columns.AttachmentColumn', {extend:'Ext.grid.column.Column', alias:['widget.attachmentColumn', 'widget.attachmentcolumn'], xtype:'attachmentcolumn', stopSelection:true, actionIdRe:new RegExp(Ext.baseCSSPrefix + 'action-col-(\\d+)'), altText:'', localized:{menuText:{tpl:'\x3ci\x3e{MONITOR_ACTIONS}\x3c/i\x3e', keys:['MONITOR_ACTIONS']}}, ignoreExport:true, sortable:false, innerCls:Ext.baseCSSPrefix + 'grid-cell-inner-action-col', actionIconCls:Ext.baseCSSPrefix + 'action-col-icon', 
constructor:function(config) {
  var me = this;
  var cfg = Ext.apply({}, config);
  var iconItems = cfg.iconItems || me.iconItems || [me];
  var hasGetClass, i, len;
  me.origRenderer = cfg.renderer || me.renderer;
  me.origScope = cfg.scope || me.scope;
  me.renderer = me.scope = cfg.renderer = cfg.scope = null;
  cfg.iconItems = null;
  me.callParent([cfg]);
  me.iconItems = iconItems;
  for (i = 0, len = iconItems.length; i < len; ++i) {
    if (iconItems[i].getClass) {
      hasGetClass = true;
      break;
    }
  }
  if (me.origRenderer || hasGetClass) {
    me.hasCustomRenderer = true;
  }
}, initComponent:function() {
  var me = this;
  me.callParent();
  if (me.sortable && !me.dataIndex) {
    me.sortable = false;
  }
}, defaultRenderer:function(v, cellValues, record, rowIdx, colIdx, store, view) {
  var me = this;
  var scope = me.origScope || me;
  var iconItems = me.iconItems || [];
  var len = iconItems.length;
  var i, item, ret, disabled, tooltip, altText, icon;
  ret = Ext.isFunction(me.origRenderer) ? me.origRenderer.apply(scope, arguments) || '' : '';
  cellValues.tdCls += ' ' + Ext.baseCSSPrefix + 'action-col-cell';
  for (i = 0; i < len; i++) {
    item = iconItems[i];
    icon = item.icon;
    disabled = item.disabled || (item.isDisabled ? item.isDisabled.call(item.scope || scope, view, rowIdx, colIdx, item, record) : false);
    tooltip = disabled ? null : item.tooltip || (item.getTip ? item.getTip.apply(item.scope || scope, arguments) : null);
    altText = item.getAltText ? item.getAltText.apply(item.scope || scope, arguments) : item.altText || me.altText;
    if (!item.hasActionConfiguration) {
      item.stopSelection = me.stopSelection;
      item.disable = Ext.Function.bind(me.disableAction, me, [i], 0);
      item.enable = Ext.Function.bind(me.enableAction, me, [i], 0);
      item.hasActionConfiguration = true;
    }
    ret += '\x3c' + (icon ? 'img' : 'div') + ' tabIndex\x3d"0" role\x3d"button"' + (icon ? ' alt\x3d"' + altText + '" src\x3d"' + item.icon + '"' : '') + ' class\x3d"' + me.actionIconCls + ' ' + Ext.baseCSSPrefix + 'action-col-' + String(i) + ' ' + (disabled ? me.disabledCls + ' ' : ' ') + (Ext.isFunction(item.getClass) ? item.getClass.apply(item.scope || scope, arguments) : item.iconCls || me.iconCls || '') + '"' + (tooltip ? ' data-qtip\x3d"' + tooltip + '"' : '') + (icon ? '/\x3e' : '\x3e\x3c/div\x3e');
  }
  return ret;
}, updater:function(cell, value, record, view, dataSource) {
  var cellValues = {};
  Ext.fly(cell).addCls(cellValues.tdCls).down(this.getView().innerSelector, true).innerHTML = this.defaultRenderer(value, cellValues, record, null, null, dataSource, view);
}, enableAction:function(index, silent) {
  var me = this;
  if (!index) {
    index = 0;
  } else {
    if (!Ext.isNumber(index)) {
      index = Ext.Array.indexOf(me.iconItems, index);
    }
  }
  me.iconItems[index].disabled = false;
  me.up('tablepanel').el.select('.' + Ext.baseCSSPrefix + 'action-col-' + index).removeCls(me.disabledCls);
  if (!silent) {
    me.fireEvent('enable', me);
  }
}, disableAction:function(index, silent) {
  var me = this;
  if (!index) {
    index = 0;
  } else {
    if (!Ext.isNumber(index)) {
      index = Ext.Array.indexOf(me.iconItems, index);
    }
  }
  me.iconItems[index].disabled = true;
  me.up('tablepanel').el.select('.' + Ext.baseCSSPrefix + 'action-col-' + index).addCls(me.disabledCls);
  if (!silent) {
    me.fireEvent('disable', me);
  }
}, beforeDestroy:function() {
  this.renderer = this.iconItems = null;
  return this.callParent(arguments);
}, processEvent:function(type, view, cell, recordIndex, cellIndex, e, record, row) {
  var me = this;
  var key = type === 'keydown' && e.getKey();
  var cellFly = Ext.fly(cell);
  var target = e.getTarget(), match, item, disabled;
  e.stopSelection = !key && me.stopSelection;
  if (key && (target === cell || !cellFly.contains(target))) {
    target = cellFly.query('.' + me.actionIconCls, true);
    if (target.length === 1) {
      target = target[0];
    } else {
      return;
    }
  }
  if (target && (match = target.className.match(me.actionIdRe))) {
    item = me.iconItems[parseInt(match[1], 10)];
    disabled = item.disabled || (item.isDisabled ? item.isDisabled.call(item.scope || me.origScope || me, view, recordIndex, cellIndex, item, record) : false);
    if (item && !disabled) {
      if (type === 'mousedown' && !me.getView().actionableMode) {
        e.preventDefault();
      } else {
        if (type === 'click' || (key === e.ENTER || key === e.SPACE)) {
          Ext.callback(item.handler || me.handler, item.scope || me.origScope, [view, recordIndex, cellIndex, item, e, record, row], undefined, me);
          if (!view.el.contains(Ext.Element.getActiveElement())) {
            return false;
          }
        }
      }
    }
  }
  return me.callParent(arguments);
}, cascade:function(fn, scope) {
  fn.call(scope || this, this);
}, iconItems:[{iconCls:'x-fal fa-download', localized:{tooltip:'MONITOR_DOWNLOAD_MESSAGE'}, scope:this, handler:function(tableView, rowIndex, colIndex, item, event, record) {
  try {
    if (tableView.up('bpcMonitor')) {
      tableView.up('bpcMonitor').downloadFile(record);
    }
  } catch (e) {
    Ext.log({msg:': ERROR file download handler', dump:e, stack:true, level:'error'});
  }
}, isDisabled:function(view, rowIndex, colIndex, item, record) {
  try {
    var column = 'REFERENCE';
    if (view.up('bpcMonitor')) {
      column = BpcCommon.Api.getSetting(view.up('bpcMonitor').moduleId, monitor.assets.ConfigKeys.columnFile);
    }
    return !record.get(column);
  } catch (e) {
    Ext.log({msg:': ERROR file download isDisabled', dump:e, stack:true, level:'error'});
  }
}}]});
Ext.define('monitor.view.grid.viewmode.stacked.StackedMode', {extend:'Ext.container.Container', alias:'widget.monitorStackedPanel', controller:'monitorStackedPanelController', region:'center', layout:{type:'vbox', align:'stretch'}, items:[]});
Ext.define('monitor.view.grid.viewmode.stacked.StackedModeController', {extend:'Ext.app.ViewController', alias:'controller.monitorStackedPanelController', requires:[], control:{'processGrid':{selectionchange:'onSelectionChange', statesave:'onStateSave'}, 'processGrid \x3e gridview':{scroll:{element:'body', fn:'syncScrolling'}}, 'monitorStackedPanel':{'globalSearch':'onGlobalSearch'}}, init:function() {
  var grids = this.getView().down('processGrid');
  Ext.Array.each(grids, function(grid) {
    grid.store.on('sort', this.onSortChange.bind(this));
  }, this);
}, onGlobalSearch:function(value) {
  try {
    var items = this.getView().items;
    items.each(function(grid) {
      var store = grid.getStore();
      store.proxy.extraParams.query = value;
      grid.getController().refreshData();
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onGlobalSearch', dump:e, stack:true, level:'error'});
  }
}, onSelectionChange:function(selectionModel) {
  try {
    var grids = this.getView().query('processGrid[id!\x3d' + selectionModel.view.grid.id + ']');
    Ext.Array.each(grids, function(grid) {
      grid.getSelectionModel().deselectAll(true);
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onSelectionChange', dump:e, stack:true, level:'error'});
  }
}, onStateSave:function(cmp, state) {
  var gridId = cmp.bpcGridViewName;
  var items = this.getView().items;
  items.each(function(grid) {
    if (grid.bpcGridViewName !== gridId) {
      if (BpcCommon.Util.getHash(state) !== BpcCommon.Util.getHash(grid.getState())) {
        grid.suspendEvents();
        grid.applyState(state);
        grid.resumeEvents(true);
      }
    }
  });
}, syncScrolling:function(e, t) {
  var gridLead = e.up('processGrid');
  var gridId = gridLead.bpcGridViewName;
  var items = this.getView().items;
  items.each(function(grid) {
    if (grid.bpcGridViewName !== gridId) {
      grid.getView().suspendEvent('scroll');
      grid.getScrollable().scrollTo(t, null).then(function() {
        Ext.defer(function() {
          grid.getView().resumeEvent('scroll');
        }, 5);
      }, function() {
        grid.getView().resumeEvent('scroll');
      });
    }
  });
}, onSortChange:function(store) {
  var parentSorters = store.getSorters().getRange();
  var items = this.getView().items;
  items.each(function(grid) {
    if (grid.getStore().storeId !== store.storeId) {
      grid.suspendEvents();
      grid.getStore().sorters.removeAll();
      grid.getStore().sorters.add(parentSorters);
      grid.getStore().load();
      grid.resumeEvents(true);
    }
  });
}});
Ext.define('monitor.view.grid.tabbed.TabModeController', {extend:'Ext.app.ViewController', alias:'controller.monitorTabPanelController', control:{'#':{'tabchange':'onTabChange'}}, onTabChange:function(tabPanel, newCard, oldCard) {
  newCard.getController().updateModuleHeaderInfos();
  var oldFilters = oldCard.getStore().getFilters().getRange();
  var oldSorters = oldCard.getStore().getSorters().getRange();
  var oldQuery = oldCard.getStore().proxy.extraParams.query;
  var newFilters = newCard.getStore().getFilters().getRange();
  var newSorters = newCard.getStore().getSorters().getRange();
  var newQuery = newCard.getStore().proxy.extraParams.query;
  if (oldQuery !== newQuery) {
    newCard.getStore().proxy.extraParams.query = oldQuery;
    this.getView().up('bpcMonitor').getActiveGrid().getController().refreshData();
  }
  if (!Ext.Array.equals(oldFilters, newFilters) || !Ext.Array.equals(oldSorters, newSorters)) {
    newCard.getStore().clearFilter();
    newCard.getStore().sorters.removeAll();
    newCard.getStore().sorters.add(oldSorters);
    newCard.getStore().addFilter(oldFilters);
  }
}});
Ext.define('monitor.view.grid.tabbed.Tabbed', {extend:'Ext.tab.Panel', alias:'widget.monitorTabPanel', controller:'monitorTabPanelController', region:'center', items:[]});
Ext.define('monitor.view.interaction.SearchField', {extend:'Ext.toolbar.Toolbar', alias:'widget.monitorSearchField', items:[{xtype:'button', iconCls:'x-fal fa-search', stateful:{pressed:true}, stateId:'monitorSearchFieldButton', itemId:'fullTextSearchButton', stateEvents:['toggle'], enableToggle:true, bind:{pressed:'{global.monitor.showSearchField}'}}, {xtype:'bpcTextField', htmlEncode:false, flex:1, minWidth:250, maxWidth:350, name:'searchField', itemId:'fullTextSearch', localized:{emptyText:'MONITOR_FULL_TEXT_SEARCH'}, 
hidden:true, triggers:{resetField:{cls:'x-fal fa-times', handler:function() {
  this.setValue('');
}}}, setTriggerResetHidden:function(hidden) {
  this.getTrigger('resetField').setVisible(!hidden);
}, getTriggerResetHidden:function() {
  return !this.getTrigger('resetField').isVisible();
}, bind:{value:'{globalFilterValue}', hidden:'{!global.monitor.showSearchField}', triggerResetHidden:'{!globalFilterValue}'}, listeners:{afterrender:function(sf) {
  Ext.create('Ext.tip.ToolTip', {target:sf.id, dismissDelay:0, localized:{html:'MONITOR_FULLTEXT_QUERY_TOOLTIP'}});
}, beforehide:function() {
  this.oldValue = this.getValue();
  this.setValue('');
}, show:function(searchField) {
  var currentValue = searchField.lookupViewModel().get('globalFilterValue');
  if (this.oldValue && currentValue === '') {
    this.setValue(this.oldValue);
    delete this.oldValue;
  } else {
    this.setValue(currentValue);
    this.oldValue = searchField.lookupViewModel().get('globalFilterValue');
  }
  searchField.focus();
}}}]});
Ext.define('monitor.view.interaction.changeState.ChangeStateMixin', {moduleId:undefined, iconCls:monitor.assets.Icons.TASKS, localized:{tooltip:'MONITOR_CHANGE_STATUS'}, handler:function() {
  var me = this;
  Ext.create({xtype:'monitorChangeStateWindow', moduleId:me.moduleId, viewModel:{parent:monitor.Util.getViewModel(me.lookupViewModel())}});
}, isAbleToChangeState:function(moduleId, cmp) {
  var isChangeStateActive = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.changeState);
  var hasUserRight = BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.changeProcessState) || BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.changeProcessState + '_' + moduleId);
  if (cmp.xtype === 'monitorChangeStateMenu') {
    var currentMonitorView = Ext.ComponentQuery.query('bpcMonitor').find(function(item) {
      return item.moduleId === moduleId;
    });
    var isItemSelected = currentMonitorView.getViewModel().get('activeGridSelection').length !== 0;
    return isChangeStateActive && hasUserRight && isItemSelected;
  }
  return isChangeStateActive && hasUserRight;
}});
Ext.define('monitor.view.interaction.changeState.ChangeStateButton', {extend:'Ext.Button', alias:'widget.monitorChangeStateBtn', mixins:['monitor.view.interaction.changeState.ChangeStateMixin'], hidden:true, disabled:true, bind:{disabled:'{activeGridSelection.length \x3c 1}'}, initComponent:function() {
  this.hidden = !this.isAbleToChangeState(this.moduleId, this);
  this.callParent();
}});
Ext.define('monitor.view.interaction.changeState.ChangeStateMenu', {extend:'Ext.menu.Item', alias:'widget.monitorChangeStateMenu', mixins:['monitor.view.interaction.changeState.ChangeStateMixin'], hidden:true, text:BpcCommon.Api.getTranslation('MONITOR_CHANGE_STATUS'), initComponent:function() {
  this.hidden = !this.isAbleToChangeState(this.moduleId, this);
  this.callParent();
}});
Ext.define('monitor.view.interaction.changeState.ChangeStateWindowController', {extend:'Ext.app.ViewController', alias:'controller.changeStateWindowController', control:{'#stateColumnSelector':{change:'onColumnStoreChange'}, '#statesField':{change:'onStateChange'}}, onFormSubmit:function() {
  var me = this;
  var unlockFn = BpcCommon.Util.blockComponentForAsyncAction('onFormSubmit', 'handler', BpcCommon.Api.getTranslation('MONITOR_IS_BEING_PROCESSED'), '^ monitorChangeStateWindow');
  try {
    var form = me.getView().down('form');
    if (form.isValid()) {
      var postObj = {};
      var stateConfig = me.getView().changeStateConfigMap;
      postObj.tablePrefix = BpcCommon.Api.getSetting(me.getView().moduleId, monitor.assets.ConfigKeys.legacyPmTablePrefix);
      postObj.mandant = BpcCommon.Api.getSetting(me.getView().moduleId, monitor.assets.ConfigKeys.legacyPmMandant);
      postObj.timelineUpdate = BpcCommon.Api.getSetting(me.getView().moduleId, monitor.assets.ConfigKeys.columnTimeseries);
      var statusfield = me.getView().down('#stateColumnSelector').getValue();
      var childStatus = 'Info';
      if (Ext.isDefined(stateConfig[statusfield].childStatus)) {
        childStatus = stateConfig[statusfield].childStatus;
      }
      postObj.childStatus = childStatus;
      postObj.command = 'StatusChange';
      postObj.columnsstring = statusfield.toLowerCase();
      postObj['changeStatusBox_' + statusfield.toLowerCase()] = 'on';
      postObj['newStatusCombo_' + statusfield.toLowerCase()] = me.getView().down('#statesField').getValue();
      postObj.commentfield = me.getView().down('#comment').getValue();
      var processes = [];
      var columnId = BpcCommon.Api.getSetting(me.getView().moduleId, monitor.assets.ConfigKeys.columnId);
      columnId = columnId.split(',').length > 1 ? columnId.split(',') : columnId;
      if (Ext.isArray(columnId)) {
        Ext.Array.each(me.getView().selectedRecords, function(record) {
          var joinedVal = [];
          columnId.forEach(function(val) {
            joinedVal.push(record.get(val));
          });
          processes.push(joinedVal.join(','));
        });
      } else {
        Ext.Array.each(me.getView().selectedRecords, function(record) {
          processes.push(record.id);
        });
      }
      postObj.processes = processes.join(';');
      if (postObj) {
        var moduleId = this.getView().moduleId;
        var inubitUrl = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.bpmBasePath);
        var inubitEndpoint = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.changeStateEndpoint);
        var inubitProxyId = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.bpmProxyId);
        var proxyUrl = BpcCommon.Api.getBackendUrl(inubitProxyId) + inubitUrl + inubitEndpoint;
        proxyUrl = proxyUrl.replace('/bpc-httpproxy/httpProxy/', '/bpc-monitor/monitor/httpProxy/');
        var notification = {toast:true, toastTarget:this.getView()};
        Ext.Ajax.request({url:proxyUrl, method:'POST', params:postObj, headers:{ISPortalUser:BpcCommon.Api.getUserSession().data.loginName, 'X-BPC-ModuleId':moduleId}, success:function(response) {
          var obj = Ext.decode(response.responseText, true);
          if (obj && obj.success) {
            notification.text = BpcCommon.Api.getTranslation('MONITOR_STATUS_CHANGE_SUCCESSFUL');
            if (obj.msg) {
              notification.text = notification.text + ': ' + obj.msg;
            }
            BpcCommon.Api.showNotification(notification);
            me.destroyWindow();
          } else {
            var errorMsg = BpcCommon.Util.getErrorFromFailureResponse(response).message;
            notification.text = BpcCommon.Api.getTranslation('MONITOR_STATUS_CHANGE_FAILED') + ': ' + errorMsg;
            notification.type = 'ERROR';
            BpcCommon.Api.showNotification(notification);
          }
        }, failure:function(response) {
          var errorMsg = BpcCommon.Util.getErrorFromFailureResponse(response).message;
          notification.text = BpcCommon.Api.getTranslation('MONITOR_STATUS_CHANGE_FAILED') + ': ' + errorMsg;
          notification.type = 'ERROR';
          BpcCommon.Api.showNotification(notification);
        }, callback:unlockFn});
      }
    } else {
      unlockFn();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onFormSubmit', dump:e, stack:true, level:'error'});
    unlockFn();
  }
}, onColumnStoreChange:function(combo, newValue) {
  this.modifyStateStore(newValue);
}, onStateChange:function(combo, newValue) {
  try {
    var vm = this.getViewModel();
    vm.set('displayState', newValue);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onStateChange', dump:e, stack:true, level:'error'});
  }
}, modifyStateStore:function(columnName) {
  var me = this;
  var monitorMain = BpcCommon.Api.getModuleInstanceComponent(me.getView().moduleId);
  try {
    var moduleId = this.getView().moduleId;
    var store = Ext.data.StoreManager.lookup('dynStates');
    store.removeAll();
    var viewModel = this.getViewModel();
    viewModel.set('columnName', columnName);
    var changeStateConfigMap = this.getView().changeStateConfigMap;
    var config = changeStateConfigMap[columnName];
    if (config) {
      var monitorCustomRenderer = monitorMain.findPlugin('monitorCustomRenderer');
      var monitorColumnConfig = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnConfig);
      var columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
        return colConfig.id === columnName;
      });
      if (!columnConfig) {
        columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
          return colConfig.dataIndex === columnName;
        });
      }
      var customRendererId = monitorCustomRenderer.getRendererIdByColumnConfig(columnConfig);
      if (!config.states) {
        config.states = [];
      }
      var addToStore = function(value) {
        var label = monitorCustomRenderer.render(customRendererId, value, false, true);
        if (!Ext.isDefined(label) || label === null) {
          label = value;
        }
        store.add({valueR:monitorCustomRenderer.render(customRendererId, value), value:value, raw:value, translated:label});
      };
      if (config.useDistinctValues || config.useDistinctValues === undefined) {
        var url = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + this.getView().moduleId + '/distinctFieldValues/' + columnName + '.raw';
        monitor.Util.ajaxGetCall(url, function(success, response) {
          Ext.each(response.values, function(value) {
            addToStore(value.value);
          });
        });
      }
      if (config.useRendererValues) {
        var rendererConfig = monitorCustomRenderer.getRendererConfigMap()[String(customRendererId).toLowerCase()];
        Ext.Object.getAllKeys(rendererConfig.valueMap).forEach(addToStore);
      }
      if (!config.useRendererValues && !(config.useDistinctValues || config.useDistinctValues === undefined)) {
        Ext.each(config.states, function(stateVal) {
          if (stateVal.settable !== false) {
            addToStore(stateVal.state);
          }
        });
      }
    } else {
      Ext.log({msg:this.self.getName() + ': modifyStateStore : no config found for ' + columnName, level:'warning'});
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR modifyStateStore', dump:e, stack:true, level:'error'});
  }
}, destroyWindow:function() {
  this.getView().destroy();
}});
Ext.define('monitor.view.interaction.changeState.ChangeStateWindow', {extend:'BpcCommon.component.window.Window', alias:['widget.monitorChangeStateWindow'], requires:['monitor.view.interaction.changeState.ChangeStateWindowController'], controller:'changeStateWindowController', localized:{title:'MONITOR_EDIT_STATE'}, stateful:true, stateId:'changeStateWindow', constrain:true, layout:'fit', padding:'10 10 10 10', width:700, minWidth:300, minHeight:300, iconCls:monitor.assets.Icons.TASKS, moduleId:undefined, 
columnStore:undefined, defaultFocus:'#changeStateComment', user:undefined, viewModel:{data:{columnName:undefined, displayState:''}}, autoShow:true, initComponent:function() {
  var me = this;
  var monitorMain = BpcCommon.Api.getModuleInstanceComponent(me.moduleId);
  me.changeStateConfig = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.changeStateConfig);
  me.selectedRecords = me.getViewModel().get('activeGrid.selectedRecords');
  if (!me.changeStateConfig || !me.moduleId) {
    me.items = [{xtype:'bpcCenterMessageCmp', message:'MONITOR_MODULE_NO_CONFIG_FOR_STATE_CHANGE'}];
    me.callParent();
    return;
  }
  var proxyId = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.bpmProxyId);
  if (!proxyId || proxyId === '') {
    me.items = [{xtype:'bpcCenterMessageCmp', message:BpcCommon.Api.getTranslation('MONITOR_BACKEND_CONNECTION_MISSING') + ' ' + BpcCommon.Api.getTranslation('MONITOR_STATUS_CHANGE_ERROR')}];
    me.callParent();
    return;
  }
  if (Ext.isArray(me.changeStateConfig)) {
    me.changeStateConfigMap = Ext.Array.toValueMap(me.changeStateConfig, 'dataIndex');
  } else {
    me.changeStateConfigMap = me.changeStateConfig;
    me.changeStateConfig = [];
    Ext.Object.each(me.changeStateConfigMap, function(key, val) {
      me.changeStateConfig.push(Ext.apply(val, {dataIndex:key}));
    });
  }
  me.user = BpcCommon.Api.getUserName();
  me.columnStore = new Ext.data.ArrayStore({fields:['value']});
  var columnId = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.columnId);
  columnId = columnId.split(',').length > 1 ? columnId.split(',') : columnId;
  var fieldArray = Ext.isArray(columnId) ? columnId : [columnId];
  Ext.Array.each(me.changeStateConfig, function(stateColumnConfig) {
    var dataIndex = stateColumnConfig.dataIndex;
    var column = me.getViewModel().get('activeGrid').getColumnManager().getHeaderByDataIndex(dataIndex);
    if (!column) {
      return;
    }
    me.columnStore.add({value:dataIndex, display:column.text, column:column});
    fieldArray.push(dataIndex);
  });
  var records = Ext.Array.map(me.selectedRecords, function(record) {
    return record.clone();
  });
  var monitorColumnConfig = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.columnConfig);
  me.items = [{xtype:'form', layout:{type:'vbox', align:'stretch'}, buttons:[{text:BpcCommon.Api.getTranslation('MONITOR_CHANGE_STATUS'), iconCls:BpcCommon.Icons.OkIcon, formBind:true, disabled:true, handler:'onFormSubmit'}, {text:BpcCommon.Api.getTranslation('MONITOR_CANCEL'), iconCls:'x-fal fa-times', handler:'destroyWindow'}], items:[{xtype:'bpcComboBox', autoSelect:true, localized:{fieldLabel:'MONITOR_COLUMN'}, store:me.columnStore, queryMode:'local', displayField:'display', valueField:'value', 
  allowBlank:false, itemId:'stateColumnSelector', width:150, listeners:{afterrender:function(combo) {
    var recordSelected = combo.getStore().getAt(0);
    if (recordSelected) {
      combo.setValue(recordSelected.get('value'));
    }
  }}}, {xtype:'fieldcontainer', localized:{fieldLabel:'MONITOR_PROCESSES'}, items:[{xtype:'grid', maxHeight:300, store:{data:records, fields:fieldArray.concat([])}, columns:Ext.Array.map(fieldArray, function(field) {
    var columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
      return colConfig.id === field;
    });
    if (!columnConfig) {
      columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
        return colConfig.dataIndex === field;
      });
    }
    if (!columnConfig) {
      columnConfig = {text:field};
    }
    var text = columnConfig.text;
    if (columnConfig.localized && columnConfig.localized.text) {
      text = BpcCommon.Api.getTranslation(columnConfig.localized.text);
    }
    return {dataIndex:field, renderer:monitorMain.findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(columnConfig), text:text, flex:1};
  })}]}, {xtype:'fieldcontainer', layout:{type:'hbox'}, localized:{fieldLabel:'MONITOR_STATE'}, items:[{xtype:'bpcDisplayField', htmlEncode:false, flex:1, bind:{value:'{displayState}'}}, {xtype:'combo', reference:'states', itemId:'statesField', autoSelect:true, pickerAlign:'tr-br?', fieldStyle:'display: none', matchFieldWidth:false, store:{fields:['value', 'raw', 'valueR', 'translated'], storeId:'dynStates'}, queryMode:'local', displayField:'valueR', valueField:'value', typeAhead:true, listeners:{beforequery:function(record) {
    record.query = new RegExp(record.query, 'ig');
  }}, forceSelection:true, allowBlank:false, width:32, listConfig:{itemTpl:new Ext.XTemplate('\x3ctpl\x3e\x3cdiv data-qtip\x3d"{value}"\x3e{valueR}\x3c/div\x3e\x3c/tpl\x3e')}}]}, {xtype:'bpcTextArea', name:'changeStateComment', itemId:'comment', localized:{fieldLabel:'MONITOR_COMMENT', emptyText:'MONITOR_ENTER_COMMENT'}, flex:1, allowBlank:false}]}];
  this.callParent();
}});
Ext.define('monitor.view.interaction.export.ExportButton', {extend:'Ext.Button', alias:'widget.monitorExportBtn', iconCls:monitor.assets.Icons.DOWNLOAD, localized:{tooltip:'MONITOR_EXPORT_DATA'}, hidden:true, bind:{hidden:'{!setting.' + monitor.assets.ConfigKeys.exportEnabled + '}'}, handler:function() {
  var me = this;
  Ext.create({xtype:'monitorExportWindow', moduleId:me.moduleId, viewModel:{parent:me.lookupViewModel()}});
}});
Ext.define('monitor.view.interaction.export.ExportWindow', {extend:'BpcCommon.component.window.Window', alias:'widget.monitorExportWindow', controller:'monitorExportWindowController', localized:{title:'MONITOR_PROCESS_EXPORT'}, width:400, constrain:true, layout:'fit', bodyPadding:'10 10 10 10', iconCls:monitor.assets.Icons.DOWNLOAD, grid:undefined, moduleId:undefined, viewModel:{data:{isFormatXlsx:false, hideWarning:true, field:{}}}, autoShow:true, initComponent:function() {
  var me = this;
  try {
    me.backendUrl = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + me.moduleId;
    me.grid = me.lookupViewModel().get('activeGrid');
    var activeTab = null;
    var defaults = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.exportDialogDefaults);
    if (!defaults.hasOwnProperty('exportChildrenDisable')) {
      defaults.exportChildrenDisable = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.dataHistoryIndex).length === 0 ? true : false;
    }
    if (defaults.exportChildrenDisable) {
      defaults.exportChildren = false;
    }
    this.getViewModel().set('field', defaults);
    var currentLanguage = BpcCommon.Api.getSetting('_core', 'language');
    if (defaults && defaults.title && defaults.title[currentLanguage]) {
      me.title = defaults.title[currentLanguage];
    }
    var viewsArray = [];
    if (BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.gridMultipleViews)) {
      if (this.grid.up('tabpanel')) {
        activeTab = this.grid.up('tabpanel').getActiveTab();
      }
      if (this.grid.up('monitorStackedPanel')) {
        var stackedPanel = this.grid.up('monitorStackedPanel');
        activeTab = stackedPanel.query('processGrid')[0];
      }
      var views = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.gridMultipleViewsConfig);
      Ext.Array.each(views.views, function(view) {
        if (BpcCommon.Api.isUserAllowedToSee(view)) {
          var checked = false;
          if (activeTab) {
            if (activeTab.bpcGridViewName === view.id) {
              checked = true;
            }
          }
          viewsArray.push({boxLabel:view.title, inputValue:view.id, name:'selectedView', checked:checked, itemId:'radiofield-' + BpcCommon.Util.cleanUpId(view.id)});
        }
      });
    }
    var maxExportLimit = BpcCommon.Api.getSetting(this.moduleId, 'function_maxExportLimit') || 10000;
    this.items = [{xtype:'form', standardSubmit:true, method:'GET', url:this.backendUrl, buttons:[{localized:{text:'MONITOR_DOWNLOAD'}, iconCls:monitor.assets.Icons.DOWNLOAD, formBind:true, disabled:true, itemId:'formSubmit'}, {localized:{text:'MONITOR_CANCEL'}, iconCls:BpcCommon.Icons.C, itemId:'formCancel'}], items:[{xtype:'radiogroup', localized:{fieldLabel:'MONITOR_VIEW'}, itemId:'viewId', columns:1, vertical:true, allowBlank:!BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.gridMultipleViews), 
    reference:'viewSelection', hidden:!BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.gridMultipleViews), items:viewsArray, simpleValue:true, bind:'{field.view}'}, {xtype:'radiogroup', localized:{fieldLabel:'MONITOR_FILE_DOWNLOAD_FORMAT'}, columns:1, allowBlank:false, reference:'format', itemId:'outputFormat', bind:'{field.format}', simpleValue:true, items:[{boxLabel:'CSV', name:'format', inputValue:'csv', checked:true, hidden:!BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.exportCsv)}, 
    {boxLabel:'XLSX', name:'format', inputValue:'xlsx', hidden:!BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.exportXlsx)}, {boxLabel:'JSON', name:'format', inputValue:'json', hidden:!BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.exportJson)}, {boxLabel:'XML', name:'format', inputValue:'json', hidden:!BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.exportXml)}, {boxLabel:'PDF', name:'format', inputValue:'json', hidden:!BpcCommon.Api.getSetting(this.moduleId, 
    monitor.assets.ConfigKeys.exportPdf)}]}, {xtype:'numberfield', localized:{fieldLabel:'MONITOR_FILE_DOWNLOAD_LIMIT'}, bind:{hidden:'{!isFormatXlsx}', value:'{field.limit}'}, itemId:'Limit', columns:1, hidden:false, allowBlank:true, reference:'limit', value:1000, maxValue:maxExportLimit, minValue:0}, {xtype:'box', padding:'5 5 5 5', bind:{hidden:'{hideWarning}'}, localized:{html:'MONITOR_FILE_DOWNLOAD_CUT_DATA'}}, {xtype:'toggleslidefield', reference:'exportChildren', bind:{value:'{field.exportChildren}', 
    hidden:'{field.exportChildrenDisable}'}, localized:{fieldLabel:'MONITOR_EXPORT_CHILD_DATA', onText:'MONITOR_YES', offText:'MONITOR_NO'}}, {xtype:'toggleslidefield', itemId:'considerCurrentView', autoEl:{'data-testid':'considerCurrentView'}, reference:'currentView', bind:'{field.currentView}', localized:{fieldLabel:'MONITOR_CONSIDER_CURRENT_VIEW', onText:'MONITOR_YES', offText:'MONITOR_NO'}}]}];
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  this.callParent();
}});
Ext.define('monitor.view.interaction.export.ExportWindowController', {extend:'Ext.app.ViewController', alias:'controller.monitorExportWindowController', control:{'#formSubmit':{click:'onFormSubmit'}, '#formCancel':{click:'destroyWindow'}, '#Prozesse':{change:'onSelectionChange'}, '#Limit':{change:'showCutUpNotification'}, '#outputFormat':{change:'onOutputFormatChanged'}}, onSelectionChange:function(cmp, newVal) {
  try {
    var refs = this.getReferences();
    if (newVal.selection === 'all') {
      refs.limit.show();
      this.showCutUpNotification();
    } else {
      refs.limit.hide();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onSelectionChange', dump:e, stack:true, level:'error'});
  }
}, onFormSubmit:function() {
  try {
    var refs = this.getReferences();
    var form = this.getView().down('form').getForm();
    if (form.isValid()) {
      var format = refs.format.getValue();
      var limit;
      if (this.getViewModel().get('isFormatXlsx') === true) {
        limit = refs.limit.getValue();
      }
      this.downloadFile(format, limit);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onFormSubmit', dump:e, stack:true, level:'error'});
  }
}, onOutputFormatChanged:function(radioGroup, newVal) {
  if (newVal === 'xlsx') {
    this.getViewModel().set('isFormatXlsx', true);
    this.showCutUpNotification();
  } else {
    this.getViewModel().set('isFormatXlsx', false);
    this.getViewModel().set('hideWarning', true);
  }
}, createUrl:function(format, limit) {
  try {
    var url = this.getView().backendUrl;
    var filterArray = this.getView().grid.store.getFilters().items;
    var sorterArray = this.getView().grid.store.getSorters().items;
    var fullTextQuery = this.getView().lookupViewModel().get('globalFilterValue');
    var timezoneOffset = '+0' + (new Date).getTimezoneOffset() / 60 * -1 + ':00';
    var view = this.getSelectedView();
    var timeZoneName = BpcCommon.Util.getTimezoneName();
    var refs = this.getReferences();
    var exportChildren = refs.exportChildren.getValue();
    var bpcLanguage = BpcCommon.Api.getSetting('_core', 'language');
    var currentView = refs.currentView.getValue();
    var columns = [];
    if (currentView === true && this.getView().grid.getState() && this.getView().grid.getState().columns) {
      Ext.each(this.getView().grid.down('headercontainer').getVisibleGridColumns(), function(column) {
        if (column.dataIndex && column.dataIndex !== null) {
          columns.push(column.dataIndex);
        }
      });
    }
    var params = {format:format, timezoneOffset:timezoneOffset, timezoneName:timeZoneName, query:fullTextQuery, exportChildren:exportChildren, bpcLanguage:bpcLanguage};
    if (limit) {
      Ext.apply(params, {limit:limit});
    }
    if (columns.length > 0) {
      Ext.apply(params, {exportColumns:JSON.stringify(columns)});
    }
    if (Ext.isArray(sorterArray) && sorterArray.length > 0) {
      params['sort'] = this.getView().grid.store.proxy.encodeSorters(sorterArray);
    }
    if (Ext.isArray(filterArray) && filterArray.length > 0) {
      params['filter'] = this.getView().grid.store.proxy.encodeFilters(filterArray);
    }
    if (Ext.isDefined(view)) {
      params['view'] = view;
    }
    url += '?' + Ext.Object.toQueryString(params);
    return url;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createUrl', dump:e, stack:true, level:'error'});
  }
}, getSelectedView:function() {
  try {
    var view = 'mainGrid';
    var refs = this.getReferences();
    if (BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.gridMultipleViews)) {
      view = refs.viewSelection.getValue();
    }
    return view;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR getSelectedView', dump:e, stack:true, level:'error'});
  }
}, showCutUpNotification:function() {
  try {
    var grid = this.getView().grid;
    var store = grid.getStore();
    var totalCount = store.getCount();
    var refs = this.getReferences();
    if (totalCount > refs.limit.getValue()) {
      this.getViewModel().set('hideWarning', false);
    } else {
      this.getViewModel().set('hideWarning', true);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR showCutUpNotification', dump:e, stack:true, level:'error'});
  }
}, downloadFile:function(format, limit) {
  try {
    this.getView().add({xtype:'component', autoEl:{tag:'iframe', src:this.createUrl(format, limit)}});
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR downloadFile', dump:e, stack:true, level:'error'});
  }
}, destroyWindow:function() {
  try {
    this.getView().destroy();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR destroyWindow', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.view.interaction.moduleJump.Controller', {extend:'Ext.app.Controller', doModuleJump:function(column, record, value, jumpParamFnXtype) {
  if (jumpParamFnXtype) {
    var linkedClass = Ext.ClassManager.getByAlias(jumpParamFnXtype);
    var fn = linkedClass ? linkedClass.jumpParamFn : null;
    if (Ext.isFunction(fn)) {
      this.jumpParamFn = fn;
    } else {
      Ext.log({msg:this.self.getName() + ": doModuleJump - can't find jumpParamFn " + jumpParamFnXtype, level:'warn'});
    }
  }
  var jumpParams = this.jumpParamFn(record, column, value);
  if (column.targetConfig) {
    jumpParams = Ext.applyIf(jumpParams, column.targetConfig);
  }
  BpcCommon.Api.showModule(column.targetModule, column.forceNewInstance, jumpParams, column.targetRoute);
}, jumpParamFn:function(record, column, value) {
  var params = {};
  try {
    return {storeState:{filters:[{property:column.targetColumn, operator:column.filterOperation || 'analyzed', value:value, source:column.filterSourceType || 'analyzed', type:column.filterType}]}, record:record, column:column};
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': jumpParamFn + Error While Fetching Jump Params', level:'warn'});
    params = {};
  }
  return params;
}, getJumpColumnsForMonitor:function(monitorInstanceId) {
  return BpcCommon.Api.getSetting(monitorInstanceId, monitor.assets.ConfigKeys.columnConfig).filter(function(col) {
    return 'bpcModuleJumpColumn' === col.xtype;
  });
}});
Ext.define('monitor.view.interaction.processAction.ButtonMenuMixin', {moduleId:undefined, iconCls:monitor.assets.Icons.PROCESS_ACTION, localized:{tooltip:'MONITOR_PROCESS_ACTIONS'}, isAbleToExecuteAction:function(moduleId, cmp) {
  var isExecuteActionActive = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.processActions);
  var hasUserRight = BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.processAction) || BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.processAction + '_' + moduleId);
  if (cmp.xtype === 'monitorChangeStateMenu') {
    var currentMonitorView = Ext.ComponentQuery.query('bpcMonitor').find(function(item) {
      return item.moduleId === moduleId;
    });
    var isItemSelected = currentMonitorView.getViewModel().get('activeGridSelection').length !== 0;
    return isExecuteActionActive && hasUserRight && isItemSelected;
  }
  return isExecuteActionActive && hasUserRight;
}});
Ext.define('monitor.view.interaction.moduleJump.Menu', {extend:'Ext.menu.Item', alias:'widget.monitorModuleJumpMenu', mixins:['monitor.view.interaction.processAction.ButtonMenuMixin'], iconCls:BpcCommon.Icons.LINK, localized:{text:'MONITOR_JUMP_TO'}, selection:undefined, initComponent:function() {
  var me = this;
  var moduleJumpController = Ext.getApplication().getController('monitor.view.interaction.moduleJump.Controller');
  var jumpColumns = moduleJumpController.getJumpColumnsForMonitor(me.moduleId);
  var selectedRecord = me.selection[0];
  if (jumpColumns.length === 0 || !selectedRecord) {
    me.hidden = true;
  } else {
    me.menu = Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', items:jumpColumns.map(function(column, index) {
      var value = selectedRecord.get(column.dataIndex);
      return {text:value, hidden:value === undefined || value === '', itemId:'jumpToMenuItem-' + index, handler:moduleJumpController.doModuleJump.bind(moduleJumpController, column, selectedRecord, value, column.jumpParamFn)};
    })});
  }
  this.callParent();
}});
Ext.define('monitor.view.interaction.moduleJump.ModuleJump', {extend:'Ext.grid.column.Widget', alias:['widget.bpcCommonModuleJumpColumn', 'widget.bpcModuleJumpColumn'], menuDisabled:false, targetModule:undefined, targetRoute:undefined, targetColumn:undefined, showIcon:true, showValue:true, filterOperation:'\x3d', filterSourceType:'raw', filterType:'text', sourceColumn:undefined, forceNewInstance:false, iconCls:'fal fa-external-link', sortable:true, separator:undefined, displayText:'', renderValue:false, 
initComponent:function() {
  var me = this;
  if (me.targetModule) {
    var monitor$12 = me.up('bpcMonitor');
    var rendererFn;
    if (monitor$12) {
      var customRenderer = monitor$12.findPlugin('monitorCustomRenderer');
      rendererFn = customRenderer.render.bind(customRenderer, customRenderer.getRendererIdByColumnConfig(me));
    }
    this.widget = {xtype:'bpcCommonModuleJumpColumnWidget', showIcon:this.showIcon, showValue:this.showValue, iconCls:this.iconCls, separator:this.separator, displayText:this.displayText, renderValue:this.renderValue, rendererFn:Ext.isFunction(rendererFn) ? rendererFn : undefined, bind:{value:'{record.' + me.dataIndex + '}', sourceColumnValue:'{record.' + me.sourceColumn + '}'}};
    if (this.jumpParamFn) {
      var moduleFnArray = String(this.jumpParamFn).split('.');
      if (moduleFnArray.length) {
        BpcCommon.Api.loadModule(moduleFnArray[0]);
        this.widget.jumpParamFnXtype = this.jumpParamFn;
      }
    }
  } else {
    this.dataIndex = undefined;
    this.widget = {xtype:'box', html:'\x3ci class\x3d"fal fa-exclamation-triangle"\x3e\x3c/i\x3e Missing targetModule in column configuration'};
  }
  this.callParent(arguments);
}});
Ext.define('monitor.view.interaction.moduleJump.ModuleJumpWidget', {extend:'Ext.Widget', alias:['widget.bpcCommonModuleJumpColumnWidget'], element:{reference:'element', style:'cursor: pointer;\n' + '    overflow: hidden;\n' + '    text-overflow: ellipsis; ', listeners:{click:'onModuleJump'}}, config:{sourceColumnValue:undefined, value:undefined}, defaultBindProperty:'value', showIcon:true, showValue:true, renderValue:undefined, separator:undefined, rendererFn:undefined, tpl:'', constructor:function(config) {
  var me = this;
  this.tpl = "\x3ctpl for\x3d\"valueArray\"\x3e\x3ctpl if\x3d'.'\x3e\x3ca data-value\x3d'{jumpValue:htmlEncode2}'\x3e";
  if (me.renderValue && Ext.isFunction(me.rendererFn)) {
    this.tpl += '{displayValue}';
  } else {
    if (this.showIcon) {
      this.tpl += '\x3cspan class\x3d"' + this.iconCls + '" aria-hidden\x3d"true"\x3e \x3c/span\x3e';
    }
    this.tpl += this.showValue ? ' {displayValue:htmlEncode2}' : this.displayText || '';
  }
  this.tpl += '\x3c/a\x3e \x3c/tpl\x3e\x3c/tpl\x3e';
  this.tpl = new Ext.XTemplate(this.tpl);
  this.callParent([config]);
}, setValue:function() {
  this.callParent(arguments);
  this.updateContent();
}, setSourceColumnValue:function() {
  this.callParent(arguments);
  this.updateContent();
}, updateContent:function() {
  var me = this;
  var displayValue = me.getValue();
  var jumpValue = me.getSourceColumnValue() || displayValue;
  var valueArray;
  if (me.renderValue && Ext.isFunction(me.rendererFn)) {
    var renderedValue = me.rendererFn(displayValue);
    if (renderedValue !== null) {
      valueArray = [{displayValue:renderedValue, jumpValue:jumpValue}];
    }
  }
  if (!valueArray) {
    if (Ext.isArray(displayValue)) {
      valueArray = displayValue.map(function(value) {
        return {displayValue:value, jumpValue:value};
      });
    } else {
      if (Ext.isString(displayValue)) {
        valueArray = me.separator ? displayValue.split(me.separator).map(function(value) {
          return {displayValue:value.trim(), jumpValue:value.trim()};
        }) : [{displayValue:displayValue, jumpValue:jumpValue}];
      } else {
        valueArray = [{displayValue:displayValue, jumpValue:jumpValue}];
      }
    }
  }
  me.element.setHtml(me.tpl.apply({valueArray:valueArray, jumpValue:jumpValue}));
}, onModuleJump:function(event, domEl) {
  var valueElement = domEl;
  if (!valueElement.hasAttribute('data-value')) {
    valueElement = Ext.get(valueElement).up('[data-value]');
  }
  var record = this.getWidgetRecord();
  var column = this.getWidgetColumn();
  var value = valueElement ? valueElement.getAttribute('data-value') : null;
  Ext.getApplication().getController('monitor.view.interaction.moduleJump.Controller').doModuleJump(column, record, value, this.jumpParamFnXtype);
}});
Ext.define('monitor.view.interaction.multiAttachmentDownload.Button', {extend:'Ext.Button', alias:'widget.monitorMultiAttachmentDownloadBtn', iconCls:'x-fal fa-file-download', localized:{tooltip:'MONITOR_DOWNLOAD_SELECTED_ATTACHMENTS'}, hidden:true, bind:{hidden:'{!setting.' + monitor.assets.ConfigKeys.functionEnableMultiDownload + '}', disabled:'{activeGridSelection.length \x3c 2}'}, handler:function() {
  var me = this;
  var selectedRecords = me.lookupViewModel().get('activeGridSelection');
  var idColumn = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnId);
  var blobColumn = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnFile);
  var idList = [];
  var blobList = [];
  Ext.Array.each(selectedRecords, function(record) {
    idList.push(record.get(idColumn));
    blobList.push(record.get(blobColumn));
  });
  var baseUrl = BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.bpmProxyId));
  var suffix = 'directoryList\x3d' + blobList.join(',') + '\x26processidList\x3d' + idList.join(',') + '\x26prefix\x3d' + BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.legacyPmTablePrefix);
  var url = baseUrl + '/ibis/servlet/IBISHTTPUploadServlet/' + BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.inubitLoadFilesAsZipEndpoint) + '?' + suffix;
  window.open(url, '_blank');
}});
Ext.define('monitor.view.interaction.processAction.Button', {extend:'Ext.Button', alias:'widget.monitorProcessActionBtn', controller:'monitorProcessActionController', mixins:['monitor.view.interaction.processAction.ButtonMenuMixin'], hidden:true, disabled:true, bind:{disabled:'{activeGridSelection.length \x3c 1 || actionStore.count \x3c 1}'}, initComponent:function() {
  this.hidden = !this.isAbleToExecuteAction(this.moduleId, this);
  this.callParent();
}});
Ext.define('monitor.view.interaction.processAction.WidgetActionButton', {extend:'Ext.button.Button', alias:['widget.actionColumnWidgetButton', 'widget.actionColumnWidget'], cls:'widgetActionButton', iconCls:monitor.assets.Icons.PROCESS_ACTION, localized:{text:'MONITOR_ACTIONS'}, tooltip:'!', padding:'2 2 2 2', textAlign:'left', actionData:undefined, instanceId:undefined, moduleId:undefined, referenceId:undefined, instanceType:undefined, showIconOnly:undefined, activeBGColor:undefined, record:undefined, 
initComponent:function() {
  this.callParent(arguments);
}, initActionData:function(actionStore, showIconOnly) {
  var actionTranslation = BpcCommon.Api.getTranslation('MONITOR_ACTIONS');
  var me = this;
  if (actionStore) {
    me.showIconOnly = showIconOnly;
    if (!me.activeBGColor) {
      this.setActiveBGColor();
    }
    if (me.activeBGColor) {
      this.styleComponent();
    }
    if (actionStore.getCount() < 1) {
      this.setButtonText(0, actionTranslation);
      this.setTooltip('0 ' + actionTranslation);
      this.setArrowVisible(false);
      this.disable();
      this.disabled = true;
      this.styleComponent('#D3D3D3');
    } else {
      this.setArrowVisible(true);
      this.enable();
      this.disabled = false;
    }
    if (actionStore.getCount() === 1) {
      this.createActionButton(actionStore, showIconOnly);
    } else {
      this.setMenu(this.createActionMenu(actionStore));
      this.setButtonText(actionStore.getCount(), actionTranslation);
      this.setTooltip(actionStore.getCount() + ' ' + actionTranslation);
    }
  }
}, createActionButton:function(actionStore) {
  if (actionStore) {
    var me = this;
    var actionRecord = actionStore.first();
    var actionLabel = BpcCommon.Api.getTranslation(actionRecord.get('label'));
    this.setButtonText('', actionLabel);
    this.setIconCls(actionRecord.get('iconCls') || 'x-fal fa-indent');
    this.setTooltip(actionLabel);
    this.setHandler(monitor.ProcessActionUtil.triggerAction.bind(monitor.ProcessActionUtil, me.moduleId, actionRecord));
    actionRecord.set('selection', [me.record]);
    this.setArrowVisible(false);
    this.disabled = false;
  }
}, createActionMenu:function(actionStore) {
  var me = this;
  var actionMenu = Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', items:[]});
  if (actionStore) {
    actionStore.each(function(actionRecord) {
      actionMenu.add({text:BpcCommon.Api.getTranslation(actionRecord.get('label')), iconCls:actionRecord.get('iconCls'), handler:monitor.ProcessActionUtil.triggerAction.bind(monitor.ProcessActionUtil, me.moduleId, actionRecord)});
      actionRecord.set('selection', [me.record]);
    });
  }
  return actionMenu;
}, setActiveBGColor:function() {
  var me = this;
  var button = document.getElementById(me.id);
  me.activeBGColor = window.getComputedStyle(button, null).getPropertyValue('background-color') || '#96bebe';
}, setButtonText:function(itemCount, buttonText) {
  var me = this;
  var text = '';
  if (!me.showIconOnly) {
    text = itemCount + ' ' + buttonText;
  } else {
    text = itemCount;
    this.addCls('iconOnly');
  }
  this.setText(text);
}, styleComponent:function() {
  var me = this;
  var elem = this.getEl();
  if (Ext.isDefined(elem)) {
    if ('dom' in elem && 'style' in elem.dom) {
      elem.dom.style.backgroundColor = me.activeBGColor;
    }
  }
}});
Ext.define('monitor.view.interaction.processAction.GridActionColumn', {extend:'Ext.grid.column.Widget', alias:'widget.gridActionColumn', localized:{text:'MONITOR_ACTIONS'}, dataIndex:'BpcActions', widget:{xtype:'actionColumnWidgetButton'}, moduleId:undefined, instanceType:undefined, onWidgetAttach:function(col, widget, rec) {
  if (widget && rec) {
    var me = this;
    var actionStore = monitor.ProcessActionUtil.getStoreForSelection(me.moduleId, [rec]);
    widget.moduleId = me.moduleId;
    widget.record = rec;
    widget.initActionData(actionStore, !!this.showIconOnly);
  }
}});
Ext.define('monitor.view.interaction.processAction.Menu', {extend:'Ext.menu.Item', alias:'widget.monitorProcessActionMenu', controller:'monitorProcessActionController', mixins:['monitor.view.interaction.processAction.ButtonMenuMixin'], hidden:true, text:BpcCommon.Api.getTranslation('MONITOR_ACTIONS'), menu:[], initComponent:function() {
  var me = this;
  if (BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.processActions) === true) {
    var actionStore = monitor.ProcessActionUtil.getStoreForSelection(me.moduleId, me.selection);
    this.hidden = actionStore.count() <= 0 || !this.isAbleToExecuteAction(this.moduleId, this);
  }
  this.callParent();
}});
Ext.define('monitor.view.interaction.processAction.Toolbar', {extend:'Ext.toolbar.Toolbar', alias:'widget.monitorProcessActionToolbar', selectedProcesses:undefined, vertical:false, moduleId:undefined, initComponent:function() {
  var me = this;
  var actionStore = monitor.ProcessActionUtil.getStoreForSelection(me.moduleId, me.selectedProcesses);
  me.items = [];
  if (actionStore) {
    actionStore.each(function(actionRecord) {
      me.items.push({text:BpcCommon.Api.getTranslation(actionRecord.get('label')), itemId:BpcCommon.Util.cleanUpId(actionRecord.get('id')) || 'actions-item', iconCls:actionRecord.get('iconCls'), handler:monitor.ProcessActionUtil.triggerAction.bind(monitor.ProcessActionUtil, me.moduleId, actionRecord), actionRecord:actionRecord});
    });
  }
  me.callParent();
}});
Ext.define('monitor.view.interaction.processAction.Util', {singleton:true, alternateClassName:['monitor.ProcessActionUtil'], instanceCacheMap:{docuDummy:{actionColumns:undefined, processActionsSeparator:',', currentActionsMap:{}}}, initInstanceCache:function(moduleId) {
  var me = this;
  var actionsActive = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.processActions);
  if (me.instanceCacheMap[moduleId]) {
    return;
  }
  if (actionsActive) {
    me.instanceCacheMap[moduleId] = {currentActionsMap:{}};
    me.instanceCacheMap[moduleId].processActionsSeparator = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.actionSeperator);
    var columnPrefix = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnActionPrefix);
    var columnList = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnList);
    if (columnList) {
      me.instanceCacheMap[moduleId].actionColumns = Ext.Array.filter(Ext.Object.getAllKeys(columnList), function(key) {
        return Ext.String.startsWith(key, columnPrefix);
      });
    }
  }
}, getStoreForSelection:function(moduleId, selection) {
  var me = this;
  var actionStore = Ext.create('Ext.data.Store', {model:'monitor.model.Action', sorters:[{property:'sortValue', direction:'DESC'}, {property:'name', direction:'ASC'}], data:[]});
  me.initInstanceCache(moduleId);
  var selectionArray = selection || [];
  var actionIdArray = [];
  Ext.each(selectionArray, function(record) {
    var selectionActionIdArray = [];
    Ext.each(me.instanceCacheMap[moduleId].actionColumns, function(column) {
      var actionString = record.get(column);
      if (actionString) {
        var actions = me.parseAction(actionString, me.instanceCacheMap[moduleId].processActionsSeparator, column, selection);
        actionStore.add(actions);
        Ext.Array.each(actions, function(action) {
          selectionActionIdArray.push(action.getId());
        });
      }
    });
    actionIdArray.push(selectionActionIdArray);
  });
  var distinctActionIds = Ext.Array.intersect.apply(undefined, actionIdArray);
  actionStore.each(function(action) {
    if (!Ext.Array.contains(distinctActionIds, action.getId())) {
      actionStore.remove(action);
    }
  }, me.actionStore);
  return actionStore;
}, triggerAction:function(moduleId, actionRecord) {
  var me = this;
  var preparedParam = {};
  var showAlert = false;
  var action = BpcCommon.Api.getTranslation(actionRecord.get('label'));
  var buttonId = actionRecord.get('column');
  var selection = actionRecord.get('selection');
  var proxyId = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.bpmProxyId);
  var legacyPmTablePrefix = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.legacyPmTablePrefix);
  if (BpcCommon.Util.isStringEqual(actionRecord.get('target'), 'processStarter')) {
    var params = actionRecord.get('params') || {};
    monitor.view.interaction.startprocess.Util.openStartProcessForm(moduleId, Ext.first('bpcMonitor:visible').getViewModel(), {key:params.process});
    return;
  }
  var multi = false;
  if (!proxyId || proxyId === '') {
    BpcCommon.Api.showNotification({text:BpcCommon.Api.getTranslation('MONITOR_BACKEND_CONNECTION_MISSING') + ' ' + BpcCommon.Api.getTranslation('MONITOR_ACTION_CALL_ERROR'), popUp:true, type:'ERROR'});
    return;
  }
  if (selection.length === 1) {
    Ext.Object.each(selection[0].getData(), function(key, value) {
      preparedParam[key.toLowerCase()] = value;
    });
    preparedParam.tablePrefix = legacyPmTablePrefix;
  } else {
    if (selection.length > 1) {
      var prefix = 'index';
      selection.forEach(function(record, i) {
        Ext.Object.each(record.getData(), function(key, value) {
          preparedParam[prefix + i + '_' + key.toLowerCase()] = value;
        });
        preparedParam[prefix + i + '_' + 'tablePrefix'] = legacyPmTablePrefix;
      });
      multi = true;
    }
  }
  Ext.Object.each(actionRecord.getData(), function(key, value) {
    if (key !== 'selection') {
      preparedParam['actionConfig_' + key] = value;
    }
  });
  if (actionRecord.get('requireConfirmation') || actionRecord.get('requireComment')) {
    var confirmationText = '';
    if (actionRecord.get('requireConfirmation')) {
      var defaultText = BpcCommon.Api.getTranslation({key:'MONITOR_EXECUTE_ACTION', data:{name:actionRecord.get('name') || ''}});
      confirmationText = BpcCommon.Api.getTranslation(actionRecord.get('confirmationText')) || defaultText;
    }
    var msg = confirmationText + '\x3c/br\x3e' + BpcCommon.Api.getTranslation('MONITOR_COMMENT') + ':';
    Ext.create('Ext.window.MessageBox', {resizable:true}).show({title:BpcCommon.Api.getTranslation('MONITOR_PROCESS_ACTIONS') + ': ' + actionRecord.get('name'), msg:actionRecord.get('requireComment') ? msg : confirmationText, width:300, multiline:actionRecord.get('requireComment') || false, scope:this, buttons:!actionRecord.get('requireConfirmation') && actionRecord.get('requireComment') ? Ext.MessageBox.OKCANCEL : Ext.MessageBox.YESNO, fn:function(btn, text) {
      if (btn === 'yes' || btn === 'ok') {
        preparedParam.actionConfig_comment = text;
        me.sendActionToInubit(moduleId, preparedParam, multi, action, buttonId, showAlert);
      }
    }});
    return;
  }
  me.sendActionToInubit(moduleId, preparedParam, multi, action, buttonId, showAlert);
}, sendActionToInubit:function(moduleId, preparedParam, multiAction, action, buttonId, showAlert) {
  var deferred = new Ext.Deferred;
  var me = this;
  var unlockFn = Ext.emptyFn;
  try {
    var inubitProxyId = BpcCommon.Api.getSetting(moduleId, 'inubit_proxyId');
    var inubitBaseUrl = BpcCommon.Api.getSetting(moduleId, 'inubit_baseUrl');
    var inubitActionEndpoint = BpcCommon.Api.getSetting(moduleId, 'inubit_actionEndpoint');
    var dbGridId = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.legacyPmGridId);
    var allowParallelActions = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.parallelProcessActions);
    var extGridId = 'PM-core-' + dbGridId + '-grid';
    var multiUrl = BpcCommon.Api.getBackendUrl(inubitProxyId) + inubitBaseUrl + inubitActionEndpoint + '?gridId\x3d' + dbGridId + '\x26gridExtId\x3d' + extGridId + '\x26multiRecords\x3dtrue' + ('\x26buttonId\x3d' + buttonId + '\x26' + buttonId + '\x3d' + action);
    var singleUrl = BpcCommon.Api.getBackendUrl(inubitProxyId) + inubitBaseUrl + inubitActionEndpoint + '?gridId\x3d' + dbGridId + '\x26gridExtId\x3d' + extGridId + '\x26buttonId\x3d' + buttonId + '\x26' + buttonId + '\x3d' + action;
    var url = singleUrl;
    if (multiAction) {
      url = multiUrl;
    }
    url = url.replace('/bpc-httpproxy/httpProxy/', '/bpc-monitor/monitor/httpProxy/');
    if (!allowParallelActions && me.instanceCacheMap[moduleId].currentActionsMap[action]) {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ACTION_ALREADY_STARTED'));
      return;
    }
    me.instanceCacheMap[moduleId].currentActionsMap[action] = true;
    if (!allowParallelActions) {
      unlockFn = BpcCommon.Util.blockComponentForAsyncAction(action, 'action');
    }
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation({tpl:'{MONITOR_ACTION_ALREADY_STARTED1}' + action + '{MONITOR_ACTION_ALREADY_STARTED2}', keys:['MONITOR_ACTION_ALREADY_STARTED1', 'MONITOR_ACTION_ALREADY_STARTED2']}));
    Ext.fireEvent('monitorProcessAction', action);
    var connection = BpcCommon.Api.getConnection(inubitProxyId);
    connection.setUrl(encodeURI(url));
    var notification = {popUp:showAlert};
    connection.request({params:preparedParam, headers:{ISPortalUser:BpcCommon.Api.getUserName(), 'X-BPC-ModuleId':moduleId}, success:function(response) {
      try {
        var msg = Ext.DomQuery.selectValue('msg', response.responseXML, '');
        var successResponse = Ext.DomQuery.selectValue('success', response.responseXML);
        if (successResponse === 'true') {
          notification.text = BpcCommon.Api.getTranslation('MONITOR_ACTION_CALL_SUCCESSFUL');
          if (msg) {
            notification.text = notification.text + ': ' + msg;
          }
          BpcCommon.Api.showNotification(notification);
          var download = Ext.DomQuery.selectNode('download', response.responseXML);
          if (download) {
            try {
              BpcCommon.Util.download(Ext.DomQuery.selectValue('data', download), Ext.DomQuery.selectValue('fileName', download), Ext.DomQuery.selectValue('contentType', download));
            } catch (e) {
              BpcCommon.Api.showNotification('Fehler beim Bereitstellen des Dateidownloads.');
              this.lookupReference('startProcessBnt').enable();
              return;
            }
          }
        } else {
          notification.text = BpcCommon.Api.getTranslation('MONITOR_ACTION_CALL_ERROR');
          notification.type = 'ERROR';
          if (msg) {
            notification.text = notification.text + ': ' + msg;
          }
          BpcCommon.Api.showNotification(notification);
        }
      } catch (e$13) {
        Ext.log({msg:this.self.getName() + ': ERROR success', dump:e$13, stack:true, level:'error'});
      }
      deferred.resolve();
    }, failure:function(response) {
      try {
        var msg = Ext.DomQuery.selectValue('msg', response.responseXML, BpcCommon.Api.getTranslation('MONITOR_UNKNOWN_ERROR'));
        notification.text = BpcCommon.Api.getTranslation('MONITOR_ACTION_CALL_ERROR');
        notification.type = 'ERROR';
        if (msg) {
          notification.text = notification.text + ': ' + msg;
        }
        BpcCommon.Api.showNotification(notification);
      } catch (e) {
        Ext.log({msg:this.self.getName() + ': ERROR failure', dump:e, stack:true, level:'error'});
      }
      deferred.reject();
    }, callback:function() {
      delete me.instanceCacheMap[moduleId].currentActionsMap[action];
      unlockFn();
    }, scope:this});
  } catch (e) {
    BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('MONITOR_ACTION_SEND_ERROR') + e);
    delete me.instanceCacheMap[moduleId].currentActionsMap[action];
    unlockFn();
  }
  return deferred.promise;
}, parseAction:function(actionString, seperator, columnName, selection) {
  var result = [];
  var me = this;
  try {
    var newColumnName = String(columnName).toLowerCase();
    var json = Ext.JSON.decode(actionString, true);
    if (json) {
      if (!Ext.isArray(json)) {
        json = [json];
      }
      Ext.Array.each(json, function(action) {
        if (BpcCommon.Api.isUserAllowedToSee(action)) {
          try {
            action = Ext.applyIf(action, {column:newColumnName, label:action.name, id:newColumnName + '_' + action.name, selection:selection, target:'action'});
            var actionModel = monitor.model.Action.loadData(action);
            result.push(actionModel);
          } catch (e) {
            Ext.log({msg:me.self.getName() + ': ERROR parseAction', dump:e, stack:true, level:'error'});
          }
        }
      });
    } else {
      Ext.Array.each(String(actionString).split(seperator), function(actionName) {
        try {
          result.push(monitor.model.Action.loadData({name:actionName, label:actionName, id:newColumnName + '_' + actionName, column:newColumnName, selection:selection}));
        } catch (e) {
          Ext.log({msg:me.self.getName() + ': ERROR parseAction', dump:e, stack:true, level:'error'});
        }
      });
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR parseAction', dump:e, stack:true, level:'error'});
  }
  return result;
}});
Ext.define('monitor.view.interaction.processAction.ViewController', {extend:'Ext.app.ViewController', alias:'controller.monitorProcessActionController', actionColumns:undefined, processActionsSeparator:',', currentActionsMap:{}, actionStore:undefined, init:function(view) {
  var me = this;
  var vm = me.getViewModel();
  var actionsActive = BpcCommon.Api.getSetting(view.moduleId, monitor.assets.ConfigKeys.processActions);
  if (actionsActive) {
    vm.bind('{activeGridSelection}', me.onSelectionChange, me);
  }
}, onSelectionChange:function(selection) {
  var me = this;
  var view = me.getView();
  var selectionArray = selection || [];
  if (selectionArray.length < 1) {
    view.setMenu(null, true);
    me.getViewModel().set('actionStore', null);
  } else {
    var actionStore = monitor.ProcessActionUtil.getStoreForSelection(view.moduleId, selection);
    var menu = Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', items:[]});
    me.getViewModel().set('actionStore', actionStore);
    if (actionStore) {
      actionStore.each(function(actionRecord) {
        menu.add({text:BpcCommon.Api.getTranslation(actionRecord.get('label')), itemId:BpcCommon.Util.cleanUpId(actionRecord.get('id')) || 'actions-item', iconCls:actionRecord.get('iconCls'), handler:monitor.ProcessActionUtil.triggerAction.bind(monitor.ProcessActionUtil, view.moduleId, actionRecord), actionRecord:actionRecord});
      });
    }
    view.setMenu(menu, true);
  }
}});
Ext.define('monitor.view.interaction.refresh.Button', {extend:'Ext.button.Split', alias:'widget.monitorRefreshBtn', iconCls:monitor.assets.Icons.REFRESH + ' bpcPlay', localized:{tooltip:'MONITOR_REFRESH'}, bind:{iconCls:'{setting.' + monitor.assets.ConfigKeys.autoUpdate + " ? '" + monitor.assets.Icons.REFRESH + " bpcPlay' : '" + monitor.assets.Icons.REFRESH + " bpcPause'}"}, menu:{width:200, plain:true, items:[{xtype:'menucheckitem', hideOnClick:true, clickHideDelay:50, localized:{text:'MONITOR_AUTOMATIC_REFRESH'}, 
bind:{checked:'{setting.' + monitor.assets.ConfigKeys.autoUpdate + '}'}}]}, handler:function() {
  var me = this;
  try {
    var grid = me.lookupViewModel().get('activeGrid');
    grid.getController().refreshData();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshData', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.view.interaction.startprocess.Plugin', {extend:'Ext.Container', alias:'widget.monitorStartProcessPlugin', layout:'card', viewModel:{parent:BpcCommon.Api.getGlobalViewModel()}, initComponent:function() {
  var me = this;
  me.items = [];
  if (!(me.pluginConfiguration && me.pluginConfiguration.configuration && me.pluginConfiguration.configuration.monitorId)) {
    me.items.push({xtype:'bpcCenterMessageCmp', message:'Missing monitorId config'});
    me.callParent();
    return;
  } else {
    if (!BpcCommon.Util.isStringEqual(BpcCommon.Api.getBaseModuleIdById(me.pluginConfiguration.configuration.monitorId), 'monitor')) {
      me.items.push({xtype:'bpcCenterMessageCmp', message:"can't get monitor instance for configured monitorId"});
      me.callParent();
      return;
    }
  }
  Ext.applyIf(me, me.pluginConfiguration.configuration.wrapperConfiguration);
  if (me.pluginConfiguration.configuration.monitorConfiguration && me.pluginConfiguration.context.record) {
    var stringConfig = JSON.stringify(me.pluginConfiguration.configuration.monitorConfiguration);
    Ext.Object.each(me.pluginConfiguration.context.record.getData(), function(key, value) {
      stringConfig = stringConfig.replaceAll('record.' + key, value);
    });
    me.pluginConfiguration.configuration.monitorConfiguration = JSON.parse(stringConfig);
  }
  me.items.push({xtype:'monitorStartProcessBtn', moduleId:me.pluginConfiguration.configuration.monitorId});
  me.callParent();
}});
Ext.define('monitor.view.interaction.startprocess.PluginInterface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Monitor Process Starter', COMPONENT_XTYPE:'monitorStartProcessPlugin', PLUGIN_ID:'monitor_process_starter'}});
Ext.define('monitor.view.interaction.startprocess.StartProcessMixin', {moduleId:undefined, iconCls:monitor.assets.Icons.PLAY, localized:{tooltip:'MONITOR_START_PROCESS'}, handler:function() {
  var me = this;
  monitor.StartProcessUtil.openStartProcessForm(me.moduleId, monitor.Util.getViewModel(me.lookupViewModel()));
}});
Ext.define('monitor.view.interaction.startprocess.StartProcessButton', {extend:'Ext.Button', alias:'widget.monitorStartProcessBtn', mixins:['monitor.view.interaction.startprocess.StartProcessMixin'], hidden:true, initComponent:function() {
  this.hidden = !monitor.view.interaction.startprocess.Util.isAbleToStartProcess(this.moduleId, this);
  this.callParent();
}});
Ext.define('monitor.view.interaction.startprocess.StartProcessController', {extend:'Ext.app.ViewController', alias:'controller.startProcessController', TODAY_SYNTAX:'CURRENT_DATE', control:{'#processTypeCombo':{change:'onSelectProcessType'}, '#startProcessBnt':{click:'onCommit'}, '#startProcessForm':{validitychange:'validateForm'}, '#startProcessItemsContainer field':{blur:'onFieldBlur', change:'markFieldForReloadTrigger'}}, typeMapping:{'text':'bpcTextField', 'textarea':'bpcTextArea', 'date':'bpcDateField', 
'dateFromTo':'bpcDateField', 'month':'monthfield', 'time':'timefield', 'number':'numberfield', 'spinner':'spinnerfield', 'boolean':'checkbox', 'choice':'combo', 'upload':'fileuploadfield', 'table':'bpcEditableGrid'}, monitorInstance:undefined, reloadOnChangeCmps:undefined, selectedProcess:undefined, init:function(view) {
  var me = this;
  this.reloadOnChangeCmps = [];
  me.monitorInstance = BpcCommon.Api.getModuleInstanceComponent(view.moduleId);
}, validateForm:function(form, valid) {
  var isValid = valid;
  var container = this.lookupReference('startProcessItemsContainer');
  var items = container.items.items;
  for (var i = 0; i < items.length; i++) {
    var innerContainer = items[i];
    if (!monitor.Util.isEmpty(innerContainer.items) && !monitor.Util.isEmpty(innerContainer.items.items)) {
      var dataField = innerContainer.items.items[0];
      if (dataField.disabled) {
        isValid = false;
      }
    }
  }
  var startProcessBnt = this.lookupReference('startProcessBnt');
  if (isValid) {
    startProcessBnt.enable();
  } else {
    startProcessBnt.disable();
  }
}, onSelectProcessType:function(combobox, value, oldValue) {
  var me = this;
  if (value !== oldValue) {
    me.selectProcess(value);
  }
}, selectProcess:function(processKey) {
  var me = this;
  var processStore = monitor.view.interaction.startprocess.Util.getStore(me.getView().moduleId);
  var processRecord = processStore.getById(processKey);
  if (!processRecord) {
    return;
  }
  me.selectedProcess = processRecord;
  me.getView().setMinWidth(processRecord.get('windowWidth') || 400);
  me.getView().setMinHeight(processRecord.get('windowHeight') || 200);
  me.getViewModel().set('processConfig', processRecord);
  me.createElements(processRecord);
  var form = me.lookupReference('startProcessForm').getForm();
  me.validateForm(form, form.isValid());
  me.getView().setIconCls(processRecord.get('iconCls') || 'x-fal fa-play');
  return processRecord;
}, createElements:function(processRecord, loadedParams) {
  var me = this;
  var items = [];
  var container = me.lookupReference('startProcessItemsContainer');
  var parameters = processRecord.get('parameters') || loadedParams;
  var parametersEndpoint = processRecord.get('parametersEndpoint');
  container.removeAll();
  if (!parameters && parametersEndpoint) {
    var unlockFn = BpcCommon.Util.blockComponentForAsyncAction('id', me.getView().id);
    var selectedRecords = me.getViewModel().get('activeGrid.selectedRecords') || [];
    Ext.Ajax.request({url:parametersEndpoint, method:'POST', callback:unlockFn, jsonData:{records:selectedRecords.map(function(record) {
      return record.getData();
    }), process:processRecord.getData()}, headers:{ISPortalUser:BpcCommon.Api.getUserName(), 'X-BPC-ModuleId':me.getView().moduleId}, success:function(response) {
      var data = Ext.JSON.decode(response.responseText, true);
      if (data) {
        me.createElements(processRecord, data);
      } else {
        container.add({xtype:'bpcCenterMessageCmp', messageIconCls:BpcCommon.Icons.ERROR, message:BpcCommon.Api.getTranslation('MONITOR_PROCESS_START_LOAD_PARAMS_FAILED') + '\nno valid JSON'});
      }
    }, failure:function(response) {
      container.add({xtype:'bpcCenterMessageCmp', messageIconCls:BpcCommon.Icons.ERROR, message:BpcCommon.Api.getTranslation('MONITOR_PROCESS_START_LOAD_PARAMS_FAILED') + '\n                  \n' + BpcCommon.Util.getErrorFromFailureResponse(response).message});
    }});
    return;
  }
  Ext.each(parameters, function(parameter) {
    if (parameter.type in me.typeMapping && BpcCommon.Api.isUserAllowedToSee(parameter)) {
      var newField = me.getComponent(parameter);
      newField.flex = 1;
      var iconContainer = {width:0};
      if (parameter.tooltip !== undefined) {
        iconContainer = Ext.create('Ext.container.Container', {html:'\x3ci class\x3d"fa fa-info-circle" ' + 'style\x3d"color: #003333; font-size: 18px; margin-left: 10px; margin-top: 5px"\x3e\x3c/i\x3e', listeners:{render:function() {
          this.getEl().dom.title = parameter.tooltip;
        }}, width:50});
      }
      var hBoxContainer = Ext.create('Ext.container.Container', {layout:{type:'hbox'}, style:{marginTop:'10px'}, items:[newField, iconContainer]});
      items.push(hBoxContainer);
    }
  }, this);
  container.add(items);
}, getComponent:function(parameter) {
  var me = this;
  var selectedRecords = me.getViewModel().get('activeGrid.selectedRecords');
  if (parameter.initialValueFrom && selectedRecords && selectedRecords.length > 0) {
    var from = parameter.initialValueFrom;
    parameter = Ext.apply({}, parameter);
    delete parameter.initialValueFrom;
    var value = Ext.valueFrom(selectedRecords[0].data[from], '');
    if (!Ext.isEmpty(value)) {
      if (parameter.type === 'date' || parameter.type === 'time') {
        value = Ext.Date.parse(value, 'c');
      } else {
        if (parameter.type === 'boolean') {
          value = String(value) === 'true';
        }
      }
    }
    parameter.initialValue = value;
  }
  var fieldConfig = {xtype:me.typeMapping[parameter.type], name:parameter.key, fieldLabel:parameter.label, width:me.fieldWidth || 400, allowBlank:!!parameter.optional, msgTarget:'side', reference:'processFormInputField', cls:'processFormInputField', value:parameter.initialValue, labelWidth:me.getViewModel().get('processConfig.labelWidth') || 150};
  var newField = null;
  if (parameter.type === 'choice') {
    newField = me.createCombobox(parameter, fieldConfig);
  } else {
    if (parameter.type === 'date') {
      newField = me.createDateField(parameter, fieldConfig);
    } else {
      if (BpcCommon.Util.isStringEqual(parameter.type, 'dateFromTo')) {
        newField = me.createDateFieldFromTo(parameter, fieldConfig);
      } else {
        if (parameter.type === 'month') {
          newField = me.createMonthField(parameter, fieldConfig);
        } else {
          if (BpcCommon.Util.isStringEqual(parameter.type, 'table')) {
            newField = me.createTable(parameter, fieldConfig);
          } else {
            if (parameter.type === 'boolean') {
              newField = me.createBooleanField(parameter, fieldConfig);
            } else {
              if (parameter.type === 'time') {
                newField = me.createTimeField(parameter, fieldConfig);
              } else {
                if (parameter.type === 'number' || parameter.type === 'spinner') {
                  newField = me.createNumberField(parameter, fieldConfig);
                } else {
                  if (parameter.type === 'upload') {
                    fieldConfig.name = 'fileuploadfield-' + fieldConfig.name;
                    newField = fieldConfig;
                  } else {
                    if (parameter.type === 'textarea') {
                      fieldConfig.height = parameter.height;
                      newField = fieldConfig;
                    } else {
                      newField = fieldConfig;
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  return newField;
}, createTable:function(parameter, fieldConfig) {
  var me = this;
  var columns = [{xtype:'rownumberer'}];
  var fields = [];
  var errorMsg = '';
  if (!parameter.columns || !Ext.isArray(parameter.columns)) {
    errorMsg = errorMsg + 'no columns configured\x3cbr\x3e';
  } else {
    Ext.Array.each(parameter.columns, function(columnConfig) {
      if (!columnConfig.key) {
        errorMsg = errorMsg + 'missing key in column config\x3cbr\x3e';
        return;
      }
      if (!columnConfig.type) {
        errorMsg = errorMsg + 'missing key in column config\x3cbr\x3e';
        return;
      }
      if (BpcCommon.Util.isStringEqual(columnConfig.type, 'date')) {
        fields.push({name:columnConfig.key, type:'date', dateFormat:'Y-m-d'});
      } else {
        fields.push(columnConfig.key);
      }
      var editorCmp = me.getComponent(columnConfig);
      delete editorCmp.fieldLabel;
      var column = {text:columnConfig.label || columnConfig.key, dataIndex:columnConfig.key, formatter:'htmlEncode2', flex:1, editor:editorCmp};
      if (BpcCommon.Util.isStringEqual(columnConfig.type, 'date')) {
        column.xtype = 'datecolumn';
        column.format = 'Y-m-d';
      }
      Ext.applyIf(column, columnConfig);
      columns.push(column);
    });
  }
  if (errorMsg !== '') {
    return {xtype:'box', html:'Wrong configuration for table:\x3cbr\x3e' + errorMsg};
  }
  return Ext.apply(fieldConfig, {height:parameter.height || 250, columns:columns, fieldLabel:undefined, title:parameter.label, resizable:{handles:'s'}, store:{fields:fields, data:[]}});
}, createCombobox:function(parameter, fieldConfig) {
  var referenceName = fieldConfig.name + 'Combo';
  var initialValue = fieldConfig.initialValue || fieldConfig.value;
  var baseUrl = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_baseUrl');
  var inubitVpsEndpoint = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_VpsEndpoint');
  var inubitProxyId = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_proxyId');
  var comboStore = new Ext.data.JsonStore({idProperty:'key', fields:['label', 'key']});
  var combobox = Ext.apply(fieldConfig, {store:comboStore, displayField:'label', valueField:'key', triggerAction:'all', forceSelection:true, mode:'local', queryMode:'local', reference:referenceName, value:initialValue});
  var url = '';
  combobox.onFocusLeave = function() {
    Ext.form.field.ComboBox.prototype.onFocusLeave.apply(this, arguments);
    this.validate();
  };
  combobox.reloadRemoteData = function(me) {
    var processId = me.selectedProcess.getId();
    var requestData = me.buildRequestDataForCombo(processId, fieldConfig.name);
    me.requestRemoteData(url, requestData, referenceName);
  };
  combobox.reloadRemoteDataOnChange = function(me) {
    var processId = me.selectedProcess.getId();
    var requestData = me.buildRequestDataForCombo(processId, fieldConfig.name);
    var addedParameter = '?reloadOnChange\x3dtrue';
    me.requestRemoteData(url + addedParameter, requestData, referenceName);
  };
  if (parameter.mode && parameter.mode === 'initialRemote') {
    var processStartConfig = this.getView().processStartConfig;
    if (processStartConfig && processStartConfig.url === void 0) {
      if (!baseUrl) {
        Ext.log({msg:"Problem in start process: Couldn't find the configuration to get the data for the combo box. " + 'Please check the monitor configurations.', level:'warn'});
      } else {
        if (baseUrl && inubitVpsEndpoint) {
          if (processStartConfig.endpoint !== void 0) {
            url = '' + (BpcCommon.Api.getBackendUrl(inubitProxyId) + baseUrl + processStartConfig.endPoint);
          } else {
            url = '' + (BpcCommon.Api.getBackendUrl(inubitProxyId) + baseUrl + inubitVpsEndpoint);
          }
        } else {
          Ext.log({msg:"Problem in start process: Couldn't find the configuration to get the data for the combo box. " + 'Please add a backend url and endpoint.', level:'warn'});
        }
      }
    } else {
      if (processStartConfig && processStartConfig.url.length) {
        url = processStartConfig.url;
      } else {
        url = '' + (BpcCommon.Api.getBackendUrl(inubitProxyId) + baseUrl + inubitVpsEndpoint);
      }
    }
    if (url.length > 0) {
      var me = this;
      combobox.emptyText = BpcCommon.Api.getTranslation('MONITOR_LOADING_LIST');
      combobox.reloadRemoteData(me);
      if (parameter.reloadRemoteData) {
        combobox.reloadOnChange = true;
        me.reloadOnChangeCmps.push(combobox);
      }
    }
  } else {
    comboStore.loadData(parameter.options);
  }
  return combobox;
}, markFieldForReloadTrigger:function(field) {
  field.reloadOnBlur = true;
}, onFieldBlur:function(field) {
  var me = this;
  if (field.reloadOnBlur === true) {
    field.reloadOnBlur = false;
    me.reloadRemoteData();
  }
}, reloadRemoteData:function() {
  var me = this;
  var remoteDataCmps = me.reloadOnChangeCmps;
  Ext.Array.each(remoteDataCmps, function(cmp) {
    cmp.reloadRemoteDataOnChange(me);
  });
}, requestRemoteData:function(url, requestData, referenceName) {
  var me = this;
  var actualUser = BpcCommon.Api.getUserName();
  var moduleId = this.getView().moduleId;
  Ext.Ajax.request({url:url, method:'POST', params:{request:requestData}, headers:{ISPortalUser:actualUser ? actualUser : '', 'X-BPC-ModuleId':moduleId}, scope:this, callback:function(options, success, response) {
    var responseData = '';
    if (success) {
      try {
        responseData = Ext.JSON.decode(response.responseText);
      } catch (e) {
        Ext.log({msg:'Monitor: Invalid json configured: ' + e, level:'warn'});
      }
    } else {
      responseData = 'serverNotResponse';
    }
    var combobox = me.lookupReference(referenceName);
    if (responseData === 'serverNotResponse') {
      Ext.Msg.alert(BpcCommon.Api.getTranslation('MONITOR_ERROR_RETRIEVING_DATA'), BpcCommon.Api.getTranslation('MONITOR_SERVER_UNREACHABLE'));
    } else {
      if (responseData.success === true || responseData.success === 'true') {
        if (!combobox) {
          return;
        }
        combobox.getStore().loadData(responseData.data);
        combobox.enable();
        combobox.setValueOnData();
        combobox.validate();
      } else {
        var message = monitor.Util.isEmpty(responseData.message) ? 'Keine Antwort vom Server.' : responseData.message;
        Ext.Msg.alert('Fehler beim Datenabruf', message);
      }
    }
    combobox.setEmptyText(' ');
  }});
}, buildRequestDataForCombo:function(processId, comboboxId) {
  var requestData = monitor.Util.toBeginXML('root', 'atom');
  requestData += monitor.Util.toAtomXML('portletArchiveName', '');
  requestData += monitor.Util.toAtomXML('mandant', this.getTenant());
  requestData += monitor.Util.toAtomXML('gridID', this.getGridId());
  requestData += monitor.Util.toAtomXML('operation', 'choiceList');
  requestData += monitor.Util.toAtomXML('custom', 'true');
  requestData += monitor.Util.toAtomXML('process', processId);
  requestData += monitor.Util.toAtomXML('key', comboboxId);
  requestData += monitor.Util.toBeginXML('formData');
  if (this.getView().rendered === true) {
    var fieldValueMap = this.getView().down('form').getForm().getFieldValues();
    Ext.Object.each(fieldValueMap, function(key, value) {
      requestData += monitor.Util.toAtomXML(key, value);
    });
  }
  requestData += monitor.Util.toEndXML('formData');
  requestData += monitor.Util.toEndXML('root');
  return requestData;
}, createDateField:function(parameter, fieldConfig) {
  var initialDate = null;
  var initialValue = parameter.initialValue;
  if (initialValue !== undefined && typeof initialValue === 'string' && this.isValidRelativeDate(initialValue)) {
    initialDate = this.createRelativeDate(initialValue);
  }
  var maxValue, minValue = null;
  var paramMin = parameter.minValue;
  if (paramMin !== undefined && typeof paramMin === 'string' && this.isValidRelativeDate(paramMin)) {
    minValue = this.createRelativeDate(paramMin);
  } else {
    if (parameter.minValue !== undefined && /\d\d\d\d-\d\d-\d\dT/i.test(parameter.minValue)) {
      minValue = new Date(parameter.minValue.split('T')[0].split('-'));
    }
  }
  var paramMax = parameter.maxValue;
  if (paramMax !== undefined && typeof paramMax === 'string' && this.isValidRelativeDate(paramMax)) {
    maxValue = this.createRelativeDate(paramMax);
  } else {
    if (parameter.maxValue !== undefined && /\d\d\d\d-\d\d-\d\dT/i.test(parameter.maxValue)) {
      maxValue = new Date(parameter.maxValue.split('T')[0].split('-'));
    }
  }
  return Ext.apply(fieldConfig, {format:'d.m.Y', maxValue:maxValue, minValue:minValue, value:initialDate !== null ? initialDate : initialValue, submitFormat:'Y-m-d'});
}, createDateFieldFromTo:function(parameter, fieldConfig) {
  delete fieldConfig.fieldLabel;
  var fromConfig = Ext.apply({}, {initialValue:parameter.initialDateFrom || parameter.initialValue, name:parameter.key + '_from', bind:{maxValue:'{valueTo}', value:'{valueFrom}'}}, fieldConfig);
  var fromField = this.createDateField(parameter, fromConfig);
  var toConfig = Ext.apply({}, {initialValue:parameter.initialDateTo || parameter.initialValue, name:parameter.key + '_to', bind:{minValue:'{valueFrom}', value:'{valueTo}'}}, fieldConfig);
  var toField = this.createDateField(parameter, toConfig);
  var fieldContainer = {xtype:'fieldcontainer', layout:'hbox', defaults:{flex:1}, viewModel:{data:{valueFrom:fromField.value, valueTo:toField.value}}, fieldLabel:parameter.label, width:fieldConfig.width, items:[fromField, toField]};
  return fieldContainer;
}, createMonthField:function(parameter, fieldConfig) {
  var initialDate = null;
  var initialValue = parameter.initialValue;
  if (initialValue !== undefined && typeof initialValue === 'string' && this.isValidRelativeDate(initialValue)) {
    initialDate = this.createRelativeDate(initialValue);
  }
  var maxValue, minValue = null;
  var paramMin = parameter.minValue;
  if (paramMin !== undefined && typeof paramMin === 'string' && this.isValidRelativeDate(paramMin)) {
    minValue = this.createRelativeDate(paramMin);
  } else {
    if (parameter.minValue !== undefined && /\d\d\d\d-\d\d-\d\dT/i.test(parameter.minValue)) {
      minValue = new Date(parameter.minValue.split('T')[0].split('-'));
    }
  }
  var paramMax = parameter.maxValue;
  if (paramMax !== undefined && typeof paramMax === 'string' && this.isValidRelativeDate(paramMax)) {
    maxValue = this.createRelativeDate(paramMax);
  } else {
    if (parameter.maxValue !== undefined && /\d\d\d\d-\d\d-\d\dT/i.test(parameter.maxValue)) {
      maxValue = new Date(parameter.maxValue.split('T')[0].split('-'));
    }
  }
  if ('format' in parameter) {
    fieldConfig.format = parameter.format;
  }
  return Ext.apply(fieldConfig, {maxValue:maxValue, minValue:minValue, value:initialDate !== null ? initialDate : initialValue, submitFormat:'Y-m-d'});
}, isValidRelativeDate:function(value) {
  value = value.trim();
  if (value.indexOf(this.TODAY_SYNTAX) === -1) {
    return false;
  }
  var regExp = new RegExp('^' + this.TODAY_SYNTAX + '(\\s*[-+]\\s*[0-9]+){0,1}$');
  var result = value.match(regExp);
  if (result !== null && result.length > 0) {
    return true;
  }
  Ext.log({msg:"Problem in start process: Problem to read the relative value of date. This isn't correct configured: " + value, level:'warn'});
  return false;
}, createRelativeDate:function(valueAsString) {
  var newDate = new Date;
  var lastValueOfString = valueAsString.substring(this.TODAY_SYNTAX.length, valueAsString.length);
  if (lastValueOfString.length > 0) {
    var indexOfSign = lastValueOfString.indexOf('-') !== -1 ? lastValueOfString.indexOf('-') : lastValueOfString.indexOf('+');
    var number = parseInt(lastValueOfString.substr(indexOfSign + 1, lastValueOfString.length));
    if (lastValueOfString.indexOf('-') !== -1) {
      newDate.setDate(newDate.getDate() - number);
    } else {
      newDate.setDate(newDate.getDate() + number);
    }
  }
  return newDate;
}, createBooleanField:function(parameter, fieldConfig) {
  return Ext.apply(fieldConfig, {checked:parameter.initialValue, uncheckedValue:false, inputValue:true});
}, createTimeField:function(parameter, fieldConfig) {
  var timeIncrement = parameter.increment !== undefined ? parseInt(parameter.increment, 10) : 60;
  return Ext.apply(fieldConfig, {increment:timeIncrement, format:'H:i'});
}, createNumberField:function(parameter, fieldConfig) {
  var minValue, maxValue = '';
  if (parameter.minValue !== undefined) {
    minValue = parameter.minValue;
  }
  if (parameter.maxValue !== undefined) {
    maxValue = parameter.maxValue;
  }
  return Ext.apply(fieldConfig, {minValue:minValue, maxValue:maxValue});
}, onCommit:function() {
  var me = this;
  var process = me.selectedProcess.get('label');
  Ext.GlobalEvents.fireEvent('processStarted', {process:process});
  var unlockFn = Ext.emptyFn;
  try {
    var panel = this.lookupReference('startProcessForm');
    var form = panel.getForm();
    if (form.isValid()) {
      var values = form.getValues();
      var url = '';
      var moduleId = this.getView().moduleId;
      var baseUrl = BpcCommon.Api.getSetting(moduleId, 'inubit_baseUrl');
      var inubitProxyId = BpcCommon.Api.getSetting(moduleId, 'inubit_proxyId');
      var inubitVpsEndpoint = BpcCommon.Api.getSetting(moduleId, 'inubit_VpsEndpoint');
      url = BpcCommon.Api.getBackendUrl(inubitProxyId) + baseUrl + inubitVpsEndpoint;
      url = url.replace('/bpc-httpproxy/httpProxy/', '/bpc-monitor/monitor/httpProxy/');
      this.lookupReference('startProcessBnt').disable();
      if (!monitor.Util.isEmpty(url)) {
        if (panel.down('fileuploadfield')) {
          var loadMask = Ext.create('Ext.LoadMask', {target:this.getView(), msg:'Wird ausgeführt'});
          loadMask.show();
          form.submit({url:url, params:{request:this.buildRequestData(values), ISPortalUser:BpcCommon.Api.getUserSession().data.loginName, 'X-BPC-ModuleId':moduleId}, scope:this, success:function(source, action) {
            loadMask.destroy();
            this.handleSubmitSuccess(action.response);
          }, failure:function(source, action) {
            loadMask.destroy();
            this.handleSubmitFailure(action.response);
          }});
        } else {
          unlockFn = BpcCommon.Util.blockComponentForAsyncAction('startProcessBnt', 'itemId', 'Wird ausgeführt', '^ startProcessWindow');
          Ext.Ajax.request({url:url, method:'POST', params:{request:this.buildRequestData(values)}, headers:{ISPortalUser:BpcCommon.Api.getUserSession().data.loginName, 'X-BPC-ModuleId':moduleId}, callback:unlockFn, scope:this, success:function(response) {
            this.handleSubmitSuccess(response);
          }, failure:function(response) {
            this.handleSubmitFailure(response);
          }});
        }
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onCommit', dump:e, stack:true, level:'error'});
    unlockFn();
  }
}, handleSubmitSuccess:function(response) {
  var me = this;
  var notification = {};
  var obj = Ext.decode(response.responseText, true);
  if (obj.success && obj.success !== 'false') {
    if (obj.download) {
      try {
        BpcCommon.Util.download(obj.download.data, obj.download.fileName, obj.download.contentType);
      } catch (e) {
        BpcCommon.Api.showNotification('Fehler beim Bereitstellen des Dateidownloads.');
        me.lookupReference('startProcessBnt').enable();
        return;
      }
    }
    notification.text = BpcCommon.Api.getTranslation('MONITOR_PROCESS_START_SUCCESSFUL');
    if (obj.msg || obj.message) {
      notification.text = notification.text + ': ' + (obj.msg || obj.message);
    }
    BpcCommon.Api.showNotification(notification);
    var checkbox = me.getView().down('#startFurtherProcess');
    if (checkbox && checkbox.getValue() !== true) {
      Ext.Function.defer(function() {
        me.getView().close();
      }, 200, this);
    }
    me.lookupReference('startProcessBnt').enable();
  } else {
    me.handleSubmitFailure(response);
  }
}, handleSubmitFailure:function(response) {
  var notification = {};
  var errorMsg = BpcCommon.Util.getErrorFromFailureResponse(response).message;
  notification.text = BpcCommon.Api.getTranslation('MONITOR_PROCESS_START_FAILED') + ': ' + errorMsg;
  notification.type = 'ERROR';
  BpcCommon.Api.showNotification(notification);
  this.lookupReference('startProcessBnt').enable();
}, buildRequestData:function(values) {
  var me = this;
  var processConfig = me.getViewModel().get('processConfig');
  var selectedRecords = me.getViewModel().get('activeGrid.selectedRecords');
  var requestData = monitor.Util.toBeginXML('root', 'atom');
  requestData += monitor.Util.toAtomXML('portletArchiveName', '');
  requestData += monitor.Util.toAtomXML('operation', 'startProcess');
  requestData += monitor.Util.toAtomXML('mandant', this.getTenant());
  requestData += monitor.Util.toAtomXML('gridID', this.getGridId());
  requestData += monitor.Util.toAtomXML('key', values.processType);
  requestData += monitor.Util.toAtomXML('bpcModule', 'monitor');
  requestData += monitor.Util.toAtomXML('bpcModuleInstanceId', this.getView().moduleId);
  requestData += monitor.Util.toBeginXML('data', 'array');
  requestData += monitor.Util.toBeginXML('item', 'tuple');
  var processParameters = me.selectedProcess.get('parameters');
  Ext.Object.each(values, function(key, value) {
    if (key !== 'processType') {
      if (this.getParameterConfig(processParameters, key) && this.getParameterConfig(processParameters, key).type === 'time') {
        value = value ? value + ':00' : '';
      }
      requestData += monitor.Util.toAtomXML(key, value);
    }
  }, this);
  if (processConfig.get('startWithContext')) {
    if (selectedRecords) {
      requestData += monitor.Util.toBeginXML('records', 'array');
      Ext.each(selectedRecords, function(r) {
        requestData += monitor.Util.toBeginXML('item', 'tuple');
        Ext.iterate(r.data, function(key, value) {
          requestData += monitor.Util.toAtomXML(key.toLowerCase(), value);
        }, this);
        requestData += monitor.Util.toEndXML('item');
      }, this);
      requestData += monitor.Util.toEndXML('records');
    }
  }
  me.getView().query('bpcEditableGrid').forEach(function(grid) {
    requestData += BpcCommon.Util.getSerializedStoreData(grid.store, 'xml', {documentRoot:grid.name, writeAllFields:true});
  });
  requestData += monitor.Util.toEndXML('item');
  requestData += monitor.Util.toEndXML('data');
  requestData += monitor.Util.toEndXML('root');
  return requestData;
}, getTenant:function() {
  var tenant = '';
  var pmMandant = BpcCommon.Api.getSetting(this.getView().moduleId, 'inubit_pmMandant');
  if (!monitor.Util.isEmpty(pmMandant)) {
    tenant = pmMandant;
  }
  return tenant;
}, getGridId:function() {
  var gridId = '';
  var readGrid = BpcCommon.Api.getSetting(this.getView().moduleId, monitor.assets.ConfigKeys.legacyPmGridId);
  if (!monitor.Util.isEmpty(readGrid)) {
    gridId = readGrid;
  } else {
    Ext.log({msg:"Problem in start process: Couldn't read the configuration 'db_gridId'. " + 'Please configure this in your monitor. ', level:'warn'});
  }
  return gridId;
}, getParameterConfig:function(config, key) {
  var requiredConfig = null;
  Ext.each(config, function(parameter) {
    if (parameter.key === key) {
      requiredConfig = parameter;
      return false;
    }
  });
  return requiredConfig;
}});
Ext.define('monitor.view.interaction.startprocess.StartProcessMenu', {extend:'Ext.menu.Item', alias:'widget.monitorStartProcessMenu', mixins:['monitor.view.interaction.startprocess.StartProcessMixin'], hidden:true, text:BpcCommon.Api.getTranslation('MONITOR_START_PROCESS'), initComponent:function() {
  var me = this;
  this.hidden = !monitor.view.interaction.startprocess.Util.isAbleToStartProcess(this.moduleId, this);
  var spConfig = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.processStartConfig);
  var processStartMenu = [];
  if (spConfig && spConfig.processes && Ext.isArray(spConfig.processes) && spConfig.processes.length > 0) {
    me.handler = null;
    spConfig.processes.forEach(function(processConfig) {
      if (processConfig.startWithContext === true && BpcCommon.Api.isUserAllowedToSee(processConfig)) {
        processStartMenu.push({text:processConfig.label, iconCls:processConfig.iconCls, handler:monitor.StartProcessUtil.openStartProcessForm.bind(monitor.StartProcessUtil, me.moduleId, monitor.Util.getViewModel(me.lookupViewModel()), processConfig), processConfig:processConfig});
      }
    });
  }
  if (processStartMenu.length > 0) {
    me.menu = processStartMenu;
  }
  me.callParent();
}});
Ext.define('monitor.view.interaction.startprocess.StartProcessWindow', {extend:'BpcCommon.component.window.Window', alias:'widget.monitorStartProcessWindow', layout:'fit', controller:'startProcessController', autoScroll:true, autoShow:true, bind:{title:'{MONITOR_START_PROCESS:translate} - {processConfig.label:translate}'}, viewModel:{data:{processConfig:{label:'', key:undefined}, MONITOR_START_PROCESS:'MONITOR_START_PROCESS'}}, iconCls:'x-fal fa-play', padding:'10px', preselectedProcess:undefined, 
configuration:undefined, records:undefined, scrollable:true, minWidth:200, minHeight:400, stateful:true, initComponent:function() {
  var me = this;
  me.width = document.body.clientWidth * 0.4;
  me.height = document.body.clientHeight * 0.6;
  me.stateId = me.moduleId + '_monitorStartProcessWindow';
  me.processStartConfig = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.processStartConfig);
  if (!me.processStartConfig || !me.processStartConfig.processes || me.processStartConfig.processes.length === 0) {
    me.items = [{xtype:'bpcCenterMessageCmp', message:'MONITOR_ERROR_PROCESS_START'}];
    me.callParent(arguments);
    return;
  }
  if (me.preselectedProcess instanceof Ext.data.Model) {
    me.preselectedProcess = me.preselectedProcess.getData();
  }
  var preselectedProcessKey = undefined;
  if (me.preselectedProcess && me.preselectedProcess.key) {
    preselectedProcessKey = me.preselectedProcess.key;
  }
  me.items = [{xtype:'form', autoScroll:true, reference:'startProcessForm', itemId:'startProcessForm', layout:{align:'stretch', type:'vbox'}, flex:1, items:[preselectedProcessKey ? {xtype:'textfield', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_PROCESS_TYPE') + ':', readOnly:true, itemId:'processTypeField', name:'processType', listeners:{afterrender:function(field) {
    var processRecord = me.getController().selectProcess(preselectedProcessKey);
    field.setValue(processRecord.get('label'));
  }}} : {xtype:'combobox', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_PROCESS_TYPE') + ':', itemId:'processTypeCombo', emptyText:BpcCommon.Api.getTranslation('MONITOR_CHOOSE_PROCESS_TYPE'), editable:false, queryMode:'local', displayField:'label', valueField:'key', allowBlank:false, name:'processType', store:monitor.view.interaction.startprocess.Util.getStore(me.moduleId), listeners:{afterrender:function(combo) {
    if (combo && combo.getStore().getCount() === 1) {
      combo.setValue(combo.getStore().first());
    }
  }}}, {xtype:'displayfield', hidden:true, localized:{fieldLabel:'CORE_DESCRIPTION'}, bind:{hidden:'{!processConfig.description}', value:'{processConfig.description}'}}, {xtype:'fieldset', reference:'startProcessItemsContainer', itemId:'startProcessItemsContainer', localized:{title:'MONITOR_PROCESSSTART_PARAMETERS_TITLE'}, bind:{hidden:'{!processConfig.key}'}, hidden:true, items:[]}], buttons:[{xtype:'displayfield', boxLabel:BpcCommon.Api.getTranslation('MONITOR_START_WITH_CONTEXT'), hidden:true, 
  bind:{hidden:'{!processConfig.startWithContext}'}, localized:{value:{tpl:"\x3cspan class\x3d'x-fal fa-list-ul'\x3e\x3c/span\x3e {MONITOR_PROCESSES}: " + (me.records ? me.records.length : 0), keys:['MONITOR_PROCESSES']}}}, '-\x3e', {xtype:'checkbox', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_KEEP_WINDOW_OPENED_AFTER_PROCESS_START'), labelWidth:250, itemId:'startFurtherProcess', submitValue:false}, {text:BpcCommon.Api.getTranslation('MONITOR_START_PROCESS'), itemId:'startProcessBnt', reference:'startProcessBnt', 
  iconCls:'x-fal fa-check', disabled:true}, {text:BpcCommon.Api.getTranslation('MONITOR_CANCEL'), itemId:'cancelBtn', iconCls:'x-fal fa-times', handler:function(button) {
    button.up('window').close();
  }, style:{marginLeft:'10px'}}]}];
  me.callParent(arguments);
}});
Ext.define('monitor.view.interaction.startprocess.Toolbar', {extend:'Ext.toolbar.Toolbar', alias:'widget.monitorStartProcessToolbar', vertical:false, moduleId:undefined, initComponent:function() {
  var me = this;
  var actionStore = monitor.StartProcessUtil.getStore(me.moduleId);
  me.items = [];
  if (actionStore) {
    actionStore.each(function(actionRecord) {
      me.items.push({text:BpcCommon.Api.getTranslation(actionRecord.get('label')), itemId:BpcCommon.Util.cleanUpId(actionRecord.get('id')) || 'start-item', iconCls:actionRecord.get('iconCls'), handler:monitor.StartProcessUtil.openStartProcessForm.bind(monitor.StartProcessUtil, me.moduleId, monitor.Util.getViewModel(me.lookupViewModel()), actionRecord), actionRecord:actionRecord});
    });
  }
  me.callParent();
}});
Ext.define('monitor.view.interaction.startprocess.Util', {singleton:true, alternateClassName:['monitor.StartProcessUtil'], instanceCacheMap:{docuDummy:{store:undefined}}, initInstanceCache:function(moduleId) {
  var me = this;
  if (me.instanceCacheMap[moduleId]) {
    return;
  }
  me.instanceCacheMap[moduleId] = {store:undefined};
}, getStore:function(moduleId) {
  var me = this;
  me.initInstanceCache(moduleId);
  if (me.instanceCacheMap[moduleId].store) {
    return me.instanceCacheMap[moduleId].store;
  }
  var processStartConfig = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.processStartConfig);
  var processes = [];
  if (processStartConfig && Ext.isArray(processStartConfig.processes)) {
    processes = processStartConfig.processes;
  }
  me.instanceCacheMap[moduleId].store = Ext.create('Ext.data.JsonStore', {model:'monitor.model.Starter', filters:[BpcCommon.Api.isUserAllowedToSee, function(record) {
    return record.get('hidden') !== true;
  }], data:processes});
  return me.instanceCacheMap[moduleId].store;
}, openStartProcessForm:function(moduleId, parentViewModel, preselectedProcess) {
  Ext.create({xtype:'monitorStartProcessWindow', moduleId:moduleId, preselectedProcess:preselectedProcess, viewModel:{parent:parentViewModel}});
}, isAbleToStartProcess:function(moduleId, cmp) {
  var me = this;
  var isStartProcessActive = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.processStart);
  var hasUserRight = BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.startProcess) || BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.startProcess + '_' + moduleId);
  var selectableProcesses = me.getStore(moduleId);
  if (cmp.xtype === 'monitorChangeStateMenu') {
    var currentMonitorView = Ext.ComponentQuery.query('bpcMonitor').find(function(item) {
      return item.moduleId === moduleId;
    });
    var isItemSelected = currentMonitorView.getViewModel().get('activeGridSelection').length !== 0;
    return isStartProcessActive && hasUserRight && isItemSelected;
  }
  return isStartProcessActive && hasUserRight && selectableProcesses.getCount() > 0;
}});
Ext.define('monitor.view.moduleheader.MonitorInfo', {extend:'Ext.container.Container', alias:'widget.bpcMonitorMeta', layout:{type:'hbox', pack:'end', align:'center'}, controller:'monitorinfocontroller', viewModel:{data:{itemInt:0, filterInt:0, sortInt:0, lastReplication:[], stackedInt:0, sorters:'', filters:''}, formulas:{replicationData:{get:function(get) {
  var replicationRawInfo = get('lastReplication');
  var overallReplicationStateOk = true;
  var replicationData = Ext.Array.map(replicationRawInfo, function(dataElement) {
    if (dataElement.replication) {
      if (!dataElement.replication.sourceAndTargetConsistent) {
        overallReplicationStateOk = false;
      }
      return {id:dataElement.id, synchron:dataElement.replication.sourceAndTargetConsistent, errorMsg:dataElement.replication.currentErrorMessage, lastReplication:Ext.Date.parse(dataElement.replication.lastRunEnd, 'time'), overallReplicationStateOk:overallReplicationStateOk};
    }
    return {id:dataElement.id};
  }, this);
  return {overallReplicationStateOk:overallReplicationStateOk, sources:replicationData};
}}, moduleHeaderInfos:{get:function(get) {
  var itemInt = get('itemInt');
  var filterInt = get('filterInt');
  var sortInt = get('sortInt');
  var itemCount = Ext.util.Format.number(itemInt, '0,000');
  var countLimit = BpcCommon.Api.getSetting('monitor', monitor.assets.ConfigKeys.dataCountLimit);
  if (itemInt >= countLimit) {
    itemCount = '\x3e' + itemCount;
  }
  var view = this.getView();
  var moduleHeader = view.up('monitorModuleHeader');
  var hideDatasets = false;
  if (BpcCommon.Api.getSetting(moduleHeader.moduleId, monitor.assets.ConfigKeys.gridMultipleViews)) {
    var multiGridConf = BpcCommon.Api.getSetting(moduleHeader.moduleId, monitor.assets.ConfigKeys.gridMultipleViewsConfig);
    if (multiGridConf.multiViewMode === 'stacked') {
      itemCount = Ext.util.Format.number(get('stackedInt'), '0,000');
    }
  }
  var infos = '' + ("\x3c/div\x3e\x3cdiv class\x3d'metaInfoItem' data-testid\x3d'metaFilterInfo'\x3e" + '\x3cspan class\x3d\'metaInfoLabel\'\x3e\x3ci class\x3d"fal fa-filter monitorInfoIcons"\x3e\x3c/i\x3e') + BpcCommon.Api.getTranslation('MONITOR_FILTER') + ':\x3c/span\x3e' + ("\x3cspan class\x3d'metaInfo'\x3e " + filterInt + '\x3c/span\x3e') + "\x3c/div\x3e\x3cdiv class\x3d'metaInfoItem'\x3e" + ('\x3cspan class\x3d\'metaInfoLabel\'\x3e\x3ci class\x3d"fal fa-sort-amount-down monitorInfoIcons"\x3e\x3c/i\x3e' + 
  BpcCommon.Api.getTranslation('MONITOR_SORTING') + ':\x3c/span\x3e') + ("\x3cspan class\x3d'metaInfo'\x3e " + sortInt + '\x3c/span\x3e') + '\x3c/div\x3e';
  if (hideDatasets === false) {
    infos = '' + ("\x3cdiv class\x3d'metaInfoItem'\x3e" + '\x3cspan class\x3d\'metaInfoLabel\'\x3e\x3ci class\x3d"fal fa-table monitorInfoIcons"\x3e\x3c/i\x3e') + BpcCommon.Api.getTranslation('MONITOR_DATASETS') + ':\x3c/span\x3e' + ("\x3cspan class\x3d'metaInfo'\x3e " + String(itemCount) + infos + '\x3c/span\x3e');
  }
  return infos;
}}}}, defaults:{xtype:'box', anchor:'100%', cls:'bpcMonitorMeta', margin:'0 10 0 10'}, initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  var large = BpcCommon.Api.getSetting('_core', 'moduleHeader_large');
  if (large) {
    this.items = [{bind:{html:'{moduleHeaderInfos}'}, listeners:{afterrender:function(cmp) {
      cmp.el.on('mouseover', function() {
        var tipText = '';
        var tooltip = false;
        if (vm.get('filterInt') > 0) {
          tooltip = true;
          tipText = BpcCommon.Api.getTranslation('MONITOR_FILTER') + ':\x3cbr\x3e' + vm.get('filters') + '\x3cbr\x3e\x3cbr\x3e';
        }
        if (vm.get('sortInt') > 0) {
          tooltip = true;
          tipText += BpcCommon.Api.getTranslation('MONITOR_SORTING') + ':\x3cbr\x3e' + vm.get('sorters') + ' \x3cbr\x3e';
        }
        var previusTips = Ext.ComponentQuery.query('tooltip[itemId \x3d sortInfo]');
        if (tooltip) {
          if (previusTips.length > 0) {
            Ext.each(previusTips, function(tip) {
              tip.setHtml(tipText);
            });
          } else {
            Ext.create('Ext.tip.ToolTip', {trackMouse:true, itemId:'sortInfo', target:cmp.id, html:tipText});
          }
        } else {
          if (previusTips.length > 0) {
            Ext.each(previusTips, function(tip) {
              tip.destroy();
            });
          }
        }
      });
    }}}];
  } else {
    this.items = [{xtype:'button', iconCls:'x-fal fa-info', bind:{tooltip:'{moduleHeaderInfos}'}}];
  }
  this.items.push({xtype:'button', itemId:'infoTarget', bind:{hidden:'{!replicationData.overallReplicationStateOk}'}, iconCls:'x-fal fa-check', okIconCls:'x-fal fa-check successColor', errorIconCls:'x-fal fa-exclamation failureColor'});
  this.callParent();
  var dateFormat = BpcCommon.Api.getSetting(this.up('[moduleId]').moduleId, monitor.assets.ConfigKeys.dateFormat);
  this.infoTpl = new Ext.XTemplate('\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_SOURCE_COUNT') + ': {[values.length]}\x3c/p\x3e', '\x3ctpl for\x3d"."\x3e\x3chr\x3e', '\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_SOURCE') + ': {id}\x3c/p\x3e', '\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_SYNCHRONOUS') + ': {synchron:pick("Nein","Ja")}\x3c/p\x3e', '\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_LAST_UPDATE') + ': {lastReplication:date("' + dateFormat + '")}\x3c/p\x3e', '\x3ctpl if\x3d"errorMsg"\x3e', 
  '\x3cp\x3e' + BpcCommon.Api.getTranslation('MONITOR_ERROR') + ': {errorMsg}\x3c/p\x3e', '\x3c/tpl\x3e', '\x3c/tpl\x3e\x3c/p\x3e');
  this.getViewModel().bind('{replicationData}', this.updateInfosUi, this, {deep:true});
}, updateInfosUi:function(data) {
  Ext.log(this.self.getName() + ': updateInfosUi');
  try {
    var target = this.down('#infoTarget');
    if (!target) {
      return;
    }
    target.setIconCls(data.overallReplicationStateOk ? target.okIconCls : target.errorIconCls);
    target.setTooltip({width:500, text:this.infoTpl.applyTemplate(data.sources)});
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateInfosUi', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.view.moduleheader.MonitorInfoController', {extend:'Ext.app.ViewController', alias:'controller.monitorinfocontroller', refreshData:function() {
  Ext.log(this.self.getName() + ': refreshData');
  try {
    var grids = this.getView().moduleInstance.getGridList();
    Ext.Array.each(grids, function(grid) {
      grid.getController().refreshData();
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshData', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.view.moduleheader.MonitorModuleHeaderController', {extend:'Ext.app.ViewController', alias:'controller.monitorModuleHeaderController'});
Ext.define('monitor.view.state.ConfigurationController', {extend:'Ext.app.ViewController', alias:'controller.monitorStateConfigurationController', control:{'#stateGrid':{select:'onStateSelect'}}, init:function() {
  this.moduleId = this.getView().moduleId;
  this.stateViews = new Ext.util.HashMap;
}, onStateSelect:function(grid, record) {
  try {
    var container = this.lookupReference('stateObjectViewContainer');
    if (this.stateViews.containsKey(record.getId())) {
      container.setActiveItem(this.stateViews.get(record.getId()));
    } else {
      var stateView = {xtype:'monitorStateView', stateObject:record, stateController:this.getView().stateController, moduleId:this.getView().moduleId};
      stateView = container.add(stateView);
      this.stateViews.add(record.getId(), stateView);
      container.setActiveItem(stateView);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onStateSelect', dump:e, stack:true, level:'error'});
  }
}, cancel:function() {
  try {
    this.getView().up('window').close();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR cancel', dump:e, stack:true, level:'error'});
  }
}, reset:function() {
  var me = this;
  var view = me.getView();
  var stateGrid = view.down('#stateGrid');
  var store = stateGrid.getStore();
  if (Ext.isFunction(store.rejectChanges)) {
    store.rejectChanges();
  }
  me.setDirty(false);
  stateGrid.setSelection(store.first());
}, 'delete':function(grid) {
  var stateStore = grid.getStore();
  var rowIndex = grid.actionPosition.rowIdx;
  grid.setSelection(rowIndex);
  this.setDirty(true);
  stateStore.remove(grid.getSelection());
  grid.setSelection(stateStore.first());
}, save:function() {
  var stateGrid = this.getView().down('#stateGrid');
  var store = stateGrid.getStore();
  this.setDirty(false);
  monitor.Module.stateController.setState(this.moduleId, store.getRange());
}, setDirty:function(store) {
  var me = this;
  var view = me.getView();
  var vm = me.getViewModel();
  if (!vm.data.firstSelectionDone) {
    return;
  }
  if (typeof store === 'boolean') {
    vm.set('unsavedChanges', store);
  } else {
    if (store.isStore && store.isLoaded() && store.isDirty()) {
      vm.set('unsavedChanges', true);
    }
  }
}, applyState:function() {
  var stateGrid = this.getView().down('#stateGrid');
  var selection = stateGrid.getSelection();
  monitor.Module.stateController.applyState(this.moduleId, selection[0]);
}});
Ext.define('monitor.view.state.StateView', {extend:'Ext.panel.Panel', alias:['widget.monitorStateView'], requires:['Ext.container.Container', 'monitor.view.state.StateViewController', 'monitor.model.Filter', 'monitor.model.Sorter'], controller:'monitorStateViewController', layout:{type:'vbox', align:'stretch'}, bodyPadding:5, scrollable:true, viewModel:{data:{stateObject:undefined, moduleInstance:undefined, isGrouped:false}}, initComponent:function() {
  try {
    this.items = [{xtype:'bpcTextField', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_NAME'), bind:'{stateObject.name}'}, {xtype:'bpcIconPicker', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_VIEW_ICONCLS'), bind:'{stateObject.iconCls}'}, {xtype:'bpcTextField', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_VIEW_TOOLTIP'), bind:'{stateObject.tooltip}'}, {xtype:'checkbox', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_VIEW_FAVORITE'), bind:'{stateObject.favorite}'}, {xtype:'bpcTextField', 
    fieldLabel:BpcCommon.Api.getTranslation('MONITOR_ACTIVE_VIEW'), bind:'{stateObject.activeView}'}];
    this.getViewModel().set(monitor.assets.ModuleRights.editMonitorViews, BpcCommon.Api.hasUserRight(monitor.assets.ModuleRights.editMonitorViews));
    this.callParent();
    this.setStateObject(this.stateObject);
    this.getViewModel().set('moduleInstance', this.moduleInstance);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, setStateObject:function(stateObject) {
  var me = this;
  me.getViewModel().set('stateObject', stateObject);
  try {
    var state = stateObject;
    if (!state) {
      return;
    }
    if (state.get('state')) {
      Ext.Object.each(state.get('state'), function(key, value) {
        state.set(key, value);
      });
    }
    if (Ext.isObject(me.stateObject.get('views'))) {
      var viewCmps = [];
      Ext.Object.each(me.stateObject.get('views'), function(key, value) {
        viewCmps.push({xtype:'monitorStateViewDetails', moduleId:me.moduleId, viewId:key, viewState:value, title:key});
      });
      me.add({xtype:'tabpanel', items:viewCmps});
    } else {
      me.add({xtype:'monitorStateViewDetails', moduleId:me.moduleId, viewId:'mainViewGrid', viewState:me.stateObject.getData()});
    }
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR setStateObject', dump:e, stack:true, level:'error'});
  }
}, getStateObject:function() {
  return this.getViewModel().get('stateObject');
}});
Ext.define('monitor.view.state.StateWindow', {extend:'Ext.panel.Panel', alias:'widget.monitorStateConfigurationPanel', requires:['Ext.form.field.Text', 'monitor.view.state.ConfigurationController', 'Ext.container.Container', 'Ext.data.Store', 'monitor.view.state.StateView'], controller:'monitorStateConfigurationController', header:false, iconCls:monitor.assets.Icons.VIEW, viewContext:undefined, layout:{type:'hbox', align:'stretch'}, viewModel:{data:{unsavedChanges:false, firstSelectionDone:false, 
viewContextWindow:false}}, items:[{xtype:'gridpanel', itemId:'stateGrid', bind:{store:'{stateStore}'}, columns:[{localized:{text:'MONITOR_VIEW_ICONCLS'}, dataIndex:'iconCls', width:42, renderer:function(value) {
  return '\x3cspan class\x3d"' + value + '" aria-hidden\x3d"true" \x3e\x3c/span\x3e';
}}, {localized:{text:'MONITOR_VIEW'}, dataIndex:'name', renderer:function(value) {
  return BpcCommon.Api.getTranslation(value);
}, flex:3}, {text:'ID', dataIndex:'id', flex:2}, {localized:{text:'MONITOR_FAVORITE'}, dataIndex:'favorite', flex:1, xtype:'checkcolumn', bind:{disabled:'{!global.right.' + monitor.assets.ModuleRights.editMonitorViews + '}'}}, {xtype:'actioncolumn', width:90, items:[{iconCls:'x-fal fa-arrow-up', tooltip:'Move up', handler:function(grid, rowIndex, colIndex, item, e, record) {
  var store = grid.getStore();
  store.remove(record);
  store.insert(rowIndex - 1, record);
  grid.setSelection(rowIndex - 1);
}}, {iconCls:'x-fal fa-arrow-down', tooltip:'Move down', handler:function(grid, rowIndex, colIndex, item, e, record) {
  var store = grid.getStore();
  store.remove(record);
  store.insert(rowIndex + 1, record);
  grid.setSelection(rowIndex + 1);
}}, {iconCls:BpcCommon.Icons.DELETE, localized:{tooltip:'CORE_DELETE'}, handler:'delete', bind:{hidden:'{!' + monitor.assets.ModuleRights.editMonitorViews + '}'}}]}], width:400, resizable:{handles:'e'}, listeners:{selectionchange:function(sm, selection) {
  if (selection && selection.length < 1) {
    sm.select(0);
  }
}, storechange:function(grid) {
  if (grid && grid.getStore()) {
    var stateStore = grid.getStore();
    if (!grid.lookupViewModel().get('firstSelectionDone')) {
      grid.setSelection(stateStore.first());
    }
    grid.lookupViewModel().set('firstSelectionDone', true);
  }
}, scope:this}}, {xtype:'container', flex:1, layout:'card', reference:'stateObjectViewContainer'}], buttons:[{xtype:'label', html:'\x3cspan class\x3d"' + BpcCommon.Icons.WARNING + ' warningColor"\x3e\x3c/span\x3e ' + BpcCommon.Api.getTranslation('MONITOR_UNSAVED_CHANGES'), hidden:true, bind:{hidden:'{!unsavedChanges}'}}, {iconCls:BpcCommon.Icons.RESET, ui:'secondary', itemId:'resetBtn', handler:'reset', localized:{text:'CORE_RESET'}, hidden:true, bind:{hidden:'{viewContextWindow}'}}, {iconCls:BpcCommon.Icons.CANCEL, 
ui:'secondary', handler:'cancel', localized:{text:'MONITOR_CLOSE'}, hidden:true, bind:{hidden:'{!viewContextWindow}'}}, {xtype:'button', localized:{text:'MONITOR_SAVE'}, handler:'save', bind:{hidden:'{!' + monitor.assets.ModuleRights.editMonitorViews + '}'}}], initComponent:function() {
  var stateStore = Ext.create('monitor.store.State', {data:BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.viewStates) || [], listeners:{datachanged:'setDirty'}});
  this.getViewModel().setStores({stateStore:stateStore});
  if (this.viewContext === 'window') {
    this.getViewModel().set('viewContextWindow', true);
  }
  this.callParent();
}});
Ext.define('monitor.view.state.FavoriteToolbar', {extend:'Ext.toolbar.Toolbar', alias:'widget.monitorFavoriteToolbar', cls:'favourite-toolbar', viewModel:true, overflowHandler:'scroller', stateModel:undefined, defaults:{enableToggle:true, ui:'moduleHeader'}, initComponent:function() {
  var me = this;
  var vm = this.getViewModel();
  me.stateModel = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.viewStates, true);
  me.callParent(arguments);
  me.updateComponent();
  me.stateModel.on('changed', me.updateComponent.bind(me), me);
  vm.bind('{activeState}', me.checkToggleState.bind(me));
  vm.bind('{activeStateDirty}', me.checkToggleState.bind(me));
}, updateComponent:function() {
  var me = this;
  var statesArray = me.stateModel.get('value') || [];
  me.removeAll();
  statesArray.forEach(function(stateObj) {
    if (!BpcCommon.Api.isUserAllowedToSee(stateObj)) {
      return;
    }
    if (stateObj.favorite) {
      me.add({xtype:'button', cls:'favourite-toolbar-item', iconCls:stateObj.iconCls, text:stateObj.name, tooltip:stateObj.tooltip, defaultTooltip:stateObj.tooltip, state:stateObj, moduleId:me.moduleId, handler:function(btn) {
        if (!btn.pressed) {
          monitor.Module.stateController.resetState(this.moduleId, this.state);
        } else {
          monitor.Module.stateController.applyState(this.moduleId, this.state);
        }
      }});
    }
  });
  me.checkToggleState();
}, checkToggleState:function() {
  var me = this;
  var vm = this.getViewModel();
  var activeStateId = vm.get('activeState');
  var activeStateDirty = vm.get('activeStateDirty');
  me.query('button').forEach(function(btn) {
    btn.setPressed(btn.state.id === activeStateId);
    if (btn.state.id === activeStateId && activeStateDirty) {
      btn.addCls('activeStateDirty');
      if (btn.defaultTooltip) {
        btn.setTooltip('\x3ci\x3e' + BpcCommon.Api.getTranslation('MONITOR_UNSAVED_CHANGES') + '\x3c/i\x3e \x3cbr/\x3e ' + btn.defaultTooltip);
      } else {
        btn.setTooltip('\x3ci\x3e' + BpcCommon.Api.getTranslation('MONITOR_UNSAVED_CHANGES') + '\x3c/i\x3e');
      }
    } else {
      btn.removeCls('activeStateDirty');
      btn.setTooltip(btn.defaultTooltip || '');
    }
  });
}});
Ext.define('monitor.view.state.GlobalConfigurationController', {extend:'Ext.app.ViewController', alias:'controller.monitorGlobalConfigurationController', control:{'#monitorInstanceGrid':{select:'onSelect'}}, init:function() {
  var viewModel = this.getViewModel();
  viewModel.bind('{activeInstanceId}', this.selectInstance.bind(this));
}, selectInstance:function(activeInstanceId) {
  var instanceGrid = this.getView().down('#monitorInstanceGrid');
  if (instanceGrid) {
    instanceGrid.setSelection(instanceGrid.getStore().getById(activeInstanceId));
  }
}, onSelect:function(grid, record) {
  var me = this;
  var target = me.getView().down('#configContainer');
  var viewModel = this.getViewModel();
  if (!record.stateConfigCmp) {
    var moduleId = record.get('moduleId');
    var dataIndex = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.dataIndex);
    var viewStates = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.viewStates) || [];
    var configurationPanelConfig;
    if (dataIndex === '' || dataIndex === undefined) {
      configurationPanelConfig = {xtype:'bpcCenterMessageCmp', message:'MONITOR_NO_INDEX_SET'};
    } else {
      if (viewStates.length === 0) {
        configurationPanelConfig = {xtype:'bpcCenterMessageCmp', message:'MONITOR_NO_VIEW_STATES_SET'};
      } else {
        configurationPanelConfig = {xtype:'monitorStateConfigurationPanel', moduleId:moduleId};
      }
    }
    record.stateConfigCmp = target.add(configurationPanelConfig);
  }
  target.setActiveItem(record.stateConfigCmp);
  viewModel.set('activeInstanceId', record.getId());
}});
Ext.define('monitor.view.state.GlobalConfigurationPanel', {extend:'Ext.Container', alias:'widget.monitorGlobalStateConfigurationPanel', requires:['monitor.view.state.GlobalConfigurationController'], controller:'monitorGlobalConfigurationController', layout:{type:'hbox', align:'stretch'}, viewModel:true, localized:{title:'MONITOR_VIEWS'}, iconCls:monitor.assets.Icons.VIEW, initComponent:function() {
  var me = this;
  me.items = [{xtype:'grid', itemId:'monitorInstanceGrid', localized:{title:'MONITOR_MONITORS'}, iconCls:monitor.assets.Icons.MONITOR, store:BpcCommon.Api.getModuleInstances('monitor'), columns:[{localized:{text:'CORE_NAME'}, flex:1, dataIndex:'instanceName'}, {text:'ID', dataIndex:'moduleId', flex:1}], width:450, resizable:{handles:'e'}, listeners:{afterrender:function() {
    this.setSelection(this.getSelection()[0]);
  }}}, {xtype:'container', layout:'card', itemId:'configContainer', flex:1, items:[]}];
  me.callParent();
}});
Ext.define('monitor.view.state.NewStatePanel', {extend:'Ext.panel.Panel', alias:'widget.monitorNewStatePanel', layout:{type:'vbox', align:'stretch'}, header:false, viewModel:{data:{isFormValid:true}}, moduleId:undefined, bodyPadding:10, items:[{xtype:'bpcTextField', itemId:'stateName', localized:{fieldLabel:'MONITOR_ENTER_VIEW_NAME'}, labelAlign:'top', listeners:{change:function() {
  this.lookupViewModel().set('isFormValid', true);
}}}, {xtype:'bpcIconPicker', itemId:'stateIconCls', localized:{fieldLabel:'MONITOR_ENTER_VIEW_ICON'}, labelAlign:'top', listeners:{change:function() {
  this.lookupViewModel().set('isFormValid', true);
}}}, {xtype:'bpcTextField', itemId:'stateTooltip', localized:{fieldLabel:'MONITOR_ENTER_VIEW_TOOLTIP'}, labelAlign:'top', listeners:{change:function() {
  this.lookupViewModel().set('isFormValid', true);
}}}, {xtype:'checkbox', itemId:'stateFavorite', localized:{boxLabel:'MONITOR_SAVE_AS_FAVORITE'}}, {xtype:'label', html:'\x3cspan class\x3d"' + BpcCommon.Icons.WARNING + ' warningColor"\x3e\x3c/span\x3e ' + BpcCommon.Api.getTranslation('MONITOR_NEW_VIEW_VALIDATION'), bind:{hidden:'{isFormValid}'}}], buttons:[{iconCls:BpcCommon.Icons.OkIcon, localized:{text:'CORE_OK'}, handler:function() {
  var monitorNewStatePanel = this.up('monitorNewStatePanel');
  var moduleId = monitorNewStatePanel.moduleId;
  var state = monitor.Module.stateController.getCurrentState(moduleId);
  state.id = Date.now();
  state.iconCls = monitorNewStatePanel.down('#stateIconCls').getValue();
  state.name = monitorNewStatePanel.down('#stateName').getValue();
  state.favorite = monitorNewStatePanel.down('#stateFavorite').getValue();
  state.tooltip = monitorNewStatePanel.down('#stateTooltip').getValue();
  if (state.iconCls || state.name) {
    var addedState = monitor.Module.stateController.addState(moduleId, state);
    var vm = BpcCommon.Api.getModuleInstanceComponent(monitorNewStatePanel.moduleId).getViewModel();
    vm.set('activeState', addedState.id);
    vm.set('activeStateDirty', false);
    this.up('window').close();
  } else {
    this.lookupViewModel().set('isFormValid', false);
  }
}}]});
Ext.define('monitor.view.state.StateSelectionMenu', {extend:'Ext.button.Button', alias:'widget.monitorStateSelectionMenu', stateSettingModel:undefined, showOnlyFavorites:false, iconCls:'x-fal fa-star', ui:'toolbar', moduleId:undefined, stateResetFn:Ext.emptyFn, showResetItem:true, menu:[], initComponent:function() {
  var me = this;
  me.stateSettingModel = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.viewStates, true);
  me.callParent(arguments);
  if (me.stateSettingModel) {
    me.updateComponent();
    me.stateSettingModel.on('changed', me.updateComponent.bind(me), me);
  } else {
    Ext.log({msg:this.self.getName() + ": initComponent - can't get view states from monitor " + me.moduleId, level:'error'});
    me.setText('Missing config');
  }
}, updateComponent:function() {
  var me = this;
  var statesArray = me.stateSettingModel.get('value') || [];
  me.getMenu().removeAll();
  statesArray.forEach(function(stateObj) {
    if (!BpcCommon.Api.isUserAllowedToSee(stateObj)) {
      return;
    }
    if (me.showOnlyFavorites === false || stateObj.favorite) {
      me.getMenu().add({xtype:'menucheckitem', group:'state', text:stateObj.name, state:stateObj, moduleId:me.moduleId, handler:me.onStateSelect});
    }
  });
  if (me.showResetItem) {
    me.getMenu().add([{xtype:'menuseparator'}, {iconCls:BpcCommon.Icons.ResetIcon, localized:{text:'MONITOR_RESET_VIEW'}, handler:Ext.Function.createSequence(me.stateResetFn.bind(me, me, me.moduleId), me.onStateReset.bind(me))}]);
  }
}, onStateSelect:function() {
  var selectionMenu = this.up('monitorStateSelectionMenu');
  var selectedState = this.state;
  selectedState.state = null;
  var widget = this.up('monitorDashboardWidget');
  widget.setMonitorState(null, this.moduleId, selectedState);
  selectionMenu.setIconCls('x-fas fa-star');
}, onStateReset:function() {
  var me = this;
  me.setIconCls('x-fal fa-star');
  me.updateComponent();
}});
Ext.define('monitor.view.state.StateToolbarItemController', {extend:'Ext.app.ViewController', alias:'controller.monitorStateToolbarItemController', requires:[], init:function() {
  try {
    var me = this;
    me.moduleId = me.getView().moduleId;
    me.stateModel = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.viewStates, true);
    me.stateStore = Ext.create('monitor.store.State', {data:me.stateModel.get('value') || []});
    me.stateModel.on('changed', me.updateViewList.bind(me), me);
    me.getViewModel().set('stateModel', me.stateModel);
    me.getViewModel().bind('{activeState}', me.updateViewList, me);
    me.stateModel.on('changed', function() {
      me.stateStore.setData(me.stateModel.get('value') || []);
    }, me);
    me.updateViewList();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initBind', dump:e, stack:true, level:'error'});
  }
}, updateViewList:function() {
  try {
    var me = this;
    var vm = me.getViewModel();
    var targetMenu = me.getView().getMenu();
    var activeGrid = vm.get('activeGrid');
    var currentStateDisplayName;
    var activeStateId;
    if (activeGrid) {
      activeStateId = activeGrid.lookupViewModel().get('activeState');
      if (activeStateId) {
        var activeState = me.stateStore.findRecord('id', activeStateId, 0, false, false, true);
        if (activeState) {
          vm.set('currentStateId', activeStateId);
          vm.set('currentState', activeState);
          if (activeState.get('iconCls')) {
            currentStateDisplayName = '\x3cspan class\x3d"' + activeState.get('iconCls') + '"\x3e\x3c/span\x3e' + (activeState.get('name') || '\x26nbsp;');
          } else {
            currentStateDisplayName = activeState.get('name');
          }
          vm.set('currentStateName', currentStateDisplayName || '');
        }
      }
    }
    var refItem = targetMenu.down('#filterListPlaceholder');
    if (me.stateStore.getCount() > 0) {
      var oldItems = me.getView().query('[viewFavorite\x3dtrue]');
      Ext.Array.each(oldItems, function(item) {
        targetMenu.remove(item, true);
      });
      refItem.hide();
      var insertIndex = targetMenu.items.indexOf(refItem) + 1;
      me.stateStore.each(function(state) {
        if (state.get('favorite')) {
          var stateObj = {text:state.get('name') || '\x26nbsp;', iconCls:state.get('iconCls'), tooltip:'\x3ci\x3e' + BpcCommon.Api.getTranslation('MONITOR_SAVED_VIEW') + '\x3c/i\x3e\x3cbr\x3e\n                                     \x3ci class\x3d"' + state.get('iconCls') + '"\x3e\x3c/i\x3e\x3cspan\x3e ' + state.get('name') + '\x3c/span\x3e', handler:monitor.Module.stateController.applyState.bind(monitor.Module.stateController, me.moduleId, state), stateId:state.get('id'), viewFavorite:true, pressed:activeStateId === 
          state.get('id')};
          targetMenu.insert(insertIndex, stateObj);
          insertIndex++;
        }
      }, this);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateViewList', dump:e, stack:true, level:'error'});
  }
}, saveCurrentStatePopup:function() {
  Ext.create({width:300, height:400, xtype:'bpcWindow', closable:true, header:true, modal:true, localized:{title:'MONITOR_SAVE_VIEW'}, items:[{xtype:'monitorNewStatePanel', moduleId:this.moduleId}]}).show();
}, openStateWindow:function() {
  Ext.create({xtype:'bpcWindow', header:true, modal:true, closable:true, localized:{title:'MONITOR_VIEWS'}, items:[{xtype:'monitorStateConfigurationPanel', moduleId:this.moduleId, viewContext:'window'}]}).show();
}, updateCurrentState:function() {
  try {
    var me = this;
    var vm = me.getViewModel();
    var state = monitor.Module.stateController.getCurrentState(this.moduleId);
    state.id = vm.get('currentState.id');
    state.favorite = vm.get('currentState.favorite');
    state.name = vm.get('currentState.name');
    state.iconCls = vm.get('currentState.iconCls');
    state.tooltip = vm.get('currentState.tooltip');
    monitor.Module.stateController.updateState(this.moduleId, state);
    me.clearActiveStateDirty();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateCurrentState', dump:e, stack:true, level:'error'});
  }
}, clearActiveStateDirty:function() {
  var me = this;
  var vm = me.getViewModel();
  var activeGrid = vm.get('activeGrid');
  activeGrid.lookupViewModel().initialState = undefined;
  vm.set('activeStateDirty', false);
}, removeAllFilter:function() {
  var me = this;
  try {
    me.getViewModel().get('activeGrid').getController().removeAllFilter();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR removeFilter', dump:e, stack:true, level:'error'});
  }
}, removeSorter:function() {
  var me = this;
  try {
    me.getViewModel().get('activeGrid').getController().removeSorter();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR removeSorter', dump:e, stack:true, level:'error'});
  }
}, resetState:function() {
  monitor.Module.stateController.resetState(this.moduleId);
}});
Ext.define('monitor.view.state.StateViewDetails', {extend:'Ext.Container', alias:['widget.monitorStateViewDetails'], moduleId:undefined, viewModel:true, initComponent:function() {
  var me = this;
  var columnConfig = BpcCommon.Api.getSetting(me.moduleId, monitor.assets.ConfigKeys.columnConfig);
  var monitorMain = BpcCommon.Api.getModuleInstanceComponent(me.moduleId);
  me.items = [{xtype:'fieldset', title:BpcCommon.Api.getTranslation('MONITOR_FILTER'), anchor:'100%', collapsible:true, layout:'fit', items:[{xtype:'gridpanel', itemId:'filterGrid', emptyText:BpcCommon.Api.getTranslation('MONITOR_NO_FILTER'), store:{model:'monitor.model.Filter', data:[]}, columns:[{text:BpcCommon.Api.getTranslation('MONITOR_COLUMN'), dataIndex:'property', flex:3, renderer:function(value) {
    return monitorMain.getColumnAttributeMatch('dataIndex', value, 'text');
  }}, {text:BpcCommon.Api.getTranslation('MONITOR_OPERATOR'), dataIndex:'operator', flex:1}, {text:BpcCommon.Api.getTranslation('MONITOR_VALUE'), dataIndex:'value', flex:2}, {xtype:'actioncolumn', menuDisabled:true, width:32, bind:{hidden:'{!' + monitor.assets.ModuleRights.editMonitorViews + '}'}, items:[{iconCls:'x-fal fa-trash', tooltip:BpcCommon.Api.getTranslation('MONITOR_DELETE'), handler:function(grid, rowIndex) {
    var rec = grid.getStore().getAt(rowIndex);
    grid.getStore().remove(rec);
  }}]}]}]}, {xtype:'fieldset', title:BpcCommon.Api.getTranslation('MONITOR_SORT'), anchor:'100%', collapsible:true, layout:'fit', items:[{xtype:'gridpanel', itemId:'sorterGrid', emptyText:BpcCommon.Api.getTranslation('MONITOR_NO_SORTING'), store:{model:'monitor.model.Sorter', data:[]}, plugins:{ptype:'cellediting', clicksToEdit:1}, columns:[{text:BpcCommon.Api.getTranslation('MONITOR_COLUMN'), dataIndex:'property', flex:3, renderer:function(value) {
    return monitorMain.getColumnAttributeMatch('dataIndex', value, 'text');
  }}, {text:BpcCommon.Api.getTranslation('MONITOR_DIRECTION'), dataIndex:'direction', width:130, editor:{xtype:'combo', queryMode:'local', displayField:'name', valueField:'id', store:{fields:['id', 'name'], data:[{'id':'ASC', 'name':BpcCommon.Api.getTranslation('MONITOR_ASCENDING')}, {'id':'DESC', 'name':BpcCommon.Api.getTranslation('MONITOR_DESCENDING')}]}}, renderer:function(value) {
    var newValue = String(value);
    if (newValue.toLowerCase() === 'asc') {
      newValue = BpcCommon.Api.getTranslation('MONITOR_ASCENDING');
    } else {
      if (newValue.toLowerCase() === 'desc') {
        newValue = BpcCommon.Api.getTranslation('MONITOR_DESCENDING');
      }
    }
    return newValue;
  }}, {xtype:'actioncolumn', menuDisabled:true, width:32, bind:{hidden:'{!' + monitor.assets.ModuleRights.editMonitorViews + '}'}, items:[{iconCls:'x-fal fa-trash', tooltip:'delete', handler:function(grid, rowIndex) {
    var rec = grid.getStore().getAt(rowIndex);
    grid.getStore().remove(rec);
  }}]}]}]}, {xtype:'fieldset', title:BpcCommon.Api.getTranslation('MONITOR_GROUPING'), anchor:'100%', collapsible:true, layout:{type:'vbox', align:'stretch'}, itemId:'groupingContainer', items:[{xtype:'checkbox', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_GROUPING_ENABLED'), itemId:'groupingCheck', bind:'{stateObject.groupingEnabled}', handler:'toggleGrouping'}, {xtype:'combo', fieldLabel:BpcCommon.Api.getTranslation('MONITOR_GROUPING'), displayField:'dataIndex', valueField:'dataIndex', store:columnConfig, 
  queryMode:'local', itemId:'groupingCombo', bind:{disabled:'{!isGrouped}', value:'{stateObject.groupField}'}}]}, {xtype:'fieldset', title:BpcCommon.Api.getTranslation('MONITOR_COLUMNS'), anchor:'100%', collapsible:true, layout:'fit', items:[{xtype:'gridpanel', itemId:'columnGrid', emptyText:BpcCommon.Api.getTranslation('MONITOR_NO_COLUMN_CONFIG'), plugins:{ptype:'cellediting', clicksToEdit:1}, store:{}, columns:[{xtype:'rownumberer', text:BpcCommon.Api.getTranslation('MONITOR_POSITION')}, {text:BpcCommon.Api.getTranslation('MONITOR_COLUMN_ID'), 
  dataIndex:'id', flex:1}, {text:BpcCommon.Api.getTranslation('MONITOR_WIDTH'), dataIndex:'width', editor:'numberfield', flex:2}, {text:BpcCommon.Api.getTranslation('MONITOR_HIDDEN'), xtype:'checkcolumn', dataIndex:'hidden', flex:2}, {xtype:'actioncolumn', menuDisabled:true, width:32, bind:{hidden:'{!' + monitor.assets.ModuleRights.editMonitorViews + '}'}, items:[{iconCls:'x-fal fa-trash', tooltip:'delete', handler:function(grid, rowIndex) {
    var rec = grid.getStore().getAt(rowIndex);
    grid.getStore().remove(rec);
  }}]}]}]}];
  me.callParent();
  var storeState = me.viewState.storeState;
  if (storeState && storeState.filters) {
    this.down('#filterGrid').store.setData(storeState.filters);
  }
  if (storeState && storeState.sorters) {
    this.down('#sorterGrid').store.setData(storeState.sorters);
  }
  if (me.viewState && me.viewState.columns) {
    this.down('#columnGrid').store.setData(me.viewState.columns);
  }
}});
Ext.define('monitor.view.tableviewconfiguration.ColumnTypeSelector', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.columnTypeSelector'], editable:true, displayField:'name', valueField:'name', queryMode:'local', viewModel:{data:{setting:null}}, listeners:{change:function(field) {
  var cellEditor = field.up('bpcCellEditor');
  if (cellEditor && cellEditor.isComponent) {
    cellEditor.valueChanged = true;
  }
}}, initComponent:function() {
  var me = this;
  var storeData = [{name:''}];
  var dataSourceFactoryNames = ['gridcolumn', 'datecolumn', 'bpcCheckColumn', 'booleancolumn', 'actioncolumn', 'attachmentcolumn', 'bpcModuleJumpColumn', 'monitorColumnHook'];
  if (dataSourceFactoryNames) {
    Ext.each(dataSourceFactoryNames, function(value) {
      storeData.push({name:value});
    });
  }
  me.store = {fields:['name'], data:storeData};
  me.callParent();
  me.getViewModel().set('setting', me.setting);
}});
Ext.define('monitor.view.tableviewconfiguration.CustomRendererSelector', {extend:'Ext.form.field.ComboBox', alias:['widget.bpcconfig.customRendererSelector'], editable:true, displayField:'name', valueField:'name', queryMode:'local', setting:undefined, listeners:{change:function(field) {
  var cellEditor = field.up('bpcCellEditor');
  if (cellEditor && cellEditor.isComponent) {
    cellEditor.valueChanged = true;
  }
}}, initComponent:function() {
  var moduleId = this.setting.get('moduleId');
  var customRenderers = [];
  var customRendererSetting = BpcCommon.Api.getSetting(moduleId, 'column_customRenderer');
  Ext.Object.each(customRendererSetting, function(key) {
    customRenderers.push({name:key});
  });
  this.store = {fields:['name'], data:customRenderers};
  this.callParent();
}});
Ext.define('monitor.view.tableviewconfiguration.TableViewConfigurationContainer', {extend:'Ext.Container', alias:'widget.monitorTableViewConfigurationContainer', layout:{type:'hbox', align:'stretch'}, localized:{title:'MONITOR_COLUMN_CONFIGURATOR'}, iconCls:monitor.assets.Icons.COLUMN_CONFIGURATOR, viewModel:true, initComponent:function() {
  var sheet = document.styleSheets[0];
  sheet.addRule('.column-config-grid .x-grid-item .column-config-hidden-row', 'background-color: rgb(230, 230, 230) !important; color: rgba(0, 0, 0, 0.87) !important');
  sheet.addRule('.column-config-grid .x-grid-cell-inner.x-grid-widgetcolumn-cell-inner', 'padding: 0px;');
  sheet.addRule('.column-config-grid .x-grid-item-focused .x-grid-cell-inner:before', 'border: 0px solid !important');
  sheet.addRule('.column-config-grid .x-grid-item-focused', 'background-color: unset !important');
  sheet.addRule('.column-config-grid .column-configurator-grid-row .x-grid-cell.x-grid-item-focused', 'color: inherit');
  var me = this;
  me.items = [{xtype:'grid', itemId:'monitorInstanceGrid', localized:{title:'MONITOR_MONITORS'}, style:{'margin-right':'10px'}, iconCls:monitor.assets.Icons.MONITOR, store:BpcCommon.Api.getModuleInstances('monitor'), columns:[{localized:{text:'CORE_NAME'}, flex:1, dataIndex:'instanceName'}, {text:'ID', flex:1, dataIndex:'moduleId'}, {xtype:'actioncolumn', width:32, align:'center', items:[{iconCls:BpcCommon.Icons.LINK, localized:{tooltip:'CORE_SHOW_MODULE'}, handler:function(grid, rowIndex, colIndex, 
  item, e, record) {
    try {
      var moduleId = record.get('moduleId');
      BpcCommon.Api.showModule(moduleId, true);
    } catch (e$14) {
      Ext.log({msg:': ERROR moduleJump handler', dump:e$14, stack:true, level:'error'});
    }
  }}]}], width:440, resizable:{handles:'e'}, listeners:{afterrender:function() {
    if (this.getStore().getData().items.length === 0) {
      var configPanel = me.down('#configPanel');
      configPanel.add({xtype:'bpcCenterMessageCmp', message:'CORE_NO_COMPONENT_AVAILABLE'});
    } else {
      this.setSelection(this.getSelection()[0]);
    }
  }, select:this.onSelect.bind(this)}}, {xtype:'panel', localized:{title:'MONITOR_COLUMN_CONFIGURATOR'}, controller:'monitorTableViewConfigurationPanelController', iconCls:monitor.assets.Icons.COLUMN_CONFIGURATOR, layout:'card', itemId:'configPanel', flex:1, items:[]}];
  me.callParent();
}, onSelect:function(grid, record) {
  var me = this;
  var target = me.down('#configPanel');
  var viewModel = me.getViewModel();
  if (!record.columnConfigurator) {
    Ext.suspendLayouts();
    var moduleId = record.get('moduleId');
    var columnConfigs = BpcCommon.Api.getSetting(moduleId, 'column_config');
    var item = columnConfigs && columnConfigs.length !== 0 ? {xtype:'tableViewConfigurator', moduleId:moduleId} : {xtype:'bpcCenterMessageCmp', message:'MONITOR_NO_INDEX_SET'};
    record.columnConfigurator = target.add(item);
    Ext.resumeLayouts(true);
  }
  target.setActiveItem(record.columnConfigurator);
  viewModel.set('activeInstanceId', record.getId());
}});
Ext.define('monitor.view.tableviewconfiguration.TableViewConfigurationPanelController', {extend:'Ext.app.ViewController', alias:'controller.monitorTableViewConfigurationPanelController', init:function() {
  var viewModel = this.getViewModel();
  viewModel.bind('{activeInstanceId}', this.selectInstance.bind(this));
}, selectInstance:function(activeInstanceId) {
  var instanceGrid = this.getView().up().down('#monitorInstanceGrid');
  if (instanceGrid) {
    instanceGrid.setSelection(instanceGrid.getStore().getById(activeInstanceId));
  }
}});
Ext.define('monitor.view.tableviewconfiguration.TableViewConfigurator', {extend:'Ext.grid.Panel', alias:'widget.tableViewConfigurator', controller:'tableViewConfiguratorController', initColumnConfigs:undefined, modified:false, bodyMargin:10, cls:'column-config-grid', viewConfig:{getRowClass:function(record) {
  var classes = 'column-configurator-grid-row';
  if (record.get('hidden')) {
    classes += ' column-config-hidden-row';
  }
  return classes;
}, plugins:{ptype:'gridviewdragdrop'}}, initComponent:function() {
  this.initColumnConfigs = this.getFullColumnConfigs();
  this.store = this.createStore(this.initColumnConfigs);
  this.columns = this.createColumns(this.initColumnConfigs);
  this.cellEditing = new Ext.grid.plugin.CellEditing({clicksToEdit:1});
  this.plugins = [this.cellEditing];
  this.listeners = {edit:function(grid, context) {
    context.record.set(context.field, context.value);
  }};
  this.buttons = [{text:BpcCommon.Api.getTranslation('MONITOR_ADD_ATTRIBUTE'), iconCls:BpcCommon.Icons.ADD, ui:'secondary', handler:'onAddAttribute'}, {text:BpcCommon.Api.getTranslation('MONITOR_ADD_COLUMN'), iconCls:BpcCommon.Icons.COLUMNS, ui:'secondary', handler:'onAddColumn'}, '-\x3e', {text:BpcCommon.Api.getTranslation('CORE_RESET'), iconCls:BpcCommon.Icons.RESET, ui:'secondary', handler:'onReset'}, {text:BpcCommon.Api.getTranslation('MONITOR_SAVE'), iconCls:BpcCommon.Icons.SAVE, handler:'onSave'}];
  this.callParent();
}, createColumns:function(configs) {
  var baseConfigs = this.getBaseConfigObject(configs);
  var columns = [this.getFirstColumn()];
  Ext.Object.each(baseConfigs, function(key, value) {
    if (key === 'name') {
      return;
    }
    var type = 'text';
    switch(typeof value) {
      case 'object':
        type = 'json';
        break;
      case 'string':
        type = 'text';
        break;
      case 'number':
        type = 'number';
        break;
      case 'boolean':
        type = 'boolean';
        break;
    }
    switch(key) {
      case 'headerIconCls':
        type = 'icon';
        break;
      case 'xtype':
        type = 'columnTypeSelector';
        break;
      case 'customRenderer':
        type = 'customRendererSelector';
        break;
    }
    var column = {xtype:'bpcSettingColumn', text:key, dataIndex:key, type:type, hidden:key === 'localized' ? true : false, flex:1, minWidth:180, sortable:false, lockable:false, codeEditorTitle:key, renderer:function(value, metaData, record) {
      var settingClass = Ext.ClassManager.getByAlias('widget.bpcconfig.' + type);
      if (settingClass && settingClass.prototype.renderer) {
        return settingClass.prototype.renderer.apply(this, arguments);
      }
      record.renderer = false;
      return Ext.util.Format.htmlEncode2(value);
    }};
    columns.push(column);
  });
  return columns;
}, createStore:function(configs) {
  var me = this;
  var columnConfigs = Ext.clone(configs);
  var storeData = columnConfigs.map(function(item) {
    var baseConfigs = me.getBaseConfigObject(configs);
    var mergedConfigs = Ext.apply({}, item, baseConfigs);
    var columnName = item.localized && item.localized.text ? BpcCommon.Api.getTranslation(item.localized.text) : item.text;
    if (!item.text && item.localized && item.localized.text) {
      mergedConfigs.text = item.localized.text;
    }
    mergedConfigs.columnName = columnName;
    mergedConfigs.moduleId = me.moduleId;
    return mergedConfigs;
  });
  return Ext.create('Ext.data.Store', {data:storeData, model:'BpcCommon.component.data.ObservableModel', proxy:'memory', listeners:{update:function(store, record, operation, modifiedFieldNames) {
    if (modifiedFieldNames && modifiedFieldNames.includes('text')) {
      record.set('columnName', BpcCommon.Api.getTranslation(record.get('text')), {dirty:false});
    }
    if (modifiedFieldNames && modifiedFieldNames.includes('localized') && record.get('localized').text) {
      record.set('columnName', BpcCommon.Api.getTranslation(record.get('localized').text), {dirty:false});
    }
    if (modifiedFieldNames && modifiedFieldNames.includes('hidden')) {
      var hidden = record.get('hidden');
      var recordIndex = me.store.getData().indexOf(record);
      me.el.dom.querySelectorAll('[data-recordindex\x3d"' + recordIndex + '"] .x-grid-row').forEach(function(item) {
        if (hidden) {
          item.classList.add('column-config-hidden-row');
        } else {
          item.classList.remove('column-config-hidden-row');
        }
      });
    }
    me.modified = true;
  }}});
}, getBaseConfigObject:function(configs) {
  var clonedConfigs = Ext.clone(configs);
  var baseColumnConfig = clonedConfigs.reduce(function(accumulator, currentValue) {
    return Ext.apply(accumulator, currentValue);
  });
  Ext.Object.each(baseColumnConfig, function(key, value) {
    if (Ext.isString(value)) {
      baseColumnConfig[key] = '';
    } else {
      if (Ext.isObject(value)) {
        baseColumnConfig[key] = {};
      } else {
        if (Ext.isBoolean(value)) {
          baseColumnConfig[key] = !value;
        } else {
          if (Ext.isNumber(value)) {
            baseColumnConfig[key] = 0;
          }
        }
      }
    }
  });
  baseColumnConfig.minWidth = 64;
  baseColumnConfig.width = 200;
  baseColumnConfig.hidden = true;
  baseColumnConfig.hideable = true;
  return baseColumnConfig;
}, getFirstColumn:function() {
  return {xtype:'templatecolumn', text:BpcCommon.Api.getTranslation('MONITOR_COLUMN_HEADER_PREVIEW') + '\n                  \x26nbsp\x3ci data-qtip\x3d"' + BpcCommon.Api.getTranslation('MONITOR_HEADER_PREVIEW') + '" class\x3d"fal fa-info-circle"\x3e\x3c/i\x3e', dataIndex:'columnName', locked:true, width:200, draggable:false, menuDisabled:true, sortable:false, tpl:Ext.create('Ext.XTemplate', '\x3cspan role\x3d"iconEl" class\x3d"{headerIconCls}"\x3e\x3c/span\x3e', '\x3cspan role\x3d"textEl" \x3e\x26nbsp{columnName}\x3c/span\x3e')};
}, getFullColumnConfigs:function() {
  var columnConfigs = BpcCommon.Api.getSetting(this.moduleId, 'column_config');
  var columnList = BpcCommon.Api.getSetting(this.moduleId, 'column_list');
  Ext.Object.each(columnList, function(key) {
    var isNewColumn = columnConfigs.filter(function(columnConfig) {
      return columnConfig.dataIndex === key;
    }).length === 0;
    if (isNewColumn) {
      var newColumnConfig = {dataIndex:key, hidden:true, text:key, xtype:'gridcolumn'};
      columnConfigs.push(newColumnConfig);
    }
  });
  return columnConfigs;
}});
Ext.define('monitor.view.tableviewconfiguration.TableViewConfiguratorController', {extend:'Ext.app.ViewController', alias:'controller.tableViewConfiguratorController', onAddColumn:function() {
  var grid = this.getView();
  var store = grid.getStore();
  var storeData = store.getData().items.map(function(record) {
    var clonedData = Ext.clone(record.data);
    delete clonedData.id;
    return clonedData;
  });
  store.add(grid.getBaseConfigObject(storeData));
  this.getView().modified = true;
}, addNewAttribute:function(key, type) {
  var grid = this.getView();
  var store = grid.getStore();
  var value;
  switch(type) {
    case 'json':
      value = {};
      break;
    case 'text':
      value = '';
      break;
    case 'number':
      value = 0;
      break;
    case 'boolean':
      value = false;
      break;
  }
  var columnConfigs = grid.initColumnConfigs.map(function(item) {
    var $jscomp$compprop0 = {};
    return Ext.apply({}, item, ($jscomp$compprop0[key] = value, $jscomp$compprop0));
  });
  store.each(function(record) {
    record.set(key, value);
  });
  Ext.suspendLayouts();
  grid.setColumns(grid.createColumns(columnConfigs));
  Ext.resumeLayouts(true);
  this.getView().modified = true;
}, onSave:function() {
  var configuratorView = this.getView();
  var store = configuratorView.getStore();
  var moduleId = configuratorView.moduleId;
  if (configuratorView.modified) {
    var toSaveConfigs = store.getData().items.map(function(record) {
      var toSaveConfig = Ext.clone(record.data);
      delete toSaveConfig.id;
      delete toSaveConfig.columnName;
      return toSaveConfig;
    });
    var unlockFn = BpcCommon.Util.blockComponentForAsyncAction('onSave', undefined, BpcCommon.Api.getTranslation('CORE_PLEASE_WAIT'), '^ bpcConfigModule \x3e monitorTableViewConfigurationContainer');
    var configSettingModel = BpcCommon.Api.getSetting(moduleId, 'column_config', true);
    configSettingModel.set('value', toSaveConfigs);
    monitor.Module.stateController.resetState(moduleId);
    store.save();
    configSettingModel.save({callback:unlockFn});
    configuratorView.modified = false;
  }
}, onReset:function() {
  var configuratorView = this.getView();
  var moduleId = configuratorView.moduleId;
  var initConfigs = BpcCommon.Api.getSetting(moduleId, 'column_config');
  configuratorView.setStore(configuratorView.createStore(initConfigs));
  var columns = configuratorView.createColumns(initConfigs);
  Ext.suspendLayouts();
  configuratorView.setColumns(columns);
  Ext.resumeLayouts(true);
  configuratorView.modified = false;
}, onAddAttribute:function() {
  var me = this;
  Ext.create('Ext.window.Window', {title:BpcCommon.Api.getTranslation('MONITOR_ADD_ATTRIBUTE'), modal:true, height:200, width:350, padding:10, items:{xtype:'form', items:[{xtype:'textfield', fieldLabel:'Name', name:'key'}, {xtype:'combobox', name:'type', fieldLabel:'Type', queryMode:'local', store:{data:[{name:'json'}, {name:'text'}, {name:'boolean'}, {name:'number'}]}, displayField:'name'}]}, buttons:[{text:BpcCommon.Api.getTranslation('MONITOR_CANCEL'), iconCls:BpcCommon.Icons.CANCEL, ui:'secondary', 
  handler:function() {
    this.up('window').close();
  }}, {text:BpcCommon.Api.getTranslation('MONITOR_OK'), iconCls:BpcCommon.Icons.OK, ui:'primary', handler:function() {
    var formValues = this.up('window').down('form').getValues();
    me.addNewAttribute(formValues.key, formValues.type);
    this.up('window').close();
  }}]}).show();
}});
Ext.define('monitor.view.toolbar.LeftToolbar', {extend:'Ext.toolbar.Toolbar', alias:'widget.monitorLeftToolbar', initComponent:function() {
  this.items = [{xtype:'tbspacer', width:10}, {xtype:'monitorSearchField', hidden:true, bind:{hidden:'{setting.' + monitor.assets.ConfigKeys.showToolbarRightInHeader + '}'}}, {xtype:'bpcMonitorLeftToolbarHook', context:{moduleId:'monitor', instanceId:this.moduleInstance.moduleId}}];
  this.callParent();
}});
Ext.define('monitor.view.toolbar.ModuleHeaderToolbar', {extend:'Ext.toolbar.Toolbar', alias:'widget.monitorModuleHeaderToolbar', initComponent:function() {
  var me = this;
  me.items = [{xtype:'monitorSearchField', moduleId:me.moduleId}, {xtype:'monitorMultiAttachmentDownloadBtn', moduleId:me.moduleId}, {xtype:'monitorStartProcessBtn', moduleId:me.moduleId}, {xtype:'monitorChangeStateBtn', moduleId:me.moduleId}, {xtype:'monitorProcessActionBtn', moduleId:me.moduleId}, {xtype:'monitorExportBtn', moduleId:me.moduleId}, {xtype:'monitorStateToolbarItem', moduleId:me.moduleId}, {xtype:'monitorRefreshBtn', moduleId:me.moduleId}];
  me.callParent(arguments);
}});
Ext.define('monitor.view.toolbar.PluginHookLeft', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcMonitorLeftToolbarHook', layout:{type:'hbox', align:'middle'}, inheritableStatics:{NAME:'Monitor Toolbar links', HOOK_ID:'monitor_toolbar_left', HOOK_LEVEL:'instance'}});
Ext.define('monitor.view.toolbar.PluginHookRight', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcMonitorRightToolbarHook', layout:{type:'hbox', align:'middle'}, inheritableStatics:{NAME:'Monitor Toolbar rechts', HOOK_ID:'monitor_toolbar_right', HOOK_LEVEL:'instance'}});
Ext.define('monitor.widget.abstract.MonitorViewMixin', {mixinId:'bpcMonitorWidget', getSetting:function(key) {
  var parent = this.up('[isBpcWidget\x3dtrue]');
  this.getSetting = parent.getSetting.bind(parent);
  return this.getSetting(key);
}, getSettingFromModuleInstance:function(key) {
  var parent = this.up('[isBpcWidget\x3dtrue]');
  this.getSettingFromModuleInstance = parent.getSettingFromModuleInstance.bind(parent);
  return this.getSettingFromModuleInstance(key);
}, getQueryId:function() {
  var userSession = BpcCommon.Api.getUserSession();
  var sessionId = userSession.get('loginName') + userSession.get('expirationDate').getTime();
  return this.widgetId + ':::' + this.bpcGridViewName + ':::' + sessionId;
}});
Ext.define('monitor.widget.processOverviewAll.view.singleTab', {extend:'Ext.tab.Panel', alias:'widget.monitorWidgetCircleTab', controller:'monitorSingleTabController', mixins:['monitor.widget.abstract.MonitorViewMixin'], activeTab:0, items:[{xtype:'box', style:'display: flex;justify-content: center;align-items: center;', localized:{title:'CORE_LOADING', html:{tpl:'\x3ci class\x3d"fal fa-spinner fa-spin fa-5x fa-fw"\x3e\x3c/i\x3e\x3cbr\x3e\x3cspan\x3e{CORE_LOADING}\x3c/span\x3e', keys:['CORE_LOADING']}}}], 
moduleId:undefined, viewObj:undefined, bpcGridViewName:null, initComponent:function() {
  var me = this;
  me.creationTimeStamp = (new Date).getTime();
  if (me.viewObj && me.viewObj.id) {
    me.bpcGridViewName = me.viewObj.id;
  } else {
  }
  me.callParent();
  me.widgetMain = me.up('monitorWidgetColAgg');
  me.initWidget();
}, initWidget:function() {
  var me = this;
  try {
    var suffix = 'analyzed';
    this.widgetOverviewColumn = this.widgetMain.columnConfig.dataIndex;
    var url = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + this.moduleId + '/distinctFieldValues/' + this.widgetOverviewColumn;
    var excludedValuesStr = this.up('monitorWidgetColAgg').getSetting('excludedValues') || '';
    var excludedValuesArr = excludedValuesStr.split(',').map(Ext.String.trim);
    var colConfig = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnConfig);
    if (!colConfig) {
      this.removeAll();
      this.add({xtype:'bpcCenterMessageCmp', message:'CORE_ERROR_MISSING_RIGHT', messageIconCls:'x-fal fa-lock', localized:{title:'CORE_ERROR'}});
      return;
    }
    var column = this.widgetMain.columnConfig;
    if (column && column.filter && column.filter.source) {
      suffix = column.filter.source;
    }
    var globalCalendarValue = BpcCommon.Api.getGlobalViewModel().get('global.dateRange').value;
    this.store = Ext.create('Ext.data.Store', {filters:[{property:'value', value:excludedValuesArr, operator:'notin'}], fields:[{name:'value'}, {name:'count'}], proxy:{type:'ajax', url:url, extraParams:{size:this.getSetting(monitor.assets.ConfigKeys.aggregationLimit), view:this.bpcGridViewName, queryId:this.getQueryId(), source:suffix, startDate:globalCalendarValue.start || this.getSetting('startDate'), endDate:globalCalendarValue.end || this.getSetting('endDate'), timeseriesColumn:this.getSetting('timeseriesColumn'), 
    timezoneOffset:'+0' + (new Date).getTimezoneOffset() / 60 * -1 + ':00', timezoneName:BpcCommon.Util.getTimezoneName()}, reader:{rootProperty:'values', type:'json'}}});
    this.store.load({failure:function(records, operation) {
      var widget = me.up('monitorWidgetColAgg');
      var error = BpcCommon.Util.getErrorFromFailureResponse(operation);
      widget.removeAll();
      widget.add({xtype:'bpcCenterMessageCmp', message:error.message, messageIconCls:BpcCommon.Icons.ERROR, localized:{title:'CORE_ERROR'}});
    }});
    var targetView = this.up('monitorWidgetColAgg');
    if (targetView) {
      var targetController = targetView.getController();
      if (targetController) {
        this.store.on('load', targetController.updateOverViewData.bind(targetController, this));
      }
    }
    this.store.on('load', this.updateChartData, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initWidget', dump:e, stack:true, level:'error'});
  }
}, refreshWidget:function(options) {
  try {
    var globalCalendarValue = BpcCommon.Api.getGlobalViewModel().get('global.dateRange').value;
    var params = {};
    params.startDate = globalCalendarValue.start;
    params.endDate = globalCalendarValue.end;
    params.size = this.up('monitorWidgetColAgg').getSetting(monitor.assets.ConfigKeys.aggregationLimit);
    params = Ext.apply(params, options, params);
    this.store.load({params:params});
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshWidget', dump:e, stack:true, level:'error'});
  }
}, updateChartData:function() {
  try {
    if (!this.chart) {
      this.initOverview();
    } else {
      this.chart.updateData(this.prepareChartData());
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateChartData', dump:e, stack:true, level:'error'});
  }
}, prepareChartData:function() {
  var me = this;
  var data = [];
  try {
    me.store.each(function(record) {
      var customRendererPlugin = me.widgetMain.findPlugin('monitorCustomRenderer');
      var valueRendererConfig = customRendererPlugin.getValueConfig(me.widgetMain.columnRendererId, record.get('value'));
      var value = {original:record.get('value'), value:customRendererPlugin.render(me.widgetMain.columnRendererId, record.get('value'), false, true), count:record.get('count')};
      var hiddenGraphsStr = me.getSetting('hiddenGraphs') || '';
      var hiddenGraphsArr = hiddenGraphsStr.split(',').map(Ext.String.trim);
      var hidden = false;
      if (hiddenGraphsArr.length > 0) {
        if (Ext.Array.contains(hiddenGraphsArr, value.original)) {
          Ext.log('disable slice for : ' + value.original);
          hidden = true;
        }
      }
      value.hidden = hidden;
      if (valueRendererConfig.color) {
        value.color = valueRendererConfig.color;
      }
      data.push(value);
    }, this);
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR prepareChartData', dump:e, stack:true, level:'error'});
  }
  return data;
}, initOverview:function() {
  try {
    var me = this;
    this.removeAll();
    var viewMode = this.getSetting('viewMode') ? this.getSetting('viewMode') : '';
    var chartConfig = {xtype:'monitorWidgetColAggChart', flex:1, config:{data:this.prepareChartData(), moduleId:this.moduleId, viewObj:this.viewObj}};
    var tableConfig = {xtype:'monitorWidgetColAggGrid', store:this.store, header:false, region:'south', config:{viewObj:this.viewObj, moduleId:this.moduleId}, moduleId:this.moduleId, widgetOverviewColumn:me.widgetOverviewColumn};
    var wrapperChartGridConfig = {xtype:'panel', header:false, tabConfig:{hidden:true}, layout:{type:'vbox', align:'stretch'}, resizeable:true};
    if (Ext.String.startsWith(viewMode, 'stacked')) {
      var panel = this.add(wrapperChartGridConfig);
      this.chart = panel.add(chartConfig);
      this.dataView = panel.add(tableConfig);
    } else {
      if (Ext.String.startsWith(viewMode, 'chartOnly')) {
        var panel$15 = this.add(wrapperChartGridConfig);
        this.chart = panel$15.add(chartConfig);
      } else {
        if (Ext.String.startsWith(viewMode, 'tableOnly')) {
          var panel$16 = this.add(wrapperChartGridConfig);
          this.chart = panel$16.add(tableConfig);
        } else {
          this.chart = this.add(chartConfig);
          this.dataView = this.add(tableConfig);
          var activeTab = this.chart;
          var initViewStr = this.getSetting('initialView') || '';
          var initViewArr = initViewStr.split(':');
          if (initViewStr.length > 0) {
            var view = initViewArr[0];
            var chartGrid = initViewArr[1] || 'chart';
            if (this.viewObj && this.viewObj.id === view && chartGrid === 'chart') {
              activeTab = this.chart;
            } else {
              if (!this.viewObj && chartGrid === 'chart') {
                activeTab = this.chart;
              } else {
                activeTab = this.dataView;
              }
            }
          }
          this.setActiveTab(activeTab);
        }
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initOverview', dump:e, stack:true, level:'error'});
  }
}, getSetting:function(key) {
  var target = this.up('monitorWidgetColAgg');
  this.getSetting = this.up('monitorWidgetColAgg').getSetting.bind(target);
  return this.getSetting(key);
}});
Ext.define('monitor.widget.processOverviewAll.view.singleTabController', {extend:'Ext.app.ViewController', alias:'controller.monitorSingleTabController', moduleId:undefined, control:{'monitorWidgetCircleTab':{show:'onViewChange'}}, listen:{global:{dataLoaded:'onDataLoaded', moduleShow:'onViewChange'}}, init:function() {
  var bufferInSeconds = this.getView().getSetting('dataRefreshBuffer');
  this.refreshDataBuffered = Ext.Function.createThrottled(this.refreshData, bufferInSeconds * 1000);
}, refreshDataBuffered:function() {
  this.refreshData();
}, onDataLoaded:function(dataObj) {
  try {
    var queryId = this.getView().getQueryId();
    if (dataObj.properties.componentId && dataObj.properties.componentId === 'monitor_distinct' && dataObj.properties.customId && dataObj.properties.customId === queryId) {
      this.refreshDataBuffered();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onDataLoaded', dump:e, stack:true, level:'error'});
  }
}, refreshData:function(force) {
  var forceRefresh = force || false;
  var view = this.getView();
  var overview = view.up('monitorWidgetColAgg').down('monitorWidgetColAggOverview');
  if (overview && overview.isVisible(true)) {
    forceRefresh = true;
  }
  if (!forceRefresh && !view.isVisible(true)) {
    this.refreshDataOnView = true;
    return;
  }
  this.getView().refreshWidget();
}, onViewChange:function() {
  try {
    var view = this.getView();
    if (view.isVisible(true)) {
      if (this.refreshDataOnView) {
        this.refreshDataOnView = false;
        this.refreshData(true);
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onViewChange', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.widget.processOverviewAll.view.tabs.Chart', {extend:'Ext.Component', alias:'widget.monitorWidgetColAggChart', title:'Charts', layout:'fit', initComponent:function() {
  try {
    this.data = this.config.data;
    var moduleId = this.config.moduleId;
    var viewObj = this.config.viewObj;
    var viewId = viewObj ? viewObj.id : 'mainGrid';
    var dynamicConfig = this.up('monitorWidgetColAgg').getSetting('chartConfiguration');
    var pieType;
    if (this.up('monitorWidgetColAgg').getSetting('3d')) {
      pieType = true;
    }
    this.on('boxready', function(cmp) {
      try {
        var hardConfig = {'type':'pie', 'dataProvider':this.data, 'valueField':'count', 'titleField':'value', 'colorField':'color'};
        var pieConfig = Ext.Object.merge(hardConfig, dynamicConfig);
        if (pieType === true) {
          pieConfig.depth3D = 15;
          pieConfig.angle = 30;
        }
        this.chart = AmCharts.makeChart(cmp.getId(), pieConfig);
        this.chart.addListener('clickSlice', function(event) {
          try {
            var value = event.dataItem.dataContext.original;
            var statusField = this.up('monitorWidgetColAgg').getSetting(monitor.assets.ConfigKeys.columnStatus) || 'STATUS';
            var filters = [{operator:'in', property:statusField, value:[value]}];
            BpcCommon.Api.showModule(moduleId, false, {storeState:{filters:filters}, viewId:viewId});
          } catch (e) {
            Ext.log({msg:': ERROR clickSlice ', dump:e, stack:true, level:'error'});
          }
        }, this);
        this.chart.validateNow();
      } catch (e) {
        Ext.log({msg:': ERROR afterrender', dump:e, stack:true, level:'error'});
      }
    }, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  this.callParent();
}, updateData:function(chartData) {
  try {
    if (this.chart) {
      this.chart.dataProvider = chartData;
      this.chart.validateData();
    } else {
      this.data = chartData;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateData', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.widget.processOverviewAll.view.tabs.Grid', {extend:'Ext.grid.Panel', alias:'widget.monitorWidgetColAggGrid', features:[], forceFit:true, moduleId:undefined, widgetOverviewColumn:undefined, listeners:{cellclick:function(tableView, td, cellIndex, record) {
  try {
    var moduleId = tableView.up('monitorWidgetColAggGrid').moduleId;
    var widgetOverviewColumn = tableView.up('monitorWidgetColAggGrid').widgetOverviewColumn;
    var filters = [{operator:'in', property:widgetOverviewColumn, value:[record.get('value')]}];
    BpcCommon.Api.showModule(moduleId, false, {storeState:{filters:filters}});
  } catch (e) {
    Ext.log({msg:'Fehler beim Sprung zum Monitor - cellClick', dump:e, stack:true, level:'error'});
    BpcCommon.Api.showNotification('Fehler beim Sprung zum Monitor');
  }
}}, initComponent:function() {
  var me = this;
  var pluginMain = me.up('monitorWidgetColAgg');
  try {
    me.title = BpcCommon.Api.getTranslation('MONITOR_DATA');
    me.columns = [{text:BpcCommon.Api.getTranslation('MONITOR_NAME'), dataIndex:'value', flex:2, summaryType:'sum', renderer:me.up('monitorWidgetColAgg').columnRenderer, summaryRenderer:function() {
      return '\x3cb\x3eGesamt\x3c/b\x3e';
    }}, {text:BpcCommon.Api.getTranslation('MONITOR_COUNT'), dataIndex:'count', flex:1, summaryType:'sum', summaryRenderer:function(value) {
      return '\x3cb\x3e' + value + '\x3c/b\x3e';
    }}];
    me.features = [{ftype:'summary', dock:pluginMain.getSetting('dockSummary')}];
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  me.callParent(arguments);
}});
Ext.define('monitor.widget.processOverviewAll.view.tabs.Overview', {extend:'Ext.grid.Panel', alias:'widget.monitorWidgetColAggOverview', localized:{title:'MONITOR_OVERVIEW', emptyText:'MONITOR_LOADING_DATA'}, forceFit:true, autoScroll:true, storeId:undefined, moduleId:undefined, isSingle:undefined, initComponent:function() {
  var me = this;
  try {
    var pluginMain = me.up('monitorWidgetColAgg');
    this.store = Ext.create('Ext.data.Store', {fields:[], storeId:this.storeId, data:[], listeners:{datachanged:function(store) {
      try {
        var customRenderer = pluginMain.findPlugin('monitorCustomRenderer');
        var storeCollection = store.getData();
        var targetColumnValues = [];
        storeCollection.each(function(item) {
          var viewObj = item.getData();
          delete viewObj.id;
          delete viewObj.view;
          targetColumnValues = targetColumnValues.concat(Object.keys(viewObj));
        });
        var cellAlign = me.up('monitorWidgetColAgg').getSetting(monitor.assets.ConfigKeys.cellAlign) || 'center';
        targetColumnValues = Ext.Array.unique(targetColumnValues);
        var columns = [{dataIndex:'view', text:BpcCommon.Api.getTranslation('MONITOR_VIEW'), align:cellAlign, hidden:me.isSingle ? me.isSingle : false, minWidth:90}];
        Ext.Array.each(targetColumnValues, function(targetColumnValue) {
          var valueRendererConfig = customRenderer.getValueConfig(pluginMain.columnRendererId, targetColumnValue);
          var columnHeaderText = pluginMain.columnRenderer(targetColumnValue) ? pluginMain.columnRenderer(targetColumnValue) : targetColumnValue;
          columns.push({minWidth:60, dataIndex:targetColumnValue, text:columnHeaderText, align:cellAlign, renderer:function(value, metaData) {
            try {
              metaData.tdStyle = 'border: 1px solid ' + valueRendererConfig.color + ';';
              if (me.up('monitorWidgetColAgg').getSetting(monitor.assets.ConfigKeys.hideZeroValues) && value === 0) {
                return '';
              }
              return value;
            } catch (e) {
              Ext.log({msg:': ERROR renderer', dump:e, stack:true, level:'error'});
            }
          }});
        });
        me.reconfigure(columns);
      } catch (e) {
        Ext.log({msg:': ERROR datachanged', dump:e, stack:true, level:'error'});
      }
    }}});
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  this.callParent(arguments);
}});
Ext.define('monitor.widget.timeseriesAggregation.monitorView', {extend:'Ext.tab.Panel', alias:'widget.monitorTimeseriesAggregationMonitorView', mixins:['monitor.widget.abstract.MonitorViewMixin'], controller:'monitorViewController', activeTab:0, title:false, moduleId:undefined, viewObj:undefined, multi:undefined, widgetId:undefined, bpcGridViewName:null, items:[{xtype:'box', style:'display: flex;justify-content: center;align-items: center;', localized:{html:{tpl:'\x3ci class\x3d"fal fa-spinner fa-spin fa-5x fa-fw"\x3e\x3c/i\x3e\x3cbr\x3e\x3cspan\x3e{CORE_LOADING}\x3c/span\x3e', 
keys:['CORE_LOADING']}}}], initComponent:function() {
  var me = this;
  try {
    me.creationTimeStamp = (new Date).getTime();
    if (Ext.isDefined(me.viewObj) && Ext.isObject(me.viewObj) && me.viewObj.id) {
      me.bpcGridViewName = me.viewObj.id;
    } else {
    }
    me.callParent(arguments);
    me.widgetMain = me.up('monitorWidgetTsAgg');
    me.initWidget();
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, initWidget:function() {
  this.loadData(this.initChart);
}, createParams:function(options) {
  var globalCalendarValue = BpcCommon.Api.getGlobalViewModel().get('global.dateRange').value;
  try {
    var presetParams = Ext.isObject(options) ? options : {};
    var interval = this.getSetting('interval') || 'day';
    var startDate = presetParams.startDate || globalCalendarValue.start || this.getSetting('startDate') || 'now-7d/d';
    var endDate = presetParams.endDate || globalCalendarValue.end || this.getSetting('endDate') || 'now';
    var groupedField = this.widgetMain.columnConfig.dataIndex, filterSuffix = null;
    if (this.widgetMain.columnConfig.filter && this.widgetMain.columnConfig.filter.source) {
      filterSuffix = this.widgetMain.columnConfig.filter.source;
    }
    if (filterSuffix && filterSuffix !== 'analyzed') {
      groupedField = groupedField + '.' + filterSuffix;
    }
    return {field:groupedField, interval:interval, startDate:startDate, endDate:endDate, timezoneOffset:'+0' + (new Date).getTimezoneOffset() / 60 * -1 + ':00', view:this.bpcGridViewName, queryId:this.getQueryId(), timezoneName:BpcCommon.Util.getTimezoneName(), timeseriesColumn:this.getSetting('timeseriesColumn'), showPreviousData:this.getSetting('showPreviousData'), showFollowingData:this.getSetting('showFollowingData')};
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createParams', dump:e, stack:true, level:'error'});
  }
}, loadData:function(callback, options) {
  var me = this;
  var url = BpcCommon.Api.getBackendUrl('monitor') + '/monitor/tsAggregation/';
  url += this.moduleId;
  var excludedValuesStr = this.getSetting('excludedValues') || '';
  var excludedValuesArr = [];
  if (excludedValuesStr) {
    excludedValuesArr = excludedValuesStr.split(',').map(Ext.String.trim);
  }
  Ext.Ajax.request({url:url, method:'GET', params:this.createParams(options), scope:this, success:function(response) {
    var responseJson = Ext.JSON.decode(response.responseText);
    var responseData = {};
    var processedData = [];
    if (Ext.isArray(excludedValuesArr) && excludedValuesArr.length > 0) {
      Ext.Array.each(responseJson.fields, function(item) {
        if (Ext.Array.contains(excludedValuesArr, item.name)) {
        } else {
          processedData.push(item);
        }
      });
    } else {
      processedData = responseJson.fields;
    }
    responseData.data = responseJson.data;
    responseData.fields = processedData;
    if (callback) {
      callback.call(this, responseData);
    }
  }, failure:function(response) {
    Ext.log({msg:'server-side failure with status code ' + response.status, level:'error'});
    if (response.status === 403) {
      this.removeAll();
      this.add({xtype:'bpcCenterMessageCmp', message:'CORE_ERROR_MISSING_RIGHT', messageIconCls:'x-fal fa-lock', localized:{title:'CORE_ERROR'}});
    }
    var error = BpcCommon.Util.getErrorFromFailureResponse(response);
    this.removeAll();
    this.add({xtype:'bpcCenterMessageCmp', message:error.message, messageIconCls:BpcCommon.Icons.ERROR, localized:{title:'CORE_ERROR'}});
  }});
}, refreshWidget:function(options) {
  this.loadData(this.updateItems, options);
}, updateItems:function(dataObj) {
  try {
    var chart = this.down('monitorWidgetTsAggChart');
    chart.updateData(dataObj.data, this.getGraphConfig(dataObj));
    var grid = this.down('monitorWidgetTsAggGrid');
    grid.updateData(dataObj);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateItems', dump:e, stack:true, level:'error'});
  }
}, getGraphConfig:function(dataObj) {
  var me = this;
  var customRendererPlugin = me.up('monitorWidgetTsAgg').findPlugin('monitorCustomRenderer');
  var graphConfig = [];
  try {
    var fields = dataObj.fields;
    if (!me.hiddenGraphs) {
      var hiddenGraphsStr = me.getSetting('hiddenGraphs') || '';
      me.hiddenGraphs = hiddenGraphsStr.split(',').map(Ext.String.trim);
    }
    Ext.Array.each(fields, function(field) {
      var valueConfig = customRendererPlugin.getValueConfig(customRendererPlugin.getRendererIdByColumnConfig(me.widgetMain.columnConfig), field.name);
      var hidden = false;
      if (me.hiddenGraphs.length > 0) {
        if (Ext.Array.contains(me.hiddenGraphs, field.name)) {
          hidden = true;
        }
      }
      var graphType = me.getSetting('graphType');
      var graph = {};
      if (graphType === 'line') {
        graph = {type:'line', valueField:field.name, title:valueConfig.label || field.name, fillColors:valueConfig.color, balloonText:'\x3cb\x3e[[title]]\x3c/b\x3e\x3cbr\x3e[[category]]: \x3cb\x3e[[value]]\x3c/b\x3e', lineThickness:2, fillAlphas:0, markerType:'circle', hidden:hidden};
      } else {
        graph = {type:'column', valueField:field.name, title:valueConfig.label || field.name, fillColors:valueConfig.color, balloonText:'\x3cb\x3e[[title]]\x3c/b\x3e\x3cbr\x3e[[category]]: \x3cb\x3e[[value]]\x3c/b\x3e', lineThickness:0, fillAlphas:1, markerType:'circle', hidden:hidden};
      }
      graphConfig.push(graph);
    });
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR getGraphConfig', dump:e, stack:true, level:'error'});
  }
  return graphConfig;
}, initChart:function(dataObj) {
  try {
    this.removeAll();
    var graphConfig = this.getGraphConfig(dataObj);
    var contentItems = [];
    var viewMode = this.getSetting('viewMode') || '';
    if (Ext.String.startsWith(viewMode, 'stacked')) {
      var items = [];
      if (Ext.String.endsWith(viewMode, 'chartOnly')) {
        items.push({xtype:'monitorWidgetTsAggChart', flex:1, resizeable:true, config:{data:dataObj.data, moduleId:this.moduleId, graphConfig:graphConfig, viewObj:this.viewObj}});
      } else {
        if (Ext.String.endsWith(viewMode, 'tableOnly')) {
          items.push({xtype:'monitorWidgetTsAggGrid', flex:1, resizeable:true, header:true, config:{moduleId:this.moduleId, data:dataObj, viewObj:this.viewObj}});
        } else {
          items.push({xtype:'monitorWidgetTsAggChart', flex:1, resizeable:true, config:{data:dataObj.data, moduleId:this.moduleId, graphConfig:graphConfig, viewObj:this.viewObj}});
          items.push({xtype:'monitorWidgetTsAggGrid', forceFit:true, resizeable:true, header:false, config:{moduleId:this.moduleId, data:dataObj, viewObj:this.viewObj}});
        }
      }
      contentItems = [{xtype:'panel', header:false, tabConfig:{hidden:true}, layout:{type:'vbox', align:'stretch'}, resizeable:true, items:items}];
    } else {
      contentItems = [{xtype:'monitorWidgetTsAggChart', config:{data:dataObj.data, moduleId:this.moduleId, graphConfig:graphConfig, viewObj:this.viewObj}}, {xtype:'monitorWidgetTsAggGrid', config:{moduleId:this.moduleId, data:dataObj, viewObj:this.viewObj}}];
    }
    this.add(contentItems);
    var activeTab = 0;
    var initViewStr = this.getSetting('initialView') || 'chart';
    var initViewArr = initViewStr.split(':');
    if (initViewArr.length === 2) {
      var view = initViewArr[0];
      var chartGrid = initViewArr[1];
      if (this.viewObj && this.viewObj.id === view && chartGrid === 'chart') {
        activeTab = 0;
      } else {
        if (this.viewObj && this.viewObj.id === view) {
          activeTab = 1;
        }
      }
    } else {
    }
    this.setActiveTab(activeTab);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initChart', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.widget.timeseriesAggregation.view.monitorViewController', {extend:'Ext.app.ViewController', alias:'controller.monitorViewController', moduleId:undefined, control:{'monitorTimeseriesAggregationMonitorView':{show:'onViewChange'}, 'monitorWidgetTsAggChart':{showItem:'onShowChartItem', hideItem:'onHideChartItem'}}, listen:{global:{dataLoaded:'onDataLoaded', moduleShow:'onViewChange'}}, init:function() {
  var bufferInSeconds = this.getView().getSetting('dataRefreshBuffer');
  this.refreshDataBuffered = Ext.Function.createThrottled(this.refreshData, bufferInSeconds * 1000);
}, refreshDataBuffered:function() {
  this.refreshData();
}, onDataLoaded:function(dataObj) {
  try {
    var queryId = this.getView().getQueryId();
    if (dataObj.properties.componentId && dataObj.properties.componentId === 'monitor_ts_agg' && dataObj.properties.customId && dataObj.properties.customId === queryId) {
      this.refreshDataBuffered();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onDataLoaded', dump:e, stack:true, level:'error'});
  }
}, refreshData:function(force) {
  var forceRefresh = force || false;
  var view = this.getView();
  if (!forceRefresh && !view.isVisible(true)) {
    this.refreshDataOnView = true;
    return;
  }
  this.getView().refreshWidget();
}, onViewChange:function() {
  try {
    var view = this.getView();
    if (view.isVisible(true)) {
      if (this.refreshDataOnView) {
        this.refreshDataOnView = false;
        this.refreshData(true);
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onViewChange', dump:e, stack:true, level:'error'});
  }
}, onHideChartItem:function(chartCmp, chartEvent) {
  var me = this;
  var hiddenGraphs = me.getView().hiddenGraphs;
  try {
    if (Ext.isArray(hiddenGraphs) && !Ext.Array.contains(hiddenGraphs, chartEvent.dataItem.valueField)) {
      hiddenGraphs.push(chartEvent.dataItem.valueField);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onShowChartItem', dump:e, stack:true, level:'error'});
  }
}, onShowChartItem:function(chartCmp, chartEvent) {
  var me = this;
  var hiddenGraphs = me.getView().hiddenGraphs;
  try {
    if (Ext.isArray(hiddenGraphs)) {
      me.getView().hiddenGraphs = Ext.Array.remove(hiddenGraphs, chartEvent.dataItem.valueField);
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onShowChartItem', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.widget.timeseriesAggregation.view.tabs.Chart', {extend:'Ext.Component', alias:'widget.monitorWidgetTsAggChart', localized:{title:'MONITOR_CHARTS'}, layout:'fit', minHeight:100, initComponent:function() {
  try {
    this.data = this.config.data.filter(function(item) {
      return item.date !== 'beforestart' && item.date !== 'afterend';
    });
    var hasAnyData = this.data.some(function(item) {
      return item.totalCount !== 0;
    });
    var graphConfig = this.config.graphConfig;
    var moduleId = this.config.moduleId;
    var viewObj = this.config.viewObj;
    var viewId = viewObj ? viewObj.id : 'mainGrid';
    var dynamicConfig = this.up('monitorWidgetTsAgg').getSetting('chartConfiguration');
    this.itemId = viewId + '-chart';
    this.on('afterrender', function(cmp) {
      try {
        if (hasAnyData) {
          var hardConfig = {'type':'serial', 'dataProvider':this.data, 'graphs':graphConfig, 'balloonDateFormat':'DD.MM.YYYY'};
          var chartConfig = Ext.Object.merge(hardConfig, Ext.clone(dynamicConfig));
          cmp.chart = AmCharts.makeChart(cmp.getId(), chartConfig);
          cmp.chart.legend.addListener('showItem', cmp.fireEvent.bind(cmp, 'showItem', cmp));
          cmp.chart.legend.addListener('hideItem', cmp.fireEvent.bind(cmp, 'hideItem', cmp));
          cmp.chart.addListener('clickGraphItem', function(event) {
            try {
              var statusField = this.up('monitorWidgetTsAgg').getSetting(monitor.assets.ConfigKeys.columnStatus);
              var dateField = this.up('monitorWidgetTsAgg').getSetting('timeseriesColumn');
              var startDate = new Date(event.item.dataContext.date);
              var interval = this.up('monitorWidgetTsAgg').getSetting('interval') || 'day';
              var endDate = BpcCommon.util.EsDateMath.addEsIntervalToDate(startDate, interval, 1);
              var filters = [{id:'x-gridfilter-' + dateField + '-start', operator:'gte', property:dateField, value:startDate}, {id:'x-gridfilter-' + dateField + '-end', operator:'lt', property:dateField, value:endDate}, {operator:'in', property:statusField, value:[event.graph.valueField]}];
              var sorters = [];
              var sorter = {property:this.up('monitorWidgetTsAgg').getSetting('timeseriesColumn'), direction:'DESC'};
              sorters.push(sorter);
              BpcCommon.Api.showModule(moduleId, false, {storeState:{filters:filters, sorters:sorters}, viewId:viewId});
            } catch (e) {
              Ext.log({msg:': ERROR clickGraphItem ', dump:e, stack:true, level:'error'});
            }
          }, this);
        } else {
          cmp.update('\x3cdiv\x3e\n                        \x3cp style\x3d"line-height:50px;text-align:center;"\x3e\x3cbr/\x3e\x3cbr/\x3e\x3ci class\x3d"fa fa-line-chart" style\x3d"color: #D49A6A; font-size: 30px; margin-right: 3px;"\x3e\x3c/i\x3e\x3cbr\x3e\x3cbr\x3e\n                           ' + BpcCommon.Api.getTranslation('MONITOR_NO_DATA_IN_TIME_SPAN') + '\n                        \x3c/p\x3e\n                  \x3c/div\x3e');
        }
      } catch (e) {
        Ext.log({msg:': ERROR afterrender chart', dump:e, stack:true, level:'error'});
      }
    }, this);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  this.callParent();
}, updateData:function(chartData, graphConfig) {
  chartData = chartData.filter(function(item) {
    return item.date !== 'beforestart' && item.date !== 'afterend';
  });
  try {
    if (this.chart) {
      this.chart.dataProvider = chartData;
      if (Ext.isDefined(graphConfig)) {
        this.chart.graphs = graphConfig;
      }
      this.chart.validateData();
    } else {
      this.data = chartData;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateData', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('monitor.widget.processOverviewTime.view.tabs.Grid', {extend:'Ext.grid.Panel', alias:'widget.monitorWidgetTsAggGrid', localized:{title:'MONITOR_DATA'}, features:[], autoScroll:true, listeners:{el:{delegate:'.summary-cell', click:function(ev, element) {
  Ext.log({msg:this.self.getName() + ': Summary Cell Clicked'});
  var grid = Ext.getCmp(this.id);
  var moduleId = grid.config.moduleId;
  var statusValue = element.getAttribute('dataindex');
  var statusField = grid.up('monitorWidgetTsAgg').getSetting(monitor.assets.ConfigKeys.columnStatus) || 'STATUS';
  var dateField = grid.up('monitorWidgetTsAgg').getSetting('timeseriesColumn');
  var viewObj = grid.config.viewObj;
  var viewId = viewObj ? viewObj.id : 'mainGrid';
  var filters = [];
  if (statusValue !== 'totalCount') {
    filters.push({operator:'in', property:statusField, value:[statusValue]});
  }
  if (element.classList.contains('range-summary')) {
    var startDate = !isNaN(new Date(grid.getSetting('startDate'))) ? new Date(grid.getSetting('startDate')) : BpcCommon.util.EsDateMath.getCalculatedDateFromOffsetMap(BpcCommon.util.EsDateMath.getOffsetMapFromEsDateMathString(grid.getSetting('startDate')));
    var endDate = !isNaN(new Date(grid.getSetting('endDate'))) ? new Date(grid.getSetting('endDate')) : BpcCommon.util.EsDateMath.getCalculatedDateFromOffsetMap(BpcCommon.util.EsDateMath.getOffsetMapFromEsDateMathString(grid.getSetting('endDate')));
    endDate.setHours(23, 59, 59);
    filters.push([{id:'x-gridfilter-' + dateField + '-start', operator:'gte', property:dateField, value:startDate}, {id:'x-gridfilter-' + dateField + '-end', operator:'lte', property:dateField, value:endDate}]);
  }
  BpcCommon.Api.getGlobalViewModel().get('global.dateRange').active = false;
  BpcCommon.Api.showModule(moduleId, false, {storeState:{filters:filters}, viewId:viewId});
}}, cellclick:function(tableView, td, cellIndex, record) {
  var grid = tableView.up('monitorWidgetTsAggGrid');
  var moduleId = grid.config.moduleId;
  var statusField = tableView.up('monitorWidgetTsAgg').getSetting(monitor.assets.ConfigKeys.columnStatus) || 'STATUS';
  var dateField = tableView.up('monitorWidgetTsAgg').getSetting('timeseriesColumn');
  var clickedDataIndex = grid.headerCt.getHeaderAtIndex(cellIndex).dataIndex;
  var viewObj = grid.config.viewObj;
  var viewId = viewObj ? viewObj.id : 'mainGrid';
  var startDate;
  var endDate;
  if (record.get('flag') === 'before') {
    endDate = !isNaN(new Date(grid.getSetting('startDate'))) ? new Date(grid.getSetting('startDate')) : BpcCommon.util.EsDateMath.getCalculatedDateFromOffsetMap(BpcCommon.util.EsDateMath.getOffsetMapFromEsDateMathString(grid.getSetting('startDate')));
  } else {
    if (record.get('flag') === 'after') {
      startDate = !isNaN(new Date(grid.getSetting('endDate'))) ? new Date(grid.getSetting('endDate')) : BpcCommon.util.EsDateMath.getCalculatedDateFromOffsetMap(BpcCommon.util.EsDateMath.getOffsetMapFromEsDateMathString(grid.getSetting('endDate')));
      startDate.setHours(23, 59, 59);
    } else {
      var interval = grid.getSetting('interval') || 'day';
      startDate = new Date(record.get('date'));
      endDate = BpcCommon.util.EsDateMath.addEsIntervalToDate(startDate, interval, 1);
    }
  }
  var filters = [];
  if (startDate) {
    filters.push({id:'x-gridfilter-' + dateField + '-start', operator:'gte', property:dateField, value:startDate});
  }
  if (endDate) {
    filters.push({id:'x-gridfilter-' + dateField + '-end', operator:'lt', property:dateField, value:endDate});
  }
  if (clickedDataIndex !== 'date' && clickedDataIndex !== 'totalCount') {
    filters.push({operator:'in', property:statusField, value:[clickedDataIndex]});
  }
  var sorters = [{property:dateField, direction:'DESC'}];
  BpcCommon.Api.showModule(moduleId, false, {storeState:{filters:filters, sorters:sorters}, viewId:viewId});
}}, viewConfig:{stripeRows:false, getRowClass:function(record) {
  if (record.get('flag') === 'before' || record.get('flag') === 'after') {
    return 'x-grid-item-alt';
  }
  return '';
}}, initComponent:function() {
  var me = this;
  try {
    var viewObj = this.config.viewObj;
    var viewId = viewObj ? viewObj.id : 'mainGrid';
    this.itemId = viewId + '-table';
    var widgetCls = this.up('monitorWidgetTsAgg');
    this.getSetting = widgetCls.getSetting.bind(widgetCls);
    me.widgetMain = me.up('monitorWidgetTsAgg');
    this.columns = this.createColumns(this.config.data.fields);
    var fields = [{name:'date', type:'date', dateFormat:'Y-m-d H:i:s', displayFormat:this.getSetting('dateFormat')}];
    this.config.data.fields.forEach(function(fieldObj) {
      fields.push({name:fieldObj.name, defaultValue:0});
    });
    var preparedData = this.prepareData(this.config.data.data);
    this.store = Ext.create('Ext.data.Store', {data:preparedData, fields:fields});
    var hideEmptyRows = this.getSetting('hideEmptyRows');
    if (Ext.isDefined(hideEmptyRows) && hideEmptyRows === true) {
      this.store.filterBy(function(record) {
        return record.get('totalCount') !== 0;
      });
    }
    this.features = [{ftype:'summary', dock:this.getSetting('dockSummary') && this.getSetting(monitor.assets.ConfigKeys.dockSummary).length ? this.getSetting('dockSummary') : undefined}];
    if (this.getSetting('showPreviousData') || this.getSetting('showFollowingData')) {
      this.features.unshift({ftype:'summaryignorerows', dock:this.getSetting('dockSummary') && this.getSetting(monitor.assets.ConfigKeys.dockSummary).length ? this.getSetting('dockSummary') : undefined});
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
  this.callParent(arguments);
}, createColumns:function(fields) {
  var me = this;
  var customRendererPlugin = me.widgetMain.findPlugin('monitorCustomRenderer');
  var dateFormat = me.widgetMain.settingStore.findRecord('id', 'dateFormat').get('value');
  var shouldShowPreviousData = this.getSetting('showPreviousData');
  var shouldShowFollowingData = this.getSetting('showFollowingData');
  var startDate = !isNaN(new Date(this.getSetting('startDate'))) ? new Date(this.getSetting('startDate')) : BpcCommon.util.EsDateMath.getCalculatedDateFromOffsetMap(BpcCommon.util.EsDateMath.getOffsetMapFromEsDateMathString(this.getSetting('startDate')));
  var formatedStartDate = Ext.Date.format(startDate, dateFormat);
  var endDate = !isNaN(new Date(this.getSetting('endDate'))) ? new Date(this.getSetting('endDate')) : BpcCommon.util.EsDateMath.getCalculatedDateFromOffsetMap(BpcCommon.util.EsDateMath.getOffsetMapFromEsDateMathString(this.getSetting('endDate')));
  var formatedEndDate = Ext.Date.format(endDate, dateFormat);
  var columns = [{dataIndex:'date', xtype:'datecolumn', format:dateFormat, text:BpcCommon.Api.getTranslation('MONITOR_DATE'), width:150, renderer:function(val, meta, rec) {
    if (!val && rec.get('flag') === 'before' && shouldShowPreviousData) {
      return '\x3c ' + formatedStartDate;
    }
    if (!val && rec.get('flag') === 'after' && shouldShowFollowingData) {
      return '\x3e ' + formatedEndDate;
    }
    return Ext.util.Format.date(val, dateFormat);
  }, summaryRenderer:function() {
    return '\x3cb\x3e' + BpcCommon.Api.getTranslation('MONITOR_TOTAL') + '\x3c/b\x3e';
  }, summaryIgnoreRowsRenderer:function() {
    return '\x3cb\x3e' + BpcCommon.Api.getTranslation('MONITOR_TOTAL') + ' (' + formatedStartDate + ' - ' + formatedEndDate + ')\x3c/b\x3e';
  }}];
  var moduleId = this.config.moduleId;
  var columnIdentity = String(me.up('monitorWidgetTsAgg').getSetting('aggregationColumn')).trim();
  var monitorColumnConfig = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnConfig);
  me.columnConfig = Ext.Array.findBy(monitorColumnConfig, function(colConfig) {
    if (colConfig.id) {
      return colConfig.id === columnIdentity;
    }
    return colConfig.dataIndex === columnIdentity && !colConfig.id;
  });
  me.columnRenderer = customRendererPlugin.getColumnRendererByColumnConfig(me.columnConfig);
  var defaultColumnConfig = {flex:1, align:this.getSetting(monitor.assets.ConfigKeys.cellAlign) || 'center', summaryType:'sum', xtype:'numbercolumn', minWidth:60, renderer:function(value, meta) {
    meta.tdStyle = 'cursor: pointer';
    if (!value) {
      value = 0;
    }
    if (this.getSetting(monitor.assets.ConfigKeys.hideZeroValues) && value === 0) {
      return '';
    }
    return value;
  }, summaryRenderer:function(value, summaryData, dataIndex) {
    if (isNaN(value)) {
      value = 0;
    }
    return '\x3cspan class\x3d"summary-cell" data-qtip\x3d"' + BpcCommon.Api.getTranslation('MONITOR_SHOW_ALL_STATUS') + '"' + (' dataindex\x3d"' + dataIndex + '" style\x3d"cursor: pointer"\x3e\x3cb\x3e' + value + '\x3c/b\x3e\x3cspan\x3e');
  }, summaryIgnoreRowsRenderer:function(value, summaryData, dataIndex) {
    if (isNaN(value)) {
      value = 0;
    }
    return '\x3cspan class\x3d"summary-cell range-summary" data-qtip\x3d"' + BpcCommon.Api.getTranslation('MONITOR_SHOW_ALL_STATUS') + '"' + (' dataindex\x3d"' + dataIndex + '" style\x3d"cursor: pointer"\x3e\x3cb\x3e' + value + '\x3c/b\x3e\x3cspan\x3e');
  }};
  fields.concat({name:'totalCount'}).forEach(function(fieldObj) {
    var fieldName = fieldObj.name;
    var columnHeaderText;
    if (fieldName === 'totalCount') {
      columnHeaderText = BpcCommon.Api.getTranslation('MONITOR_TOTAL');
    } else {
      columnHeaderText = me.widgetMain.customColumnRenderer(fieldName) ? me.widgetMain.customColumnRenderer(fieldName) : fieldName;
    }
    columns.push(Ext.applyIf({text:columnHeaderText, dataIndex:fieldName}, defaultColumnConfig));
  }, this);
  return columns;
}, updateData:function(data) {
  this.getStore().loadRawData(this.prepareData(data.data));
  this.reconfigure(this.store, this.createColumns(data.fields));
}, prepareData:function(data) {
  var shouldShowPreviousData = this.getSetting('showPreviousData');
  var shouldShowFollowingData = this.getSetting('showFollowingData');
  var result = data;
  if (!shouldShowPreviousData) {
    result = result.filter(function(item) {
      return item.date !== 'beforestart';
    });
  }
  if (!shouldShowFollowingData) {
    result = result.filter(function(item) {
      return item.date !== 'afterend';
    });
  }
  var calculateTotalCount = function(obj) {
    var totalCount = 0;
    Ext.Object.each(obj, function(key, value) {
      if (Ext.isNumber(value)) {
        totalCount += value;
      }
    });
    return totalCount;
  };
  result.forEach(function(item) {
    if (item.date === 'beforestart') {
      item.flag = 'before';
      item.ignoreSummary = true;
      item.totalCount = calculateTotalCount(item);
    }
    if (item.date === 'afterend') {
      item.flag = 'after';
      item.ignoreSummary = true;
      item.totalCount = calculateTotalCount(item);
    }
  });
  return result;
}});
Ext.define('monitor.widget.processPreview.Grid', {alternateClassName:['monitor.widget.monitorWidget.Grid'], extend:'Ext.grid.Panel', alias:'widget.monitorWidgetGridCmp', mixins:['monitor.widget.abstract.MonitorViewMixin'], controller:'monitorWidgetGridCmpController', bodyStyle:'cursor: pointer', forceFit:true, height:100, plugins:'gridfilters', listeners:{rowdblclick:function(row, record) {
  if (row && row.up('monitorDashboardWidget')) {
    if (row.up('monitorWidgetGridCmp') && row.up('monitorWidgetGridCmp').moduleId) {
      var moduleId = row.up('monitorWidgetGridCmp').moduleId;
      if (row.up('monitorDashboardWidget').getSettingFromModuleInstance(monitor.assets.ConfigKeys.detailViewPopupEnabled) === true) {
        var detailedWindow = Ext.createByAlias('widget.detailWindow', {moduleId:moduleId, selectedRecord:record, hackMode:true, grid:row.up('grid'), width:document.body.clientWidth * 0.8, height:document.body.clientHeight * 0.8, minWidth:document.body.clientWidth * 0.4, minHeight:document.body.clientHeight * 0.5, maxWidth:document.body.clientWidth, maxHeight:document.body.clientHeight});
        detailedWindow.show();
      }
    }
  }
}}, bbar:{xtype:'pagingtoolbar', displayInfo:true}, moduleId:undefined, viewObj:undefined, multi:undefined, widgetId:undefined, initComponent:function() {
  this.viewConfig = {localized:{emptyTexT:'MONITOR_NO_PROCESSES_FOUND'}, deferEmptyText:false, getRowClass:monitor.Module.rowStyleController.getRowClass.bind(this, this.moduleId, this.viewObj.id)};
  this.creationTimeStamp = (new Date).getTime();
  if (Ext.isObject(this.viewObj) && this.viewObj.id) {
    this.bpcGridViewName = this.viewObj.id;
  } else {
    this.bpcGridViewName = this.viewObj;
  }
  this.queryId = this.getQueryId();
  this.title = Ext.isDefined(this.multi) ? this.viewObj.title : null;
  this.store = this.createStore(this.bpcGridViewName);
  this.columns = this.createColumns();
  this.columnId = BpcCommon.Api.getSetting(this.moduleId, monitor.assets.ConfigKeys.columnId);
  this.callParent(arguments);
}, createColumns:function() {
  var me = this;
  var pluginMain = me.up('monitorDashboardWidget');
  try {
    var columnConfigArray = Ext.clone(me.getSettingFromModuleInstance(monitor.assets.ConfigKeys.columnConfig));
    if (!columnConfigArray) {
      me.emptyText = BpcCommon.Api.getTranslation('CORE_ERROR_MISSING_RIGHT');
      return [];
    }
    var widgetColumnString = me.getSetting('columnList');
    var widgetColumnConfig = widgetColumnString.split(',');
    var columns = [];
    var moduleId = me.moduleId;
    Ext.Array.each(widgetColumnConfig, function(colName) {
      var columnName = colName.trim();
      var column = Ext.Array.findBy(columnConfigArray, function(columnConfig) {
        return columnConfig.id === columnName || columnConfig.dataIndex === columnName;
      }) || {};
      delete column.width;
      delete column.hidden;
      delete column.id;
      delete column.filter;
      column.renderer = pluginMain.findPlugin('monitorCustomRenderer').getColumnRendererByColumnConfig(column);
      columns.push(column);
    });
    var useActionCol = me.getSetting('goTo');
    if (useActionCol === true) {
      var moduleName = BpcCommon.Api.getSetting(moduleId, 'module_name');
      var tooltip = 'Monitorsprung';
      if (Ext.isDefined(moduleName)) {
        tooltip += ' - ' + moduleName;
      }
      columns.push({xtype:'actioncolumn', align:'center', width:30, items:[{iconCls:'x-fal fa-external-link', tooltip:tooltip, handler:function(grid, rowIndex) {
        var wrapper = grid.up('monitorDashboardWidget');
        var record = grid.getStore().getAt(rowIndex);
        if (useActionCol === true) {
          var id = BpcCommon.Api.getSetting(moduleId, monitor.assets.ConfigKeys.columnId);
          var filters = [{property:id, value:record.get(id)}];
          var sorters = [];
          var sorter = {property:wrapper.getSetting('timeseriesColumn'), direction:'DESC'};
          sorters.push(sorter);
          BpcCommon.Api.showModule(moduleId, false, {storeState:{filters:filters, sorters:sorters}});
        }
      }}]});
    }
    return columns;
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR createColumns', dump:e, stack:true, level:'error'});
  }
}, createStore:function(viewNameObj) {
  try {
    var me = this;
    var moduleId = this.moduleId;
    var newModel = Ext.define(null, {extend:'Ext.data.Model', idProperty:BpcCommon.Api.getSetting(me.getSetting('moduleId'), monitor.assets.ConfigKeys.columnId)});
    var timestampColumn = me.getSetting('timeseriesColumn');
    var store = Ext.create('Ext.data.Store', {model:newModel, moduleId:moduleId, remoteFilter:true, pageSize:me.getSetting('pageSize'), proxy:{type:'ajax', url:BpcCommon.Api.getBackendUrl('monitor') + '/monitor/' + moduleId, reader:{type:'json', rootProperty:'data', totalProperty:'totalCount', keepRawData:true}, extraParams:{view:viewNameObj, queryId:this.queryId}}, filters:[{id:'x-gridfilter-' + timestampColumn + '-start', property:timestampColumn, value:me.getSetting('startDate'), operator:'gte'}, 
    {id:'x-gridfilter-' + timestampColumn + '-end', property:timestampColumn, value:me.getSetting('endDate'), operator:'lte'}], sorters:[{property:timestampColumn, direction:'DESC'}]});
    store.load();
    return store;
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR createStore', dump:e, stack:true, level:'error'});
  }
}, refreshGrid:function() {
  this.getStore().reload();
}});
Ext.define('monitor.widget.processPreview.TableController', {alternateClassName:['monitor.widget.monitorWidget.TableController'], extend:'Ext.app.ViewController', alias:'controller.monitorWidgetGridCmpController', listen:{global:{dataLoaded:'onDataLoaded'}}, init:function() {
  this.handleGlobalDateRange = BpcCommon.Util.getGlobalDateRangeHandler(this.getView().getStore(), this.getView().getSetting('timeseriesColumn'), {start:this.getView().getSetting('startDate'), end:this.getView().getSetting('endDate')});
  var vm = this.getViewModel();
  vm.bind({bindTo:'{global.dateRange}', deep:true}, Ext.Function.createBuffered(this.handleGlobalDateRange, 100, this));
  this.handleGlobalDateRange(true);
}, onDataLoaded:function(dataObj) {
  try {
    var queryId = this.getView().queryId;
    if (dataObj.properties.componentId && dataObj.properties.componentId === 'monitor' && dataObj.properties.customId && dataObj.properties.customId === queryId) {
      this.getView().getStore().reload();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onDataLoaded', dump:e, stack:true, level:'error'});
  }
}, refreshData:function() {
  this.getView().getStore().reload();
}});
